/*
TASK:e1
LANG:C++
*/


#include <iostream>

using std::cin;
using std::cout;
using std::endl;

int main()
{
	const unsigned short FEB = 2, JULY = 7;
	const unsigned short MIN_YEAR = 1800, MAX_YEAR = 2099,
						 SECOND_PERIOD_START = 1900,
						 THIRD_PERIOD_START = 2000,
						 MAX_MONTH = 12,
						 MAX_NUMBER = 999;
	const unsigned short GENDER_POSITION = 8;

	unsigned short maxDays = 31;
	
	const unsigned short weights[]={2,4,8,5,10,9,7,3,6};
	unsigned short egn[10]={0};
		
	unsigned short year, month, day, number;

	cin >> year
		>> month
		>> day
		>> number;

	//Namirane na maksimalen den!
	if ((month<=JULY && month%2==0) || (month>JULY && month%2==1))
	{
		maxDays--;		//30 dni za 2,4,6,9,11 meseci
	}

	//Proverka za fevruari!
	if (month==FEB)
	{
		maxDays -= 1 + !(year%400==0 || (year%4==0 && year%100!=0));
	}

	//Proverka za korektni danni!
	if ((year<MIN_YEAR || year>MAX_YEAR) ||
		(month>MAX_MONTH) ||
		(day>maxDays) ||
		(number>MAX_NUMBER)
		)
	{
		cout << "error" << endl;
		return 0;
	}

	//Korigirane na meseca
	if (year<SECOND_PERIOD_START)
	{
		month+=20;
	}
	else if (year>=THIRD_PERIOD_START)
	{
		month+=40;
	}

	//Korigirane na godinata - poslednite dve cifri
	year %= 100;


	//Zapylvane na masiva egn
	unsigned short i = 0;
	unsigned int controlSum = 0;
	
	egn[i] = year/10;
	controlSum += egn[i]*weights[i++];
	
	egn[i] = year%10;
	controlSum += egn[i]*weights[i++];

	egn[i] = month/10;
	controlSum += egn[i]*weights[i++];

	egn[i] = month%10;
	controlSum += egn[i]*weights[i++];

	egn[i] = day/10;
	controlSum += egn[i]*weights[i++];

	egn[i] = day%10;
	controlSum += egn[i]*weights[i++];

	egn[i] = number/100;
	controlSum += egn[i]*weights[i++];

	egn[i] = (number/10)%10;
	controlSum += egn[i]*weights[i++];

	egn[i] = number%10;
	controlSum += egn[i]*weights[i++];

	egn[i] = (controlSum%11)%10;


	//Pechatane na ekrana
	for (unsigned int index = 0; index < 10; index++)
	{
		cout << egn[index];
	}

	if (egn[GENDER_POSITION]%2==0)
	{
		cout << endl << "male" << endl;
	}
	else
	{
		cout << endl << "female" << endl;
	}

	return 0;
}
