#include <iostream>
#include <string>

#define CALC_SYMBOL_POS (roman_number_length(current_number) + m - current_len)

using namespace std;

char lengths[]={0,1,2,3,2,1,2,3,4,2},
		 roman_digits[]={'\0','I','V','X','L','C','D','M'};

int roman_number_length(int number);
char symbol_of_roman_number(int number, int symbol_number);

int main() {
	int n, m, current_len=0, current_number=0;

	for(cin>>n>>m; current_len < m; current_len+=roman_number_length(++current_number));
	cout << symbol_of_roman_number(current_number, CALC_SYMBOL_POS) << '\n'; 
		
  return 0;		
}

int roman_number_length(int number){
  int i=0;
	for (;number;i+=lengths[number%10],number/=10); 
	return i;
} 

char symbol_from_roman_number(int number, int from_pos){
  string s;
  int i=1, j;

  do {
		j = number%10;
		switch (j) {
			case 5:	s=roman_digits[i+1]+s;
			case 0: break;
			case 3: 
		 	case 8: s=roman_digits[i]+s; 
			case 2: 
		 	case 7: s=roman_digits[i]+s;
			default:
				if (j%5==4) s=roman_digits[j==4?i+1:i+2]+s;
			 	s=roman_digits[i]+s;
			 	if ((j>5)&&(j<9)) s=roman_digits[i+1]+s;
		}
		number/=10;
		i+=2;
	} while (number);
	
	return s[from_pos-1];
}	
				
