/*
TASK:economics
LANG:C++
*/
#include <iostream>
#include <cstdio>

using namespace std;

int n, m;
char A[16][16];
double K[16][16];

void solve()
{
	for (int i=0; i<n; ++i)
		K[0][i]=1.00/n;
	for (int i=0; i<n-1; ++i)
		for (int j=0; j<m; ++j)
			if (A[i][j] == 'v')
				continue;
			else if (A[i][j] == '\\')
			{
				if (j+1 < m)
					K[i+1][j+1]+=K[i][j];
			}
			else if (A[i][j] == '/')
			{
				if (j-1 >= 0)
					K[i+1][j-1]+=K[i][j];
			}
			else if (A[i][j] == '|')
			{
				K[i+1][j]+=K[i][j];
			}
			else if (A[i][j] == '*')
			{
				if (j-1<0 && j+1<m)
				{
					K[i+1][j]+=K[i][j]/3;
					K[i+1][j+1]+=K[i][j]/3;
					K[i][j+1]+=K[i][j]/3;
				}
				else if (j-1<0 && j+1>=m)
					K[i][j+1]+=K[i][j];
				else if (j+1>=m && j-1>=0)
				{
					K[i+1][j]+=K[i][j]/3;
					K[i+1][j-1]+=K[i][j]/3;
					K[i][j-1]+=K[i][j]/3;
				}
				else
				{
					K[i+1][j]+=K[i][j]/5;
					K[i+1][j+1]+=K[i][j]/5;
					K[i][j+1]+=K[i][j]/5;
					K[i+1][j-1]+=K[i][j]/5;
					K[i][j-1]+=K[i][j]/5;
				}
			}
	double answer=0;
	for (int i=0; i<n; ++i)
		for (int j=0; j<m; ++j)
			if (A[i][j] == 'v')
				answer+=K[i][j];
	printf("%.3lf\n", answer);
}

void input()
{
	scanf("%d%d", &n, &m);
	for (int i=0; i<n; ++i)
		for (int j=0; j<m; ++j)
			cin >> A[i][j];
}

int main()
{
	input();
	solve();
return 0;
}
