#include <iostream>
#include <cstring>
#include <vector>
using namespace std;

int a[26];
int o=1;
long long s;
char str[256];

struct rr {
	char s;
	int v;
} q;

vector <rr> v;

int vsize=0;

void print() {
	cout<<o++<<") ";
	for (int i=0;i<vsize;i++) {
		if (v[i].s!=0) cout<<v[i].s;
		else cout<<v[i].v;
	}
	cout<<"\n";
}

void printp(int yr,int ys) {
	cout<<"*)";
	for (int i=yr;i<=ys;i++) {
		if (v[i].s!=0) cout<<v[i].s;
		else cout<<v[i].v;
	}
	cout<<"\n";
}

void err(int pos,int am) {
	for (int i=pos;i<vsize-am;i++) {
		v[i]=v[i+am];
	}
	vsize-=am;
}

bool ch() {
	for (int i=0;i<vsize;i++) if (v[i].s=='(') return true;
	return false;
}

void solve(int st,int fn) {
	printf("(%d,%d)\n",st,fn);
//	printp(st,fn);
	for (int i=st;i<=fn;i++) {

		if (v[i].s=='*') { v[i-1].v=v[i-1].v*v[i+1].v; err(st+i,2); err(st+i,2); fn-=2; i--;v[i].s=0;}

		if (v[i].s=='/') { v[i-1].v=v[i-1].v/v[i+1].v; err(st+i,2); err(st+i,2); fn-=2; i--;v[i].s=0;}

		if (v[i].s=='%') { v[i-1].v=v[i-1].v%v[i+1].v; err(st+i,2); err(st+i,2); fn-=2; i--;v[i].s=0;}

	}



	for (int i=st;i<=fn;i++) {
		if (v[i].s=='+') { v[i-1].v=v[i-1].v+v[i+1].v; err(st+i,2); err(st+i,2); fn-=2; i--;v[i].s=0;}
		if (v[i].s=='-') { v[i-1].v=v[i-1].v-v[i+1].v; err(st+i,2); err(st+i,2); fn-=2; i--;v[i].s=0;}
	}


	for (int i=st;i<=fn;i++) {
		if (v[i].s=='<')  { if (v[i-1].v<v[i+1].v) v[i-1].v=1; else v[i-1].v=0; err(st+i,2); err(st+i,2); fn-=2; i--;v[i].s=0;}
		if (v[i].s=='>') { if (v[i-1].v>v[i+1].v) v[i-1].v=1; else v[i-1].v=0; err(st+i,2); err(st+i,2); fn-=2; i--;v[i].s=0;}
		if (v[i].s=='=') { if (v[i-1].v==v[i+1].v) v[i-1].v=1; else v[i-1].v=0; err(st+i,2); err(st+i,2); fn-=2; i--;v[i].s=0;}
	}


	for (int i=st;i<=fn;i++) {
		if (v[i].s=='&') {if (v[i-1].v!=0 && v[i+1].v!=0) v[i-1].v=1;else v[i-1].v=0; err(st+i,2); err(st+i,2); fn-=2; i--;v[i].s=0;}
		if (v[i].s=='|') {if (v[i-1].v!=0 || v[i+1].v!=0) v[i-1].v=1;else v[i-1].v=0; err(st+i,2); err(st+i,2); fn-=2; i--;v[i].s=0;}
	}
	print();

}


int main() {
	for (int i=0;i<26;i++) cin>>a[i];
	gets(str);
	gets(str);
	for (int i=0;i<strlen(str);i++) {
		if (str[i]>='a' && str[i]<='z') {
			q.s=0;
			q.v=a[str[i]-'a'];
		}
		else {
			q.s=str[i];
			q.v=0;
		}
		v.push_back(q);
	}
	vsize=v.size();





	while(ch()) {
		int ind=0;
		for (int i=0;i<vsize-1;i++) {
			if (v[i].s=='(') ind=i;
			if (v[i].s==')') {

				err(i,1);
				err(ind,1);

				solve(ind,i-2);
				printf("(%d)\n",v[ind].v);

				break;
			}
		}
	}


	solve(0,vsize-1);

	cout<<v[0].v<<"\n";
	return 0;
}
