#include <iostream>
using namespace std;

double ph[64], wh[64];
const double eps=1e-9;

int main()
{
  int n; scanf("%d", &n);
  int i, j;
  for(i=1; i<n; i++) scanf("%lf", ph+i);
  scanf("%lf", wh+1);
  
  ph[0]=200000;
  int groups=0, groupm, groupch;
  double eq_k, eq_h, eq_x;
  for(i=1; i<n; i++)
  {
    if(wh[i]<ph[i]) break;
    groupch=1;
    while(wh[i]>ph[i]+eps && wh[i]>wh[i+1]+eps)
    {
      groupch=0;
      groupm=i;
      for(j=groups+1; j<=i; j++) if(ph[j]>ph[groupm]) groupm=j;
      eq_k=i-groups;
      eq_h=wh[groupm];
      eq_x=(eq_h-wh[i+1])/(eq_k+1);
      if(eq_x >= eq_h - ph[groupm] ) { groupch=1; eq_x = eq_h - ph[groupm]; }
      //printf("%d %d %d\n", groups, groupm, i);
      for(j=groups+1; j<=i; j++) wh[j]-=eq_x;
      wh[i+1]+=eq_k*eq_x;
      if(groupch) groups=groupm;
      /*
      printf("%lf", wh[1]);
      for(int ii=2; ii<=n; ii++) printf(" %lf", wh[ii]);
      printf("\n");
      //scanf("%lf", ph+60);
      */
    }
  }
  
  //printf("! Done.\n\n");
  
  printf("%lf", wh[1]);
  for(i=2; i<=n; i++) printf(" %lf", wh[i]);
  printf("\n");
  return 0;
}
