/*
TASK:platforms
LANG:C++
*/

#include<cstdio>
#include<queue>

int m,n;

struct el{
	int t;
	int x,y;
	bool operator< (const el& b) const {
		return t>b.t;
	}
	el(int _x,int _y, int _t) {
		x=_x;y=_y;t=_t;
	}
};

std::priority_queue <el> PQ;

struct train {
	int start;
	int speed;
	int pos(int t, int s) {
		if((t-start)%speed) return -1;
		int c=(t-start)/speed;
		if((c/(s-1))%2==0) {
			return c%(s-1);
		} else {
			return s-1-c%(s-1);
		}
	}
};

int sp(char c) {
	if(c=='S') return 3;
	if(c=='F') return 1;
	return 2;	
}
train ht[52],vt[52];
int bx,by,ex,ey,bt;
char used[52][52];

int main() {
	scanf("%d%d ",&m,&n);
	char c;
	int t;
	for(int i=0;i<m;++i) {
		scanf("%c%d ",&c,&t);
		ht[i].speed=sp(c);ht[i].start=t;
	}
	for(int i=0;i<n;++i) {
		scanf("%c%d ",&c,&t);
		vt[i].speed=sp(c);vt[i].start=t;
	}
	scanf("%d%d%d%d%d",&bx,&by,&bt,&ex,&ey);
	--bx;--by;--ex;--ey;
	PQ.push(el(bx,by,bt));
	el e(0,0,0);
	int nnn;
	while(1) {
		e=PQ.top();PQ.pop();
		used[e.x][e.y]==1;
		if(e.x==ex&&e.y==ey) {
			printf("%d\n",e.t);
			return 0;
		}
		PQ.push(el(e.x,e.y,e.t+1));
		if(vt[e.x].pos(e.t,m)==e.y) {
			nnn=vt[e.x].pos(e.t+vt[e.x].speed,m);
			if(!used[e.x][nnn]) PQ.push(el(e.x,nnn,e.t+vt[e.x].speed));
		}
		if(ht[e.y].pos(e.t,n)==e.x) {
			nnn=ht[e.y].pos(e.t+ht[e.y].speed,n);
			if(!used[nnn][e.y]) PQ.push(el(nnn,e.y,e.t+ht[e.y].speed));
		}
	}
	return 0;	
}
