/*
TASK: platforms
LANG: C++
*/
#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
using namespace std;

int Min(int a,int b){if (a<b && a!=0)return a; else return b;}
int Max(int a,int b){if (a>b)return a; else return b;}

struct PlatformStruct{
    char Type;      //F O S
    char RC;        //Row Col
    int Position;   //
    bool Direction; //0 1
    int Progress;   //0 1 2 3
    int Token;      //0 1
};

vector <pair<int,int> > Positions;
vector <PlatformStruct> Platforms;
int Map[50][50];
int R,C;

void MovePlatforms(){
    for(int i=0;i<Platforms.size();i++){

        if(Platforms[i].Type=='F'){
            if(Platforms[i].Progress!=0){Platforms[i].Progress++;}
            else{
                if(Platforms[i].RC=='C'){
                    if(Platforms[i].Position<C && Platforms[i].Direction==0){Platforms[i].Position++;}
                    else if(Platforms[i].Position>0 && Platforms[i].Direction==1){Platforms[i].Position--;}
                    else if(Platforms[i].Position==0 && Platforms[i].Direction==1){Platforms[i].Position++;Platforms[i].Direction=0;}
                    else if(Platforms[i].Position==C && Platforms[i].Direction==0){Platforms[i].Position--;Platforms[i].Direction=1;}
                    }
                if(Platforms[i].RC=='R'){
                    if(Platforms[i].Position<R && Platforms[i].Direction==0){Platforms[i].Position++;}
                    else if(Platforms[i].Position>0 && Platforms[i].Direction==1){Platforms[i].Position--;}
                    else if(Platforms[i].Position==0 && Platforms[i].Direction==1){Platforms[i].Position++;Platforms[i].Direction=0;}
                    else if(Platforms[i].Position==R && Platforms[i].Direction==0){Platforms[i].Position--;Platforms[i].Direction=1;}
                    }
                Platforms[i].Progress=0;
                }
            }

        if(Platforms[i].Type=='O'){
            if(Platforms[i].Progress!=1){Platforms[i].Progress++;}
            else{
                if(Platforms[i].RC=='C'){
                    if(Platforms[i].Position<C && Platforms[i].Direction==0){Platforms[i].Position++;}
                    else if(Platforms[i].Position>0 && Platforms[i].Direction==1){Platforms[i].Position--;}
                    else if(Platforms[i].Position==0 && Platforms[i].Direction==1){Platforms[i].Position++;Platforms[i].Direction=0;}
                    else if(Platforms[i].Position==C && Platforms[i].Direction==0){Platforms[i].Position--;Platforms[i].Direction=1;}
                    }
                if(Platforms[i].RC=='R'){
                    if(Platforms[i].Position<R && Platforms[i].Direction==0){Platforms[i].Position++;}
                    else if(Platforms[i].Position>0 && Platforms[i].Direction==1){Platforms[i].Position--;}
                    else if(Platforms[i].Position==0 && Platforms[i].Direction==1){Platforms[i].Position++;Platforms[i].Direction=0;}
                    else if(Platforms[i].Position==R && Platforms[i].Direction==0){Platforms[i].Position--;Platforms[i].Direction=1;}
                    }
                Platforms[i].Progress=0;
                }
            }
            
        if(Platforms[i].Type=='S'){
            if(Platforms[i].Progress!=2){Platforms[i].Progress++;}
            else{
                if(Platforms[i].RC=='C'){
                    if(Platforms[i].Position<C && Platforms[i].Direction==0){Platforms[i].Position++;}
                    else if(Platforms[i].Position>0 && Platforms[i].Direction==1){Platforms[i].Position--;}
                    else if(Platforms[i].Position==0 && Platforms[i].Direction==1){Platforms[i].Position++;Platforms[i].Direction=0;}
                    else if(Platforms[i].Position==C && Platforms[i].Direction==0){Platforms[i].Position--;Platforms[i].Direction=1;}
                    }
                if(Platforms[i].RC=='R'){
                    if(Platforms[i].Position<R && Platforms[i].Direction==0){Platforms[i].Position++;}
                    else if(Platforms[i].Position>0 && Platforms[i].Direction==1){Platforms[i].Position--;}
                    else if(Platforms[i].Position==0 && Platforms[i].Direction==1){Platforms[i].Position++;Platforms[i].Direction=0;}
                    else if(Platforms[i].Position==R && Platforms[i].Direction==0){Platforms[i].Position--;Platforms[i].Direction=1;}
                    }
                Platforms[i].Progress=0;
                }
            }
    }
}

int main() {


PlatformStruct NewPlatform;

cin>>R>>C;

for(int i=0;i<R;i++){
cin>>NewPlatform.Type;
NewPlatform.RC='R';
NewPlatform.Position=0;
NewPlatform.Direction=0;
NewPlatform.Token=0;
cin>>NewPlatform.Progress;
NewPlatform.Progress*=(-1);
Platforms.push_back(NewPlatform);}

for(int i=0;i<C;i++){
cin>>NewPlatform.Type;
NewPlatform.RC='C';
NewPlatform.Position=0;
NewPlatform.Direction=0;
NewPlatform.Token=0;
cin>>NewPlatform.Progress;
NewPlatform.Progress*=(-1);
Platforms.push_back(NewPlatform);}

int a,b,c,d,e;

cin>>a>>b>>c>>d>>e;

for(int Time=0;Time<1000;Time++){
    if(Time==c){Positions.push_back(make_pair(b-1,a-1));}
    for(int i=0;i<Platforms.size();i++){
        if(i>=0 && i<R){
            for(int j=0;j<Positions.size();j++){
                if(Positions[j].first==i && Positions[j].second==Platforms[i].Position && Platforms[i].Token==0){Platforms[i].Token=1;}
            }
        }
        else{
            for(int j=0;j<Positions.size();j++){
                if(Positions[j].second==i-R && Positions[j].first==Platforms[i].Position && Platforms[i].Token==0){Platforms[i].Token=1;}
            }
        }

    if(Platforms[i].Token==1){
        if(i>=0 && i<R){Positions.push_back(make_pair(i,Platforms[i].Position));Map[i][Platforms[i].Position]=Min(Map[i][Platforms[i].Position],Time);}
        else{Positions.push_back(make_pair(Platforms[i].Position,i-R));Map[Platforms[i].Position][i-R]=Min(Map[Platforms[i].Position][i-R],Time);}
    }

    }
    MovePlatforms();
}


cout<<Map[e-1][d-1]<<endl;

//system("pause");
return 0;}
