/*
TASK:jori
LANG:C++
*/
#include <cstdio>
#include <string>
#include <vector>
#include <iostream>

using namespace std;

const int MAX_LEN = 1<<8;
const int MAX_COUNT = 200000 + 5;

string words[MAX_COUNT];
char cnt[MAX_COUNT][1<<5];
vector<int> curr, best;

int n;

void init (void) {
     n=0;
     while (getline(cin,words[n++]));
     --n;
     }

bool cmp (string a, string b) {
     return a.size()<b.size();
     }

void check (int x) {
     if (x>=n) return;
     int br;
     for (int i=x+1; i<n; ++i) {
         br=0;
         if (words[i].size()==words[x].size()) continue;
         for (int j=0; j<26; ++j) {
             if (cnt[i][j]<cnt[x][j]) { br=2; break; }
             br+=cnt[i][j]-cnt[x][j];
             if (br>1) break;
             }
         if (br==1) {
                    curr.push_back(i);
                    check(i);
                    if (curr.size()>best.size()) best=curr;
                    curr.pop_back();
                    }
         }
     }

void solve (void) {
     sort(words,words+n,cmp);
     for (int i=0; i<n; ++i)
         for (int j=0; j<words[i].size(); ++j)
             cnt[i][words[i][j]-'a']++;
     /*
     for (int i=0; i<n; ++i) {
         cout<<words[i]<<" ";
         for (int j=0; j<26; ++j)
             if (cnt[i][j]) cout<<(char)('a'+j)<<" "<<(int)cnt[i][j]<<" ";
         cout<<endl;
         }
     */
     for (int i=0; words[i].size()==3; ++i) {
         curr.push_back(i);
         check(i);
         if (curr.size()>best.size()) best=curr;
         curr.pop_back();
         }
     for (int i=0; i<best.size(); ++i)
         cout<<words[best[i]]<<endl;
     }

int main()
{
    init();
    solve();
    
return 0;
}

