/*
TASK: jori
LANG: C++
*/
// Iordan Boev
# include <stdio.h>
# include <string.h>
# define MAXW (1<<8)
# define MAXN (200002)
# define MAXL (1<<5)

int n;
struct words {
    char word[MAXW];
    int next, len;
} data[MAXN];
int pr[MAXN];
int ans[MAXN];
int current[MAXN];
int max;
int used[MAXN];
int prev[MAXN];
int letters[MAXL];

void read() {
    n = 1;
    while( scanf("%s", data[n].word) > 0) {
        data[n].len = strlen(data[n].word);
        data[n].next = pr[data[n].len];
        pr[data[n].len] = n;
        n++;        
    } 
}

int check(int a,int b) {
    //printf("\ncheck(%d,%d)=", a,b);
    for(int i = 0; i < MAXL; i++) letters[i] = 0;
    for(int i = 0; i < data[b].len; i++) letters[((int)data[b].word[i])-97]++;
    for(int i = 0; i < data[a].len; i++)
        if(letters[((int)data[a].word[i])-97] > 0) letters[((int)data[a].word[i])-97]--;
    int cnt=0;
    for(int i = 0; i < MAXL; i++) cnt+=letters[i];
    //printf("%d\n", cnt);
    if(cnt==1) return 1;
    return 0;
}

void print(int w) {
    if(prev[w] == 0) {
        printf("%s\n", data[w].word);
        return;
    }
    print(prev[w]);
    printf("%s\n", data[w].word);
}

void solve() {
    int queue[MAXN],start=0,end=0,level=0,step;
    step = 3;
    int p = pr[step];
    while(p > 0) {
        queue[end] = p;
        used[p] = 1;
        end++;
        p = data[p].next;
    }
    step++;
    level = end;
    while(start < end) {
        //printf("end = %d\n",end);
        for(int i = start; i < level; i++) {
            p = pr[step];
            //printf("%d ", queue[i]);
            while(p > 0) {
                if(used[p] == 0 && check(queue[i],p) == 1) {
                    queue[end] = p;
                    max = p;
                    used[p] = 1;
                    prev[p] = queue[i];
                    end++;
                }
                p = data[p].next;
            }            
        }
        step++;
        start = level;
        level = end;
    }
    print(max);
    //printf("\n%d\n", step);
    //for(int i = 1; i <= n; i++) printf("%d ", prev[i]);
    //printf("\n");
}

int main() {
    read();
    solve();
    return 0;
}
