/*
TASK: nobel
LANG: C++
*/
#include <cstdio>
#include <algorithm>
using namespace std;

typedef long long ll;

ll b , n , mod;

void read() {
	scanf ( "%lld%lld%lld" , &b , &n , &mod );
}

pair < ll , ll > go ( int n ) {
	if ( n == 1 ) return make_pair ( b , b );
	pair < ll , ll > ans;
	
	ans = go ( n >> 1 );
	ans.first = (ans.first + ans.first * ans.second) % mod;
	ans.second = (ans.second * ans.second) % mod;
	
	if ( n & 1 ) {
		ans.second = (ans.second * b) % mod;
		ans.first = (ans.first + ans.second) % mod;
	}
	
	return ans;
}

void solve() {
	b %= mod;
	printf ( "%lld\n" , (go ( n ).first + 1) % mod );
}

int main() {
	int cases;
	
	scanf ( "%d" , &cases );
	
	while ( cases -- ) {
		read();
		solve();
	}
	
	return 0;
}
