/*
TASK:platforms
LANG:C++
*/
#include <iostream>
#include <queue>
#include <vector>
using namespace std;
int tn[64];
int startn[64];
int tmy[64];
int startm[64];
int bx, by, bt, ex, ey;
int n, m;
int TIMEX1[4][64];
int TIMEX2[4][64];
int TIMEY1[4][64];
int TIMEY2[4][64];
struct point
{
	int x, y;
	int T;
};
int D[64][64];
int nx[] = {+1, -1, 0, 0};
int ny[] = {0, 0, +1, -1};
struct cmp
{
	bool operator ()(point p1, point p2)
	{
		return p1.T > p2.T;
	}
};


int main()
{
	memset(D, -1, sizeof(D));
	//scanf("%d%d\n", &n, &m);
	cin>>n>>m;
	int i, j;
	TIMEX1[1][1] =  TIMEX1[2][1] = TIMEX1[3][1] = 0; 
	for (i = 2;i<=m;i++) for (j = 1;j<=3;j++) TIMEX1[j][i] = TIMEX1[j][i-1] + j;
	
	for(j = 1;j<4;j++)TIMEX2[j][m] = TIMEX1[j][m];
	for (i = m-1;i>0;i--) for (j = 1;j<=3;j++) TIMEX2[j][i] = TIMEX2[j][i+1] + j;
	for(j = 1;j<4;j++)TIMEX1[j][1] = TIMEX2[j][1];
	
	TIMEY1[1][1] =  TIMEY1[2][1] = TIMEY1[3][1] = 0; 
	for (i = 2;i<=n;i++) for (j = 1;j<=3;j++) TIMEY1[j][i] = TIMEY1[j][i-1] + j;
	
	for(j = 1;j<4;j++) TIMEY2[j][n] = TIMEY1[j][n];
	
    for (i = n-1;i>0;i--) for (j = 1;j<=3;j++) TIMEY2[j][i] = TIMEY2[j][i+1] + j;
	for(j = 1;j<4;j++)TIMEY1[j][1] = TIMEY2[j][1];
	
	//for (i = 1;i<=n;i++)cout<<TIMEY2[3][i]<<" ";
	//cout<<endl;
	
	for(i = 1;i<=n;i++)
	{
		char c;
			//scanf("%c %d\n", &c,&startn[i]);
	cin>> c >> startn[i];
		if(c == 'F') tn[i] = 1;
	else
	if(c == 'S') tn[i] = 3;
	else
		tn[i] = 2; 
	}
	
	
	for(i = 1;i<=m;i++)
	{
		char c;
		//scanf("%c%d\n", &c,&startm[i]);
		cin>> c >> startm[i];
		if(c == 'F') tmy[i] = 1;
		else
			if(c == 'S') tmy[i] = 3;
		else
			tmy[i] = 2; 
	}

	cin>>bx>>by>>bt>>ex>>ey;
	priority_queue<point, vector<point>, cmp> q;

	point r;
	r.x = bx;
	r.y = by;
	r.T = bt;
	q.push(r);
	
	while (!q.empty())
	{
		point temp = q.top();
		q.pop();
		//cout<<temp.x<<" "<<temp.y<<" "<<temp.T<<endl;
		if(D[temp.x][temp.y] !=-1 && D[temp.x][temp.y] < temp.T) continue;
		
		
for(i = 0;i<4;i++)
	{
		point k;
		k.x = temp.x + nx[i];
		k.y = temp.y + ny[i];
		if(k.x < 1 || k.x > n || k.y > m || k.y <1) continue;
			
		if(temp.x!=k.x)
		{
			//cout <<TIMEY1[tmy[k.y]][k.x]<<" "<<tmy[k.y]<<" "<<k.x<<endl;
			
			int coef = (temp.T - startm[k.y]);
			if(coef <=0) coef = startm[k.y];
			k.T = coef / TIMEY1[tmy[k.y]][k.x] + ((coef%TIMEY1[tmy[k.y]][k.x])!=0); 
			k.T *= TIMEY1[tmy[k.y]][k.x]; k.T += startm[k.y];
			
			if(D[k.x][k.y] == -1 || k.T < D[k.x][k.y]) {D[k.x][k.y] = k.T; q.push(k);}
			
			//cout <<TIMEY2[tmy[k.y]][k.x]<<endl;
			k.T = coef / TIMEY2[tmy[k.y]][k.x] + ((coef%TIMEY2[tmy[k.y]][k.x])!=0); 
			k.T *= TIMEY2[tmy[k.y]][k.x]; k.T += startm[k.y];
			
			if(D[k.x][k.y] == -1 || k.T < D[k.x][k.y]){D[k.x][k.y] = k.T; q.push(k);}	
		}
		else
		{
			int coef = (temp.T - startn[k.x]);
			if(coef <= 0) coef = startn[k.x]; 
			//cout <<TIMEX1[tn[k.x]][k.y]<<" "<<tn[k.x]<<" "<<k.y<<endl;
			k.T = coef / TIMEX1[tn[k.x]][k.y] + ((coef%TIMEX1[tn[k.x]][k.y])!=0); 
			k.T *= TIMEX1[tn[k.x]][k.y]; k.T += startn[k.x];
			
			if(D[k.x][k.y] == -1 || k.T < D[k.x][k.y]){D[k.x][k.y] = k.T; q.push(k);}
			
			//cout <<TIMEX2[tn[k.x]][k.y]<<" t "<<tn[k.x]<<" "<<k.y<<endl;
			
			k.T = (temp.T - startn[k.x]) / TIMEX2[tn[k.x]][k.y] + (((temp.T - startn[k.x])%TIMEX2[tn[k.x]][k.y])!=0); 
			k.T *= TIMEX2[tn[k.x]][k.y]; k.T += startn[k.x];
			
			if(D[k.x][k.y] == -1 || k.T < D[k.x][k.y]){D[k.x][k.y] = k.T; q.push(k);}	
		}
			
		
	}
			
	}
	
	printf("%d\n", D[ex][ey]);
	return 0;
}
