/*
TASK: jori
LANG: C++
*/
#include <cstdio>
#include <string>
#include <cstring>
#include <vector>

using namespace std;
vector < string > stor;
vector < vector <int> > G;
vector < vector <unsigned char> > F;
vector < vector <int> > R;
char u[32];
int lev;

void input()
{
     char s[256];
     int i,l=0,x;
     stor.reserve(100000);
     while (!feof(stdin)) {
           scanf("%s\n",s);
           stor.push_back(string(s));
           x = strlen(s);
           if (x > l) l = x;
           }
     G.resize(l+2);
     F.resize(l+2);
     R.resize(l+2);
     for (i=0;i<stor.size();++i) {
         x = stor[i].length();
         G[x].push_back(i);
         F[x].push_back(0);
         R[x].push_back(-1);
         }
}

inline char OK(int p, int q)
{
     int i; char qq=0;
     memset(u,0,32*sizeof(char));
     for (i=0;i<lev;++i) ++u[stor[G[lev][p]][i]-'a'];
     for (i=0;i<lev+1;++i) --u[stor[G[lev+1][q]][i]-'a'];
     for (i=0;i<31;++i) {
         if (u[i]) ++qq;
         if (qq > 1) return 0;
         }
     return 1;
}

void dfs(int pos)
{
     unsigned char r=0;
     int i,rr=-1;
     for (i=0;i<G[lev+1].size();++i) if (OK(pos,i)) {
         if (F[lev+1][i] == 0) {++lev;dfs(i);--lev;}
         if (F[lev+1][i] > r) {r = F[lev+1][i]; rr = i;}
         }
     R[lev][pos] = rr;
     F[lev][pos] = r+1;
}

void solve()
{
     int i,r=0,rr=-1;
     for (i=0;i<G[3].size();++i) {
         lev=3;dfs(i);
         if (F[3][i] > r) {r=F[3][i]; rr = i;}
         }
     i = 3;
     while (rr != -1) {
           printf("%s\n",stor[G[i][rr]].c_str());
           rr = R[i][rr]; ++i;
           }
}

int main()
{
    input();
    solve();
    return 0;
}
