/*
TASK:jori
LANG:C++
*/

#include <iostream>
#include <cstdio>
using namespace std;

const int MAXW = 200000;
const int MAXL = 64;

struct pairw {
  char s1[MAXL];
  char s2[MAXL];
  int bestl;
  int prev;
};

pairw work[MAXW];

int cmp1(const void* w1, const void *w2)
{
 char* a = ((pairw*)w1) -> s2;
 char* b = ((pairw*)w2) -> s2;
 int l1 = strlen(a), l2 = strlen(b);
 if (l1 != l2) return l2 - l1;
 else return strcmp(a, b);
}

int cmp2(const void* w1, const void *w2)
{
 char* a = ((char*)w1);
 char* b = ((pairw*)w2) -> s2;
 int l1 = strlen(a), l2 = strlen(b);
 if (l1 != l2) return l2 - l1;
 else return strcmp(a, b);
}

int main()
{
 char tempW[MAXL]; int br = 0;
 while (scanf("%s", tempW) != -1)
 {
  if (strlen(tempW) >= 3)
  {
   strcpy(work[br].s1, tempW);
   sort(tempW, tempW + strlen(tempW));
   strcpy(work[br].s2, tempW);
   work[br].bestl = 0;
   work[br].prev = -1;
   br++;
  }
 }
 
 qsort(work, br, sizeof(pairw), cmp1); 
 
 /*for (int i = 0; i < br; i++)
  printf("%s\n", work[i].s2);
 printf("\n");*/
  
 for (int i = 0; i < br; i++)
 {
  int len = strlen(work[i].s2);
  char newWord[len];
  newWord[len - 1] = '\0';
  for (int j = 0; j < len; j++)
  {
   int ind = 0;
   for (int k = 0; k < j; k++)    
    newWord[ind++] = work[i].s2[k]; 
   for (int k = j + 1; k < len; k++)    
    newWord[ind++] = work[i].s2[k]; 
   pairw* wh = (pairw*)bsearch(newWord, work, br, sizeof(pairw), cmp2);
   if (wh == NULL) continue;
   if (work[i].bestl + 1 > wh -> bestl)
   {
    wh -> bestl = work[i].bestl + 1;
    wh -> prev = i;
   }   
  }
 } 
 
 /*for (int i = 0; i < br; i++)
  printf("%d\n", work[i].bestl);*/
 
 int ans = -1, ind = -1;
 
 for (int i = 0; i < br; i++)
  if (strlen(work[i].s2) == 3 && work[i].bestl > ans)
  {
   ind = i;
   ans = work[i].bestl;
  }
  
 if (ind != -1)
 {
  printf("%s\n", work[ind].s1);
  int cur = ind;
  for (;;)
  {
   cur = work[cur].prev;
   if (cur == -1) break;
    printf("%s\n", work[cur].s1);
  } 
 }
 
 //system("pause"); //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 return 0;
}
 
