/*
TASK:nobel
LANG:C++
*/

#include <iostream>
#include <cstdio>
using namespace std;

typedef long long LL;

LL MOD;

LL quick(LL num, LL pow)
{
 if (pow == 0) return 1;
 if (pow % 2 == 0)
 {
  LL temp = quick(num, pow / 2) % MOD;
  temp = (temp * temp) % MOD;
  return temp;
 }
 else
 {
  LL temp = (num % MOD) * (quick(num, pow - 1) % MOD);
  temp %= MOD;
  return temp;
 }
}

LL solve(LL b, LL n, LL k)
{
 MOD = k;
 LL temp = quick(b, n + 1) - (1 % MOD);
 int ret = temp;
 if (ret < 0) ret = b + 1;
 return ret;
}

int main()
{
 int Q; scanf("%d", &Q);
 
 for (int T = 0; T < Q; T++)
 {
  LL b, n, k;
  scanf("%lld %lld %lld", &b, &n, &k);
  printf("%d\n", solve(b, n, k));
 }
 
 return 0;
}
 
