/*
TASK:jori
LANG:C++
*/

#include <cstdio>
#include <cstring>
#include <iostream>
#include <algorithm>
#define FOR(q, x) for(q = 1; q <= int(x); i++)
#define FOR0(q, x) for(q = 0; q < int(x); q++)
using namespace std;

const int MAXSIZE = 10 * (1 << 20);
const int WORDS = 1 << 18;
const int WORDSIZE = 1 << 8;
int MAX_REACHED = 0;

char T[MAXSIZE];
char* p[WORDS];
int i, j, n;

struct A {
    char *s;
    char c[26];
    int size;
} a[WORDS];

int beg[WORDS], end[WORDS];
int q[WORDS], sq[WORDS], br, sbr, best;

bool cmp(A x, A y) {
    return x.size < y.size;
}


bool f;
bool check(int x, int y) {
    //printf("\n[%d %d]\n", x, y);
//    if (a[x].size != a[y].size + 1) return 0;
    f = 0;
    FOR0(j, 26) {
        if (a[x].c[j] != a[y].c[j]) {
            if (f) return 0;
            else f = 1;
        }
    }
    return 1;
}

void printAnswer() {
    FOR(i, sbr) printf("%s\n", a[sq[i]].s);
}

void rec(int m) {
    //printf("->%d\n", m);
    if (beg[m] == 0) {
        if (m - 1 > best) {
            best = m - 1;
            memcpy(sq, q, (br + 1) * sizeof(int));
            sbr = br;
        }
        
        MAX_REACHED = 1;
        printAnswer();
        exit(0);
    }
    
    int ii;
    bool ff = 0;
    for (ii = beg[m]; ii <= end[m]; ii++)
        if (check(q[br], ii)) {
            ff = 1;
            q[++br] = ii;
            //printf("(%s)", a[ii].s);
            rec(m + 1);
            br--;
        }
    
    if (!ff) {
        if (m > best) {
            best = m - 1;
            memcpy(sq, q, (br + 1) * sizeof(int));
            sbr = br;
        }
    }
}

void solve() {
    sort(a + 1, a + n + 1, cmp);
    FOR(i, n) {
        //printf("%d: %s\n", i, a[i].s);
        if (!beg[a[i].size]) beg[a[i].size] = i;
        end[a[i].size] = i;
    }
    
    for (i = beg[3]; i <= end[3]; i++) {
        q[1] = i; br = 1;
        rec(4);
    }
    
    // print answer
    FOR(i, sbr) printf("%s\n", a[sq[i]].s);
}

void input() {
    //freopen("jori.inp", "rt", stdin);
    //freopen("jori.out", "wt", stdout);
    
    char word[WORDSIZE];
    int len = 0, length;
    
    while (scanf("%s", &word) != EOF) {
        length = strlen(word);
        for (i = 0; i <= length; i++) T[len + i] = word[i];
        
        p[++n] = T + len;
        a[n].size = length;
        
        len += length + 1;
    }
    
    for (i = 1; i <= n; i++) {
        //printf("%s\n", p[i]);
        a[i].s = p[i];
        for (j = 0; j < a[i].size; j++) a[i].c[a[i].s[j] - 'a']++;
    }
    
}

int main() {
    input();
    solve();
    return 0;
}
