/*
TASK:platforms
LANG:C++
*/
#include<iostream>
#include<cstdio>
#include<queue>
using namespace std;

struct el
{
       int v1,v2,d;
       bool operator < (const el &p) const{
            return d>p.d;
       }
};
priority_queue<el> q;

struct vlak
{
    int x,y;
};

int n,m,d[64][64];
vlak a[2][64];

void dijkstra(int x1,int y1,int z)
{
     int tmp,res;
     el p,t;
     int i,j;
     for(i=1;i<=n;i++)
      for(j=1;j<=m;j++)
       d[i][j]=-1;
     p.d=z;
     p.v1=x1;
     p.v2=y1;
     q.push(p);
     d[x1][y1]=z;
     while(!q.empty())
     {
      p=q.top();
      q.pop();
      if(p.d>d[p.v1][p.v2])continue;
      if(p.v1>1)
      {
            tmp=p.d-a[1][p.v2].y;
            if(tmp<0)tmp=0;
            res=(n*2-2)*a[1][p.v2].x;
            tmp=res*(tmp/res)+a[1][p.v2].y;
            if((n*2-p.v1-1)*a[1][p.v2].x+tmp>=p.d)tmp+=(n*2-p.v1-1)*a[1][p.v2].x;
            else tmp+=(n*2-p.v1-1)*a[1][p.v2].x+res;
            if((d[p.v1-1][p.v2]==-1)||(tmp+a[1][p.v2].x<d[p.v1-1][p.v2]))
            {
                d[p.v1-1][p.v2]=tmp+a[1][p.v2].x;
                t.d=d[p.v1-1][p.v2];
                t.v1=p.v1-1;
                t.v2=p.v2;
                q.push(t);
            }
      }
      if(p.v1<n)
      {
            tmp=p.d-a[1][p.v2].y;
            if(tmp<0)tmp=0;
            res=(n*2-2)*a[1][p.v2].x;
            tmp=res*(tmp/res)+a[1][p.v2].y;
            if((p.v1-1)*a[1][p.v2].x+tmp>=p.d)tmp+=(p.v1-1)*a[1][p.v2].x;
            else tmp+=(p.v1-1)*a[1][p.v2].x+res;
            if((d[p.v1+1][p.v2]==-1)||(tmp+a[1][p.v2].x<d[p.v1+1][p.v2]))
            {
                d[p.v1+1][p.v2]=tmp+a[1][p.v2].x;
                t.d=d[p.v1+1][p.v2];
                t.v1=p.v1+1;
                t.v2=p.v2;
                q.push(t);
            }
      }
      if(p.v2>1)
      {
            tmp=p.d-a[0][p.v1].y;
            if(tmp<0)tmp=0;
            res=(m*2-2)*a[0][p.v1].x;
            tmp=res*(tmp/res)+a[0][p.v1].y;
            if((m*2-p.v2-1)*a[0][p.v1].x+tmp>=p.d)tmp+=(m*2-p.v2-1)*a[0][p.v1].x;
            else tmp+=(m*2-p.v2-1)*a[0][p.v1].x+res;
            if((d[p.v1][p.v2-1]==-1)||(tmp+a[0][p.v1].x<d[p.v1][p.v2-1]))
            {
                d[p.v1][p.v2-1]=tmp+a[0][p.v1].x;
                t.d=d[p.v1][p.v2-1];
                t.v1=p.v1;
                t.v2=p.v2-1;
                q.push(t);
            }
      }
      if(p.v2<m)
      {
            tmp=p.d-a[0][p.v1].y;
            if(tmp<0)tmp=0;
            res=(m*2-2)*a[0][p.v1].x;
            tmp=res*(tmp/res)+a[0][p.v1].y;
            if((p.v2-1)*a[0][p.v1].x+tmp>=p.d)tmp+=(p.v2-1)*a[0][p.v1].x;
            else tmp+=(p.v2-1)*a[0][p.v1].x+res;
            if((d[p.v1][p.v2+1]==-1)||(tmp+a[0][p.v1].x<d[p.v1][p.v2+1]))
            {
                d[p.v1][p.v2+1]=tmp+a[0][p.v1].x;
                t.d=d[p.v1][p.v2+1];
                t.v1=p.v1;
                t.v2=p.v2+1;
                q.push(t);
            }
      }
      
     }
}

int main()
{
    int x1,y1,z,x2,y2;
    char ch;
    int i,j;
    cin>>n>>m;
    for(i=1;i<=n;i++)
    {
     cin>>ch>>a[0][i].y;
     if(ch=='F')a[0][i].x=1;
     if(ch=='O')a[0][i].x=2;
     if(ch=='S')a[0][i].x=3;
    }
    for(i=1;i<=m;i++)
    {
     cin>>ch>>a[1][i].y;
     if(ch=='F')a[1][i].x=1;
     if(ch=='O')a[1][i].x=2;
     if(ch=='S')a[1][i].x=3;
    }
    cin>>x1>>y1>>z>>x2>>y2;
    dijkstra(x1,y1,z);
    cout<<d[x2][y2]<<"\n";
}
