/*
TASK: nobel
LANG: C++
*/
#include <iostream>
using namespace std;

long long pow(long long x, long long n, long long k)
{
    if (n == 0) return 1;
    if (n%2) return (pow(x, n-1, k)*x)%k;
    return pow((x*x)%k, n/2, k)%k;
}

long long solve(long long b, long long n, long long k)
{
    if (n == 1) return 1;
    return ((long long)solve(b, n/2, k) + pow(b, n/2, k)*solve(b, n - n/2, k))%k;
}

int main()
{
    long long Q;
    cin >> Q;
    for (long long q = 0; q < Q; q++)
    {
        long long b, n, k;
        cin >> b >> n >> k;
        cout << solve(b, n + 1, k) << endl;
    }
    return 0;
}
