/*
TASK: platforms
LANG: C++
*/
#include <iostream>
#include <queue>
using namespace std;

bool DP[ 50 ][ 50 ][ 9 * 50 * 50 ];

int rT[50], rS[50], cT[50], cS[50];
int pos(int Tone, int L, int time, int start)
{
    if (time < start) return -1;
    
    time -= start;
    int pos = ( time/Tone ) % (2*L-2);
    if (pos >= L) pos = L-1 - (pos - (L-1));
    return pos;
}

queue<int> q;

void add(int a, int b, int c)
{
     if (DP[a][b][c]) return;
     
     DP[a][b][c] = 1;
     q.push(a), q.push(b), q.push(c);
}

int main()
{
    int N, M;
    cin >> N >> M;
    
    for (int i = 0; i < N; i++)
    {
        char a; cin >> a >> rS[i];
        if (a == 'O') rT[i] = 2;
        if (a == 'F') rT[i] = 1;
        if (a == 'S') rT[i] = 3;
    }
    for (int i = 0; i < M; i++)
    {
        char a; cin >> a >> cS[i];
        if (a == 'O') cT[i] = 2;
        if (a == 'F') cT[i] = 1;
        if (a == 'S') cT[i] = 3;
    }
    
    int si, sj, fi, fj, T;
    cin >> sj >> si >> T >> fj >> fi; --si, --sj, --fi, --fj;
    
    add(si, sj, T);
    
    //for (int i = 0; i < M; i++) cout << cT[i] << " " << cS[i] << endl;
    //return 0;
    while (!q.empty())
    {
          int i = q.front(); q.pop();
          int j = q.front(); q.pop();
          int t = q.front(); q.pop();
          if (t >= 9*M*N) break;
          //cout << i << " " << j << " " << t << endl;
          
          if (i == fi && j == fj) { cout << t << endl; return 0; }
          
          //stay
          add(i, j, t + 1);
          //try to move
          if (pos(rT[i], M, t, rS[i]) == j && (t + 1 - rS[i])%rT[i] == 0)
          {
                  int p = ((t - rS[i])/rT[i])%(2*M - 2);
                  int ad = 0;
                  if (p < M-1) ad = 1;
                  else ad = -1;
                  
                  add(i, j + ad, t + 1);
          } 
          if (pos(cT[j], N, t, cS[j]) == i && (t + 1 - cS[j])%cT[j] == 0)
          {
                  int p = ((t - cS[j])/cT[j])%(2*N - 2);
                  int ad = 0;;
                  if (p < N - 1) ad = 1;
                  else ad = -1;
                  
                  add(i + ad, j, t + 1);
          }
    }
    cout << -1 << endl;
    return 0;
}
