//Ivaylo Penkov Riskov
//Plovdiv
//11-12 klas

#include <stdio.h>
#include <math.h>
#include <values.h>

double a[20][2], b[20][2], c[20][2];
int count;

int getside(double x1, double y1, double x2, double y2, double x, double y) {
	double temp;

	temp = x*(y1-y2)+(x2-x1)*y+x1*y2-y1*x2;
	if (temp > 0.000000001)
		return 1;
	if (temp < -0.0000000001)
		return -1;
	return 0;
}

int presicha(double x1, double y1, double x2, double y2, int tr) {

	if (getside(x1,y1,x2,y2,a[tr][0],a[tr][1])*
	    getside(x1,y1,x2,y2,b[tr][0],b[tr][1]) < 0 &&
	    getside(a[tr][0],a[tr][1],b[tr][0],b[tr][1],x1,y1)*
	    getside(a[tr][0],a[tr][1],b[tr][0],b[tr][1],x2,y2) < 0)
	    	return 1;

	if (getside(x1,y1,x2,y2,a[tr][0],a[tr][1])*
	    getside(x1,y1,x2,y2,c[tr][0],c[tr][1]) < 0 &&
	    getside(a[tr][0],a[tr][1],c[tr][0],c[tr][1],x1,y1)*
	    getside(a[tr][0],a[tr][1],c[tr][0],c[tr][1],x2,y2) < 0)
	    	return 2;

	if (getside(x1,y1,x2,y2,b[tr][0],b[tr][1])*
	    getside(x1,y1,x2,y2,c[tr][0],c[tr][1]) < 0 &&
	    getside(b[tr][0],b[tr][1],c[tr][0],c[tr][1],x1,y1)*
	    getside(b[tr][0],b[tr][1],c[tr][0],c[tr][1],x2,y2) < 0)
	    	return 3;

	return 0;
}

int p;

double getdist(double x1, double y1, double x2, double y2, int t) {
	double min = MAXDOUBLE;
	double m;
	int i, pr = 0;

	for (i = 0; i < count; i++) {
		if (presicha(x1,y1,x2,y2,i)) {
                	pr = 1;
                	if (t==i)
                        	break;
			m = getdist(x1,y1,a[i][0],a[i][1],i);
			m += getdist(a[i][0], a[i][1], x2, y2,i);
			if (min - m > 0.000000001)
				min = m;
			m = getdist(x1,y1,b[i][0],b[i][1],i);
			m += getdist(b[i][0], b[i][1], x2, y2,i);
			if (min - m > 0.000000001)
				min = m;
			m = getdist(x1,y1,c[i][0],c[i][1],i);
			m += getdist(c[i][0], c[i][1], x2, y2,i);
			if (min - m > 0.000000001)
				min = m;
		}
	}
	if (pr)
		return min;
	else
		return sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2));
}

int main() {
    FILE *f;
    int i;
    double p1x,p2x,p1y,p2y;

    f = fopen("short.inp", "rt");
    fscanf(f, "%i", &count);
    for (i = 0; i <count; i++)
        fscanf(f, "%lf %lf %lf %lf %lf %lf",
	  &a[i][0], &a[i][1], &b[i][0], &b[i][1], &c[i][0], &c[i][1]);
    fscanf(f, "%lf %lf %lf %lf", &p1x, &p1y, &p2x, &p2y);
    fclose(f);

    f = fopen("short.out", "wt");
    fprintf(f, "%.8lf\n", getdist(p1x, p1y, p2x, p2y,count));
    fclose(f);
    return 0;
}
