{Ludmil Antonov
Grad: Plovdiv
Grupa :4 }
const strInpFile='genom.inp';
const strOutFile='genom.out';
var arData: Array[1..100] of STRING[255];
    arOutData: Array[1..1000] of Integer;
    arCheckData:Array[1..1000] of BOOLEAN;
    uCheckLetterPos,uGenomNum:WORD;
    uCurrentGen,uCurrentPos:WORD;
    uN:WORD;
    bForward,bCurrentSide,bEqual:BOOLEAN;
    BeginingEl,EndingEl:WORD;

procedure ReadData;
     var ffile:TEXT;
         uCount:WORD;
        begin
           Assign(ffile,strInpFile);
           reset(ffile);
           readln(ffile,uN);
           bEqual:=TRUE;
           for uCount:=1 to uN do
             begin
                 readln(ffile,arData[uCount]);
                 arCheckData[uCount]:=TRUE;
             end;

           close(ffile);
        end;

procedure WriteData;
     var ffile:TEXT;
         uCount:WORD;
        begin
           Assign(ffile,strOutFile);
           rewrite(ffile);

           while arOutData[uCount]<>0 do
               begin
                  write(ffile,arOutData[uCount]);
                  uCount:=uCount+1;
               end;

           close(ffile);
        end;

function ValidateGenoms(CurrentGen,CheckGen,CurrentPos,CheckPos:WORD;forth:BOOLEAN):BOOLEAN;
     var CurrentStep,CheckStep:INTEGER;
         RealCurrentLength,RealCheckLength:WORD;
        begin
           RealCurrentLength:=length(arData[CurrentGen]);
           RealCheckLength:=length(arData[CheckGen]);

           if bForward then
             CurrentStep:=1
           else
             CurrentStep:=-1;

           if forth then
                CheckStep:=1
           else
                CheckStep:=-1;

           while ((CurrentPos>0)and(CurrentPos<RealCurrentLength)) and
                 ((CheckPos>0)and(CheckPos<RealCheckLength)) do
              begin
                 if arData[CurrentGen][CurrentPos]=arData[CheckGen][CheckPos] then
                   begin
                      CurrentPos:=CurrentPos+CurrentStep;
                      CheckPos:=CheckPos-CheckStep;
                   end
                 else
                   begin
                     ValidateGenoms:=FALSE;
                     exit;
                   end;
              end;


           if  (bCurrentSide) then
             begin
                arOutData[BeginingEl]:=CurrentGen;
                arOutData[EndingEl]:=CheckGen;
             end
           else
             begin
                arOutData[BeginingEl]:=CheckGen;
                arOutData[EndingEl]:=CurrentGen;
             end;

           ValidateGenoms:=TRUE;
           if ((CurrentPos=0)or(CurrentPos=RealCurrentLength))and
              ((CurrentPos=0)or(CurrentPos=RealCurrentLength)) then
             begin
                BeginingEl:=BeginingEl+1;
                EndingEl:=EndingEl-1;

                arCheckData[CheckGen]:=FALSE;
                arCheckData[CurrentGen]:=FALSE;

                bEqual:=TRUE;
             end;

           if (CurrentPos=0)or(CurrentPos=RealCurrentLength) then
             begin
                uCurrentGen:=CheckGen;
                uCurrentPos:=CheckPos;
                arCheckData[CheckGen]:=FALSE;

                if (bCurrentSide) then
                  begin
                     arOutData[BeginingEl]:=CurrentGen;

                     BeginingEl:=BeginingEl+1
                  end
                else
                  begin
                     arOutData[EndingEl]:=CurrentGen;

                     EndingEl:=EndingEl-1;
                  end;

                bCurrentSide:=not(bCurrentSide);
             end
           else
             begin
                uCurrentGen:=CurrentGen;
                uCurrentPos:=CurrentPos;
                arCheckData[CurrentGen]:=FALSE;

                if not(bCurrentSide) then
                  begin
                     arOutData[BeginingEl]:=CheckGen;
                     BeginingEl:=BeginingEl+1
                  end
                else
                  begin
                     arOutData[EndingEl]:=CheckGen;
                     EndingEl:=EndingEl-1;
                  end;
             end;
        end;

procedure FindGenom;
     var uCount:WORD;
        begin
           BeginingEl:=1;
           EndingEl:=uN;
           while BeginingEl<EndingEl do
              begin
                 if (bEqual) then
                   begin
                      bEqual:=FALSE;
                      uCurrentGen:=1;

                      while not(arCheckData[uCurrentGen]) do
                        uCurrentGen:=uCurrentGen+1;

                      bCurrentSide:=TRUE;
                      uCurrentPos:=1;
                   end;

                 for uCount:=1 to uN do
                   if (arCheckData[uCount])and(uCount<>uCurrentGen) then
                     begin
                        if arData[uCurrentGen][uCurrentPos]=arData[uCount][1] then
                          if ValidateGenoms(uCurrentGen,uCount,uCurrentPos,1,TRUE) then
                            begin
                                break;
                            end;

                        if arData[uCurrentGen][uCurrentPos]=arData[uCount][length(arData[uCount])] then
                          if ValidateGenoms(uCurrentGen,uCount,uCurrentPos,length(arData[uCount]),FALSE) then
                            begin
                               break;
                            end;
                     end;

                   if uCount=uN then
                     begin
                        uCurrentGen:=uCurrentGen+1;
                        while not(arCheckData[uCurrentGen]) do
                          uCurrentGen:=uCurrentGen+1;
                     end;

              end;
     end;

begin
   ReadData;
   FindGenom;
   WriteData;
end.