/*
NAME: Ivan Anev
SCHOOL: SMG
CITY: Sofia
PROBLEM: comp
CLASS: 11-12
*/

#include <stdio.h>
#include <limits.h>

#define MAXN 300

int max(int a, int b) {
    return ((a > b) ? a : b);
}

int one(int n) {
    int c;

    c = 0;
    while (n > 0) {
          if (n % 2)
             c++;
          n /= 2;
    }

    return c;
}

int g[MAXN][MAXN], b[MAXN][MAXN];

int main(void) {
    FILE *fin, *fout;
    int n, k;
    int a[MAXN];
    int i, j, p, x, c, t;
    int stack[MAXN], sp;

    fin = fopen("comp.inp", "r");
    fout = fopen("comp.out", "w");

    fscanf(fin, "%d %d\n", &n, &k);
    for (i = 0; i < n; ++i) {
        fscanf(fin, "%d", &x);
        c = one(x);
        if (a == 0)
           a[i] = c;
        else
            a[i] = a[i-1] + c;
    }

    g[0][0] = a[0];
    b[0][0] = -1;
    for (i = 1; i < n; ++i) {
        g[0][i] = INT_MAX;
        g[i][0] = a[i];
        b[0][i] = b[i][0] = -1;
    }
    for (i = 1; i < n; ++i)
        for (j = 1; j < k; ++j) {
            g[i][j] = INT_MAX;
            if (i >= j) {
               for (p = j - 1; p < i; ++p) {
                   t = max(g[p][j-1], a[i] - a[p]);
                   if (t < g[i][j]) {
                      g[i][j] = t;
                      b[i][j] = p;
                   }
               }
            }
        }

    sp = 0;
    i = n - 1;
    j = k - 1;
    while (b[i][j] != -1) {
          stack[sp++] = i - b[i][j];
          i = b[i][j];
          j--;
          if (j == 0)
             stack[sp++] = i + 1;
    }

    fprintf(fout, "%d\n", g[n-1][k-1]);
    fprintf(fout, "%d", stack[--sp]);
    while (sp-- > 0)
          fprintf(fout, " %d", stack[sp]);
    fprintf(fout, "\n");

    fclose(fin);
    fclose(fout);

    return 0;
}
