/*
NAME: Ivan Anev
SCHOOL: SMG
CITY: Sofia
PROBLEM: genom
CLASS: 11-12
*/

#include <stdio.h>
#include <string.h>

#define MAXN 1000
#define MAXLEN 256

FILE *fin, *fout;
char str[MAXN][MAXLEN];
char rev[MAXN][MAXLEN];
char v[MAXN];
int n;
int stack[MAXN], sp, list[MAXN], lp;

void reverse(int idx) {
     int i, l;

     l = strlen(str[idx]);
     for (i = 0; i < l; ++i)
         rev[idx][l - i - 1] = str[idx][i];
     rev[idx][i] = '\0';
}

void reve(char s[], char s2[]) {
     int i, l;

     l = strlen(s);
     for (i = 0; i < l; ++i) {
         s2[i] = s[l-i-1];
     }
     s2[l] = '\0';
}

int cmp(char s1[], char s2[], char d[]) {
    int i, j;

    i = 0;
    while (s1[i] && s2[i] && s1[i] == s2[i])
          ++i;
    if (i == 0)
       return 0;
    else {
         if (s1[i] == '\0') {
            if (s2[i] == '\0')
               d[0] = '\0';
            else {
                 j = 0;
                 while (s2[i])
                       d[j++] = s2[i++];
                 d[j] = '\0';
            }
            return 2;
         }
         else if (s2 == '\0') {
              j = 0;
              while (s1[i])
                    d[j++] = s1[i++];
              d[j] = '\0';
              return 1;
         }
         else
             return 0;
    }
}

void conct(char s1[], char s2[]) {
     int i, j;

     i = 0;
     while (s1[i])
           ++i;
     j = 0;
     while (s2[j])
           s1[i++] = s2[j++];
     s1[i] = '\0';
}

int is_palin(char s[]) {
    int l, i;

    l = strlen(s);
    for (i = 0; i < l / 2 && s[i] == s[l-1-i]; ++i)
        ;
    return (i == l / 2);
}

int test(char s[], int w) {
    int i, j, l, r, c, idx;
    char t[2*MAXLEN], d[MAXLEN], s2[MAXLEN];

    reve(s, s2);
    c = 0;
    for (i = 0; i < n; ++i)
        if (v[i] == 0) {
           ++c;
           idx = i;
        }
    if (c == 0)
       return 0;
    if (c == 1) {
       if (is_palin(str[idx])) {
          stack[sp++] = idx + 1;
          return 0;
       }
       else
           return 1;
    }

    for (i = 0; i < n; ++i) {
        if (v[i] == 0) {
           v[i] = 1;
           l = strlen(s);
           strcpy(t, s);
           if (w == 1) {
              conct(t, str[i]);
           }
           for (j = 0; j < n; ++j)
               if (i != j && v[j] == 0) {
                  if (w == 2) {
                     t[l] = '\0';
                     conct(t, str[j]);
                  }
                  r = (w == 1 ? cmp(t, str[j], d) : cmp(str[i], t, d));
                  if (r != 0) {
                     v[j] = 1;
                     if (test(d, r) == 0) {
                        list[lp++] = -j - 1;
                        stack[sp++] = i + 1;
                        return 0;
                     }
                     v[j] = 0;
                  }
               }
               
           if (w == 1) {
              t[l] = '\0';
              conct(t, rev[i]);
           }
           for (j = 0; j < n; ++j)
               if (i != j && v[j] == 0) {
                  if (w == 2) {
                     strcpy(t, str[j]);
                     conct(t, s2);
                  }
                  r = (w == 1 ? cmp(t, str[j], d) : cmp(rev[i], t, d));
                  if (r != 0) {
                     v[j] = 1;
                     if (test(d, r) == 0) {
                        list[lp++] = (w == 1 ? (-j - 1) : (j+1));
                        stack[sp++] = (w == 1 ? (-i - 1) : (i+1));
                        return 0;
                     }
                     v[j] = 0;
                  }
               }
           v[i] = 0;
        }
    }

    return 1;
}

int main(void) {
    int i;
    char d[MAXLEN];

    fin = fopen("genom.inp", "r");
    fout = fopen("genom.out", "w");

    fscanf(fin, "%d\n", &n);
    for (i = 0; i < n; ++i) {
        fscanf(fin, "%s\n", str[i]);
        reverse(i);
    }

    sp = lp = 0;
    i = test("\0", 1);
    while (sp-- > 0)
          fprintf(fout, "%d\n", stack[sp]);
    for (i = 0; i < lp; ++i)
        fprintf(fout, "%d\n", list[i]);

    fclose(fin);
    fclose(fout);
    
    return 0;
}
