//Nedqlko Krasimirov Borisov ot Shoumen

#include <stdio.h>
#include <math.h>

typedef struct point {double x,y;} point;
point p[70];
int n;
int ots[70][2];
double m[128][128];



  double razst(double q,double w,double e,double r)
       {
        return pow((pow((q-e),2) + pow((w-r),2)),0.5);
       };

   long orient(int i,int j,int k)
     {
      return long (p[i].x * p[j].y + p[j].x * p[k].y + p[k].x * p[i].y - p[i].x * p[k].y - p[j].x * p[i].y -  p[k].x * p[j].y);
     };

       

int main()
{
 FILE *f = fopen("short.inp","r");
     fscanf(f,"%d\n",&n);
     int i;
     for (i=0;i<3*n;i++)
       {
       fscanf(f,"%lf %lf",&p[i].x,&p[i].y);
       if (i % 3 == 2)
          {ots[i][0] = i; ots[i][1] = i-2;}
         else {ots[i][0] = i;ots[i][1] = i+1;};
       };
     if (n != -1) fscanf(f,"%lf %lf %lf %lf",&p[3*n].x,&p[3*n].y,&p[3*n+1].x,&p[3*n+1].y);
       else fscanf(f,"%lf %lf %lf %lf",&p[0].x,&p[0].y,&p[1].x,&p[1].y);
     fclose(f);
 f = fopen("short.out","w");
 if (n == -1)
   {
    fprintf(f,"%.8f",razst(p[0].x,p[0].y,p[1].x,p[1].y));
    fclose(f);
    return 0;
   };
 n *=3;
 n+=2;
 int j,k;
 long a;
 for (i=0;i<n;i++)
   for (j=0;j<n;j++)
    {
     m[i][j] = 1000.0;
     if (i!= j)
      for (k = 0;k<n-2;k++)
        if (ots[k][0] != i && ots[k][1] != i  &&ots[k][0] != j && ots[k][1] != j)
          {
           a = orient(ots[k][0],i,ots[k][1]);
           a*= orient(ots[k][0],j,ots[k][1]);
           if ( a>0 )
                 m[i][j] = razst(p[i].x,p[i].y,p[j].x,p[j].y);
          };
    };
 for (i=0;i<n;i++)
  for (j=0;j<n;j++)
    for (k=0;k<n;k++)
      if (m[i][j] > m[i][k] + m[k][j])
         {
          m[i][j] = m[i][k] + m[k][j];
         };
 fprintf(f,"%.8f",m[n-2][n-1]);
 fclose(f);
 return 0;
};
