{Marin Nozhchev, StZagora}

const
 ifn = 'genom.inp';
 ofn = 'genom.out';
 maxn = 1000;

type
 Tarr = array [1 .. 2*maxn] of longint;
var
 t : text;
 a : array [1 .. 2*maxn] of string
 ;
 d2 : array [1 .. maxn] of longint;
 i2, id : TArr;
 pl : array [1 .. maxn] of longint;
 lp, rp, pn, nn, n, nb : longint;
 u : array [1 .. maxn] of boolean;

procedure input;
var
 i : longint;

begin
 assign (t, ifn);
 reset (t);
 readln (t, n);
 for i := 1 to n do
  begin
   readln (t, a[i]);
   id[i] := i; 
  end;
 close (t);
end;

procedure sort (var id : TArr; l, r : longint);
var
 c, i, j, k :longint;

begin
 i := l;
 j := r;
 k := id[(l+r) div 2];

 repeat
  while a[id[i]] < a[k] do inc (i);
  while a[k] < a[id[j]] do dec (j);
  if i <= j then
   begin
    c := id[i];
    id[i] := id[j];
    id[j] := c;

    inc (I);
    dec (j);
   end;
 until i > j;

 if l < j then sort (id, l, j);
 if i < r then sort (id ,i, r);
end;

procedure invert (var a, b : string);
var
 i : longint;

begin
 b := '';
 for i := length(a) downto 1 do
  b := b + a[i];
end;

procedure prep;
var
 s, i, j : longint;

begin

 i := 1;
 sort (id, 1, n);

 while i < n do
  begin
   if a[id[i]] = a[id[i+1]] then
    begin

     inc (pn);
     pl[pn] := id[i];
     pl[n - pn + 1] := -id[i+1];
     inc (i, 2);
    end
    else
     begin
      inc (nn);
      i2 [nn] := id[i];
      inc (i);
     end;
  end;

 if i =n then
  begin
   inc (nn);
   i2 [nn] := id[n];
  end;

 if nn = 0 then
  exit;

 for i := 1 to nn do
  begin
   i2 [nn + i] := n+i;
   invert (a[i2[i]], a [n+i]);
  end;

 sort (i2, 1, 2*nn);

 i := 1;
 while (nb < nn) and (i < 2*nn) do
   if a[i2[i]] = a[i2[i+1]] then
    begin
     inc (i, 2);
     inc (pn);
     if i2[i] <= n then
      pl[pn] := i2[i]
     else
      pl[pn] := -(i2[i]-n);

     if i2[i+1] <= n then
      pl[(n - pn + 1)] := -i2[i+1]
     else
      pl[n - pn + 1] := i2[i+1-n];
     inc (nb, 2);

    end
   else exit;

end;

procedure output;
var
 i : longint;

begin
 assign (t, ofn);
 rewrite (t);
 write (t, pl[1]);
 for i := 2 to n do
  write(t,  ' ', pl[i]);
 close (t);
end;

procedure silly;
var
 i :longint;

begin
 assign (t, ofn);
 rewrite (t);
 write (t, 1);
 for i := 2 to n do
  write (t, ' ',i);
 close (t);
end;

begin
 input;
 prep;
 if (nn = 0) or (nb = nn) then
  output
 else
  silly;
end.