#include<stdio.h>
#include<math.h>
struct _TR
{
  double x[3],y[3];
}TR[20];
int N;
double Xq,Yq,X2q,Y2q,L,A,B,C;
void Read(void)
{
 FILE *f;
 int i;
  f = fopen("SHORT.INP","rt");
  fscanf(f,"%d",&N);
  for(i = 0;i < N;i++){
     fscanf(f,"%lf%lf%lf%lf%lf%lf",&TR[i].x[0],&TR[i].y[0],
         &TR[i].x[1],&TR[i].y[1],&TR[i].x[2],&TR[i].y[2]);
  }
  fscanf(f,"%lf%lf%lf%lf",&Xq,&Yq,&X2q,&Y2q);
  fclose(f);
}
void LineUravn(int n,int f,int s,double *a,double *b,double *c)
{
  *a = TR[n].y[s] - TR[n].y[f];
  *b = TR[n].x[f] - TR[n].x[s];
  *c = TR[n].x[s]*TR[n].y[f]-TR[n].x[f]*TR[n].y[s];
}
double ZnakTTP(double x,double y,double a,double b,double c)
{
  return a*x+b*y+c;
}

double CheckPres(double a,double b,double c,double y1,double y2,double X,double Y,double AA,double BB,double CC)
{
 double z;
  z = ZnakTTP(X,Y,a,b,c)*ZnakTTP(X2q,Y2q,a,b,c);
  if(z >= 0)return 0.1111;
  z = (a*CC - c*AA)/(AA*b-a*BB);
  if(y1 > y2){if((z < y1) && (z > y2))return z;}
  else{if((z > y1) && (z < y2))return z;}
  return 0.1111;
}
double FindSolution(double X,double Y,double X2,double Y2)
{
 double clp,a,b,c,MIN = 300000000,MINX,xxx,AA,BB,CC;
 int i,mv,mv2,t;
  AA = Y2 - Y;BB = X - X2;CC = Y*X2-Y2*X;
  for(i = 0;i < N;i++){
     LineUravn(i,0,1,&a,&b,&c);
     clp = CheckPres(a,b,c,TR[i].y[0],TR[i].y[1],X,Y,AA,BB,CC);
     if(clp != 0.1111){
        xxx = (a)?-(clp*b+c)/a:c;
        if(MIN > hypot(X-xxx,Y-clp)){
           MIN = hypot(X-xxx,Y-clp);
           MINX = xxx;
           mv = 0;mv2 = 1;t = i;
        }
        //if(fabs(X - clp) < fabs(X - MIN)){MIN = clp;MINX = (a)?-(clp*b+c)/a:c;mv = 0;mv2 = 1;t = i;}
     }
     LineUravn(i,1,2,&a,&b,&c);
     clp = CheckPres(a,b,c,TR[i].y[1],TR[i].y[2],X,Y,AA,BB,CC);
     if(clp != 0.1111){
        xxx = (a)?-(clp*b+c)/a:c;
        if(MIN > hypot(X-xxx,Y-clp)){
           MIN = hypot(X-xxx,Y-clp);
           MINX = xxx;
           mv = 1;mv2 = 2;t = i;
        }
        //if(fabs(X - clp) < fabs(X - MIN)){MIN = clp;MINX = (a)?-(clp*b+c)/a:c;mv = 0;mv2 = 1;t = i;}
     }//if(fabs(X - clp) < fabs(X - MIN)){MIN = clp;MINX = (a)?-(clp*b+c)/a:c;mv = 1;mv2 = 2;t = i;}
     LineUravn(i,2,0,&a,&b,&c);
     clp = CheckPres(a,b,c,TR[i].y[2],TR[i].y[0],X,Y,AA,BB,CC);
     if(clp != 0.1111){
        xxx = (a)?-(clp*b+c)/a:c;
       if(MIN > hypot(X-xxx,Y-clp)){
           MIN = hypot(X-xxx,Y-clp);
           MINX = xxx;
           mv = 2;mv2 = 0;t = i;
        }
//        if(fabs(X - clp) < fabs(X - MIN)){MIN = clp;MINX = (a)?-(clp*b+c)/a:c;mv = 0;mv2 = 1;t = i;}
     }//if(fabs(X - clp) < fabs(X - MIN)){MIN = clp;MINX = (a)?-(clp*b+c)/a:c;mv = 2;mv2 = 0;t = i;}
  }
  if(MIN == 300000000)return hypot(X-X2,Y-Y2);
  MIN = FindSolution(TR[t].x[mv],TR[t].y[mv],X2,Y2) + hypot(TR[t].x[mv]-X,TR[t].y[mv]-Y);
  MINX = FindSolution(TR[t].x[mv2],TR[t].y[mv2],X2,Y2) + hypot(TR[t].x[mv2]-X,TR[t].y[mv2]-Y);
  if(MIN < MINX)return MIN;else return MINX;
}

void Write(void)
{
 FILE *f;
  f = fopen("SHORT.OUT","wt");
  fprintf(f,"%.8lf",L);
  fclose(f);
}
void main(void)
{
 Read();
  A = Y2q - Yq;B = Xq - X2q;C = Yq*X2q-Y2q*Xq;
  if(N == 0){
     L = hypot(Xq-X2q,Yq-Y2q);
  }
  else L = FindSolution(Xq,Yq,X2q,Y2q);
 Write();
}