/*  Borislav Kirilov Kirilov - grad Pleven  */
#include<fstream.h>
#include<string.h>

const char *inp_file = "comp.inp";
const char *out_file = "comp.out";

int N,K,co=0,maxx=0;
long num[300];
long pos[300];
long pos1[300];
long ones[300];
/****************************************************************************/
  void init();
  long find(int a);
  void calculate();
  void done();
/****************************************************************************/
void main(){
  init();
  calculate();
  done();
}
/****************************************************************************/
void init(){
  memset(num,0,sizeof(num));
  memset(ones,0,sizeof(ones));
  memset(pos,0,sizeof(pos));
  memset(pos1,0,sizeof(pos1));

  ifstream fin(inp_file);

  fin>>N>>K;

  for (int i=0;i<N;i++) fin>>num[i];

  fin.close();
}
/****************************************************************************/
long find(int a){
  long mod=0,sum=0;

  if (!a) return 0;
  else
  while (a!=1) {
    mod=a%2;
    if (mod) sum++;
    a=a/2;
  }
  return sum+1;
}
/****************************************************************************/
void calculate(){
  for (int i=0;i<N;i++) {
    ones[i]=find(num[i]);
    co+=ones[i];
  }
  if (K==1) {
    ofstream fout(out_file); fout<<co<<endl; fout<<N<<endl;
    fout.close(); exit(0);
  }

  co=co/K;


  int temp=0,i=0,brpos=0;
  while ((i<N)&&(brpos<K-1)) {
    while ((temp<co)&&(i<N)) {
      temp+=ones[i];
      i++;
    }
    pos[brpos]=i;
    brpos++;
    temp=0;
  }

  i=0;
  int max=0,p=0,sum=0;
  while (i<K) {
    for (int j=p;j<pos[i];j++)
      sum+=ones[j];

    if (sum>max) max=sum;
    p=pos[i];
    sum=0;
    i++;
    if (i==K-1) pos[i]=N;
  }
  maxx=max;
}
/****************************************************************************/
void done(){
  ofstream fout(out_file);
  fout<<maxx<<endl;

  pos1[0]=pos[0];
  for (int i=1;i<K;i++) pos1[i]=pos[i]-pos[i-1];

  for (int i=0;i<K;i++)
    if (pos1[i]==0)
      for (int j=0;j<K;j++)
        if (pos1[j]>1) {pos1[i]++;  pos1[j]--;  break;}
/*  fout<<pos[0]<<" ";
  for (int i=1;i<K-2;i++) fout<<pos[i]-pos[i-1]<<" ";

  if (pos[K-1]-pos[K-2]==0) {
    fout<<pos[K-2]-pos[K-3]-1<<" ";
    fout<<pos[K-1]-pos[K-2]+1<<" ";
  }
  else {
    fout<<pos[K-2]-pos[K-3]<<" ";
    fout<<pos[K-1]-pos[K-2]<<" ";
  }
  

  fout<<endl;   */

  for (int i=0;i<K;i++) fout<<pos1[i]<<" ";
  fout<<endl;
  
  fout.close();
}
/****************************************************************************/



