{grad  : Ruse
 grupa : 4
 u4enik: 4
 ime   : Dimitar Mitkov Kunchev}

 Const FINN  = 'SHORT.INP';
       FOUTN = 'SHORT.OUT';

 Type Dot    = Record
                 X,Y : Real;
               End;
      Tria   = Array [1..3] of Dot;

 Var Fin,Fout : Text;
     I,J      : Integer;

     N        : Integer;
     Triang   : Array [1..20] of Tria;
     M,P      : Dot; {Maint points}

     Line     : Array [1..60] of Dot; {Array for the broken short line}
     DC       : Integer; {DotsCount}
     Short    : Real;

  Procedure Init;

   Begin
     Assign(Fin,FINN);
     Assign(Fout,FOUTN);
     Reset(Fin);
     Rewrite(Fout);
     Readln (Fin,N);
     For I:=1 to N Do
       Readln(Fin,Triang[I][1].X,Triang[I][1].Y,Triang[I][2].X,
                Triang[I][2].Y,Triang[I][3].X,Triang[I][3].Y);
     Read(Fin,M.X,M.Y);
     Read(Fin,P.X,P.Y);
     Close(Fin);
     Line[1]:=M;
     Line[2]:=P;
     DC:=2;
   End;

  Procedure Add (Place : Integer; T : Dot); {adds new point in the broken line !After the [Place] point}
      Var Q : Integer;
    Begin
      Inc(DC);
      For Q:=DC DownTo Place+1 Do
        Line[Q]:=Line[Q-1];
      Line[Place]:=T;
    End;

  Function Cross (A,B,C,D : Dot) : Boolean; {checks if AB croses CD (segments!)}
      Var FC,FD,FA,FB : Real;
          DC,AB       : Boolean;
    Begin
      DC:=False;
      If B.X<>A.X Then
        Begin
          FC := (C.X-A.X)*(A.Y-B.Y)/(A.X-B.X)+A.Y;
          FD := (D.X-A.X)*(A.Y-B.Y)/(A.X-B.X)+A.Y;
          DC := (FC>C.Y) XOR (FD>D.Y);
        End
      Else
        DC := (A.X>C.X) XOR (A.X>D.X);
      AB:=False;
      If C.X<>D.X Then
        Begin
          FA := (A.X-C.X)*(C.Y-D.Y)/(C.X-D.X)+C.Y;
          FB := (B.X-C.X)*(C.Y-D.Y)/(C.X-D.X)+C.Y;
          AB := (FA>A.Y) XOR (FB>B.Y);
        End
      Else
        AB := (C.X>A.X) XOR (C.X>B.X);

      Cross:=AB And DC;
    End;

  Function Dist (A,B : Dot) : Real;
    Begin
      Dist:=Sqrt (Sqr(A.X-B.X) + Sqr(A.Y-B.Y));
    End;

  Procedure Optimize;
      var CS1,CS2,CS3 : Boolean; {Cross side 1,2,3}
          BrokenAgain : Boolean;
          O1,O2,O3    : Real;
    Begin
      I:=0;
      Repeat
        Inc(I);
        BrokenAgain:=False;
        For J:=1 To DC-1 Do
          Begin
            CS1:=Cross(Line[J],Line[J+1],Triang[I][1],Triang[I][2]);
            CS2:=Cross(Line[J],Line[J+1],Triang[I][2],Triang[I][3]);
            CS3:=Cross(Line[J],Line[J+1],Triang[I][3],Triang[I][1]);
            BrokenAgain := CS1 Or CS2 Or CS3;
            If CS1 And CS2 Then
              Begin
                O1:= Dist(Line[J],Triang[I][2])+Dist(Triang[I][2],Line[J+1]);
                O2:= Dist(Line[J],Triang[I][1])+Dist(Triang[I][1],Triang[I][3])+Dist(Triang[I][3],Line[J+1]);
                O3:= Dist(Line[J],Triang[I][3])+Dist(Triang[I][3],Triang[I][1])+Dist(Triang[I][1],Line[J+1]);
                If (O1<=O2) And (O1<=O3) Then
                  Begin
                    Add(J+1,Triang[I][2]);
                  End;
                If (O2<=O3) And (O2<=O1) Then
                  Begin
                    Add(J+1,Triang[I][1]);
                    Add(J+2,Triang[I][3]);
                  End;
                If (O3<=O2) And (O3<=O1) Then
                  Begin
                    Add(J+1,Triang[I][3]);
                    Add(J+2,Triang[I][1]);
                  End;
              End;
            If CS2 And CS3 Then
              Begin
                O1:= Dist(Line[J],Triang[I][3])+Dist(Triang[I][3],Line[J+1]);
                O2:= Dist(Line[J],Triang[I][1])+Dist(Triang[I][1],Triang[I][2])+Dist(Triang[I][2],Line[J+1]);
                O3:= Dist(Line[J],Triang[I][2])+Dist(Triang[I][2],Triang[I][1])+Dist(Triang[I][1],Line[J+1]);
                If (O1<=O2) And (O1<=O3) Then
                  Begin
                    Add(J+1,Triang[I][3]);
                  End;
                If (O2<=O3) And (O2<=O1) Then
                  Begin
                    Add(J+1,Triang[I][1]);
                    Add(J+2,Triang[I][2]);
                  End;
                If (O3<=O2) And (O3<=O1) Then
                  Begin
                    Add(J+1,Triang[I][2]);
                    Add(J+2,Triang[I][1]);
                  End;
              End;
            If CS3 And CS1 Then
              Begin
                O1:= Dist(Line[J],Triang[I][1])+Dist(Triang[I][1],Line[J+1]);
                O2:= Dist(Line[J],Triang[I][2])+Dist(Triang[I][2],Triang[I][3])+Dist(Triang[I][3],Line[J+1]);
                O3:= Dist(Line[J],Triang[I][3])+Dist(Triang[I][3],Triang[I][2])+Dist(Triang[I][2],Line[J+1]);
                If (O1<=O2) And (O1<=O3) Then
                  Begin
                    Add(J+1,Triang[I][1]);
                  End;
                If (O2<=O3) And (O2<=O1) Then
                  Begin
                    Add(J+1,Triang[I][2]);
                    Add(J+2,Triang[I][3]);
                  End;
                If (O3<=O2) And (O3<=O1) Then
                  Begin
                    Add(J+1,Triang[I][3]);
                    Add(J+2,Triang[I][2]);
                  End;
              End;
          End;
      Until Not BrokenAgain And (I=N);
      Short:=0;
      For I:=1 To DC-1 Do
        Short:=Short+Dist(Line[I+1],Line[I]);
      Write (Fout,Short:8:8);
    End;

BEGIN
  Init;
  Optimize;
  Close(Fout);
END.