/*
  George Tsankov, 11 star, SMG
*/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>


#define MAXN 1300
#define MAXC 260
#define MAXS (MAXN*MAXC)

int N;
char s[MAXN][2][MAXC];
int l[MAXN];
char S_[MAXS], *S = S_;
int partof;
int i1, i2, i3;
int used[MAXN];
int L;
int P[MAXN];


void read_all(void);
void do_all(void);
int makepal(void);
void write_all(void);



int main(void)
{
  read_all();
  do_all();
/*  printf("no sol\n");*/
  write_all();
  return 0;
}



void read_all(void)
{
  int i, j;
  
  FILE *f = fopen("genom.inp", "rt");
  fscanf(f, "%d", &N);
  for (i = 0; i < N; i++) {
    fscanf(f, "%s", s[i][0]);
    l[i] = strlen(s[i][0]);
    for (j = 0; j < l[i]; j++) {
      s[i][1][j] = s[i][0][l[i]-1-j];
    }
    L += l[i];
  }
  fclose(f);
}



void do_all(void)
{
  i1 = 0;
  i2 = N+1;
  i3 = N+1;
  makepal();
}



int makepal(void)
{
  int i, j, ll;

  if (i2-i1 < i3) {
    i3 = i2-i1;
/*    printf("%d\n", i3);*/
  }
  if (i1+1 >= i2) {
    write_all();
    exit(0);
    return 1;
  }
  ll = strlen(S);
  for (i = 0; i < N; i++) {
    if (used[i] != 0)  continue;
    if (l[i] <= ll) {
      for (j = 0; j < 2; j++) {
        if (strncmp(S, s[i][j], l[i]) == 0) {
          used[i] = 1;
          S += l[i];
          if (partof == 0)  P[++i1] = (1-2*j)*(i+1);
          else              P[--i2] = (2*j-1)*(i+1);
          makepal();
          if (partof == 0)  --i1;
          else              ++i2;
          S -= l[i];
          used[i] = 0;
          break;
        }
      }
    }
    else {
      for (j = 0; j < 2; j++) {
        if (strncmp(S, s[i][j], ll) == 0) {
/*          if (ll != 0) {
            ll++;ll--;
          }*/
          strcpy(S+ll, s[i][j]+ll);
          used[i] = 1;
          S += ll;
          if (partof == 0)  P[++i1] = (1-2*j)*(i+1);
          else              P[--i2] = (2*j-1)*(i+1);
          partof ^= 1;
          makepal();
          partof ^= 1;
          if (partof == 0)  --i1;
          else              ++i2;
          S -= ll;
          used[i] = 0;
          memset(S+ll, 0, l[i]-ll);
/*          if (ll != 0) {
            ll++;ll--;
          }           */
/*          S[ll] = '\0';*/
          break;
        }
      }
    }
  }
}



void write_all(void)
{
  int i;
  
  FILE *f = fopen("genom.out", "wt");
  for (i = 1; i <= N; i++) {
    fprintf(f, "%d\n", P[i]);
  }
  fclose(f);
}


