// Veselin Raychev SMG 11z

#include <stdio.h>

int n,k;
int c1[300],num[300];
int maxc1;
int allones;

int outgc;
//int outg[300];
int outgel[300];

int calcc1(void)
{
  int i,c,ones;

  maxc1=0;
  allones=0;
  
  for (i=0;i<n;i++)
  {
     ones=0;
     c=num[i];
     while (c) {
       if (c&1) { ones++; }
       c>>=1;
     }
     c1[i] = ones;
     if (ones>maxc1) { maxc1=ones; }
     allones+=ones;
  }
  return 0;
}

int calcgroups(int gs)
{
  int i,c;

  memset(outgel,0,1200);
//  memset(outg,0,1200);
  c=0;
  
  outgc=0;
  
  for (i=0;i<n;i++)
  {
//    if ( (outg[outgc]+c1[i])>gs )
    if (c+c1[i]>gs)
    { // New group
      outgc++;
      c = 0;
    }
//    outg[outgc]+=c1[i];
    c+=c1[i];
    outgel[outgc]++;
  }
  outgc++; // Last group finished

  return (outgc>k); // 0 means OK
}

int main(void)
{
  FILE* f;
  int i,nm,ind,pr;
  f = fopen("comp.inp","rt");
  fscanf(f,"%d %d",&n,&k);
  for (i=0;i<n;i++)
  {
    fscanf(f,"%d",&num[i]);
  }
  fclose(f);

  calcc1();

/*  printf("OK\n");
  printf("%d %d\n",n,k);
  for (i=0;i<n;i++)
  {
    printf("%d:%d ",num[i],c1[i]);
  }
  printf("\n\n"); */

  i=maxc1;
  while (calcgroups(i)) { i++; }

//  printf("\n%d\n",calcgroups(12));

  f = fopen("comp.out","wt");

  fprintf(f,"%d\n",i);

  if (k==outgc)
  {  
    for (i=0;i<k-1;i++)
    {
      fprintf(f,"%d ",outgel[i]);
    }
    fprintf(f,"%d\n",outgel[k-1]);
  } else {
    ind=0;
    
    pr = k-outgc;    
    for (i=0;i<k;i++)
    {
      if ((pr>0) && (outgel[ind]>1))
      {
        outgel[ind]--;
        fprintf(f,"1 ");
        pr--;
      } else
      {
        fprintf(f,"%d ",outgel[ind]);
        ind++;
      }
    }
  }
  fclose(f);

  return 0;
}
