// Veselin Raychev SMG 11z Zala 2 No4

#include <stdio.h>
#include <strings.h>
#include <stdlib.h>

typedef struct
{
  char c[256];
  int clen;
  int num;
  int neg;
} strin;


int n;
strin st[2000];

int stused[1000];
int result[1000];


int searchdeep(char* find,int findl,int right,int lw,int rw)
{
  int i,ind;
  
  int f,t;
  char* c;
  int cl;
  FILE *fil;

//  if (strlen(find)!=findl) { printf("Error\n"); findl=strlen(find); }

//  printf("%d %d\n",lw,rw);

  if (lw==rw)
  {
    cl = -1;
    for (i=0;i<n;i++)
    {
      if (stused[i]==0) { cl=i; break; }
    }
    if (cl>=0)
    {
      result[lw] = i+1;
    }

    fil = fopen("genom.out","wt");
    for (i=0;i<n;i++)
    {
      fprintf(fil,"%d\n",result[i]);
    }
    fclose(fil);
    exit(0);
//     printf("e re6enie\n");
  }


  f=n;
  for (i=0;i<2*n;i++)
  {
    cl=st[i].clen;
    if (cl>findl) cl=findl;
    if (memcmp(find,st[i].c,cl)==0)
    {
      f=i; break;
    }
  }
  t=n;
  for (i=f+1;i<2*n;i++)
  {
    cl=st[i].clen;
    if (cl>findl) cl=findl;
    if (memcmp(find,st[i].c,cl)!=0)
    {
      t=i; break;
    }
  }



  if (t>f)
  {
//    printf("check\n");
  }

  for (i=f;i<t;i++)
  { // otgovariat na uslovieto
     ind = st[i].num;
     if (stused[ind]) { continue; }
     stused[ind] = 1;
  
     cl=st[i].clen;
     c=st[i].c;

     if (cl>findl)
     { // Inverse the search
       if (right==0)
       {
         result[rw] = -st[i].neg;
         searchdeep(&c[findl],cl-findl,1,lw,rw-1);
       } else
       {
         result[lw] = st[i].neg;
         searchdeep(&c[findl],cl-findl,0,lw+1,rw);
       }
     } else
     { // Ok continue
       if (right==0)
       {
         result[rw] = -st[i].neg;
         searchdeep(&find[cl],findl-cl,0,lw,rw-1);
       } else
       {
         result[lw] = st[i].neg;
         searchdeep(&find[cl],findl-cl,1,lw+1,rw);
       }
     }
     stused[ind] = 0;
  }
}

int cmp(const void *e1,const void *e2)
{
  return strcmp( ((const strin*)e1)->c , ((const strin*)e2)->c);
}

int main(void)
{
  FILE* f;
  int i,j,k,l;
  f = fopen("genom.inp","rt");
  fscanf(f,"%d",&n);
  for (i=0;i<n;i++)
  {
    fscanf(f,"%s ",st[i].c);
    st[i].clen = strlen(st[i].c);
    st[i].num=i;
    st[i].neg=i+1;
  }
  fclose(f);

  k = n;
  for (i=0;i<n;i++)
  {
    l = st[i].clen;
    for (j=0;j<l;j++)
    {
      st[k].c[j] = st[i].c[l-j-1];
    }
    st[k].clen=l;
    st[k].c[l] = 0;
    st[k].num=i;
    st[k].neg=-i-1;
    k++;
  }
  qsort(st,2*n,sizeof(strin),cmp);

  for (i=0;i<n;i++)
  {
    result[0] = st[i].neg;
    stused[st[i].num] = 1;

    searchdeep(st[i].c,st[i].clen,0,1,n-1);
    
    stused[st[i].num] = 0;
  }

//  printf("All is OK\n");
  
  return 0;
}
