/* Nikolay Krasimirov Marinov
   Shumen
*/





#include <fstream.h>
#include <deque>
#include <stack>

  ifstream fin ("comp.inp");
  ofstream fout ("comp.out");

  long A[512];
  long P[512];
  long S[512][512];
  int K[512][512];
  int n, k;


  long Decomp (long x)
    {
      long br = 0;
      while (x != 0)
        {
          if (x % 2 == 1)
            br++;
          x /= 2;
        }
      return br;
    }

  void ReadData ()
    {
      fin >> n >> k;
      long x;
      for (int i = 1; i <= n; i++)
        {
          fin >> x;
          A[i] = Decomp (x);
        }
    }

  long Max (long xx, long yy)
    {
      if (xx > yy)
        return xx;
           else
             return yy;
    }
    
    
  void Solve ()
    {
      long s;
      long min;
      long z;
      for (int i = 1; i <= n; i++)
        P[i] = P[i - 1] + A[i];
      for (int i = 1; i <= n; i++)
        S[i][1] = P[i];
      for (int i = 2; i <= k; i++)
        S[1][i] = A[1];
      for (int j = 2; j <= k; j++)
        for (int i = 2; i <= n; i++)
          {
            min = 9999999;
            for (int ind = 1; ind <= i; ind++)
              {
                s = Max ( P[i] - P[ind - 1],  S[ind - 1][j - 1]);
                if (s < min)
                  {
                    min = s;
                    z = ind;
                  }
              }
            S[i][j] = min;
            K[i][j] = z - 1;
          }
    }

  void WriteData ()
    {
      fout << S[n][k] << '\n';
      stack <int, deque <int> > A;
      while (k != 0)
        {
          int x;
          x = n - K[n][k];
          n = K[n][k];
          k--;
          A.push (x);
        }
      while (!A.empty ())
        {
          fout << A.top () << ' ';
          A.pop ();
        }
    }

    

  int main ()
    {
      ReadData ();
      Solve ();
      WriteData ();
      return 0;
    }
