{
 Stara Zagora - No.4
 Vesselin Anriev Georgiev
 PMG geo milev - SZ

}

Uses DOS;

const  infile = 'short.inp';
      outfile = 'short.out';
          eps = 1e-11;
          inf = 1e13;

type Tpoint = record
              x,y : extended;
              end;
     t3k    = array [1..3] of TPoint;
     scene  = array [1..20] of t3k;
     savlin = array [1..4] of TPoint;

var  a        : scene;
     p1,p2,cp : TPoint;
     n        : integer;
     dist     : extended;
     mindist  : extended;
     clk0     : real;

Procedure InX;
 var t : text;
     i : integer;
 begin
 assign(t, infile);
 reset(t);
 readln(t,n);
 for i:=1 to n do readln(t, a[i,1].x,a[i,1].y,a[i,2].x,a[i,2].y,a[i,3].x,a[i,3].y);
 readln(t,p1.x,p1.y,p2.x,p2.y);
 close(t);
 end;

Function Pit(a,b : TPoint): extended;
 begin
 Pit:=sqrt(sqr(a.x-b.x)+sqr(a.y-b.y));
 end;

Function eq(a,b : extended): boolean;
 begin
 eq := (abs(a-b)<eps);
 end;

function eqp(a,b : TPoint): boolean;
 begin
 eqp:=(eq(a.x,b.x) and eq(a.y,b.y));
 end;


Function intersect(p1,p2,p3,p4: TPoint; var ip : TPoint): boolean;
 var l,r,m : TPoint;
 begin
 if eqp(p1,p3) or eqp(p1,p4) then
  begin
  intersect:=FALSE;
  exit;
  end;
 l:=p1;
 r:=p2;
 while not eqp(l,r) do
  begin
  m.x:=(l.x+r.x)/2;
  m.y:=(l.y+r.y)/2;
  if (pit(l,p3)+pit(l,p4)) < (pit(r,p3)+pit(r,p4))  then r:=m
                                                    else l:=m;
  end;
 m:=l;
 if eqp(m,p3) or eqp(m,p4) then
  begin
  intersect:=FALSE;
  exit;
  end;
 if eq(pit(m,p3)+pit(m,p4),pit(p3,p4)) or (pit(m,p3)+pit(m,p4)<pit(p3,p4)) then
  begin
  intersect:=TRUE;
  ip:=m;
  exit;
  end;
 intersect:=FALSE;
 end;

var flag : boolean;


Procedure Timeset;
 var h,m,s,hds : word;
 begin
 gettime(h,m,s,hds);
 clk0:=hds/100 + s + m * 60 + h * 3600;
 end;

Function Timetest : boolean;
 var h,m,s,hds : word;
     clk1      : real;
 begin
 gettime(h,m,s,hds);
 clk1:=hds/100 + s + m * 60 + h * 3600;
 timetest:=(clk1-clk0>0.92); {time critical}
 end;

Procedure swrr(var a,b : TPoint);
 var c : Tpoint;
 begin
 c:=a;
 a:=b;
 b:=c;
 end;

Procedure Bt(cp : TPoint; cdist: extended);
 var ip    : TPoint;
     i,j   : integer;
     mind  : extended;
     A1,A2 : TPoint;
     f     : boolean;
     D     : savlin;
     ls    : integer;
 begin
 if n > 6 then if timetest then flag:=TRUE;
 if flag then exit;
 f:=false;
 mind:=inf;
 for j:=1 to n do
  for i:=1 to 3 do
   begin
    case i of
    1: begin a1:=a[j,1]; a2:=a[j,2]; end;
    2: begin a1:=a[j,1]; a2:=a[j,3]; end;
    3: begin a1:=a[j,2]; a2:=a[j,3]; end;
    end;
   if intersect(cp,p2,a1,a2,ip) then
    begin
    f:=TRUE;
    if eq(pit(ip,cp),mind) then
     begin
     ls:=2;
     d[3]:=a1;
     d[4]:=a2;
     end else
    if pit(ip,cp)<mind then
     begin
     mind:=pit(ip,cp);
     ls:=1;
     d[1]:=a1;
     d[2]:=a2;
     if pit(ip,d[2])<pit(ip,d[1]) then swrr(d[1],d[2]);

     end;
    end;
   end;
 if f then
  begin
  bt(d[1],cdist+pit(cp,d[1]));
  bt(d[2],cdist+pit(cp,d[2]));
  if ls = 2 then
   begin
   bt(d[3],cdist+pit(cp,d[3]));
   bt(d[4],cdist+pit(cp,d[4]));
   end;
  end;
 if not f then if cdist+pit(cp,p2)<mindist then
  begin
  mindist:=cdist+pit(cp,p2);
{  writeln('New mindist: ',mindist);}
  exit;
  end;
 end;

Procedure DoWork;
 begin
 if n = 0 then
  begin
  dist:= pit(p1,p2);
  exit;
  end;
 mindist:=inf;
 timeset;
 bt(p1,0);
 dist:=mindist;
 end;

Procedure OutX;
 var t : text;
 begin
 assign(t, outfile);
 rewrite(t);
 writeln(t, dist:1:8);
 close(t);
 end;

BEGIN
InX;
DoWork;
OutX;
END.