/************************************/
/** NAME : Slavi Marinov ************/
/** CLASS : 11-12        ************/
/** PROBLEM : COMP       ************/
/************************************/
#include <fstream>
#include <stack>
using namespace std;

const int MAX = 301;
const int inf = 100000; //infinity
ifstream fin("COMP.INP");
ofstream fout("COMP.OUT");

int n,k,m[MAX],entr[MAX],sol[MAX][MAX],last[MAX][MAX];
stack<int> st;
int all;

void init() {
  fin>>n>>k;
  all=n;
  for (int i=1;i<=n;i++) fin>>entr[i];
}

int max(int i,int j) {
 if (i>j) return i; else return j;
}
int min(int i,int j) {
 if (i>j) return j; else return i;
}

int bones(int num) {
 int o=0;
 while (num!=0) {
   if (num%2) o++;
   num/=2;
 }
 return o;
}

int sum(int i1,int i2) {
 int ss=0;
 for (int b=i1;b<=i2;b++) ss+=m[b];
 return ss;
}

void build_new() {
  for (int i=1;i<=n;i++) {
     m[i]=bones(entr[i]);
  }
}

void solve() {
 sol[1][1]=m[1];
 for (int i=1;i<=n;i++) {
   sol[i][i]=max(sol[i-1][i-1],m[i]);
   sol[i][1]=sol[i-1][1]+m[i];
   last[i][i]=m[i];
   last[i][1]=sol[i][1];
 }
 for (int i=1;i<=n;i++) {
   for (int j=i+1;j<=n;j++)
    sol[i][j]=-1;
 }
 for (int i=1;i<=n;i++) {
   for (int j=2;j<i;j++) {
    int p=inf;//max(sol[i-1][j],(last[i-1][j]+m[j]));
    int q=max(sol[i-1][j-1],m[i]);
    int ind;
    for (int c=1;c<i;c++) {
      int r=max(sol[c][j-1],sum(c+1,i));
      if (r<=p) { p=r; ind=c; }
    }
    sol[i][j]=min(p,q);
    if (p<=q) last[i][j]=sum(ind+1,i);
       else last[i][j]=m[i];
   }
 }
}

void print() {
 fout<<sol[n][k]<<endl;
 int backk=k;
 while (k>0) {
  int tmp=n;
  int ss=0;
  while ((ss<last[tmp][k])&&(n>0)) {
    ss+=m[n];
    n--;
  }
  k--;
  all-=(tmp-n);  
  if (k==0) st.push(tmp-n+all); else
  st.push(tmp-n);
 }
 for (int i=1;i<backk;i++) {
  fout<<st.top()<<" ";
  st.pop();
 }
 fout<<st.top()<<endl;
 st.pop();
}

void tmp_print() {
 for (int i=1;i<=n;i++) {
  for (int j=1;j<=n;j++) cout<<last[i][j]<<" ";
  cout<<endl;
 }
}


int main() {
  init();
  build_new();
  solve();
  ////////////////////
  /**tmp_print();**/
  ////////////////////
  print();
  return 0;
}
