/************************************/
/** NAME : Slavi Marinov ************/
/** CLASS : 11-12        ************/
/** PROBLEM : GENOM      ************/
/************************************/
#include <fstream>
#include <string>
using namespace std;
const int MAX = 1001;

ifstream fin("GENOM.INP");
ofstream fout("GENOM.OUT");

int n,used[MAX],soln[MAX],glob;
string s,m[MAX];
int b,e;

void init() {
 fin>>n;
 for (int i=1;i<=n;i++) {
  fin>>m[i];
 }
}

int can(string s1,string s2) {
 int can=1;
 if (s1.length()<s2.length()) {
   int j=s2.length();
   for (int i=0;i<s1.length();i++) {
    j--;   
    if (s1[i]!=s2[j]) can=0;
   }
   if (can) {
     glob=s2.length();
     return 1;
   }  else return 0;
 } else {
   int j=-1;
   for (int i=s2.length()-1;i>=0;i--) {
    j++;
    if (s2[i]!=s1[j]) can=0;
   }
   if (can) {
     glob=s1.length();
     return 2;
   } else return 0;
 }
}

void quit() {
 for (int i=1;i<=n;i++) fout<<soln[i]<<endl;
 exit(0);
}

int pal(string baba) {
 for (int i=1;i<(baba.length()/2);i++)
  if (baba[i-1]!=baba[baba.length()-i]) return 0;
 return 1;
}


void solve(string beg,string end) {
 int found=1;
 int tt1,tt2;
 int cc=0;
 for (int i=1;i<=n;i++) {
  if (used[i]==0)  { found=0; cc++; }
 }
 if (cc==1) {
  for (int i=1;i<=n;i++)
   if (!used[i]) tt1=i;
  for (int i=1;i<=n;i++)
   if (soln[i]==0) tt2=i;
  string sss("");
  sss=beg+m[tt1]+end;
  if (pal(sss)) {
   soln[tt2]=tt1;
   quit();
  }
  string smtp1("");
  for (int i=m[tt1].length()-1;i>=0;i--)
   smtp1+=m[i];
  string sss2=beg+smtp1+end;
  if (pal(sss2)) {
   soln[tt2]=-tt1;
   quit();
  }
  
 }
 if (found!=0) quit();
 for (int i=1;i<=n;i++) {
  string t0=beg+m[i];
  string t1("");
  for (int l=m[i].length()-1;l>=0;l--)
   t1+=m[i][l];
  t1=beg+t1;
  for (int j=1;j<=n;j++)
    if ((!used[j])&&(i!=j)) {
     string tmp("");
     string t2=m[j]+end;
     for (int l=m[j].length()-1;l>=0;l--)
      tmp+=m[j][l];
     string t3=tmp+end;
     int x1=can(t0,t2);
     int x2=can(t0,t3);
     int x3=can(t1,t2);
     int x4=can(t1,t3);
     if (x1) {
       used[i]=1;
       used[j]=1;
       b++;
       soln[b]=i;
       e--;
       soln[e]=j;
       if (x1==1) solve("",t2.substr(glob));
          else    solve(t0.substr(glob),"");
       soln[b]=0;
       soln[e]=0;          
       e++;
       b--;
       used[j]=0;
       used[i]=0;
     }
     if (x2) {
       used[i]=1;
       used[j]=1;
       b++;
       soln[b]=i;
       e--;
       soln[e]=-j;
       if (x2==1) solve("",t3.substr(glob));
          else    solve(t0.substr(glob),"");
       soln[b]=0;
       soln[e]=0;          
       e++;
       b--;
       used[j]=0;
       used[i]=0;
     
     }
     if (x3) {
       used[i]=1;
       used[j]=1;
       b++;
       soln[b]=-i;
       e--;
       soln[e]=j;
       if (x1==1) solve("",t2.substr(glob));
          else    solve(t1.substr(glob),"");
       soln[b]=0;
       soln[e]=0;          
       e++;
       b--;
       used[j]=0;
       used[i]=0;
     
     }
     if (x4) {
       used[i]=1;
       used[j]=1;
       b++;
       soln[b]=-i;
       e--;
       soln[e]=-j;
       if (x1==1) solve("",t3.substr(glob));
          else    solve(t1.substr(glob),"");
       soln[b]=0;
       soln[e]=0;          
       e++;
       b--;
       used[j]=0;
       used[i]=0;
     
     }     
    }

 }
}

int main() {
 init();
 b=0;
 e=n+1;
 solve("","");
}
