{
Yambol-4
Nikolay Nikolov, 12 (11*) klas
}

{$MODE objfpc}
{$H+}

Type
  TPiece = Record
    s1, s2 : AnsiString;
    palin : Boolean;
    used : Boolean;
  End;

Var
  N : Integer;
  TotalLen : Integer;
  Piece : Array[0..1000] Of TPiece;
  Genom : Array[0..256000] Of Char;
  L, R : Integer;
  LQ : Array[0..1000] Of Integer;
  RQ : Array[0..1000] Of Integer;
  Que : Array[0..1000] Of Integer;
  QueNum : Integer;

Procedure ReadIn;

Var
  F : Text;
  I, J, L : Integer;
  tmp : Char;
  palin : Boolean;

Begin
  TotalLen := 0;
  FillChar(Piece, SizeOf(Piece), 0);
  ASSign(F, 'GENOM.INP');
  Reset(F);
  Readln(F, N);
  For I := 1 To N Do
  Begin
    Readln(F, Piece[I].s1);
    Inc(TotalLen, Length(Piece[I].s1));
    For J := 1 To Length(Piece[I].s1) Do
      Piece[I].s1[J] := UpCase(Piece[I].s1[J]);
    Piece[I].s2 := Piece[I].s1;
    L := Length(Piece[I].s2);
    palin := True;
    For J := 1 To L Div 2 Do
    Begin
      tmp := Piece[I].s2[J];
      Piece[I].s2[J] := Piece[I].s2[L - J + 1];
      Piece[I].s2[L - J + 1] := tmp;
      If Piece[I].s2[J] <> Piece[I].s2[L - J + 1] Then
        palin := False;
    End;
    Piece[I].palin := palin;
    Piece[I].used := False;
  End;
  Close(F);
End;

Function TestLeft(Const s : AnsiString) : Boolean;

Var
  I : Integer;

Begin
  For I := 1 To Length(s) Do
  Begin
    If (TotalLen - (L + I) + 1) < R Then
      Exit(True);
    If s[I] <> Genom[TotalLen - (L + I) + 1] Then
      Exit(False);
  End;
  TestLeft := True;
End;

Procedure PutLeft(Const s : AnsiString);

Begin
  Move(s[1], Genom[L + 1], Length(s));
  Inc(L, Length(s));
End;

Function TestRight(Const s : AnsiString) : Boolean;

Var
  I : Integer;

Begin
  For I := 1 To Length(s) Do
  Begin
    If (TotalLen - (R - I) + 1) > L Then
      Exit(True);
    If s[Length(s) - I + 1] <> Genom[TotalLen - (R - I) + 1] Then
      Exit(False);
  End;
  TestRight := True;
End;

Procedure PutRight(Const s : AnsiString);

Begin
  Dec(R, Length(s));
  Move(s[1], Genom[R], Length(s));
End;

Function Check : Boolean;

Var
  I : Integer;

Begin
  For I := TotalLen Shr 1 DownTo 1 Do
  Begin
    If Genom[I] <> Genom[TotalLen - I + 1] Then
      Exit(False);
  End;
  Check := True;
End;

Procedure WriteOut;

Var
  I : Integer;
  F : Text;

Begin
  QueNum := 0;
  For I := 1 To LQ[0] Do
  Begin
    Inc(QueNum);
    Que[QueNum] := LQ[I];
  End;
  For I := RQ[0] DownTo 1 Do
  Begin
    Inc(QueNum);
    Que[QueNum] := RQ[I];
  End;

  ASSign(F, 'GENOM.OUT');
  Rewrite(F);
  For I := 1 To QueNum Do
    Writeln(F, Que[I]);
  Close(F);
  Halt;
End;

Procedure Dig;

Var
  RSp : Integer;
  I : Integer;

Begin
  If (R - L) = 1 Then
    If Check Then
      WriteOut;
  RSp := TotalLen + 1 - R;
  If L <= RSp Then
  Begin
    For I := 1 To N Do
      If (Not Piece[I].used) And (Length(Piece[I].s1) <= (R - L - 1)) Then
      Begin
        If TestLeft(Piece[I].s1) Then
        Begin
          Piece[I].used := True;
          Inc(LQ[0]);
          LQ[LQ[0]] := I;
          PutLeft(Piece[I].s1); {updates L...}
          Dig;
          Dec(LQ[0]);
          Dec(L, Length(Piece[I].s1));
        End;
        If (Not Piece[I].palin) And (TestLeft(Piece[I].s2)) Then
        Begin
          Piece[I].used := True;
          Inc(LQ[0]);
          LQ[LQ[0]] := -I;
          PutLeft(Piece[I].s2); {updates L...}
          Dig;
          Dec(LQ[0]);
          Dec(L, Length(Piece[I].s2));
        End;
        Piece[I].used := False;
      End;
  End
  Else
  Begin
    For I := N DownTo 1 Do
      If (Not Piece[I].used) And (Length(Piece[I].s1) <= (R - L - 1)) Then
      Begin
        If TestRight(Piece[I].s1) Then
        Begin
          Piece[I].used := True;
          Inc(RQ[0]);
          RQ[RQ[0]] := I;
          PutRight(Piece[I].s1); {updates R...}
          Dig;
          Dec(RQ[0]);
          Inc(R, Length(Piece[I].s1));
        End;
        If (Not Piece[I].palin) And (TestRight(Piece[I].s2)) Then
        Begin
          Piece[I].used := True;
          Inc(RQ[0]);
          RQ[RQ[0]] := -I;
          PutRight(Piece[I].s2); {updates R...}
          Dig;
          Dec(RQ[0]);
          Inc(R, Length(Piece[I].s2));
        End;
        Piece[I].used := False;
      End;
  End;
End;

Procedure Bahur;

Begin
  LQ[0] := 0;
  RQ[0] := 0;
  L := 0;
  R := TotalLen + 1;
  Dig;
End;

Begin
  ReadIn;
  Bahur;
End.
