/*
Name   : Valentin Stoianov Mihov
City   : Varna
Group  : A
Number : A9
*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define INPF "worch.inp"
#define MAXN 250001
#define MAXL 21

char words[MAXN][MAXL];
char orig[MAXN][MAXL];
char len[MAXN];
int br=0;
int st[21];
char T[MAXN];
int back[MAXN];
int list[MAXN];
int list2[MAXN];
int lbr=0,lbr2=0;


int cmp2(const void *a,const void *b)
  {
    return *((char*)a)-*((char*)b);
  }

void Swap(int i1,int i2)
  {
    char tmp[MAXL];
    char tmp2;
    if(i1==i2) return;
    strcpy(tmp,words[i1]);
    strcpy(words[i1],words[i2]);
    strcpy(words[i2],tmp);
    tmp2=len[i1];
    len[i1]=len[i2];
    len[i2]=tmp2;
  }

void my_q_sort(int l,int r)
  {
    int m=len[(l+r)/2],i=l,j=r;
    if(r-l==1)
      {
        if(len[l]>len[r]) Swap(l,r);
        return;
      }
    if(r-l==0) return;
    do
      {
        while(len[i]<m) i++;
        while(len[j]>m) j--;
        if(i<=j) {Swap(i,j);i++;j--;}
      }
    while(i<=j);
    if(j>l) my_q_sort(l,j);
    if(i<r) my_q_sort(i,r);
  }

void Init()
  {
    FILE *f=/*fopen(INPF,"rt")*/stdin;
    while(!feof(f))
      {
        fscanf(f," %s ",words[br++]);
        len[br-1]=strlen(words[br-1]);
        if(len[br-1]<3) br--;
      }
//    fclose(f);
  }

void SortData()
  {
    int i;
    my_q_sort(0,br-1);
    memcpy(orig,words,sizeof(orig));
    for(i=0;i<=20;i++) st[i]=-1;
    st[strlen(words[0])]=0;
    for(i=0;i<br-1;i++)
        if(len[i]<len[i+1]) st[len[i+1]]=i+1;
    for(i=0;i<br;i++)
      qsort(words[i],len[i],sizeof(words[0][0]),cmp2);
  }

int Linked(int i,int j)
  {
    int k=0;
    if(len[i]!=len[j]-1) return 0;
    while(words[i][k]==words[j][k]) k++;
    k++;
    for(;k<len[j];k++)
      if(words[i][k-1]!=words[j][k]) return 0;
    return 1;
  }

void Solve()
  {
    int s=strlen(words[0]),e;
    int i,j,k;
    memset(T,0,sizeof(T));
    for(i=0;i<br;i++) back[i]=-1;
    if(s!=3) exit(0);
    for(i=0;i<st[4];i++)
      list[lbr++]=i;
    s++;
    for(i=s;i<=20;i++)
      {
        if(st[i-1]!=-1 && st[i]!=-1)
          {
            j=st[i];
            lbr2=0;
            while(len[j]==i && j<br)
              {
                for(k=0;k<lbr;k++)
                  if(T[list[k]]+1>T[j] && Linked(list[k],j)) {T[j]=T[list[k]]+1;back[j]=list[k];list2[lbr2++]=j;}
                j++;
              }
            memcpy(list,list2,sizeof(list2));
            lbr=lbr2;
          }
        else break;
//        printf("Finish stage %d.\n",i);
      }
  }

void Rec(int pos)
  {
    if(back[pos]!=-1) Rec(back[pos]);
    printf("%s\n",orig[pos]);
  }

void Output()
  {
    int max=0,i,pos;
    for(i=1;i<br;i++)
      if(T[i]>T[max]) max=i;
    Rec(max);
  }

int main()
  {
    Init();
    SortData();
    Solve();
    Output();
    return 0;
  }
