#include <stdio.h>

//#define INP "lights.in"

#define MAXV 256
#define INF 200000000
#define MAXK 16

int t[MAXV][MAXV],n,k,m;
int l[MAXV][MAXV];
int sz[MAXV][MAXV],zab[MAXV];
int zabm[MAXV][MAXK][MAXV];
//FILE *f;

void init () {
int i,j;
int x,y,v;
int kr;
//  f = fopen ( INP , "r");
  memset(sz,0,sizeof(sz));
  scanf("%d%d%d",&n,&m,&k);
  for (i=1;i<=n;i++)
    for (j=1;j<=n;j++)
      t[i][j] = INF;
  for (i=1;i<=n;i++) {
    scanf("%d",&zab[i]);
    for (j=0;j<k;j++) {
      scanf("%d",&kr);
      while (kr!=-1) {
        zabm[i][j][sz[i][j]++]=kr;
        scanf("%d",&kr);
      }
    }
  }
  for (i=1;i<=m;i++) {
    scanf("%d%d%d",&x,&y,&v);
    t[x][y] = v;
    t[y][x] = v;
  }
}

int calc(int krast,int length,int prev) {
int gr = length%k;
int i;
  for (i=0;i<sz[krast][gr];i++)
    if (zabm[krast][gr][i]==prev) return 0;
  return zab[krast];
}

void floyd() {
int i,j;
int mid;
  for (mid=1;mid<=n;mid++)
    for (i=1;i<=n;i++)
      if (i!=mid)
        for (j=1;j<=n;j++)
          if ((j!=mid) && (i!=j) && (t[i][mid]!=INF)&&(t[mid][j]!=INF)) {
          int delta=calc(j,l[i][mid]+1,mid);
          int newd = t[i][mid]+t[mid][j]+delta;
            if (newd<t[i][j]) {
              t[i][j] = newd;
              l[i][j] = l[i][mid]+1;
            }
          }
}

void solve () {
int x,y;
  floyd();
  while (!feof(stdin)) {
    scanf("%d %d\n",&x,&y);
    if (x==y) {
      printf("%d\n",calc(x,0,x));
      continue;
    }
    if (t[x][y]==INF) printf("No route\n");
    else printf("%d\n",t[x][y]);
  }
//  fclose(f);
}

int main () {
  init();
//  printf("%d\n",calc(1,3,5));
  solve();
  return 0;
}
