#include <stdio.h>
#include <string.h>

#define MAX_N 510
#define MAX_LEN 255000
#define MAX_SQ 23

struct TPos{
 int row,col;
};

int         mm[MAX_N][MAX_N];
struct TPos mas[MAX_LEN];
int         sq[MAX_SQ];

int res=0;
int row1,col1,row2,col2;
int beg=0,vend=0;
int nsq=1;
int count=1,total;

void input();
void solve();
void output();

int main(void){

 input();
 solve();
 output();

 return 0;
}

void input(){

 scanf("%d %d %d %d", &row1,&col1,&row2,&col2);
 memset(mm,0,sizeof(mm));
 mas[0].row=1; mas[0].col=1;
 vend++;
 total=(row2-1)*(col2-1);
}

void solve(){
 int i,tmp,j;

 while(nsq*nsq<row2||nsq*nsq<col2){
  sq[nsq-1]=nsq*nsq;
  nsq++;
 }

 nsq--;

 while(beg<vend&&count<total){
  tmp=vend;
  for(i=beg; i<tmp; i++){
   for(j=0; j<nsq; j++){
    if(mas[i].row+sq[j]>=row2&&mas[i].col+sq[j]>=col2) break;
    if(mas[i].row+sq[j]<row2&&mm[mas[i].row+sq[j]][mas[i].col]==0){
     mm[mas[i].row+sq[j]][mas[i].col]=mm[mas[i].row][mas[i].col]+1;
     mas[vend].row=mas[i].row+sq[j]; mas[vend++].col=mas[i].col;
     count++;
    }
    if(mas[i].col+sq[j]<col2&&mm[mas[i].row][mas[i].col+sq[j]]==0){
     mm[mas[i].row][mas[i].col+sq[j]]=mm[mas[i].row][mas[i].col]+1;
     mas[vend].row=mas[i].row; mas[vend++].col=mas[i].col+sq[j];
     count++;
    }
   }
  }
  beg=tmp;
 }
}

void output(){
 int i,j;

 for(i=row1+1; i<row2; i++)
  for(j=col1+1; j<col2; j++)
   if(mm[i][j]%2==1)
    res++;

 printf("%d\n", res);
}

