#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define IN "worch.in"
#define MAX_LEN 22
#define MAX_WORDS 250010

FILE *fp;

struct TWord{
 char len;
 int ind;
};

struct TInterv{
 int beg;
 int vend;
};

struct TWord   mas[MAX_WORDS];
char           str[MAX_WORDS][MAX_LEN];
struct TInterv interv[MAX_LEN];
int            parent[MAX_WORDS];

int n=0;
int maximum;
int max_el=-1;

void input();
void solve();
void output(int ind);
void QSort(int l, int r);
void FindBest();
int  max(int aa, int bb);

int main(void){

 input();
 solve();
 output(max_el);

 return 0;
}

void input(){

// fp=fopen(IN,"r");

 while(!feof(stdin)){
  scanf("%s", str[n]);
  if(!feof(stdin)) n++;
 }

// fclose(fp);
}

void solve(){
 int i;
 int beg=0,vend=0;

 memset(parent,0,sizeof(parent));
 for(i=0; i<MAX_LEN; i++){
  interv[i].beg=-1; interv[i].vend=-1;
 }

 for(i=0; i<n; i++){
  mas[i].len=strlen(str[i]);
  mas[i].ind=i;
 }

 QSort(0,n-1);

 for(i=0; mas[i].len<3; i++);

 beg=i; vend=beg;
 for(i++; i<n; i++){
  if(mas[i].len==mas[i-1].len) vend++;
  else{
   interv[mas[i-1].len].beg=beg; interv[mas[i-1].len].vend=vend;
   beg=i; vend=beg;
   if(mas[i-1].len+1!=mas[i].len) {maximum=mas[i-1].len; break;}
  }
 }

 if(i==n){
  interv[mas[n-1].len].beg=beg; interv[mas[n-1].len].vend=vend;
  maximum=mas[n-1].len;
 }

 if(mas[0].len>3) exit(0);

 for(i=interv[3].beg; i<=interv[3].vend; i++)
  FindBest(i,-1);

}

void FindBest(int ind, int p){
 int i;

 max_el=max(max_el,ind);
 if(parent[ind]!=0) return;
 if(p!=-1) parent[ind]=p+1;
 if(mas[ind].len==maximum) {output(ind); exit(0);}

 for(i=interv[mas[ind].len+1].beg; i<=interv[mas[ind].len+1].vend; i++){
  if(check(str[mas[ind].ind],str[mas[i].ind],mas[ind].len)) {
   FindBest(i,ind);
  }
 }

}

int max(int aa, int bb){

 return (aa>bb) ? aa:bb;
}

int check(char ss1[], char ss2[], int len){
 int abc1[27];
 int abc2[27];
 int reg=0;
 int len1,len2;
 int i;

 memset(abc1,0,sizeof(abc1));
 memset(abc2,0,sizeof(abc2));

 len1=len; len2=len1+1;

 for(i=0; i<len1; i++)
  abc1[ss1[i]-(int)'a']++;

 for(i=0; i<len2; i++)
  abc2[ss2[i]-(int)'a']++;

 for(i=0; i<27; i++)
  if(abc1[i]!=abc2[i]&&reg!=0) return 0;
  else
   if(abc1[i]!=abc2[i]) reg=1;

 return 1;
}

void QSort(int l, int r){
 int h,g,x;
 struct TWord temp;

 h=l; g=r; x=mas[(h+g)/2].len;
 do{
  while(mas[h].len<x) h++;
  while(mas[g].len>x) g--;
  if(h<=g) {temp=mas[h]; mas[h++]=mas[g]; mas[g--]=temp;}
 }while(h<=g);

 if(h<r) QSort(h,r);
 if(l<g) QSort(l,g);
}

void output(int ind){
 int pom[MAX_LEN];
 int cc=0;
 int hlp;
 int i;

 hlp=ind;
 while(parent[hlp]!=0){
  pom[cc++]=hlp;
  hlp=parent[hlp]-1;
 }

 pom[cc++]=hlp;

 for(i=cc-1; i>=0; i--)
  printf("%s\n", str[mas[pom[i]].ind]);
}

