#include <iostream.h>

struct data
{
   int d;
   int a[11][100];
}node[100];

int as[100];
int ae[100];
int dist[100];
int vtd[100];
int str[100];
int nei[100][100];
int s,e,n,m,k,cc;
int maxint = 9999999;

void init()
{
   for (int i = 0; i <= n; i++)
   {
      dist[i] = maxint;
      vtd[i] = 0;
      str[i] = 0;
   }
   dist[1] = 0;
}

int red(int x, int y)
{
   int r = (str[x]+1) % 2;
   int i = 0;
   int found = false;
   while (node[y].a[r][i] != -1)
    if (node[y].a[r][i] == x)
    {
       found = true;
       break;
    }
    else i++;
   if (found) return 0;
   else return node[y].d;
}

void dfs(int u)
{
   int v;
   vtd[u] = 1;
   for (v = 1; v <= n; v++)
    if (nei[u][v] != 0)
     if (dist[u] + red(u,v) + nei[u][v] < dist[v])
     {
        dist[v] = dist[u] + red(u,v) + nei[u][v];
        str[v] = str[u] + 1;
     }
   int min = 0;
   int p = 0;
   for (p = 1; p <= n; p++)
    if (vtd[p] == 0 && dist[p] < dist[min])
     min = p;
   if (min != 0)
    dfs(min);
}

void output(int d)
{
   if (d != maxint)
    cout << d << endl;
   else
    cout << "No route" << endl;
}

void input()
{
   cin >> n >> m >> k;
   for (int i = 1; i <= n; i++)
   {
      cin >> node[i].d;
      for (int j = 0; j < k; j++)
      {
         int c = 0;
         while (node[i].a[j][c] != -1)
         {
            c++;
            cin >> node[i].a[j][c];
         }
      }
   }
   for (int i = 1; i <= m; i++)
   {
      int x,y,z;
      cin >> x >> y >> z;
      nei[x][y] = nei[y][x] = z;
   }
   int fs = 0;
   int fe = 0;
   while (!cin.eof())
   {
      cin >> s >> e;
      cc++;
      as[cc] = s;
      ae[cc] = e;
      fs = s; fe = e;
   }
}

void solve()
{
   for (int i = 1; i <= cc; i++)
   {
      dfs(as[cc]);
      output(dist[ae[cc]]);
   }
}

int main()
{
   input();
   solve();
   return 0;
}
