Const
  ArrNdxMax = 500;
  StepNdxMax = 23;
Type
  TData = Integer;
  TNdx = Integer;
  TArrNdx = 0..ArrNdxMax;
  TArr = Array[TArrNdx, TArrNdx] Of TData;
  TStepNdx = 0..StepNdxMax;
  TStep = Array[TStepNdx]Of TData;

Var
  Arr : TArr;
  Step : TStep;
  Ans : TData;
  I1, J1, I2, J2, MaxStep : TNdx;

   Procedure Init;
     Var
       I, J:TNdx;
     Begin
       For I:=0 To ArrNdxMax Do
         For J:=0 To ArrNdxMax Do
           Arr[I, J]:=2;
     End;

   Procedure ReadIn;
     Begin
       ReadLn(I1, J1, I2, J2);
     End;

   Function Max ( A, B:TData) : TData;
     Begin
       If A < B Then
         Max := B
       Else
         Max := A;
     End;


   Procedure MakeStep;
     Var
       I:TNdx;
     Begin
       MaxStep := Max(I2, J2);
       For I:=1 To MaxStep Do
         Step[I]:=Sqr(I);
     End;

   { -1 nedostijima
      0 toj pe4eli
      1 az pe4elq
      2 ne pregledana
   }

   Function F( I, J:TNdx) : TData;
     Var
       K:TNdx;
       St1, St2:TData;
       AllWaysWin, NotReachable:Boolean;
     Begin
       If (I < 1) Or (J < 1) Then
        Begin
          F:=-1;
          Exit;
        End
       Else If Arr[I, J] < 2 Then
         F:=Arr[I, J]
       Else
        Begin
          AllWaysWin:=True;
          NotReachable:=True;
          For K:=1 To MaxStep Do
           Begin
             St1:=F(I, J - Step[K]);
             St2:=F(I - Step[K], J);
             If (St1 = 1) Or (St2 = 1) Then
              Begin
                AllWaysWin:=False;
                NotReachable:=False;
                Break;
              End
             Else If (St1 <> -1) Or (St2 <> -1) Then
               NotReachable:=False;

             {If ((St1 = 0) Or (St1 = 1) Then
              Begin
                F:=1 - St1;
                Arr[I, J]:=1 - St1;
              End
             Else If (St2 = 0) Or (St2 = 1) Then
              Begin
                F:=1 - St2;
                Arr[I, J]:=1 - St2;
              End
             Else
              Begin
                F:=-1;
                Arr[I, J]:=-1;
              End;}
           End;

          If AllWaysWin Then
           Begin
             Arr[I, J]:=1;
             F:=1;
           End
          Else
           Begin
             Arr[I, J]:=0;
             F:=0;
           End;
          If NotReachable Then
           Begin
             Arr[I, J]:=-1;
             F:=-1;
           End;
        End;
     End;

   Procedure Solve;
     Var
       I, J:TNdx;
     Begin
       { popylwa Step sys kwadratite na 4islatata }
       MakeStep;

       { Iz4islqwane na tablicata }
       Arr[1, 1]:=0;
       For I:=1 To I2 - 1 Do
         For J:=1 To J2 - 1 Do
           Arr[I, J]:=F(I, J);

       { namirane na otgowora }
       For I:=I1 + 1 To I2 - 1 Do
         For J:=J1 + 1 To J2 - 1 Do
         If Arr[I, J] = 1 Then
           Inc(Ans, 1);
     End;

   Procedure Print;
     Begin
       WriteLn(Ans);
     End;

Begin
  Init;
  ReadIn;
  Solve;
  Print;
End.
