#include <stdio.h>

int squares[40];
int sq_ptr = 0;

int arr[512][512];

int can_win(int x, int y) {
	int i;

	for (i = 0; x - squares[i] > 0; i++)
		if (!arr[x - squares[i]][y])
			return 1;
	for (i = 0; y - squares[i] > 0; i++)
		if (!arr[x][y - squares[i]])
			return 1;
	return 0;
}

int main() {
	int i1, i2;
	int j1, j2;
	int i, j, c;

	scanf("%i %i %i %i", &i1, &j1, &i2, &j2);

	for (sq_ptr = 1; sq_ptr*sq_ptr <= 1000; sq_ptr++)
		squares[sq_ptr - 1] = sq_ptr*sq_ptr;

	for (i = 1; i < i2; i++)
		for (j = 1; j < j2; j++)
			arr[i][j] = can_win(i, j);

	c = 0;
	for (i = i1 + 1; i < i2; i++)
		for (j = j1 + 1; j < j2; j++)
			c += arr[i][j];

	printf("%i\n", c);

	return 0;
}

