#include <stdio.h>
#include <stdlib.h>
int MAX_VAL;
int data[600][600];
int vals[22]= {0,1,   4,   9,  16,  25,
                36,  49,  64,  81, 100,
               121, 144, 169, 196, 225,
               256, 289, 324, 361, 400,
               441};

int i1,i2,j1,j2;
int countfields;

void read(){
     data[1][1]=1;
     scanf("%d %d %d %d", &i1, &j1, &i2, &j2);
     if (i2>j2)
        MAX_VAL = i2 +1;
     else
        MAX_VAL = j2 +1;
}

int blackloses(int x, int y) {
    int i;

    if ((y == 1) && ( x == 1))
       return 0;

    if (data[x][y]==1)
       return 0;
    //x check
    i=1;
    while (x > vals[i] ) {
          if ( (data[y][x-vals[i]] != 1)||
               ((y == 1) && ( x - vals[i] == 1)) )
                  return 0;

          i++;
    }

    //y check
    i=1;
    while (y > vals[i] ) {
          if ((data[y - vals[i]][x] != 1) ||
              ((y - vals[i] == 1) && ( x == 1)) )
                  return 0;

          i++;
    }
    return 1;
}

void whitewin(int x, int y){
    int i;

    //x check
    i=1;
    while (x > vals[i] ) {
          if ( ((y == 1)&&( x - vals[i] == 1)) ||
               (blackloses(x-vals[i], y))) {
             data[y][x] = 1;

             return;
          }
          i++;
    }

    //y check
    i=1;
    while (y > vals[i] ) {
          if ( ((y - vals[i] == 1)&&( x == 1)) ||
                (blackloses(x,y - vals[i])) ) {
             data[y][x] = 1;
             return;
          }
          i++;
    }

    return;
}

void writetable() {
     int y,x;
     printf("\n");
     printf("\n");
     for (y = 1; y <= MAX_VAL; y++){
          for (x = 1;x <= MAX_VAL;x++)
              printf("%i, ",data[y][x]);
          printf("\n");
     }
}

void write() {
     printf("%i", countfields);
}

int inbounds(int xch,int ych){

    if ((xch == 1) && ( ych == 1))
       return 0;

    if ((i1< xch) && (xch<i2))
        if ((j1< ych) && (ych<j2))
           return 1;

    return 0;
}
int main() {
    int x,y,i;

    read();

    for (y =1; y<= MAX_VAL; y++)
        for (x =1; x<= MAX_VAL; x++){
           whitewin(x,y);
           if ( inbounds(x , y))
              if (data[y][x] == 1)
                   countfields++;
        }

    write();
    return 0;
}

