program bank;

type
	Integer = LongInt;
	TPrevod = record
		a, b			: Integer;
		sum			: Int64;
	end;
	TBank = record
		ind			: Integer;
		sum			: Int64;
	end;

var
	myBank				: Array [1 .. 30000] of Int64;
	un				: Array [1 .. 30000] of TBank;
	pr				: Array [1 .. 1000000] of TPrevod;
	N, M, K				: Integer;

procedure init;
var
	i				: Integer;
begin
	for i := 1 to 30000 do
		myBank[i] := 0;
end;

procedure readInput;
var
	myP				: TPrevod;
begin
	readln(N);
	myP.a := 1;
	while (myP.a <> 0) do begin
		readln(myP.a, myP.b, myP.sum);
		myBank[myP.a] := myBank[myP.a] - myP.sum;
		myBank[myP.b] := myBank[myP.b] + myP.sum;
	end;
end;

procedure tryToSolve;
var
	i, j				: Integer;

	procedure deleteEquals;
	var
		i, j			: Integer;
		x			: Integer;
	begin
		i := 1;
		while (i < M) do begin
			j := i + 1;
			while (j <= M) do begin
				if (un[i].sum = 0 - un[j].sum) then begin
					K := K + 1;
					if (un[i].sum > 0) then begin
						pr[K].a := un[j].ind;
						pr[K].b := un[i].ind;
						pr[K].sum := un[i].sum;
					end else begin
						pr[K].b := un[j].ind;
						pr[K].a := un[i].ind;
						pr[K].sum := un[j].sum;
					end;
					for x := j to M - 1 do
						un[x] := un[x + 1];
					M := M - 1;
					for x := i to M - 1 do
						un[x] := un[x + 1];
					M := M - 1;
				end;
				j := j + 1;
			end;
			i := i + 1;
		end;
	end;

	procedure qsort(l, r : Integer);
	var
  		i, j		: Integer;
		x		: Int64;
		y		: TBank;
	begin
  		i := l; 
		j := r;
		x := un[(l + r) DIV 2].sum;
  		repeat
	    		while (un[i].sum < x) do 
				i := i + 1;
    			while (x < un[j].sum) do 
				j := j - 1;
    			if (i <= j) then begin
      				y := un[i]; 
				un[i] := un[j]; 
				un[j] := y;
	      			i := i + 1; 
				j := j - 1;
    			end;
	  	until (i > j);
  		if (l < j) then 
			qsort(l, j);
  		if (i < r) then 
			qsort(i, r);
	end;	

begin
	M := 0;
	for i := 1 to N do
		if (myBank[i] <> 0) then begin
			M := M + 1;
			un[M].sum := myBank[i];
			un[M].ind := i;
		end;
	if (M = 0) then begin
		writeln('0');
		Exit;
	end else begin
		K := 0;
		deleteEquals;
		if (M > 0) then begin
			while (M > 0) do begin
				qsort(1, M);
				if (abs(un[1].sum) > un[M].sum) then begin
					K := K + 1;
					pr[K].a := un[1].ind;
					pr[K].b := un[M].ind;
					pr[K].sum := un[M].sum;
                                        un[1].sum := un[1].sum + un[M].sum;
                                        M := M - 1;
				end else if (abs(un[1].sum) < un[M].sum) then begin
					K := K + 1;
					pr[K].a := un[1].ind;
					pr[K].b := un[M].ind;
					pr[K].sum := abs(un[1].sum);
                                        un[M].sum := un[M].sum + un[1].sum;
                                        for i := 1 to M - 1 do
                                        	un[i] := un[i + 1];
					M := M - 1;
				end else begin
					K := K + 1;
					pr[K].a := un[1].ind;
					pr[K].b := un[M].ind;
					pr[K].sum := un[M].sum;
					M := M - 1;
					for i := 1 to M - 1 do
						un[i] := un[i + 1];
					M := M - 1;
				end;
			end;
		end;
		writeln(K);
		for i := 1 to K do
			writeln(pr[i].a, ' ', pr[i].b, ' ', pr[i].sum);
	end;
end;

begin
	init;
	readInput;
	tryToSolve;
end.