(*
SfNPMG_A3
Jordan Nikolov Markov
Sofia - NPMG
NPMG, 12
A
*)
var
  x, y: Integer;
  n: Integer;
  Count: Longint;
  Turns: Longint;

procedure WriteRes (a: Longint);
begin
  Writeln (a);
  Halt;
end;
procedure ReadInp;
var
  x0, y0: Integer;
begin
  Readln (x0, y0, x, y, n);
  Dec (x, x0);
  Dec (y, y0);
  Count := 0;
end;
function Persp (a, b, Turns: Integer): Boolean;
var
  x1, y1: Integer;
begin
  x1 := x - a;
  y1 := y - b;
  Persp := not
     (((x1 >= 0) and (y1 >= 0) and (x1 + y1 > n - Turns)) or
      ((x1 <= 0) and (y1 <= 0) and (x1 + y1 < -(n - Turns))) or
      ((x1 >= 0) and (y1 <= 0) and (x1 - y1 > n - Turns)) or
      ((x1 <= 0) and (y1 >= 0) and (y1 - x1 > n - Turns)));
end;
function Diff (x0, y0, x1, y1: Integer): Integer;
begin
  Diff := (x0 - x1) + (y0 - y1);
end;
procedure Recurse (a, b: Integer);
begin
  if (a = x) and (b = y) and (Turns = n) then
    Inc (Count);
  if Turns >= n then
    Exit;
  if not Persp (a, b, Turns) then
    Exit;
  if Abs (Diff (a, b, x, y) mod 2) <> Abs ((n - Turns) mod 2) then
    Exit;
  Inc (Turns);
  Recurse (a + 1, b);
  Recurse (a - 1, b);
  Recurse (a, b + 1);
  Recurse (a, b - 1);
  Dec (Turns);
end;
procedure Calc;
begin
  if ((x >= 0) and (y >= 0) and (x + y > n)) or
     ((x <= 0) and (y <= 0) and (x + y < -n)) or
     ((x >= 0) and (y <= 0) and (x - y > n)) or
     ((x <= 0) and (y >= 0) and (y - x > n)) then
    WriteRes (0);
  Turns := 0;
  Recurse (0, 0);
end;
begin
  ReadInp;
  Calc;
  WriteRes (Count);
end.
