#include <stdio.h>
#include <string.h>
#define MAX (1 << 5)
#define NUME 27

typedef struct  {
  int s[MAX];
} num;

void sum (num a, num b, num *c)  {
  int i, t, p;

  t = 0;
  for (i = NUME; 1 <= i; --i)  {
    c -> s[i] = (p = a.s[i] + b.s[i] + t) % 10;
    if (p >= 10)
      t = 1;
    else
      t = 0;
  }
}

void red (num a, num b, num *c)  {
  int i, t;

  t = 0;
  for (i = NUME; 1 <= i; --i)  {
    if (a.s[i] - b.s[i] - t >= 0)  {
      c -> s[i] = a.s[i] - b.s[i] - t;
      t = 0;
    }
    else  {
      c -> s[i] = 10 + a.s[i] - b.s[i] - t;
      t = 1;
    }
  }
}

char s[MAX]; int sl;
int ans[MAX];
num cs[MAX];
num a[MAX][MAX];
num n, n1, n0; int nl;

void readnum (num *a)  {
  int i;

  scanf ("%s", s);
  sl = strlen (s);

  for (i = 1; i <= sl; ++i)
    a -> s[NUME - i + 1] = s[sl - i] - '0';
}

int max (num a, num b)  {
  int i;

  for (i = 1; i <= NUME; ++i)
    if (a.s[i] > b.s[i])
      return +1;
    else if (a.s[i] < b.s[i])
      return -1;

  return 0;
}

void init ()  {
//freopen ("mono.in" , "r", stdin );
//freopen ("mono.out", "w", stdout);

  readnum (&n);
  n1.s[NUME] = 1;
}

void numinit (num *t)  {
  int i;

  for (i = 0; i <= NUME; ++i)
    t -> s[i] = 0;
}

int finddig (num *n, int p, int nl)  {
  int i, q;
  num t;

  numinit (&t);

  for (i = 1; ; ++i)  {
    sum (t, a[26 - ans[p - 1] - i][nl - p], &t);
    q = max (t, *n);
    if (q >= 0)
      break;
  }
  
  red   (t, a[26 - ans[p - 1] - i][nl - p], &t);
  red (*n, t, n);

  return ans[p - 1] + i;
}

void find (num n, int nl)  {
  int i, j, p;

  for (i = 1; i <=nl; ++i)
    ans[i] = finddig (&n, i, nl);
}

void think ()  {
  int i, j;
  num t;

  for (i = 0 ; i <= NUME; ++i)
    for (j = 0; j <= i; ++j)
      if (j == 0)
        sum (a[i][j], n1, &a[i][j]);
      else
        sum (a[i - 1][j - 1], a[i - 1][j], &a[i][j]);

  for (i = 1; i <= 26; ++i)
    cs[i] = a[26][i];

  numinit (&t);

  for (i = 1; ; ++i)  {
    sum (t, cs[i], &t);
    if (max (t, n) >= 0)
      break;
  }
  nl = i;

  for (i = 1; i <= nl - 1; ++i)
    red (n, cs[i], &n);

  find (n, nl);
}

void print ()  {
  int i;

  for (i = 1; i <= nl; ++i)
    printf ("%c", (char)(ans[i] + 'a' - 1));

  printf ("\n");
}

int main ()  {
  init ();
  think ();
  print ();

  return 0;
}
