#include <stdio.h>
#define MINC 22
#define MAX 50
#define MAXQ (1 << 16)
#define typ long long

typ min (typ a, typ b)  {
  return a <= b ? a : b;
}

typ max (typ a, typ b)  {
  return a >= b ? a : b;
}

typ abs0 (typ a)  {
  return a >= 0 ? a : -a;
}

typedef struct  {
  typ x, y, n;
} pt;

typ x1, y1, x2, y2, n;
typ ans;
typ ns[3][5] = { {0, 0, 0, 0, 0},
                 {0,+1,-1, 0, 0},
                 {0, 0, 0,+1,-1} };
typ nsn;
typ v[MAX][MAX][MAX];
pt q[MAXQ];
typ qb, qe, ql;

void qa (pt e)  {
  ++ql;

  q[qe] = e;
  qe = qe == MAXQ - 1 ? 0 : qe + 1;
}

pt qr ()  {
  pt t;

  --ql;

  t = q[qb];
  qb = qb == MAXQ - 1 ? 0 : qb + 1;

  return t;
}

void init ()  {
  typ mx, my;

//freopen ("robot.in" , "r", stdin );
//freopen ("robot.out", "w", stdout);

  scanf ("%lld%lld%lld%lld%lld", &x1, &y1, &x2, &y2, &n);
  nsn = 4;
  x2 = x2 - x1;
  y2 = y2 - y1;
  x1 = 0;
  y1 = 0;

  x1 += MINC;
  y1 += MINC;
  x2 += MINC;
  y2 += MINC;
}

void bfs (typ x1, typ y2)  {
  pt e, t;
  typ tl, i, j, mn;

  t.x = x1;
  t.y = y1;
  t.n = 0;
  qa (t);
  v[x1][y1][0] = 1;

  mn = 0;
  for (;ql;)  {
    ++mn;
    if (mn > n)
      break;
    tl = ql;
    for (i = 1; i <= tl; ++i)  {
      e = qr ();
      for (j = 1; j <= nsn; ++j)  {
        t.x = e.x + ns[1][j];
        t.y = e.y + ns[2][j];
        t.n = e.n + 1;
        if (!v[e.x + ns[1][j]][e.y + ns[2][j]][e.n + 1])
          qa (t);

        v[e.x + ns[1][j]][e.y + ns[2][j]][e.n + 1] += v[e.x][e.y][e.n];
      }
    }
  }
}

void think ()  {
  if (abs0 (x2 - x1) > n || abs0 (y2 - y1) > n)  {
    ans = 0;
    return;
  }

  bfs (x1, y1);
  ans = v[x2][y2][n];
}

void print ()  {
  printf ("%lld\n", ans);
}


int main ()  {
  init ();
  think ();
  print ();

  return 0;
}

