#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAXN 201
#define MAXS 20010

int n, s;
int a[MAXN], b[MAXN];

long long cmb[MAXS];
long long ownset[MAXN][MAXS];

void read () {
     int i;
//     freopen("game.in","r",stdin);
     scanf("%d %d",&n,&s);
     for (i = 1; i <= n; i++)
         scanf("%d%d",&a[i],&b[i]);
}

void solve () {
     int i,x,j;

     for (i = a[1]; i <= b[1]; i++) cmb[i]++;

     for (i = 2; i <= n; i++) {
         for (x = a[i]; x <= b[i]; x++) {
             for (j = s-x; j >= 1; j--) {
                 cmb[j+x] += cmb[j]-ownset[i][j];
                 ownset[i][j+x] += cmb[j]-ownset[i][j];
             }
         }
         // memset(ownset,0,sizeof(long long)*(s+1));
     }
}

void print () {
     printf("%lld\n",cmb[s]);
}

int main () {
    read();
    solve();
    print();
    return 0;
}



