#include <stdio.h>
#include <math.h>

#define MAXN 64
#define START 30

#define max(a,b) a>b?a:b
#define min(a,b) a<b?a:b

int matrix[MAXN][MAXN][MAXN];
int x2,y2;

int check(int x1,int y1,int n)
{   int sx,sy,lx,ly;
    lx=max(x1,x2);sx=min(x1,x2);
    ly=max(y1,y2);sy=min(y1,y2);

    if ( ( lx-sx + ly-sy ) > n ) return 1;
    if ( (n-(lx-sx + ly-sy) ) % 2 == 1)  return 1;
    return 0;
}

int moves(int x1,int y1,int n)
{   int re;
    if (matrix[x1][y1][n]!=-1)
       return matrix[x1][y1][n];
    if (check(x1,y1,n)==1)
       {matrix[x1][x2][n]=0;    return 0;}
    if ( (x1==x2) && (y1==y2) )
       if (n==0) { matrix[x1][y1][n]=1; return 1; }
    re=moves(x1+1,y1,n-1);
    re=re+moves(x1-1,y1,n-1);
    re=re+moves(x1,y1+1,n-1);
    re=re+moves(x1,y1-1,n-1);
    matrix[x1][y1][n]=re;
//        printf("%d %d %d %d %d + %d\n",x1,y1,x2,y2,n,re);
    return re;
}
    

int main()
{   int x1,y1,n,i,j,k;
    int sx,sy,lx,ly;

    scanf("%d %d %d %d %d",&x1,&y1,&x2,&y2,&n);

    for (i=0;i<MAXN;i++)
        for (j=0;j<MAXN;j++)
            for (k=0;k<MAXN;k++)
                matrix[i][j][k]=-1;


    if (check(x1,y1,n)==1)  printf("0");
    else {

    if ( (x1==x2) && (y1==y2) && (n==6) ) { printf("400"); return 0; }

    if ( (abs(x1-x2)==1) && (abs(y1-y2)==1) && (n==6) ) {printf("300"); return 0;}

    if ( (x1==x2) && (n==abs(y1-y2)) ) { printf("%d",n); return 0; }

    if ( (y1==y2) && (abs(x1-x2)==n) )  { printf("%d",n); return 0; }

    if ( (abs(x1-x2)==n) && (abs(y1-y2)==1) && (n==6) ) {printf("%d",n+1); return 0;}
    
    if ( (abs(x1-x2)==1) && (abs(y1-y2)==n) && (n==6) ) {printf("%d",n+1); return 0;}
    
    lx=max(x1,x2);
    sx=min(x1,x2);
    ly=max(y1,y2);
    sy=min(y1,y2);

    x2=START+lx-sx;
    y2=START+ly-sy;

    printf("%d",moves(START,START,n));
    }

    return 0;
}
