/*
NAME : Valentin Stoynov Mihov
PROB : game
CITY : Varna
DIVISION : A
*/

#include <stdio.h>
#include <string.h>

#define MAXN 201
#define MAXS 20001
#define MAXLEN 400

typedef struct
  {
    char nums[MAXLEN];
    int len;
  } SNum;

int n,s;
SNum T[MAXS];
SNum S[MAXS];
int inter[MAXN][2];

void Add(SNum *a,SNum *b)
  {
    int ost1 = 0,ost2,i;
    for (i = 0;i < b->len;i++)
      {
        if (i >= a->len) a->nums[a->len++] = 0;
        ost2 = (a->nums[i] + b->nums[i] + ost1) / 10;
        a->nums[i] = (a->nums[i] + b->nums[i] + ost1) % 10;
        ost1 = ost2;
      }
    while (ost1)
      {
        if (i >= a->len) a->nums[a->len++] = 0;
        ost2 = (a->nums[i] + ost1) / 10;
        a->nums[i] = (a->nums[i] + ost1) % 10;
        ost1 = ost2;
        i++;
      }
  }

void Sub(SNum *a,SNum *b)
  {
    int take1 = 0,take2,i;
    for (i = 0;i < b->len;i++)
      {
        if (a->nums[i] - b->nums[i] - take1 < 0)
          {
            take2 = 1;
            a->nums[i] += 10;
          }
        else take2 = 0;
        a->nums[i] = a->nums[i] - b->nums[i] - take1;
        take1 = take2;
      }
    if (take1) a->nums[i]--;
    for (i = a->len - 1;a->nums[i] == 0 && i >= 0;i--);
    a->len = i + 1;
  }

void Init()
  {
    int i;
//    freopen("game.in","rt",stdin);
    scanf("%d%d",&n,&s);
    for (i = 0;i < n;i++)
        scanf("%d%d",&inter[i][0],&inter[i][1]);
  }

void Solve2()
  {
    int i,j;
    memset(T,0,sizeof(T));
    memset(S,0,sizeof(S));
    
    // Fill the first row
    for (i = inter[0][0];i <= inter[0][1];i++)
      {
        T[i].nums[0] = 1;
        T[i].len = 1;
      }
      
    // Fill the first row with sums
    S[0].len = 0;
    for (i = 1;i <= s;i++)
      {
        S[i] = S[i - 1];
        Add(&S[i],&T[i]);
      }

    // Calc all
    for (i = 1;i < n;i++)    
      {
        memset(T,0,sizeof(T));
        // Calc the matrix
        for (j = inter[i][0];j <= s;j++)
          {
            T[j] = S[j - inter[i][0]];
            if (j - inter[i][1] - 1 >= 0 ) Sub(&T[j],&S[j - inter[i][1] - 1]);
          }
        // Calc the sums
        S[0].len = 0;
        for (j = 1;j <= s;j++)
          {
            S[j] = S[j - 1];
            Add(&S[j],&T[j]);
          }
      }
  }

void Output()
  {
    int i;
    if (T[s].len == 0) { T[s].len = 1;T[s].nums[0] = 0;}
    for (i = T[s].len - 1;i >= 0;i--)
      printf("%d",T[s].nums[i]);
    printf("\n");
  }

int main()
  {
    Init();
    Solve2();
    Output();
    return 0;
  }
