/*
NAME : Valentin Stoynov Mihov
PROB : robot
CITY : Varna
DIVISION : A
*/

#include <stdio.h>
#include <stdlib.h>

#define MAXX 50
#define MAXY 50
#define MAXN 30
#define ABS(a) ((a) > 0?(a) : (-(a)))
#define MOVES 4

int x1,y1,x2,y2,n;
long long T[MAXN][MAXX][MAXY];
short moves[MOVES][2] = {{-1,0},{1,0},{0,1},{0,-1}};

void Init()
  {
//    freopen("robot.in","rt",stdin);
    scanf("%d%d%d%d%d",&x1,&y1,&x2,&y2,&n);
  }

void OutputNo()
  {
    printf("0\n");
    exit(0);
  }

void Solve()
  {
    int i,tmpx,tmpy,j,x,y;
    // Init data
    memset(T,0,sizeof(T));

    // Make translation
    tmpx = x1 - n;
    tmpy = y1 - n;
    x1 -= tmpx;
    x2 -= tmpx;
    y1 -= tmpy;
    y2 -= tmpy;

    // Check for solution existence
    if (ABS(x1 - x2) + ABS(y1 - y2) > n) OutputNo();

    for (j = 0;j < MOVES;j++)
      T[0][x1 + moves[j][0]][y1 + moves[j][1]] = 1;

    for (i = 1;i < n;i++)
      for (x = 0;x <= 2*n;x++)
        for (y = 0;y <= 2*n;y++)
          for (j = 0;j < MOVES;j++)
            T[i][x][y] += T[i - 1][x + moves[j][0]][y + moves[j][1]];
  }

void Output()
  {
    printf("%lld\n",T[n - 1][x2][y2]);
  }

int main()
  {
    Init();
    Solve();
    Output();
    return 0;
  }
  
