/*
PROG : robot
NAME : vladimir nedev
*/

#include <stdio.h>

//#define DEBUG

#define IN      "robot.in"
#define OUT     "robot.out"
#define MAX     50
#define HALF    25

long startx, starty, endx, endy, n;
long long save[MAX][MAX][MAX];

long long rec(long x, long y, long move)
{
   if(x==endx && y==endy && move==n)
     return 1;

   if(move==n) return 0;

   if(save[x][y][move])
     return save[x][y][move]-1;

   save[x][y][move]=rec(x-1, y, move+1);
   save[x][y][move]+=rec(x+1, y, move+1);
   save[x][y][move]+=rec(x, y-1, move+1);
   save[x][y][move]+=rec(x, y+1, move+1);

   save[x][y][move]++;
   
   return save[x][y][move]-1;
}

int main()
{
   long i, diff;

#ifdef DEBUG
   freopen(IN, "r", stdin);
#endif
   scanf("%ld%ld%ld%ld%ld", &startx, &starty, &endx, &endy, &n);
#ifdef DEBUG
   fclose(stdin);
#endif

   if(startx-endx+starty-endy>n)
   {
     startx=0;
     starty=0;
     save[0][0][0]=1;
   }
   else
   {
     diff=startx-HALF;
     startx-=diff;
     endx-=diff;
     diff=starty-HALF;
     starty-=diff;
     endy-=diff;
     
     rec(startx, starty, 0);
   }

#ifdef DEBUG
   freopen(OUT, "w", stdout);
#endif
   printf("%lld\n", save[startx][starty][0]-1);
#ifdef DEBUG
   fclose(stdout);
#endif

   return 0;
}

