  #include <iostream.h>
  #define MAXN 999
  double x[MAXN+1],y[MAXN+1];
  int pos[MAXN+1],s1[MAXN+1],s2[MAXN+1],n;

  int chk(int x1,int y1,int x2,int y2,int x3,int y3)
  {
   double a=(x1-x2)*(y1+y2);
   a+=(x2-x3)*(y2+y2);
   a+=(x3-x1)*(y3+y1);
   if(a>0) return 1;
   else if(a<0) return -1;
   else if(a==0) return 0;
   return 2;
  }

  void qsort(int l, int r)
  {
   int i=l,j=r;
   double k=x[(l+r)/2];
   while(i<j)
   {
    while(x[i]<k) i++;
    while(x[j]>k) j--;
    if(i<j)
    {
     double t=x[i];
     x[i]=x[j];
     x[j]=t;
     int pt=pos[i];
     pos[i]=pos[j];
     pos[j]=pt;
     t=y[i];
     y[i]=y[j];
     y[j]=t;

    }
    i++;
    j--;
   }
   if(l<j) qsort(l,j);
   if(i<r) qsort(i,r);
  }

  void convex_hull()
  {
   if(x[1]==x[2])
    if(y[2]<y[1])
    {
     int t=pos[1];
     pos[1]=pos[2];
     pos[2]=t;
     t=y[1];
     y[1]=y[2];
     y[2]=t;
    }

   if(x[n]==x[n-1])
    if(y[n]<y[n-1])
    {
     int t=pos[n];
     pos[n]=pos[n-1];
     pos[n-1]=t;
     t=y[n];
     y[n]=y[n-1];
     y[n-1]=t;
    }
   int l1=0,l2=0,i,j,j1,j2,t;
   s1[l1++]=1;
   s1[l1++]=2;
   for(i=3;i<=n;i++)
   {
    s1[l1++]=i;
    for(j=l1-1;j>1;)
     if(s1[j])
     {
      j1=j-1;
      while(s1[j1]==0) j1--;
      j2=j1-1;
      while(s1[j2]==0) j2--;
      if(j2<0) break;
      if(chk(x[s1[j2]],y[s1[j2]],x[s1[j1]],y[s1[j1]],x[s1[j]],y[s1[j]]) >=0)
       s1[j1]=0;
      else break;
     }
   }
   s2[l2++]=n;
   s2[l2++]=n-1;
   for(i=n-2;i>=1;i--)
   {
    s2[l2++]=i;
    for(j=l2-1;j>1;)
     if(s2[j])
     {
      j1=j-1;
      while(s2[j1]==0) {if(j1>=1)j1--;else break;}
      j2=j1-1;
      while(s2[j2]==0) {if(j2>=0)j2--;else break;}
      if(j2<0) break;
      if(chk(x[s2[j2]],y[s2[j2]],x[s2[j1]],y[s2[j1]],x[s2[j]],y[s2[j]]) >=0)
       s2[j1]=0;
      else break;
     }
   }
   int br=0;
   for(i=0;i<l1;i++) if(s1[i]) br++;
   for(i=0;i<l2;i++) if(s2[i]) br++;
   br-=2;
   l1--;
   l2--;
   cout<<br<<endl;
   cout<<pos[s1[0]];
   for(i=1;i<l1;i++)
    if(s1[i]) cout<<' '<<pos[s1[i]];
   cout<<' '<<pos[s2[0]];
   for(i=1;i<l2;i++)
    if(s2[i]) cout<<' '<<pos[s2[i]];
   cout<<endl;
  }

  void main()
  {
   int i;
   cin>>n;
   for(i=1;i<=n;i++)
    cin>>x[i]>>y[i];
   for(i=1;i<=n;i++) pos[i]=i;
   if(n>1) qsort(1,n);
   convex_hull();
  }