#include <iostream>
using namespace std;

#define maxn 1001

int m,n;
int a[ maxn ][ maxn ];

void init( )
{
	int i, j;

//      ifstream cin( "table.inp " );
	cin>>m>>n;

	for  ( i=1; i<=m; i++ )
		for  ( j=1; j<=n; j++ )
			cin>>a[ i ][ j ];
//      cin.close( );
}


long see1diag( )
{
	int i, j, k, l;
	long s = 0;
	long smax = 0;

	i = 1;
	j = n;

	for ( j=n; j >= 1; j-- )
	{
		k = i;
		l = j;

		s = 0;

		while ( k <= m && l <= n )
		{
			s = 0;
			while ( a[ k ][ l ] <= 0 && k <= m && l <= n )
				{ k++; l++;  }

			while ( a[ k ][ l ] > 0 && k <= m && l <= n )
				{  s += a[ k ][ l ];  k++; l++; }

			if ( s > smax )
				smax = s;
		}
	}

	j = 1;

	for ( i=2; i<=m; i++ )
	{
		k = i;
		l = j;

		s = 0;

		while ( k <= m && l <= n )
		{
			s = 0;
			while ( a[ k ][ l ] <= 0 && k <= m && l <= n )
				{ k++; l++;  }

			while ( a[ k ][ l ] > 0 && k <= m && l <= n )
				{  s += a[ k ][ l ];  k++; l++; }

			if ( s > smax )
				smax = s;
		}

	}
	return smax;
}


long see2diag( )
{
	int i, j, k, l;
	unsigned long s = 0;
	unsigned long smax = 0;

	i = 1;
	j = 1;

	for  ( j=1; j <= n; j++ )
	{
		k = i;
		l = j;

		while ( k <= m && l > 0 )
		{
			s = 0;

			while ( a[ k ][ l ] <= 0 && k <= m && l > 0 )
				{ k++; l--; }

			while ( a[ k ][ l ] > 0 && k <= m && l > 0 )
				{ s += a[ k ][ l ]; k++; l--; }

			if ( s > smax )
				smax = s;
		}
	}

	j = n;
	i = 2;

	for ( ; i<=m; i++ )
	{
		k = i;
		l = j;

		while ( l > 0 && k <= m )
		{
			s=0;
			while ( a[ k ][ l ] <= 0 && k <= m && l > 0 )
				{ k++; l--; }

			while ( a[ k ][ l ] > 0 && k <= m && l > 0 )
				{ s += a[ k ][ l ]; k++; l--; }
			if ( s > smax )
				smax = s;
		}

	}

	return smax;
}


long seevert( )
{
	int i, j;
	long s = 0;
	long smax = 0;

	for  ( j=1; j<=n; j++ )
	{
		i = 1;

		while ( i <= m )
		{
			s = 0;

			while ( a[ i ][ j ] <= 0 && i<=m ) i++;

			while ( a[ i ][ j ] > 0 && i<=m )
			{
				s += a[ i ][ j ];
				i++;
			}

			if ( s > smax )
				smax = s;
		}
	}

	return smax;
}


long seehoriz( )
{
	int i, j;
	long s = 0;
	long smax = 0;

	for  ( i=1; i<=m; i++ )
	{
		j = 1;

		while ( j <= n )
		{
			s = 0;

			while ( a[ i ][ j ] <= 0 && j <=n ) j++;

			while ( a[ i ][ j ] > 0 && j <= n )
			{
				s += a[ i ][ j ];
				j++;
			}

			if ( s > smax )
				smax = s;
		}
	}
	return smax;
}


unsigned long solve( )
{
	unsigned long max = 0;
	unsigned long horiz = seehoriz( );
	unsigned long vert = seevert( );
	unsigned long diag1 = see1diag( );
	unsigned long diag2 = see2diag( );

	if ( horiz > max )
		max = horiz;

	if ( vert > max )
		max = vert;

	if ( diag1 > max )
		max = diag1;

	if ( diag2 > max )
		max = diag2;

	return max;
}


main()
{
	init( );
	cout<<solve( )<<endl;
}
