#include <iostream.h>
#include <string.h>
#include <stdlib.h>

char C[256];
char R[256];
int len;

void init();
void barcode();
int valid();
char cr(int r);
void country();
int between(int x,int a, int b);
void out(char*s);

int main()
{
 init();
 barcode();
 country();

 return 0;
}

void init()
{
 cin>>C;
 len=strlen(C);
}

void barcode()
{
 if(!valid()) {cout<<"Invalid barcode"<<endl; return;}

 int i,j,r,pos;
 pos=i=j=0;

 for(int t=0;t<len;)
 {
  i=t;
  while(C[i]=='0') i++;
  j=i+1;
  while(C[j]=='0') j++;
  r=j-i-1;
  if(r>9) {out("Invalid barcode"); return;}
  R[pos++]=cr(r);
  R[pos]='\0';
  t=j+1;
  if((C[t]=='0')&&(t<len)) {cout<<"Invalid barcode"<<endl; return;}
 }
}

int valid()
{
 if(C[0]!='1'||C[len-1]!='1') return 0;
}

char cr(int r)
{
 switch(r)
 {
  case 0: return '0';break;
  case 1: return '1';break;
  case 2: return '2';break;
  case 3: return '3';break;
  case 4: return '4';break;
  case 5: return '5';break;
  case 6: return '6';break;
  case 7: return '7';break;
  case 8: return '8';break;
  case 9: return '9';break;
 }
}

void country()
{
 if(strlen(R)<2) {out(R); return;}

 char* p;

 p=new char[3];
 strncpy(p,R,2);
 p[2]='\0';
 if(strcmp(p,"00")==0) {out("US"); return;}

 int x;
 x=atoi(p);

 if(between(x,0,13)) {out("US"); delete[]p; return;}
 if(between(x,30,37)) {out("FR"); delete[]p; return;}
 if(between(x,80,83)) {out("IT"); delete[]p; return;}
 if(x==45||x==49) {out("JP"); delete[]p; return;}
 if(x==50) {out("GB"); delete[]p; return;}
 if(x==84) {out("SP"); delete[]p; return;}

 if(strlen(R)>2)
 {
  p=new char[4];
  strncpy(p,R,3);
  p[4]='0';

  x=atoi(p);

  if(x==380) {out("BG"); delete[]p; return;}
  if(x==383) {out("SL"); delete[]p; return;}
  if(x==471) {out("TW"); delete[]p; return;}
  if(x==520) {out("GR"); delete[]p; return;}
  if(between(x,400,440)) {out("D"); delete[]p; return;}
  if(between(x,460,469)) {out("RU"); delete[]p; return;}
  if(between(x,690,692)) {out("CH"); delete[]p; return;}
 }
 delete[]p;
 out(R);
}

int between(int x,int a, int b)
{
 if(x>=a&&x<=b) return 1;
 return 0;
}

void out(char*s)
{
 cout<<s<<endl;
}