#include <stdio.h>
#include <math.h>

int n;
int q, ques;
typedef struct {
	int a;
	int b;
} qcell;
qcell que[131072];
double dist[1024][1024];
int loced[1024];
double loc[1024][2];

int orient(int a, int b, int c) {
	return loc[a][0]*loc[b][1]+loc[b][0]*loc[c][1]+loc[c][0]*loc[a][1]-loc[a][0]*loc[c][1]-loc[b][0]*loc[a][1]-loc[c][0]*loc[b][1];
}

int main(void) {
	int i, j, s1, s2, t1, t2, qa, qb;
	double d, cl, cosine, sine, bcos, ang;

	scanf("%d %d %d", &n, &s1, &s2);
	while (scanf("%d %d %lf", &t1, &t2, &d)==3) {
		dist[t1][t2] = d;
		dist[t2][t1] = d;
	}
	loced[s1] = loced[s2] = 1;
	loc[s2][0] = dist[s1][s2];
	que[ques].a = s1;
	que[ques].b = s2;
	ques++;
	for (q=0; q<ques; q++) {
		qa = que[q].a;
		qb = que[q].b;
		if (dist[qb][qa]>0) {
			cl = 2000000000;
			j = 0;
			for (i=1; i<=n; i++) if (i!=qa && i!=qb && dist[qa][i]>0 && dist[i][qb]>0) {
				if (loced[i] && orient(qa, qb, i)<0) continue;
				cosine = (dist[qa][i]*dist[qa][i]+
								dist[qb][qa]*dist[qb][qa]-
								dist[i][qb]*dist[i][qb])/
								(2*dist[qa][i]*dist[qb][qa]);
				sine = sqrt(1-cosine*cosine);
				if (sine*dist[qa][i] < cl) {
					bcos = cosine;
					cl = sine*dist[qa][i];
					j = i;
				}
			}
			if (j) {
				if (!loced[j]) {
					ang = acos(bcos)+atan2(loc[qb][1]-loc[qa][1], loc[qb][0]-loc[qa][0]);
					loc[j][0] = loc[qa][0]+cos(ang)*dist[qa][j];
					loc[j][1] = loc[qa][1]+sin(ang)*dist[qa][j];
					loced[j] = 1;
				}
				dist[qa][j] = 0;
				dist[j][qb] = 0;
				dist[qb][qa] = 0;
				que[ques].a = qa;
				que[ques].b = j;
				ques++;
				que[ques].a = j;
				que[ques].b = qb;
				ques++;
			}
		}
	}
	for (i=1; i<=n; i++) printf("%.2lf\n", sqrt((loc[s1][0]-loc[i][0])*(loc[s1][0]-loc[i][0])+(loc[s1][1]-loc[i][1])*(loc[s1][1]-loc[i][1])));

	return 0;
}
