#include <iostream>

using namespace std;

const unsigned MAXN = 2048;
const unsigned long long MOD = 1020847;

unsigned long long F[ MAXN ];
unsigned long long nF[ MAXN ];
unsigned long long n, p;


int main( )
{
 	cin >> n >> p;
	unsigned long long int i, j;

	F[ 1 ] = 1;
	F[ 0 ] = 0;
	unsigned long long t, t1;

	for ( i=1; i <= n; i++ )
	{
		for ( j=1; j<=i; j++ )
		{
		 	if ( j == i || j == 1 )
			  nF[ j ] = 1;
			else
			{
			 	t = ( F[ j ] * j ) % MOD;
				t1 = ( F[ j - 1 ] * (i-j+1) ) % MOD;

			 	nF[ j ] = ((t+t1)%MOD);
			}
      }

   	for ( j=1; j<=n; j++ )
			F[ j ] = nF[ j ];
   }

	cout << F[ p ] << endl;
	return 0;
}
