#include <stdio.h>
#define MAX_VALUE 15001

int i, j, otkyde, n, x, visited[1024], y;
long double a[1024][1024], dist[1024], min_dist, d;

void Dijkstra(int node)
{

  for(i = 1; i <= n; i++)
    dist[i] = MAX_VALUE;
  dist[node] = 0;

  for(;;)
  {
    min_dist = MAX_VALUE;

    for(i = 1; i <= n; i++)
      if((dist[i] < min_dist) && !visited[i])
      {
        min_dist = dist[i];
        node = i;
      }
    if(min_dist == MAX_VALUE)
      return;
      
    visited[node] = 1;
    for(i = 1; i <= n; i++)
      if(a[node][i])
        if(dist[i]  > dist[node] + a[node][i])
          dist[i] = dist[node] + a[node][i];

  }
}

int main()
{
  scanf("%d %d %llf", &n, &otkyde, &x);
  while(scanf("%d %d %llf", &x, &y, &d) == 3)

  {
    a[x][y] = d;
    a[y][x] = d;
  }
  Dijkstra(otkyde);
  for(i = 1; i <= n; i++)
    printf("%.llf\n", dist[i]);

  return 0;
}
