type
   txy = record x, y : extended; end;

var
   a : array[1..1000, 1..1000] of extended;
   b : array[1..1000] of txy;
   c : array[1..1000] of longint;
   nb : array[1..1000, 1..1000] of longint;
   par : array[1..1000] of record p1, p2 : longint; end;
   u : array[1..1000] of boolean;
   v1, v2 : longint;
   n : longint;

procedure pp(p1, p2 : txy; r, q : extended; var a1, a2 : txy);
var
   u, v, k, a, b, c, d : extended;
begin
   u:=p2.x - p1.x;
   v:=p2.y - p1.y;
   k:=(r*r + u*u + v*v - q*q) / (2*u);
   a:=(v*v)/(u*u) + 1;
   b:=-(2*k*v)/u;
   c:=k*k - r*r;
   d:=b*b - 4*a*c;
   a1.y:=(-b + sqrt(d)) / (2*a);
   a2.y:=(-b - sqrt(d)) / (2*a);
   a1.x:=(r*r + u*u + v*v - q*q - 2*v*a1.y) / (2*u);
   a2.x:=(r*r + u*u + v*v - q*q - 2*v*a2.y) / (2*u);
   a1.x:=a1.x + p1.x;
   a1.y:=a1.y + p1.y;
   a2.x:=a2.x + p1.x;
   a2.y:=a2.y + p1.y;
end;

procedure add(v : longint; x, y : extended; par1, par2 : longint);
var i : longint;
begin
   b[v].x:=x; b[v].y:=y;
   par[v].p1:=par1;
   par[v].p2:=par2;
   u[v]:=true;
   for i:=1 to n do
      if (not u[i]) and (a[v, i] <> 0) then
      begin
         inc(c[i]);
         nb[i, c[i]]:=v;
      end;
end;

function equal(a, b : extended) : boolean;
begin
   equal:=(abs(a-b) < 0.00000001);
end;

function dist(a, b : txy) : extended;
begin
   dist:=sqrt(sqr(a.x-b.x) + sqr(a.y-b.y));
end;

var
   i, j, k : longint;
   i1, i2 : longint;
   t, d1, d2 : extended;
   a1, a2, t1, t2 : txy;
begin
   readln(n, v1, v2);
   while not eof do
   begin
      readln(i1, i2, t);
      a[i1, i2]:=t;
      a[i2, i1]:=t;
   end;
   add(v1, 0, 0, 0, 0);
   add(v2, a[v1, v2], 0, 0, 0);

   for i:=1 to n-2 do
   begin
      for j:=1 to n do
         if (not u[j]) and (c[j] >= 2) then
            break;
      pp(b[nb[j,1]], b[nb[j,2]], a[j,nb[j,1]], a[j,nb[j,2]], a1, a2);

      if a1.y <= 0 then
         add(j, a2.x, a2.y, nb[j,1], nb[j,2])
      else if a2.y <= 0 then
         add(j, a1.x, a1.y, nb[j,1], nb[j,2])
      else
      begin
         for k:=1 to n do
            if u[k] then
               if not equal(a[k,j], sqrt(sqr(b[k].x-a1.x) + sqr(b[k].y-a1.y))) then
               begin
                  add(j, a2.x, a2.y, nb[j,1], nb[j,2]);
                  continue;
               end
               else if not equal(a[k,j], sqrt(sqr(b[k].x-a2.x) + sqr(b[k].y-a2.y))) then
               begin
                  add(j, a1.x, a1.y, nb[j,1], nb[j,2]);
                  continue;
               end;

         if par[nb[j,1]].p1 <> nb[j,2] then
            k:=par[nb[j,1]].p1
         else
            k:=par[nb[j,1]].p2;

         if dist(b[k], a1) > dist(b[k], a2) then
            add(j, a1.x, a1.y, nb[j,1], nb[j,2])
         else
            add(j, a2.x, a2.y, nb[j,1], nb[j,2]);
      end;
   end;

   for i:=1 to n do
      writeln(dist(b[v1], b[i]):0:2);
end.
