program hedge;

const
	MAXN				= 2000;
	M				= 1020847;

type
	Integer				= LongInt;
	Int64				= LongInt;

var
	F				: Array [1 .. MAXN, 1 .. MAXN] of Int64;
	nfmod				: Integer;
	N, P, i, j			: Integer;

begin
	readln(N, P);
	for i := 1 to N do
		for j := 1 to N do
			F[i, j] := 0;
	for i := 1 to N do
		F[i, 1] := 1;
	for i := 2 to N do
		for j := 2 to P do begin
			F[i, j] := (j * F[i-1,j]) mod M;
			nfmod := F[i-1,j-1]*(i-1);
			nfmod := abs(nfmod - ((j-1)*F[i-1,j-1])) mod M;
			F[i, j] := (F[i, j] + nfmod) mod M;
                        F[i, j] := (F[i-1,j-1] + F[i,j]) mod M;
		end;
	writeln(F[N, P]);
end.
	