#include <stdio.h>
#include <math.h>
#define sqr(a) ((a)*(a))

double a[1001][1001];

int n,p,q;

void solve2(int i) {

for (int k=1; k<=n-1; k++)
 if (a[q][k] != -1.0 && a[i][k] != -1.0 && k != q)
  for (int s=k+1; s<=n; s++)
	if (a[q][s] != -1.0 && a[i][s] != -1.0 && a[k][s] != -1 && s != q) {

	  double cos_1 = -(sqr(a[q][s])-sqr(a[k][q])-sqr(a[k][s])) / (2*a[k][q]*a[k][s]);
	  double cos_2 = -(sqr(a[i][s])-sqr(a[k][s])-sqr(a[k][i])) / (2*a[k][s]*a[k][i]);
	  double cos_3 = cos(acos(cos_1)+ acos(cos_2));

	  double f = sqrt(a[k][q]*a[k][q] + a[k][i]*a[k][i] - 2*cos_3*a[k][q]*a[k][i]);
	  a[i][q] = f; a[q][i] = f;
	  }

}



double solve(int i) {
solve2(i);
for (int k=1; k<=n-1; k++)
 if (a[p][k] != -1.0 && a[i][k] != -1.0 && k != p)
  for (int s=k+1; s<=n; s++)
    if (a[p][s] != -1.0 && a[i][s] != -1.0 && a[k][s] != -1 && s != p) {

      double cos_1 = -(sqr(a[p][s])-sqr(a[k][p])-sqr(a[k][s])) / (2*a[k][p]*a[k][s]);
      double cos_2 = -(sqr(a[i][s])-sqr(a[k][s])-sqr(a[k][i])) / (2*a[k][s]*a[k][i]);
      double cos_3 = cos(acos(cos_1)+ acos(cos_2));
      double f = sqrt(a[k][p]*a[k][p] + a[k][i]*a[k][i] - 2*cos_3*a[k][p]*a[k][i]);

    return f;
    }

}

int main() {
int i,j;
scanf("%d%d%d",&n,&p,&q);

for (i=1; i<=n; i++)
 for (j=1; j<=n; j++)
	if (i!=j) a[i][j] = -1.0;

while (!feof(stdin)) {
  double k;
  scanf("%d%d%lf", &i,&j,&k);
  a[i][j] = k;
  a[j][i] = k;
  }

for (i=1; i<=n; i++) {
	if (a[p][i] == -1.0) {
     a[i][p] = solve(i);
     a[p][i] = a[i][p];
     }
     
   printf("%.2lf\n", a[p][i]);
   }

return 0;
}

