/*
TASK:guard
LANG:C++
*/
#include <iostream>
#include <math.h>
using namespace std;
struct vec
{
       double x,y;
};
vec a[10][10];
vec o;
vec rot;
double modvec(vec V)
{
	return sqrt(V.x*V.x+V.y*V.y);
}
void normalize()
{
     vec trans=o;
     o.x-=trans.x;
     o.y-=trans.y;
     
     for(int i=1;i<=3;i++)
     {
             a[i][1].x-=trans.x;
             a[i][1].y-=trans.y;
             a[i][2].x-=trans.x;
             a[i][2].y-=trans.y;
     }
     
     for(int i=1;i<=3;i++)
     {
			double k=100./modvec(a[i][1]);
			a[i][1].x*=k;
			a[i][1].y*=k;
			
			
			k=100./modvec(a[i][2]);
			a[i][2].x*=k;
			a[i][2].y*=k;
	 }
     for(int i=1;i<=3;i++) swap(a[i][1],a[i][2]);    
}
double sina,cosa;
bool in[10];

bool eq(vec v1,vec v2)
{
	return ((v1.x-v2.x)*(v1.x-v2.x) <= 0.0000001 && (v1.y-v2.y)*(v1.y-v2.y) <= 0.0000001 );	
}
void startRotation()
{
		sina=sin(M_PI/2500.);
		cosa=cos(M_PI/2500.);
		vec tmp;
		int p=0;
		int pi=0 ;
		for(int i=0;i<=5000;i++)
		{
			for(int j=1;j<=3;j++)
				if(eq(rot,a[j][1])) in[j]=1;
				
			
			if(in[1] || in[2] || in[3]) p++;	
			
			for(int j=1;j<=3;j++)
				if(eq(rot,a[j][2]))
				{
					if(in[j]) {in[j]=0;pi=i;}
					else if( !in[1] && !in[2] && !in[3]) p+=i-pi;
				}	
			
			tmp= (vec) {cosa*rot.x+sina*rot.y , -sina*rot.x+cosa*rot.y};
			rot=tmp;
		}
		
		double d=(double)p/50.;
		if(d-double((int)d)<0.5) cout<<(int)d<<endl;
		else cout<<(int)(d+1)<<endl;
		
		
}
int main()
{
    cin>>o.x>>o.y;
    for(int i=1;i<=3;i++)
        cin>>a[i][1].x>>a[i][1].y>>a[i][2].x>>a[i][2].y;
    
    normalize();
    
   // for(int i=1;i<=3;i++)
   //     cout<<a[i][1].x<<" "<<a[i][1].y<<" "<<a[i][2].x<<" "<<a[i][2].y<<endl;
    rot=a[1][1];
    
    startRotation();
    
   return 0; 
   
}
