/*
LANG:C++
TASK:guard
*/
#include <iostream>
#include <math.h>

using namespace std;

struct point{
       int x,y;
};

int SP(point p0,point p1,point p2){
       return (p1.x-p0.x)*(p2.x-p0.x)+(p1.y-p0.y)*(p2.y-p0.y);
}

int CP(point p0,point p1,point p2){
       return (p1.x-p0.x)*(p2.y-p0.y)-(p2.x-p0.x)*(p1.y-p0.y);
}

double dist(point p0,point p1){
    return sqrt((p1.x-p0.x)*(p1.x-p0.x)+(p1.y-p0.y)*(p1.y-p0.y));
}

point c,g[3][2];
double sol,coss[3];
int i,j;

int main(){
    cin>>c.x>>c.y;
    for(i=0;i<3;i++){
        for(j=0;j<2;j++) cin>>g[i][j].x>>g[i][j].y;
    }
    for(i=0;i<3;i++){
        coss[i]=SP(c,g[i][0],g[i][1]);
        coss[i]/=dist(c,g[i][0])*dist(c,g[i][1]);
        if(SP(c,g[i][0],g[i][1])<0) sol+=2*M_PI-acos(coss[i]);
        else sol+=acos(coss[i]);
    }
    sol/=2*M_PI;
    sol*=100;
    if (sol-((int)sol)>0.5) sol+=1;
    if(sol>=100) cout<<"100";
    else cout<<(int)sol;
    cout<<"\n";
    return 0;
}
    
