/*
TASK: gen
LANG: C++
*/

#include <iostream>
#include <queue>
#include <set>
#include <cmath>
#include <ctime>

using namespace std;

pair<long long int,long long int> st;
long long int c;
double sTime,fTime,rTime;

long long int GCD(long long int a,long long int b)
{ 
 while(b)
 {c=b; b=a%c; a=c;}
 return a; 
}

void bfs()
{
 set< pair<long long int,long long int> > used;
 queue< pair< pair<long long int,long long int>, int > > q;
 pair<long long int,long long int> next,tmp;
 int d;
 long long int gcd;
 bool found=0;
  
 q.push( pair< pair<long long int,long long int>,int > (st,0) ) ;    
 
 while(!q.empty())
 {
  tmp=(q.front()).first; d=(q.front()).second; q.pop();
  
  //if(tmp.second==st.first && tmp.first==st.second) { cout<<2*d<<endl; found=1; break; }
  if(!(d%4)) { fTime=clock(); rTime=(fTime-sTime)/CLOCKS_PER_SEC; if(rTime>0.23) break; }
  
  next=pair<long long int,long long int> ( 2*(tmp.first)+tmp.second,tmp.second );
  gcd=GCD(next.first,next.second);
  next.first/=gcd; next.second/=gcd;
  if(used.find(next)==used.end()) {if(next==st) { cout<<d+1<<endl; found=1; break;}
                                   if(next.second==st.first && next.first==st.second) { cout<<2*(d+1)<<endl; found=1; break; } 
                                   used.insert(next); q.push( pair< pair<long long int,long long int>,int > ( next,d+1) );
                                  }
  
  next=pair<long long int,long long int> ( tmp.first+2*tmp.second,tmp.second );                 
  next=pair<long long int,long long int> ( tmp.first*next.second,tmp.second*next.first);
  gcd=GCD(next.first,next.second);
  next.first/=gcd; next.second/=gcd;
  if(used.find(next)==used.end()) {if(next==st) { cout<<d+1<<endl; found=1; break;} 
                                   if(next.second==st.first && next.first==st.second) { cout<<2*(d+1)<<endl; found=1; break; }
                                   used.insert(next); q.push( pair< pair<long long int,long long int>,int > ( next,d+1) ); }
 }    
 if(!found) cout<<0<<endl;    
}

int main()
{
 sTime=clock();
 cin>>st.first>>st.second;
 bfs();

 return 0;   
}
