/*
TASK:gen
LANG:C++
*/
#include <iostream>
#include <queue>
using namespace std;
long int p, q;
struct drob{
       long int x;
       long int y;
       long int pos;
       };
       
queue <drob> Q;

long int gcd(long int a, long int b)
{
     while(a!=b)
     {  if(a>b)a-=b;
         else b-=a;
     }
     return b;
} 

drob L(drob i)
{
     i.x += (i.x + i.y);
     long int delitel;
     delitel = gcd(i.x, i.y);
     i.x/=delitel;
     i.y/=delitel; 
     i.pos++;
     return i;     
}

drob R(drob i)
{
     i.y+=(i.x + i.y);
     long int delitel;
     delitel = gcd(i.x, i.y);
     i.x/=delitel;
     i.y/=delitel; 
     i.pos++;
     return i;
}

long int level=0;
int bfs()
{
    drob test;
    do
    {
      //cout << Q.front().x << " " << Q.front().y << " " << Q.front().pos << " "<< level << endl;
      test.pos=Q.front().pos;
      if((double)Q.front().x/Q.front().y==(double)p/q && level !=0) return Q.front().pos;
      test = L(Q.front());
      if(test.x + test.y == p+q) Q.push(test);      
      test = R(Q.front());
      if(test.x+test.y == p+q) Q.push(test); 
      Q.pop();
      level++;
      
    }while(!Q.empty());  
    return 0; 
}

int main()
{
    cin >> p >> q;
    int t=gcd(p, q);
    p/=t;
    q/=t;
    
    drob begin;
    begin.x=p;
    begin.y=q;
    begin.pos=0;
    Q.push(begin);
    
    cout << bfs() <<  endl;
    return 0;
}

