/*
TASK:gen
LANG:C++
ID:Momchil Tomov
*/
#include <iostream>
#include <fstream>
#include <sstream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <vector>
#include <map>
#include <string>
#include <set>
#include <queue>
#include <numeric>
#include <functional>
#include <utility>
#include <algorithm>
#include <bitset>
#include <iomanip>

using namespace std;

#define F(i,n) for (int i=0;i<n;i++)
#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)
#define SZ size()
#define x first
#define y second
#define MP make_pair
#define PB push_back
#define PI pair<int,int>
#define LL long long
#define VI vector<int>
#define sqr(x) ((x)*(x))
#define sign(x) (((x)>0)-((x)<0))
#define ALL(v) (v).begin(),(v).end()
#define time (double)clock()/CLOCKS_PER_SEC
#define pause system("pause")
#define INF 1000000000

int p,q,ans;
double x;
char path[1000];
PI aa[1000];

void bruteforce(int a,int b,int n)
{
     if (n>11) return;
     int g=__gcd(a,b); a/=g,b/=g;
     
     cout<<path<<" - "<<a<<" "<<b<<endl;
     if (a==p && b==q) 
      {  cout<<"                                       FOUND IT !!!!\n";
         Repi(n) cout<<aa[i].x<<"/"<<aa[i].y<<" "; cout<<endl;
      }
     
     double nx1=(double)(2*a+b)/(double)b,nx2=(double)a/(double)(a+2*b);

     aa[n]=MP(a,b);
     if (fabs(nx1-x)<fabs(nx2-x))
      {
        path[n]='L'; 
        bruteforce(2*a+b,b,n+1);
        path[n]='R';
        bruteforce(a,a+2*b,n+1);
      }
     else
      {
        path[n]='L'; 
        bruteforce(2*a+b,b,n+1);
        path[n]='R';
        bruteforce(a,a+2*b,n+1);
      }
     path[n]=0;
}













double invx;
struct tipaj{
       double nx; int dist;
       tipaj(){};
       tipaj(double _nx,int _dist) :nx(_nx),dist(_dist){};
       };
bool operator<(const tipaj &a,const tipaj &b)
{   return fabs(a.nx-invx)>fabs(b.nx-invx);  }


int TLE=(int)(.15*(double)CLOCKS_PER_SEC);
set<double> used;
priority_queue< tipaj > qu;
int bound; bool found;


void advance(double xx,int n)
{
     if (n>bound) return;
     double nx=xx*2.+1.;
     if (used.find(nx)!=used.end()) goto next;
     used.insert(nx);
     qu.push(tipaj(nx,n));
    // cout<<"                                       push "<<nx<<" with "<<n<<endl;
     if (fabs(invx-nx)<1e-11) found=1;
     
     next:;
     nx=xx/(xx+2.);
     if (used.find(nx)!=used.end()) return;
     used.insert(nx);
     qu.push(tipaj(nx,n));
    // cout<<"                                       push "<<nx<<" with "<<n<<endl;     
     if (fabs(invx-nx)<1e-11) found=1;
}

int stupid()
{
    tipaj tmp;
    invx=1./x;
    for (bound=1;/*clock()<TLE*/;bound++)
     {
      while (!qu.empty()) qu.pop();
      //cout<<bound<<endl;
      used.clear(); found=0;
      advance(x,1);
      Repi(10000)
       {
             if (!qu.SZ) break;
             tmp=qu.top(); qu.pop();
            // cout<<" in "<<tmp.y.x<<" with "<<tmp.y.y<<endl;
             advance(tmp.nx,tmp.dist+1);
             if (found) return bound*2;
       }
     }
    return 0;
}

int TLE2=(int)(.24*(double)CLOCKS_PER_SEC);
int greedy()
{
    int a=p,b=q;
    set<PI> used;
    for (int ans=0;ans<1300000;ans++)
     {
          if (a%2==0 && b%2==0) a/=2,b/=2;
          //if (used.find(MP(a,b))!=used.end()) return 0;
         // used.insert(MP(a,b));
          if (a==q && b==p) return ans*2;
          if (a%2==0)
                  b=a+2*b;
          else
           if (b%2==0)       
                  a=a*2+b;
           else return 0;
      }
     return 0;
}

int main()
{
    scanf("%d%d",&p,&q);
    x=(double)p/q;
  //  cout<<"  looking for "<<x<<endl;
   // bruteforce(p,q,0);
  
   // bruteforce(p,q,0);
  
  
    printf("%d\n",greedy());
    //cout<<stupid()<<endl;
  //  cout<<stupid()<<endl;
  // double tm=time;
  //  cout<<time-tm<<endl;
    
    return 0;
}
