/*
TASK: gen
LANG: C++
*/

#include <cstdio>
#include <iostream>

int bfs_new(int x, int y)
{
	int res = 1;
	int cx, cy;
	if(x > y)	{ cx = x - y, cy = 2*y;}
	else		{ cx = 2*x, cy = y - x;}
	while( x != cx )
	{
		if( std :: __gcd(cx, cy) != 1 )	return 0;
		if(x == cy)	return 2*res;
		if( cx > cy )	{ cx = cx - cy; cy = 2*cy; }
		else			{ cy = cy - cx; cx = 2*cx; }
		res ++;
	}
	return res;
}

int x, y;
int main()
{
	scanf("%d %d", &x, &y);
	printf("%d\n", bfs_new(x, y));
	fprintf(stderr, "%lf\n", clock() / double(CLOCKS_PER_SEC));
    return 0;
}
