/*
LANG:c++
TASK:guard
*/
#include <iostream>
#include <cmath>

using namespace std;
const double pi = 3.141592653589;

double find_a(int x1,int y1){
       double ang =  atan(y1/(x1+0.00001));
       if ( x1 < 0 )
             ang += pi;      
       if( x1 > 0 && y1 < 0)
           ang += 2*pi;
       return ang;       
}

int main(){
    double proc= 0;
    int x0,y0;
    cin >> x0 >> y0;
    for(int i = 0; i < 3; i++){
            int x1,x2,y1,y2;
            cin >> x1 >> y1;
            cin >> x2 >> y2;
            x1 -= x0;
            y1 -= y0;
            x2 -= x0;
            y2 -= y0;
            double guarded  = fabs(find_a(x1,y1) - find_a(x2,y2));
            while(guarded > 2*pi)
                          guarded -= 2*pi; 
            proc += guarded/(2*pi);
            }
    cout << (int) round(proc*100) % 101<< endl;

}
