/*
TASK: guard
LANG: C++
*/
#include <cstdio>
#include <cmath>
#include <vector>
#include <algorithm>
#define ABS(a) (a)>0?(a):(-(a))
using namespace std;

vector < pair<double,int> > list;
vector <char> used;

void input()
{
     int cx,cy,i=1,a,b,c,d;
     double p,q;
     scanf("%d%d",&cx,&cy);
     while (scanf("%d%d%d%d",&a,&b,&c,&d) != EOF) {
           p = atan2(b-cy,a-cx);
           q = atan2(d-cy,c-cx);
           if (p == q) continue;
           list.push_back(make_pair(p,-i));
           list.push_back(make_pair(q,i));
           ++i;
           }
     used.resize(i+1);
}

void solve()
{
     int i=-1,s,br_u=0,br_c=0,n=list.size(),fl=0;
     double r=0.0,a;
     sort(list.begin(),list.end());
     //for (s=0;s<n;++s) printf("%lf %d\n",list[s].first,list[s].second);
     s = -1;
     while (2*br_u < n) {
           ++i; if (i == n) i=0;
           if (i == s) ++fl;
           if (used[ABS(list[i].second)] == 2) continue;
           if (list[i].second < 0 && used[ABS(list[i].second)] == 0) {
              //printf("op %lf %d\n",list[i].first,list[i].second);
              if (br_c == 0) s=i;
              ++br_c;
              used[ABS(list[i].second)] = 1;
              }
           if (list[i].second > 0 && used[ABS(list[i].second)] == 1) {
              --br_c;
              used[ABS(list[i].second)] = 2;
              ++br_u;
              if (br_c == 0) {
                 //printf("fl = %d\n",fl);
                 a = list[i].first-list[s].first;
                 while (a < 0.0) a+=2.0*M_PI;
                 r += (a+fl*2.0*M_PI);
                 fl = 0; s = -1;
                 }
              }
           }
     if (r >= 2*M_PI) printf("100\n");
     else {
          a = r/(2.0*M_PI);
          a *= 100;
          if (a - (int)a < 0.5) printf("%d\n",(int)a);
          else printf("%d\n",(int)a+1);
          }
}

int main()
{
    input();
    solve();
    return 0;
}
