/*
TASK:guard
LANG:C++
*/

#include<cstdio>
#include<cmath>
#include<algorithm>

struct pnt {double x,y;void read() {scanf("%lf%lf",&x,&y);}};
struct grd {pnt g1,g2;void read(){g1.read();g2.read();}};
pnt wrhs;
grd grds[3];
struct fi{double beg,end;};

double ccw(pnt p0,pnt p1,pnt p2) {return (p1.x-p0.x)*(p2.y-p0.y)-(p1.y-p0.y)*(p2.x-p1.x);}
double dst_sqr(pnt p1,pnt p2) {return (p2.x-p1.x)*(p2.x-p1.x)+(p2.y-p1.y)*(p2.y-p1.y);}
double dst(pnt p1,pnt p2) {return sqrt((p2.x-p1.x)*(p2.x-p1.x)+(p2.y-p1.y)*(p2.y-p1.y));}
double get_angl(pnt g1, pnt g2, pnt ctr) {
	double cos=(dst_sqr(g1,ctr)+dst_sqr(g2,ctr)-dst_sqr(g1,g2))/(2.0*dst(g1,ctr)*dst(g2,ctr));
	double ang=acos(cos)*180.0/M_PI;
	if(ccw(g1,ctr,g2)>0) ang=380-ang;
	return ang;
}

#define MIN(a,b) ((a<b)?(a):(b))
#define MAX(a,b) ((a>b)?(a):(b))

fi cross(fi f1, fi f2) {
	fi ret;
	int fl1=0, fl2=0;
	if(f1.beg>f1.end){f1.end+=360;++fl1;}
	if(f2.beg>f2.end){f2.end+=360;++fl2;}
	ret.beg=MAX(f1.beg,f2.beg);ret.end=MIN(f1.end,f2.end); //1+2+
	if(ret.end<ret.beg) {
		ret.end=0;ret.beg=0;
		if(fl1==1) {f1.end-=360;f1.beg-=360;fl1=-1;} 
		ret.beg=MAX(f1.beg,f2.beg);ret.end=MIN(f1.end,f2.end); //1-2+
		if(ret.end<ret.beg) {
			ret.end=0;ret.beg=0;
			if(fl2==1) {f2.end-=360;f2.beg-=360;fl2=-1;}
			ret.beg=MAX(f1.beg,f2.beg);ret.end=MIN(f1.end,f2.end); //1-2-
			if(ret.end<ret.beg) {
				ret.end=0;ret.beg=0;
				if(fl1==-1) {f1.end+=360;f1.beg+=360;fl1=1;}
				ret.beg=MAX(f1.beg,f2.beg);ret.end=MIN(f1.end,f2.end);
				if(ret.end<ret.beg) {ret.end=0;ret.beg=0;}
			}
		}
	}
	
	
	while(ret.beg<0)ret.beg-=360;
	while(ret.end<0)ret.end+=360;
	while(ret.beg>=360)ret.beg-=360;
	while(ret.end>=360)ret.end-=360;
	return ret;
}
double fc(fi f) {
	double ret=f.end-f.beg;
	while (ret<0) ret+=360;	
	return ret;
}
int main() {
	wrhs.read();
	grds[0].read();grds[1].read();grds[2].read();
	fi a1,a2,a3;
	a1.beg=0;
	a1.end=get_angl(grds[0].g1,grds[0].g2,wrhs);
	a2.beg=get_angl(grds[0].g1,grds[1].g1,wrhs);
	a2.end=get_angl(grds[0].g1,grds[1].g2,wrhs);
	a3.beg=get_angl(grds[0].g1,grds[2].g1,wrhs);
	a3.end=get_angl(grds[0].g1,grds[2].g2,wrhs);
	
	fi a12,a13,a23,a123;
	a12=cross(a1,a2);
	a13=cross(a1,a3);
	a23=cross(a2,a3);
	a123=cross(a12,a3);
	
	double face=fc(a1)+fc(a2)+fc(a3)-fc(a12)-fc(a13)-fc(a23)+fc(a123);
	
	double perc=face/3.600;
	if(perc-floor(perc)<0.50000)floor(perc);else ceil(perc);
	printf("%d\n",(int)(perc)); 
	return 0;
}
