/*
TASK: gen
LANG: C++
*/
#include<iostream>
#include<queue>
#include<cmath>
#include<cstdlib>
using namespace std;

const double eps=1e-6;
int bfs(double k)
{
  queue<double> dat;
  queue<int> d;
  dat.push(k);
  d.push(0);
  while(1)
  {
    double t=dat.front(); dat.pop();
    //cout<<t<<' '<<k<<endl;
    int dd=d.front(); d.pop();
    //cout<<dd<<endl;
    //cin>>dd;
    if(fabs(t-k)<eps && dd!=0) return dd;
    d.push(dd+1); d.push(dd+1);
    dat.push(t*2+1); dat.push(t/(t+2));
  }
}

int main()
{
  double c, z;
  cin>>c>>z;
  cout<<bfs(c/z)<<endl;
  return 0;
}
