/*
TASK: guard
LANG: C++
*/
#include<iostream>
#include<cmath>
using namespace std;
#define INF 2000000000
#define eps 1e-16
struct point
{ double x,y;};
struct segm
{ int type;double k;
  double x;
};
point c;  
pair <double,double> b[3];
double dist(point p1,point p2)
{ return sqrt((p1.x-p2.x)*(p1.x-p2.x)+(p1.y-p2.y)*(p1.y-p2.y));}
double ang(point p1,point p2)
{  
  double d1=dist(p1,c);
  double d2=dist(p2,c);
  double d3=dist(p1,p2);
  double an=(d1*d1+d2*d2-d3*d3)/(2*d1*d2);
  //cout<<d1<<' '<<d2<<' ' <<d3<<' ';
  double anr=acos(an);
  anr*=(180.0/M_PI);
  //cout<<anr<<endl;
  return anr;
}
void read_data()
{ 
  cin>>c.x>>c.y;
  point p1,p2;
  cin>>p1.x>>p1.y>>p2.x>>p2.y;
  
  b[0].first=0;
  b[0].second=ang(p1,p2);
  int i;
  for(i=1;i<3;i++)
   { point p3,p4;
     cin>>p3.x>>p3.y>>p4.x>>p4.y;
     b[i].first=ang(p1,p3);
     b[i].second=ang(p1,p4);
     if(b[i].first>b[i].second)
      b[i].second+=360;
   }
 // for(i=0;i<3;i++)
  // cout<<b[i].first<<' '<<b[i].second<<endl;   
}

void solve()
{  
  sort(b,b+3);
  pair <double,double> t;
  t=b[0];
  double res=0;
  int i;
  for(i=1;i<3;i++)
   { if(b[i].first>=t.second)
      { res+=(t.second-t.first);
        t=b[i];
        continue;
      }
     if(b[i].first<t.second)
      if(b[i].second>t.second)
       t.second=b[i].second;
   }
   res+=(t.second-t.first);
   res=(res/double(360.0)*100.0);
   if(res-int(res)>0)
    { 
      if(res-int(res)>=0.5)
       cout<<min(100,int(res)+1)<<endl;
      else
       cout<<int(res)<<endl;
    }
   else
    cout<<int(res)<<endl; 
}                          
int main()
{
     read_data();
     solve();
     return 0;
}
