/*
TASK: guard
LANG: C++
*/
#include <cmath>
#include <cstdio>
#include <algorithm>
using namespace std;

const double pi = 3.1415926535897932384626433832795;

struct el {
	int x , y;
	double ang;
	
	void read() {
		scanf ( "%d%d" , &x , &y );
	}
};

el a;
el b[4][2];
pair < double , int > t[8];
int used[4];
int s;

void read() {
	int i;
	
	a.read();
	for (i = 0; i < 3; i++) {
		b[i][0].read();	
		b[i][1].read();
	}
}

double get_ang ( int x , int y ) {
	return atan2 ( (double)y , (double)x ) / pi * 360.;
}

int fix ( double a ) {
	int b = (int)a;
	
	while ( a - 1. > -1e-9 ) a -= 1.;
	
	if ( a - 0.5 > -1e-9 ) return b + 1;
	return b;
}

void solve() {
	int i;
	int open;
	double ans = 0.;
	double last = -360.;
	
	for (i = 0; i < 3; i++) {
		t[ ++ s ] = make_pair ( get_ang ( b[i][0].x - a.x , b[i][0].y - a.y ) , i + 1 );
		t[ ++ s ] = make_pair ( get_ang ( b[i][1].x - a.x , b[i][1].y - a.y ) , -i - 1 );
	}
	
	sort ( t + 1 , t + s + 1 );
	
	open = 0;
	for (i = 6; i >= 1; i--) {
		if ( !used[ abs ( t[i].second ) ] && t[i].second > 0 ) ++ open;
		used[ abs ( t[i].second ) ] = 1;
	}
	
	for (i = 1; i <= 6; i++) {
		if ( open > 0 )
			ans += t[i].first - last;
		last = t[i].first;
		if ( t[i].second > 0 )
			++ open;
		else
			-- open;
	}
	
	if ( open > 0 )
		ans += 360. - last;
		
	printf ( "%d\n" , fix ( ans / (2. * 360.) * 100. ) );
}

int main() {
	read();
	solve();
	
	return 0;
}
