/*
TASK:guard
LANG:C
*/
/*
  Name: 
  Copyright: aRaGaR
  Author:    Vn_A_02
  Date: 07.02.09 09:20
  Description:   2009  2
*/
#include <stdio.h>
#include <math.h>

typedef struct
	{
		double x;
		double y;
	}point;
	
point c;
point a1,a2;
point b1,b2;
point c1,c2;
point ap,bp,cp;

double angle (point,point,point *);
int cpr (point,point,point);
double check (point,point,point,point,point,double);

int main ()
{
    int i,j;
    double al,be,ga,ans;
    int cp1,cp2;
    
    scanf ("%lf %lf",&c.x,&c.y);
    scanf ("%lf %lf %lf %lf",&a1.x,&a1.y,&a2.x,&a2.y);
    scanf ("%lf %lf %lf %lf",&b1.x,&b1.y,&b2.x,&b2.y);
    scanf ("%lf %lf %lf %lf",&c1.x,&c1.y,&c2.x,&c2.y);
    
    al=angle (a1,a2,&ap);
    be=angle (b1,b2,&bp);
    ga=angle (c1,c2,&cp);
    ans=al+be+ga;
    ans+=check (a1,a2,ap,b1,b2,al);
    ans+=check (b1,b2,bp,c1,c2,be);
    ans+=check (c1,c2,cp,a1,a2,ga);
    
    if ((ans/360.0)*100>100)
    	printf ("100\n");
    else  printf ("%.0lf\n",(ans/360.0)*100);
    
    return 0;
}

double angle (point t1,point t2,point *tp)
{
	point tmp,tmp1,tmp2,tpp;
	double A1,B1,C1,A2,B2,C2;
	double l1,l2;
	
	tmp1.x=t2.y;
	tmp1.y=-t2.x;
	tmp2.x=c.y;
	tmp2.y=-c.x;
	
	tmp.x=t1.x-(tmp2.x-tmp1.x);
	tmp.y=t1.y-(tmp2.y-tmp1.y);
	
	A1=t1.y-tmp.y;
	B1=tmp.x-t1.x;
	C1=t1.x*tmp.y-tmp.x*t1.y;
	
	A2=c.y-t2.y;
	B2=t2.x-c.x;
	C2=c.x*t2.y-t2.x*c.y;
	
	if (B1==0)
		{
			tpp.x=-C1/A1;
			tpp.y=(-C2-A2*tpp.x)/B2;
		}
	
	else
		{
			tpp.x=(((B2*C1)/B1)-C2)/(A2-((A1*B2)/B1)); 
			tpp.y=(-C1-A1*tpp.x)/B1;
		}
	
	*tp=tpp;
	l1=sqrt ((t1.x-tpp.x)*(t1.x-tpp.x)+(t1.y-tpp.y)*(t1.y-tpp.y));
	l2=sqrt ((t1.x-c.x)*(t1.x-c.x)+(t1.y-c.y)*(t1.y-c.y));
	
	if ((tpp.x>=c.x && t2.x>=c.x) || (tpp.x<=c.x && t2.x<=c.x))
		{
			if (cpr (t1,c,t2)>=0)
				return ((2*M_PI)-asin(l1/l2))*360/(2*M_PI);
			return asin(l1/l2)*360/(2*M_PI);
		}
	if (cpr (t1,c,t2)>=0)
		return (M_PI+asin(l1/l2))*360/(2*M_PI);
	return (M_PI-asin(l1/l2))*360/(2*M_PI);
}

int cpr (point p0,point p1,point p2)
{
	int dx1=p1.x-p0.x;
	int dx2=p2.x-p1.x;
	int dy1=p1.y-p0.y;
	int dy2=p2.y-p1.y;
	return dx1*dy2-dx2*dy1;
}

double check (point p1,point p2,point pp,point t1,point t2,double an)
{
	int i,j,k,fl=0;
	double ans=0;
	point tmp;
	point tmp1,tmp2;

	if (p1.x-c.x>0 || (p1.x-c.x==0 && p1.y-c.y>0))
		tmp1.x=p1.x+500;
	else if (p1.x-c.x<0 || (p1.x-c.x==0 && p1.y-c.y<0))
		tmp1.x=p1.x-500;
	if (p1.y-c.y>0 || (p1.y-c.y==0 && p1.x-c.x>0))
		tmp1.y=p1.y+500;
	else if (p1.y-c.y<0 || (p1.y-c.y==0 && p1.x-c.x<0))
		tmp1.y=p1.y-500;
	
	if (p2.x-c.x>0 || (p2.x-c.x==0 && p2.y-c.y>0))
		tmp2.x=p2.x+500;
	else if (p2.x-c.x<0 || (p2.x-c.x==0 && p2.y-c.y<0))
		tmp2.x=p2.x-500;
	if (p2.y-c.y>0 || (p2.y-c.y==0 && p2.x-c.x>0))
		tmp2.y=p2.y+500;
	else if (p2.y-c.y<0 || (p2.y-c.y==0 && p2.x-c.x<0))
		tmp2.y=p2.y-500;
		
	i=cpr (tmp2,tmp1,t1);
	j=cpr (tmp1,c,t1);
	k=cpr (c,tmp2,t1);
	if ((i>=0 && j>=0 && k>=0) || (i<=0 && j<=0 && k<=0))
		{
			ans-=angle (t1,p2,&tmp);
			fl++;
		}
	
	i=cpr (tmp2,tmp1,t2);
	j=cpr (tmp1,c,t2);
	k=cpr (c,tmp2,t2);
	if ((i>=0 && j>=0 && k>=0) || (i<=0 && j<=0 && k<=0))
		{
			ans-=angle (p1,t2,&tmp);
			fl++;
		}
	if (fl==2)
		ans+=an;
	
	return ans;
}
