/*
TASK: aminosoup
LANG: C++
*/

#include <iostream>
#define MAXN 50
using namespace std;

char n[MAXN];
char cMAX[]="971412206";
const int nMAX=602214179;
const int DIV = 1000000000;
int intn;
bool done = 0;

bool checkN() {
     int l = strlen(n);
     if ((n[l - 1] - '0') % 2) return 1;
     return 0;
}

void rev(char c[]) 
{
     char a;
     int l = strlen(c), i, j;
     for (i = 0, j = l - 1; i < j; ++i, --j) {
         a = c[i];
         c[i] = c[j];
         c[j] = a;
     }
     return;
}

void long_subtr(char s1[], char s2[]) {
     rev(s1);
     int l1 = strlen(s1), l2 = strlen(s2);
     int a, b, i, ost = 0, post = 0;
     for (i = 0; i < l2; ++i) {
         a = int(s1[i] - '0');
         b = int(s2[i] - '0');
         if (a - b - post < 0) {
               ost = 1;
               a += 10;
         }
         else ost = 0;
         s1[i] = char(a - b - post) + '0';
         post = ost;
     }
     
     while (post) {
           a = int(s1[i] - '0');
           if (a - post < 0) {
                 ost = 1;
                 a += 10;
           }
           else ost = 0;
           s1[i] = char(a - post) + '0';
           i += 1;
           post = ost;
     }
     rev(s1);
     return;
}
void calc_intn() {
     int l = strlen(n), adj = 1;
     
     if (l <= 9) {
           intn = atoi(n);
           done = 1;
     }
     
     else {
          long_subtr(n, cMAX);
          intn = nMAX;
     }
     
     return;
}      
int findD2() {
    const int SIZE = 3;
    int i;
    bool fl = 1;
    int D[SIZE] = {1, 2, 3};
    done = 0;
    while (!done) {
          calc_intn();
          if (fl) {
                  if (intn < 4) return D[intn - 1];
                  intn -= 3;
                  fl = 0;
          }
          for (i = 0; i < intn; i+=3) {
              D[0] = (D[2] + D[1]) % DIV;
              D[1] = (D[0] + D[2]) % DIV;
              D[2] = (D[1] + D[0]) % DIV;
          }
    } 
    
    return D[SIZE - i + intn - 1];
}

int findD3() {
    const int SIZE = 3;
    int i;
    bool fl = 1;
    int D[SIZE] = {3, 11, 41};
    done = 0;
    while (!done) {
          calc_intn();
          intn /= 2;
          if (fl) {
                  if (intn < 4) return D[intn - 1];
                  intn -= 3;
                  fl = 0;
          }
          for (i = 0; i < intn; i+=3) {
              D[0] = (4*D[2] - D[1]) % DIV;
              D[1] = (4*D[0] - D[2]) % DIV;
              D[2] = (4*D[1] - D[0]) % DIV;
          }
    } 
    
    return D[SIZE - i + intn - 1];
}

int findD4() {
    const int SIZE = 4;
    int i;
    bool fl = 1;
    int D[SIZE] = {1, 1, 5, 27};
    done = 0;
    while (!done) {
          calc_intn();
          if (fl) {
                  if (intn < 5) return D[intn - 1];
                  intn -= 4;
                  fl = 0;
          }
          for (i = 0; i < intn; i+=4) {
              D[0] = (2*D[3] + 3*D[2] - 2*D[1]) % DIV;
              D[1] = (2*D[0] + 3*D[3] - 2*D[2]) % DIV;
              D[2] = (2*D[1] + 3*D[0] - 2*D[3]) % DIV;
              D[3] = (2*D[2] + 3*D[1] - 2*D[0]) % DIV;
          }
    } 
    
    return D[SIZE - i + intn - 1];
}

int findD5() {
    const int SIZE = 4;
    int i;
    bool fl = 1;
    int D[SIZE] = {8, 73, 656, 12464};
    done = 0;
    while (!done) {
          calc_intn();
          intn /= 2;
          if (fl) {
                  if (intn < 5) return D[intn - 1];
                  intn -= 4;
                  fl = 0;
          }
          for (i = 0; i < intn; i+=3) {
              D[0] = (10*D[3]%DIV - 8*D[2]%DIV + 8*D[1]%DIV) % DIV;
              D[1] = (10*D[0]%DIV - 8*D[3]%DIV + 8*D[2]%DIV) % DIV;
              D[2] = (10*D[1]%DIV - 8*D[0]%DIV + 8*D[3]%DIV) % DIV;
              D[3] = (10*D[2]%DIV - 8*D[1]%DIV + 8*D[0]%DIV) % DIV;
          }
    } 
    
    return D[SIZE - i + intn - 1];
}

int findD6() {
    return 0;
}

int main()
{
    int m;
    scanf("%s%d", &n, &m);
    if (m%2 && checkN()) {
            printf("0\n");
            return 0;
    }
    
    switch(m) {
              case 1: printf("1\n"); break;
              case 2: printf("%d\n", findD2()%nMAX); break;
              case 3: printf("%d\n", findD3()%nMAX); break;
              case 4: printf("%d\n", findD4()%nMAX); break;
              case 5: printf("%d\n", findD5()%nMAX); break;
              case 6: printf("%d\n", findD6()%nMAX); break;
    }

    return 0;
}
