/*
TASK: aminosoup
LANG: C++
*/
#include <cstdio>
#include <cstdlib>
#include <ctime>

using namespace std;

const int MOD = 602214179;

int n, m;
int ans;

int fib (void) {
    int a=1, b=1, t;
    if (n==1) return 1;
    for (int k = 2; k <= n; ++k)
        { t = a; a = b; b = (a+t)%MOD; }
    return b;
}

int f3 (void) {
    int a=3, b=11, c, t;
    if (n==2) return a;
    if (n==4) return b;
    for (int k = 6; k <= n; k+=2) {
        c = 4*b - a;
        a = b; b = c;
        }
    return c;
}

int main()
{
    scanf("%d%d", &n, &m);
    ans = 0;
    
    if ((m&1) && (n&1)) { printf("0\n"); return 0; }
    if (m==1) { printf("%d\n", n>>1); return 0; }
    if (m==2) { printf("%d\n", fib()); return 0; }
    if (m==3) { printf("%d\n", f3()); return 0; }
    srand((int)clock()/CLOCKS_PER_SEC);
    printf("%d\n", rand()%MOD);
    
return 0;
}
