/*
TASK: gen
LANG: C++
*/
#include <cstdio>
#include <cstdlib>
#include <algorithm>

using namespace std;

const int INF = 1<<30;

int p, q;
int mlvl = INF;

int nod (int u, int v) {
    int r;
    if (u<v) swap(u,v);
    while (r=u%v) { u=v; v=r; }
    return v;
    }

int _check (int a, int b, int c, int d) {
    int zn = b*d;
    zn /= nod(b,d);
    a *= zn/b; c *= zn/d;
    if (a<c) return -1;
    if (a>c) return 1;
    return 0;
    }

int check (int a, int b) {
    return _check(a,b,p,q);
}

int check_rec (int a, int b) {
    return _check(a,b,q,p);
}

bool check1 (int a, int b, int sa, int sb, int ea, int eb) {
     if (_check(a,b,sa,sb)<0) return false;
        else { sa=a; sb=b; }
     if (_check(a,b,ea,eb)>0) return false;
        else { ea=a; eb=b; }
     return true;
}

void f (int a, int b, int lvl, int sa, int sb, int ea, int eb) {
     if (_check(a,b,sa,sb)<0) return;
     if (_check(a,b,ea,eb)>0) return;
     if (lvl>mlvl) return;
     int n=nod(a,b);
     a/=n; b/=n;
     int c = check(a,b);
     //printf("sa=%d sb=%d ea=%d eb=%d\n", sa, sb, ea, eb);
     //printf("%d %d %d\n", a, b, lvl);
     if (!c) { mlvl=min(lvl,mlvl); return; }
     if ((!check_rec(a,b))) { mlvl=min(lvl*2,mlvl); return; }
     //if (!check1(a,b)) return;
     f(2*a+b,b,lvl+1,a,b,ea,eb);
     f(a,a+2*b,lvl+1,sa,sb,a,b);
     }

int main()
{
    scanf("%d%d", &p, &q);
    int n;
    int sa=p, sb=p+2*q, ea=2*p+q, eb=q;
    n=nod(sa,sb); sa/=n; sb/=n;
    n=nod(ea,eb); ea/=n; eb/=n;
    if (_check(sa,sb,ea,eb)>0) { swap(sa,ea); swap(sb,eb); }
    f(p,p+2*q,1,sa,sb,ea,eb);
    f(2*p+q,q,1,sa,sb,ea,eb);
    if (mlvl == INF) mlvl = 0;
    printf("%d\n", mlvl);
    
return 0;
}
