/*
TASK:guard
LANG:c++
*/

#include <iostream>
#include <cmath>

using namespace std;

#define M_PI2 (2 * M_PI)

inline bool BWN(float a, float b, float c)
{
        if( c < b)
            return (a < c) || (a > b);
        return (a > b) && (a < c);
}

int main()
{
    float Sx, Sy;
    cin >> Sx >> Sy;
    float Gx[6], Gy[6];
    float angles[6];
    float coveredA[3], coveredB[3];
    float area=0;

    float c, b;
    
    //cout << M_PI << endl << M_PI2 << endl << M_PI / M_PI2 << endl;
    //cin >> Sx;
    
    //return 0;
 /*   while(true)
    {
               cin >> c >> b;
               if(c < b)
                 area = 1 + (c - b) / 360;
               else
                 area = (c - b) / 360;
               cout << area << " = " << ceil(area*100) << "%"<< endl;
    }
  */             

    for(int i=0; i<6; ++i)
    {
            cin >> Gx[i] >> Gy[i];
            angles[i] = atan2(Gy[i] - Sy, Gx[i] - Sx);
            if(angles[i] < 0)
                         angles[i] = 2*M_PI + angles[i];
    }
    
    for(int i=0; i<6; i+=2)
    {
            for(int j=i+2; j<6; j+=2)
            {
                    if(BWN(angles[i], angles[j], angles[j+1]))
                    {
                                      //cout << i << " is between " << j << " and " << j+1 << endl;
                                      if(BWN(angles[i+1], angles[j], angles[j+1]))
                                      {
                                             //       cout << i+1 << " is between " << j << " and " << j+1 << endl;
                              
                                                     angles[i+1] = angles[i];
                                      }
                                      else
                                          angles[i] = angles[j+1];
                    }
                    else if(BWN(angles[i+1], angles[j], angles[j+1]))
                    {
                        // cout << i << " is between " << j << " and " << j+1 << endl;
                         angles[i+1] = angles[j];
                    }
            }
    }
    
    for(int i=0; i<3; ++i)        
    {
            c = angles[2*i + 1];
            b = angles[2*i];
            if(c < b)
            {
                 area += 1 - (b - c) / M_PI2;
            }
            else
                area += (c - b) / M_PI2;
            
    }                

    cout << ceil(area * 100) << endl;

    


}
