/*
LANG: C++
TASK: gen
*/
#include <iostream>
#include <map>
#include <queue>
using namespace std;


long long gcd(long long a, long long b)
{
     if (b == 0) return a;
     return gcd(b, a%b);
}

struct A
{
       long long p, q;
       A(long long _p, long long _q):p(_p), q(_q){}
       A(){}
       bool operator<(A a) const
       {
            if (p != a.p) return p < a.p;
            return q < a.q;
       }
};

map<A, bool> heap;
queue<A> qe;
    
int main()
{
    
    int P, Q;
    cin >> P >> Q;
    //heap[A(P, Q)] = 1;
    qe.push(A(P, Q));
    
    int lvl = 0;

    while (!qe.empty())
    {
          int sz = qe.size();
          for (int i = 0; i < sz; i++)
          {
              int sp = qe.front().p;
              int sq = qe.front().q;
              //if (lvl == 3) cout << sp << " " << sq << endl;
              
              if (lvl != 0 && sp == P && sq == Q)  {cout << lvl << endl; return 0;  }
              qe.pop();
              
              int p = 2*sp+sq;
              int q = sq;
              
              int GCD = gcd(p, q);
              p /= GCD;
              q /= GCD;
              
              if (heap[A(p, q)]==0)
              {       
                  heap[A(p, q)] = 1;
                  qe.push(A(p, q));
              }
              ///////////////////////////////////
              p = sp;
              q = sp + 2*sq;
              GCD = gcd(p, q);
              p /= GCD;
              q /= GCD;
              
              if (heap[A(p, q)]==0)
              {
                  heap[A(p, q)] = 1;
                  qe.push(A(p, q));
              }
          }
          //if (lvl == 4) return 0;
          lvl++;
    }
}
