import java.io.*;
import java.util.Arrays;
import java.util.Random;
import java.util.StringTokenizer;

/*
 * CTU Open Contest 2008
 * Solution: HELP
 * Jan Stoklasa, Oct 2008  
 */
class help
{
	static int packages[]=new int[100000];

    public static void main(String argv[]) throws IOException
    {
	BufferedReader stdin=new BufferedReader(new InputStreamReader(System.in));	    
	String s1,s2;
	while((s1=stdin.readLine())!=null &&
	      (s2=stdin.readLine())!=null &&
	      s1.trim()!="")
	    {
		solve(s1,s2);
	    }
    }

    enum Bank { A,B };
    static Bank bank=Bank.A;

    static void step(int packages[], int i)
    {
	printPackage(packages[i],bank);
	if(bank==Bank.A) 
	    {
		bank=Bank.B;
	    }
	else
	    {
		bank=Bank.A;
	    }
    }

    static void solve(String s1,String s2)
    {
	int N=Integer.parseInt(s1);
	if (N==0) return;
	StringTokenizer ss=new StringTokenizer(s2);


	for(int i=0;i<N;i++)
	    {		
		packages[i]=Integer.parseInt(ss.nextToken());
	    }
	Arrays.sort(packages, 0, N);

	printPackage(packages[0],Bank.A);
	bank=Bank.B;
	for(int i=N-1;i>0;i--)
	    {
		System.out.print(" ");	
		printPackage(packages[i],bank);
		bank=(bank==Bank.A)?Bank.B:Bank.A;
	    }
	System.out.println("");
    }

    static void printPackage(int x, Bank b)
    {
	System.out.print(Integer.toString(x)+"-");
	System.out.print(b);	
    }
}
