#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define eps 1e-7

double xa, ya, Ra, xb, yb, Rb, A, a;
double d, pi, alfa, beta, xm, ym, a1, a2;

double dist2d(double xA, double yA, double xB, double yB)
{
return sqrt((xA - xB) * (xA - xB) + (yA - yB) * (yA - yB));
}

int main()
{
int T;

freopen("cercuri.in", "r", stdin);
freopen("cercuri.out", "w", stdout);

pi = 2.0 * acos(0);

scanf("%d", &T);
while (T--)
  {
    scanf("%lf %lf %lf %lf %lf %lf %lf", &xa, &ya, &Ra, &xb, &yb, &Rb, &A);

    if (Ra < Rb)
      {
        a = xa; xa = xb; xb = a;
        a = ya; ya = yb; yb = a;
        a = Ra; Ra = Rb; Rb = a;
      }

    xb -= xa;
    yb -= ya;
    d = dist2d(xb, yb, 0, 0);

    if (d > Ra + Rb) // cele 2 cercuri nu se intersecteaza
      {
        a = 0;
      }
    else
    if (d + Rb < Ra || fabs(d + Rb - Ra ) < eps) // al 2-lea cerc este inclus strict in primul
      {
        a = pi * Rb * Rb;
      }
    else
      {
        alfa = acos((Ra * Ra + d * d - Rb * Rb) / (2.0 * Ra * d));

        if (alfa > 0.5 * pi)
          {
            xm = 15.0;
          }

        beta = acos((Rb * Rb + d * d - Ra * Ra) / (2.0 * Rb * d));

        if (beta > 0.5 * pi)
          {
            xm = 15.0;
          }

        xm = Ra * cos(alfa);
        ym = Ra * sin(alfa);

        a1 = alfa * Ra * Ra - xm * ym;
        a2 = beta * Rb * Rb - (d - xm) * ym;
        a = a1 + a2;
      }

    if (a > A)
      printf("DA\n");
    else
      printf("NU\n");
  }

return 0;
}
