#include <stdio.h>

#include <algorithm>
#include <vector>

using namespace std;

#define INF 666666666

#define NMAX 20
#define LMAX 3

#define GOOD_SOL 1
#define PRINT_SOL 0

vector<pair<int, int> > T[2];
int S[2], w[2][NMAX], tw[2][NMAX], tso[2][NMAX];
int i, j, k, N, cnt, t, tx, twait, countt;
int tmin[NMAX][NMAX];

void sol1_bkt(int job, int step)
{
	int x, i, j, t1, t2, i1, j1;

	if (step > S[job])
	{
		if (job == 0)
			sol1_bkt(1, 1);
		else
		{
			// dinamica

			for (i = 0; i <= S[0]; i++)
				for (j = 0; j <= S[1]; j++)
					tmin[i][j] = INF;

			tmin[0][0] = 0;

			for (i = 0; i < S[0]; i++)
				for (j = 0; j < S[1]; j++)
					if (tmin[i][j] < INF)
					{
						t1 = t2 = 0;

						i1 = i + 1; j1 = j + 1;

						while (i1 <= S[0] && j1 <= S[1])
						{
							if (w[0][i1] == w[1][j1])
								break;

							if (t1 + tw[0][i1] < t2 + tw[1][j1])
							{
								t1 += tw[0][i1];
								i1++;
							}
							else
							if (t1 + tw[0][i1] > t2 + tw[1][j1])
							{
								t2 += tw[1][j1];
								j1++;
							}
							else
							{
								t1 += tw[0][i1];
								i1++;
								t2 += tw[1][j1];
								j1++;
							}
						}

						if (i1 > S[0] || j1 > S[1])
						{
							if (tmin[i][j] < tmin[S[0]][S[1]])
								tmin[S[0]][S[1]] = tmin[i][j];
						}
						else // suprapunere
						{
							if (tmin[i][j] + t2 + tw[1][j1] - t1 < tmin[i1 - 1][j1])
								tmin[i1 - 1][j1] = tmin[i][j] + t2 + tw[1][j1] - t1;

							if (tmin[i][j] + t1 + tw[0][i1] - t2 < tmin[i1][j1 - 1])
								tmin[i1][j1 - 1] = tmin[i][j] + t1 + tw[0][i1] - t2;
						}
					}

			for (i = 0; i < S[0]; i++)
				if (tmin[i][S[1]] < tmin[S[0]][S[1]])
					tmin[S[0]][S[1]] = tmin[i][S[1]];

			for (j = 0; j < S[1]; j++)
				if (tmin[S[0]][j] < tmin[S[0]][S[1]])
					tmin[S[0]][S[1]] = tmin[S[0]][j];

			if (tx + tmin[S[0]][S[1]] < t)
			{
				t = tx + tmin[S[0]][S[1]];
				twait = tmin[S[0]][S[1]];

				for (i = 1; i <= S[0]; i++)
					tso[0][i] = w[0][i];

				for (i = 1; i <= S[1]; i++)
					tso[1][i] = w[1][i];
			}
		}
	}
	else
		for (x = 0; x < cnt; x++)
		{
			w[job][step] = T[job][x].second;
			tw[job][step] = T[job][x].first;
			tx += tw[job][step];

			if (tx < t)
				sol1_bkt(job, step + 1);

			tx -= tw[job][step];
		}
}

void sol2_bkt(int step)
{
	int x, i, j, t1, t2, i1, j1, best, i11, t11, ok;

	if (step > S[0])
	{
		// dinamica

		for (i = 0; i <= S[0]; i++)
			for (j = 0; j <= S[1]; j++)
				tmin[i][j] = INF;

		tmin[0][0] = 0;

		for (i = 0; i < S[0]; i++)
			for (j = 0; j < S[1]; j++)
				if (tmin[i][j] < INF)
				{
					t1 = t2 = 0;

					i1 = i + 1;
					j1 = j + 1;

					while (i1 <= S[0] && j1 <= S[1])
					{
						best = -1;

						for (x = 0; x < cnt; x++)
						{
							ok = 1;

							for (i11 = i1, t11 = t1; t11 < t2 + T[1][x].first && i11 <= S[0]; i11++)
							{
								if (T[1][x].second == w[0][i11])
								{
									ok = 0;

									if (tmin[i][j] + t11 + tw[0][i11] < tmin[i11][j1 - 1])
										tmin[i11][j1 - 1] = tmin[i][j] + t11 + tw[0][i11];

									if (tmin[i][j] + 2 * (t2 + T[1][x].first) - t11 < tmin[i11 - 1][j1])
										tmin[i11 - 1][j1] = tmin[i][j] + 2 * (t2 + T[1][x].first) - t11;

									break;
								}

								t11 += tw[0][i11];
							}

							if (best == -1 && ok)
								best = x;
						}

						if (best == -1)
							break;

						x = best;

						t2 += T[1][x].first;
						j1++;

						while (i1 <= S[0] && t1 + tw[0][i1] <= t2)
						{
							t1 += tw[0][i1];
							i1++;
						}
					}

					if (i1 > S[0])
					{
						if (tmin[i][j] + t2 < tmin[S[0]][j1 - 1])
								tmin[S[0]][j1 - 1] = tmin[i][j] + t2;
					}
					else
					if (j1 > S[1])
					{
						if (tmin[i][j] + t2 < tmin[S[0]][j1 - 1])
								tmin[S[0]][j1 - 1] = tmin[i][j] + t2;
					}
				}
				
		for (i = 0; i < S[0]; i++)
			if (tmin[i][S[1]] < tmin[S[0]][S[1]])
				tmin[S[0]][S[1]] = tmin[i][S[1]];
				
		for (j = 0; j < S[1]; j++)
			if (tmin[S[0]][j] + (S[1] - j) * T[1][0].first < tmin[S[0]][S[1]])
				tmin[S[0]][S[1]] = tmin[S[0]][j] + (S[1] - j) * T[1][0].first;

		if (tx + tmin[S[0]][S[1]] < t)
		{
			t = tx + tmin[S[0]][S[1]];
			//twait = tmin[S[0]][S[1]];
			twait = INF;

			for (i = 1; i <= S[0]; i++)
				tso[0][i] = w[0][i];

			for (i = 1; i <= S[1]; i++)
				tso[1][i] = -1;//w[1][i];
		}
	}
	else
		for (x = 0; x < cnt; x++)
		{
			w[0][step] = T[0][x].second;
			tw[0][step] = T[0][x].first;
			tx += tw[0][step];

			if (tx + S[1] * T[1][0].first < t)
				sol2_bkt(step + 1);

			tx -= tw[0][step];
		}
}

int main()
{
	int Te;

	freopen("j.in", "r", stdin);
	freopen("j.out", "w", stdout);

	scanf("%d", &Te);

	while (Te--)
	{
		scanf("%d %d %d", &N, &S[0], &S[1]);

		T[0].clear();
		T[1].clear();

		for (k = 1; k <= N; k++)
		{
			scanf("%d %d", &i, &j);

			T[0].push_back(make_pair(i, k));
			T[1].push_back(make_pair(j, k));
		}

		sort(T[0].begin(), T[0].end());
		sort(T[1].begin(), T[1].end());

		if (T[0][0].second != T[1][0].second)
		{
			printf("%d\n", S[0] * T[0][0].first + S[1] * T[1][0].first);

			if (PRINT_SOL)
			{
				printf("cnt = 1\n");
				printf("Job 1 : %d(%d)\n", T[0][0].second, T[0][0].first);
				printf("Job 2 : %d(%d)\n", T[1][0].second, T[1][0].first);

				printf("total waiting time = %d\n", 0);

				for (i = 0; i < 2; i++)
				{
					for (j = 1; j <= S[i]; j++)
						printf("%d ", T[i][0].second);
	
					printf("\n");
				}
			}
		}
		else
		{
			if (N == 1)
				cnt = 1;
			else
			if (T[0][1].second != T[1][1].second)
				cnt = 2;
			else
			if (N == 3)
				cnt = 3;
			else
			if (N > 3 && T[0][2].second != T[1][2].second)
				cnt = 3;
			else
				cnt = (N > LMAX) ? LMAX : N;

			t = INF;

			if (N > 1)
			{
				t = S[0] * T[0][0].first + S[1] * T[1][1].first;

				for (i = 0; i < 2; i++)
					for (j = 1; j <= S[i]; j++)
						tso[i][j] = T[i][i].second;

				if (S[0] * T[0][1].first + S[1] * T[1][0].first < t)
				{
					t = S[0] * T[0][1].first + S[1] * T[1][0].first;
				
					for (i = 0; i < 2; i++)
						for (j = 1; j <= S[i]; j++)
							tso[i][j] = T[i][1 - i].second;
				}

				twait = -1;
			}

			tx = 0;

			if (!GOOD_SOL)
			{
				if (cnt == 4)
					cnt = 3;

				countt = 1;

				for (i = 1; i <= S[0] + S[1]; i++)
					countt *= cnt;

				sol1_bkt(0, 1);
			}
			else	
				sol2_bkt(1);

			printf("%d\n", t);

			if (PRINT_SOL)
			{
				printf("cnt = %d\n", cnt);

				for (i = 0; i < 2; i++)
				{
					printf("Job %d :", i + 1);

					for (j = 0; j < cnt; j++)
						printf(" %d(%d)", T[i][j].second, T[i][j].first);

					printf("\n");
				}

				printf("total waiting time = %d\n", twait);
			
				for (i = 0; i < 2; i++)
				{
					for (j = 1; j <= S[i]; j++)
						printf("%d ", tso[i][j]);

					printf("\n");
				}
			}
		}

		//fprintf(stderr, "%d left\n", Te);
	}

	return 0;
}