/*
TASK:billiard
LANG:C++
*/

#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <cstring>
#include <cstdlib>
#include <queue>
#include <map>
#include <set>
#include <stack>

using namespace std;

// white black hole
int w[2], b[2], h[2];

int orarea(int p1[2], int p2[2], int p3[2])
{
	return (p1[0] - p3[0]) * (p2[1] - p3[1]) - (p2[0] - p3[0]) * (p1[1] - p3[1]);
}

void readInput()
{
	scanf("%d %d", &w[0], &w[1]);	
	scanf("%d %d", &b[0], &b[1]);
	scanf("%d %d", &h[0], &h[1]);
}

double dist(int p1[2], int p2[2])
{
	return  (p1[0] - p2[0]) * (p1[0] - p2[0]) +
			(p1[1] - p2[1]) * (p1[1] - p2[1]);
}

int main()
{
	readInput();
	int vec[2];
	vec[0] = b[1] - w[1];
	vec[1] = -b[0] + w[0];
	int p[2];
	p[0] = b[0] + vec[0];
	p[1] = b[1] + vec[1];
	int val = orarea(b, p, h);
	int val2 = orarea(b, p, w);
	if (val * val2 < 0)
	{
		printf("1\n");
	}
	else
	{
		if (abs(val) / hypot(b[0] - p[0], b[1] - p[1]) <= 1.0)
			printf("1\n");
		else
			printf("0\n");
	}
	return 0;
}
