/*
TASK: economics
LANG: C++
*/
# include <stdio.h>
# define MAXN (1<<5)
# define TOPKI (1<<20)
int n,m;
char data[MAXN][MAXN];
int a[MAXN][MAXN];
int z[MAXN][MAXN];
int ans;

void read() {
	scanf("%d %d\n", &n,&m);
	for(int i = 0; i <n; i++)  {
		scanf("%s", data[i]); 	
	}	
}

void pusk(int p,int q) {
	if(p >= n || q >= m|| q <0) return;
	if(data[p][q] == 'v') {
		a[p][q]++;
		return;	
	}
	if(data[p][q] == '$') return;
	if(data[p][q] == '|') {
		pusk(p+1,q);			
		return;
	}

	if(data[p][q] == '\\') {
		pusk(p+1,q+1);
		return;	
	}
	if(data[p][q] == '/') {
		pusk(p+1,q-1);	
		return;		
	}
	if(data[p][q] == '*') {
		if(z[p][q] == 0) {
			//pusk(p,q-1);
			z[p][q]++;
			z[p][q]%=5;
			pusk(p,q-1);
			return;	
		}
		if(z[p][q] == 1) {
			//pusk(p+1,q-1);
			z[p][q]++;
			z[p][q]%=5;
			pusk(p+1,q-1);
			return;	
		}
		if(z[p][q] == 2) {
			//pusk(p+1,q);
			z[p][q]++;
			z[p][q]%=5;
			pusk(p+1,q);
			return;	
		}
		if(z[p][q] == 3) {
			//pusk(p+1,q+1);
			z[p][q]++;
			z[p][q]%=5;
			pusk(p+1,q+1);
			return;	
		}
		if(z[p][q] == 4) {
			//pusk(p,q+1);
			z[p][q]++;
			z[p][q]%=5;
			pusk(p,q+1);
			return;	
		}
		
	}
}

void solve() {
	int i = 0;
	while( i < TOPKI) {
		int t = i%m;
		pusk(0,t);
		i++;	
	}
	for(int i = 0; i < n; i++) {
		for(int j =0; j < m; j++) {
				ans+=a[i][j];			
		}	
	}	
}

int main() {
 	read();
	solve();
	printf("%.3lf\n", (double)(ans/(double)TOPKI));       
    return 0;
}
