/*
LANG:C++
TASK:economics
*/
#include <cstdio>
#include <cstring>
int m, n;
char input[32][32];
double mod[32][32];
double x;
double res;
int num;

int main() {
	scanf("%d%d", &n, &m);
	x = 1./m;
	for(int i = 1; i <= n; ++i) {
		char s[1024];
		scanf("%s", s);
		for(int j = 0; j < strlen(s); ++j) {
			input[i][j+1] = s[j];
		}
	}
	for(int i = 1; i <= n; ++i) {
		mod[1][i] = x;
	}
	for(int i = 1; i <= n; ++i) {
		for(int j = 1; j <= m; ++j) {
			char c = input[i][j];
			if(c == '/') {
				mod[i+1][j-1] += mod[i][j];
			} else if(c == '\\'){
				mod[i+1][j+1] += mod[i][j];
			} else if(c == '|') {
				mod[i+1][j] += mod[i][j];
			} else if(c == '*') {
				mod[i][j-1] +=  mod[i][j]/5;
				mod[i][j+1] +=  mod[i][j]/5;
				mod[i+1][j-1] +=  mod[i][j]/5;
				mod[i+1][j] +=  mod[i][j]/5;
				mod[i+1][j+1] += mod[i][j]/5;
			}
		}
	}
	
	
	for(int i = 1; i <= n; ++i) {
		for(int j = 1; j <= m; ++j) {
			if(input[i][j] == 'v') {
				res += mod[i][j];
				++num;
				//printf("%lf\n", res);
			}
		}
	}
	
	if(num == 0) {
		printf("0\n");
	} else {
		printf("%.3lf\n", res/num);
	}
	
	return 0;
}
