/*
TASK: economics
LANG: C++ 
*/
#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>
#include <queue>
#include <string>
#define INF 1 << 20
#define x first
#define y second
#define mp make_pair
#define pb push_back 
#define forn(i,st,end) for (i=st;i < end; i++)
#define MOD 1000
using namespace std;

typedef pair <int ,int> pii;
typedef vector <int > vi;
typedef vector <vi> vii;
typedef vector <string> vs;

string s[16];
int i,j, k , n, m;
double sol;

void calc (double pr, int k, int p)
{
 if (pr < 0.0000001) return;
 if (k >= n || p >= m ) return ;
 if (k < 0 || p < 0) return ;
 //cout << k <<' '<<  p <<endl;
 if (s[k][p] == '$') return ;
 if (s[k][p] == 'v') { sol += pr; return ; }	
 
 if (s[k][p] == '\\') calc (pr , k + 1, p + 1);
 if (s[k][p] == '/') calc (pr , k + 1, p - 1);
 
 if (s[k][p] == '|') calc (pr , k + 1, p);
 if (s[k][p] == '*')
  {
   calc (pr * 0.2 , k, p - 1);
   calc (pr * 0.2 , k, p + 1);
   calc (pr * 0.2 , k + 1, p - 1);
   calc (pr * 0.2 , k + 1, p );
   calc (pr * 0.2 , k + 1 , p + 1); 		
  } 
}

int main()
{
 scanf ("%d%d", &n, &m);
 
 forn (i , 0, n)
  {
   cin >> s[i];		
  }
  
 forn (i , 0, m)
  calc (1.0 / (double)m , 0, i);
 
 printf ("%.3f\n", sol);
 return 0;	
}
