#include <iostream>

using namespace std;

int n, m;
int x, y;
char p;
int moves;

int matrix[1024][1024];

void TurnRight(){
  if(p == 'U') p = 'R';
  else if(p == 'D') p = 'L';
  else if(p == 'R') p = 'D';
  else if(p == 'L') p = 'U';
}
void TurnLeft(){
  if(p == 'U') p = 'L';
  else if(p == 'D') p = 'R';
  else if(p == 'L') p = 'D';
  else if(p == 'R') p = 'U';
}
void goStraight(){
  if(p == 'D'){
    x++;
  }
  else if(p == 'U'){
    x--;
  }
  else if(p == 'R'){
    y++;
  }
  else if(p == 'L'){
    y--;
  }
  moves++;
}
void Reverse(){
  if(p == 'L') p = 'R';
  else if(p == 'R') p = 'L';
  else if(p == 'U') p = 'D';
  else if(p == 'D') p = 'U';
}

int RightCell(){
  if(p == 'U') return matrix[x][y+1];
  if(p == 'D') return matrix[x][y-1];
  if(p == 'R') return matrix[x+1][y];
  if(p == 'L') return matrix[x-1][y];
}

int LeftCell(){
  if(p == 'U') return matrix[x][y-1];
  if(p == 'D') return matrix[x][y+1];
  if(p == 'R') return matrix[x-1][y];
  if(p == 'L') return matrix[x+1][y];
}

void Recur(){
  if(x < 0 || y < 0 || x > n || y > m){
    printf("%d %d ", x, y); cout<<p<<" "<<moves<<endl;
    return;
  }

  if(matrix[x][y] == -1){
    printf("-1\n");
    return;
  }
  if(p == 'D'){
    if(matrix[x+1][y] == 1){
      if(LeftCell() == 0) TurnLeft();
      else if(RightCell() == 0) TurnRight();
    }
    goStraight();
  }
  else if(p == 'U'){
    if(matrix[x-1][y] == 1){
      if(LeftCell() == 0) TurnLeft();
      else if(RightCell() == 0) TurnRight();

    }
    goStraight();
  }
  else if(p == 'L'){
    if(matrix[x][y-1] == 1){
      if(LeftCell() == 0) TurnLeft();
      else if(RightCell() == 0) TurnRight();

    }
    goStraight();
  }
  else if(p == 'R'){
    if(matrix[x][y+1] == 1){
      if(LeftCell() == 0) TurnLeft();
      else if(RightCell() == 0) TurnRight();
    }
    goStraight();
  }
  else{
    Reverse();
  }

  Recur();
}

int main(){
  scanf("%d%d", &n, &m);
  scanf("%d%d", &x, &y);
  cin>>p;
  for(int i = 0; i < n; i++){
    for(int j = 0; j < m; j++){
      scanf("%d", &matrix[i][j]);
    }
  }
  printf("-1\n");
//  Recur();
  return 0;
}
