/*
TASK: nobel
LANG: C++
*/

#include <cstdio>
#include <iostream>

int T;
long long b, n, MOD;

long long power(long long b, long long n)
{
	if(n == 0)	return 1;
	if((n & 1) == 0)
	{
		long long x = power(b, n >> 1);
		return (x * x) % MOD;
	}
	else
	{
		long long x = power(b, n - 1);
		return (x * b) % MOD;
	}
}

long long sum(long long b, long long n)
{
	if(n == 0)	return 1;
	if((n & 1) == 1)
	{
		long long x = sum(b, n >> 1);
		long long mply = power(b, (n >> 1) + 1);
		return (x * (mply + 1)) % MOD;
	}
	else
	{
		long long add = power(b, n);
		return (sum(b, n - 1) + add) % MOD;
	}
}

int main()
{
	std :: cin >> T;
	for(int t = 0; t < T; t ++)
	{
		std :: cin >> b >> n >> MOD;
		std :: cout << sum(b, n) << "\n";
	}
    return 0;
}
