/*
TASK:nobel
LANG:C++
*/

#include <cstdio>
#include <map>
#include <vector>

int q, b, k;
int long long n;
std::map <int, bool> used;
std::vector <int> crem, rem, r;
int len, len2;
int long long s;

int long long sqr(int long long x) {
	return x*x;
}

int long long ipow(int x, int p) {
	if(p == 0) {
		return 1;
	}
	if(p == 1) {
		return x;
	}
	if(p % 2 == 0) {
		return sqr(ipow(x, p/2));
	} else {
		return sqr(ipow(x, p/2))*x;
	}
}

int main() {
	scanf("%d", &q);
	for(int i = 0; i < q; ++i) {
		scanf("%d%Ld%d", &b, &n, &k);
		for(int j = 0; ; ++j) {
//			printf("%d %d %d : %d\n", b, j, k, ipow(b, j)%k);
			int long long a = ipow(b, j)%k;
			if(used[a] == false) {
				used[a] = true;
				r.push_back(a);
			} else {
				r.push_back(a);
				break;
			}
		}
		int x;
		for(x = 0; x < r.size(); ++x) {
			if(r[x] != r.back()) {
				rem.push_back(r[x]);
			} else {
				break;
			}
		}
		for(; x < r.size()-1; ++x) {
			crem.push_back(r[x]);
		}
		
//		for(int j = 0; j < rem.size(); ++j) {
//			printf("%d ", rem[j]);
//		}
//		printf("\n");
//		for(int j = 0; j < crem.size(); ++j) {
//			printf("%d ", crem[j]);
//		}
//		printf("\n");
		
		len = crem.size();
		len2 = rem.size();
		for(int j = 0; j <= n && j < len2; ++j) {
			s += rem[j];
			s %= k;
		}
		for(int j = len2; j <= n; ++j) {
			s += crem[(j-len2)%len];
			s %= k;
		}
		
		printf("%Ld\n", s);
	}
	
	return 0;
}
