/*
TASK:platforms
LANG:C
*/

#include<stdio.h>
#define maxn 64
#define inf 1000000000
 int n,m;
 
 struct move{
  char t;
  int time;
 }vmove[maxn],hmove[maxn];
 
 int tab[maxn][maxn];

 int mtime(int x1, int y1, int d)
 {
  int res=0,tmp,mu=1;

  if (d==0)
  {
   switch(vmove[y1].t)
   {
    case 'F':mu=1; break;
    case 'S':mu=3; break;
    case 'O':mu=2; break;
   }
   res=vmove[y1].time+vmove[y1].t*(2*n-x1+1)*mu;
   return res;
  }

   switch(hmove[x1].t)
   {
    case 'F':mu=1; break;
    case 'S':mu=3; break;
    case 'O':mu=2; break;
   }
  return hmove[x1].time+hmove[x1].t*(2*n-y1+1);
 }

 int main()
 {
  int i,j,tmp1, tmp2,tt;
  FILE *fi=stdin; //fopen("platforms.in","r");

  fscanf(fi,"%d %d",&n,&m);

  for(i=0;i<n;i++)
   fscanf(fi,"%*c %c %d",&hmove[i].t,&hmove[i].time);
  for(i=0;i<m;i++)
   fscanf(fi,"%*c %c %d",&vmove[i].t,&vmove[i].time);

  for(i=0;i<=n;i++)
   tab[i][0]=0;
  for(j=0;j<=m;j++)
   tab[0][j]=0;

  for(i=1;i<=n;i++)
   for(j=1;j<m;j++)
   {
    tmp1=tab[i-1][j]+mtime(i,j,0);
    tmp2=tab[i][j-1]+mtime(i,j,1);
    if(tmp1 < tmp2){
     tab[i][j]=tmp1;
    }
    else tab[i][j]=tmp2;
   }
  fscanf(fi,"%d %d %d %d %d",&tmp1,&tmp2,&tt,&i,&j);
  printf("%d\n",tab[tmp1][tmp2]-tab[i][j]+tt);
  return 0;
 }
