/*
TASK:platforms
LANG:C++
*/
#include <iostream>
#include <queue>
using namespace std;
struct queueNode
{
       int x,y;
       int val;
};
queueNode makeNode(int a,int b,int c)
{
          queueNode qn;
          qn.x=a;
          qn.y=b;
          qn.val=c;
          return qn;
}
struct cmp
{
       bool operator () (queueNode q1,queueNode q2)
       {
            return q1.val>q1.val;
       }
};
priority_queue<queueNode,vector<queueNode>,cmp> q;
char row[64],col[64];
int rowT[64],colT[64];
bool used[64][64];
int a,b,c,d,e;
int m[64][64];
int N,M;

int X,Y;
void updateTable(queueNode t)
{
     X=t.x;Y=t.y;
     int rs,cs,time;
     if(row[X]=='F') rs=1;
     else if(row[X]=='S') rs=3;
     else rs=2;
     
     if(col[Y]=='F') cs=1;
     else if(col[Y]=='S') cs=3;
     else cs=2;
     
     for(int i=1;i<=N;i++)
     {
                     if(i==Y) continue;
                     
                     {
                            if(i>Y) time=rowT[X]+(i-1)*rs;
                            if(i<Y) time=rowT[X]+(N-1)*rs+(N-i)*rs;
                            while(time<=t.val) time+=(2*N-2);
                            if(m[X][i]>time)
                            {
                                                        m[X][i]=time;
                                                      if(!used[X][i]) q.push(makeNode(X,i,time));
                            }
                     }
                     
     } 
     
     for(int i=1;i<=M;i++)
     {
                     if(i==X) continue;
                     
                     {
                            if(i>X) time=colT[Y]+(i-1)*cs;
                            if(i<X) time=colT[Y]+(M-1)*cs+(M-i)*cs;
                            while(time<=t.val) time+=(2*M-2);
                            if(m[i][Y]>time)
                            {
                              m[i][Y]=time;
                              if(!used[i][Y]) q.push(makeNode(i,Y,time));
                            }
                     }
                     
     }  
     
}

int main()
{
    for(int i=0;i<64;i++)
            for(int j=0;j<64;j++)
            {
                    m[i][j]=2000000000;
            }        
    cin>>M>>N;
    for(int i=1;i<=M;i++)
            cin>>row[i]>>rowT[i];
    for(int i=1;i<=N;i++)
            cin>>col[i]>>colT[i];
    cin>>a>>b>>c>>d>>e;
    q.push(makeNode(a,b,c));
   // cout<<"vhod done";
while(!q.empty())
{
        //         cout<<"poping ";
        //         cout<<q.top().x<<" "<<q.top().y<<endl;
    while(!q.empty() && used[q.top().x][q.top().y]) q.pop();
         //            cout<<"done";
    if(!q.empty())
    {
        used[q.top().x][q.top().y]=1;
        updateTable(q.top());
        q.pop();
    }
   // cout<<"all";
}   

cout<<m[d][e]<<endl;
return 0;
}
