/*
TASK: jori
LANG: C++
*/
// momtchil
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

#define MAXN 200010
#define MAXCHARS 30000000

char *s,*duma[MAXN]; int N;
char allwords[MAXCHARS];

int primesc=16,primes[]={23,	29,	31,	37,	41,	43	,47	,53,	59,	61,	67,	71,73,	79,	83,	89,	97	,101,	103	,107	,109,	113,	127	,131,	137	,139,	149	,151,	157	,163,	167,173,179	,181,	191	,193,	197	,199,	211	,223};
int base[30];

const int mod1=6661313;
bool check1[mod1]; int h1[MAXN];
bool dupe[MAXN];
int add1[30]; ULL add2[30]; int addcnt1; ULL addcnt2;
pair<ULL,int> h2list[MAXN];
ULL h2[MAXN];

inline int hash1(int cnt,int letcnt[])
{
	int hash=cnt;
	Repi(26) hash=(hash*base[i]+letcnt[i])%mod1;
	return hash;
}

inline ULL hash2(int cnt,int letcnt[])
{
	ULL hash=cnt;
	Repi(26) hash=hash*(LL)base[i]+(LL)letcnt[i];
	return hash;
}

int letcnt[MAXN][26],cnt[MAXN];
int dp[MAXN],next[MAXN];

int solve(int word)
{
	int &ret=dp[word];
	if (ret>-1) return ret;

	ret=0;

	ULL nh2; int nh1; pair<ULL,int> tmp,*at;
	Repj(26)
		 {
					nh1=(h1[word]+add1[j]+addcnt1)%mod1;

					if (!check1[nh1]) continue;
					tmp.x=h2[word]+add2[j]+addcnt2;
					
					for (at=lower_bound(h2list,h2list+N,tmp);at!=h2list+N && at->x==tmp.x;at++)
					 {
							if (cnt[at->y]!=cnt[word]+1 || h1[at->y]!=nh1) continue;
							if (solve(at->y)>ret)
							 ret=solve(at->y),next[word]=at->y;
						    break;
					 }
		 }

	return ++ret;
}

bool cmp(const pair<ULL,int> &a,const pair<ULL,int> &b)
{	return (a.x==b.x)?(cnt[a.y]==cnt[b.y])?h1[a.y]<h1[a.y]:cnt[a.y]<cnt[b.y]:a.x<b.x; }

int main()
{
	srand(34534531);
//	cout<<" bases: ";
	Repi(30)
	 {
	   base[i]=primes[rand()%primesc];
	   //cout<<base[i]<<" "; 
	 } //cout<<endl;
	 
	addcnt1=1;
	for (int i=25;i>=0;i--)
	 add1[i]=addcnt1,addcnt1=addcnt1*base[i]%mod1;
//	cout<<" add1 : "; cout<<addcnt1<<"  "; Repi(26) cout<<add1[i]<<" "; cout<<endl;
	
	addcnt2=1;
	for (int i=25;i>=0;i--)
	 add2[i]=addcnt2,addcnt2=addcnt2*(LL)base[i];
//	cout<<" add2 : "; cout<<addcnt2<<"  "; Repi(26) cout<<add2[i]<<" "; cout<<endl;
	
	
	N=0;
	s=allwords;
	while (scanf("%s",s)==1)
	 {
			duma[N]=s;
			
			cnt[N]=strlen(s);
			Repi(cnt[N])
			 letcnt[N][s[i]-'a']++;
			h1[N]=hash1(cnt[N],letcnt[N]);
		    check1[h1[N]]=1;
		    h2[N]=hash2(cnt[N],letcnt[N]);
			h2list[N]=MP(h2[N],N);
			 
		//	cout<<N<<" = "<<duma[N]<<" : "<<cnt[N]<<" - ";
		//	Repi(26) cout<<letcnt[N][i]<<" "; cout<<endl;
		//	cout<<"         hash1 "<<h1[N]<<endl;
		//	cout<<"         hash2 "<<h2[N]<<endl;
			
			s+=cnt[N]+1;
			N++; 
	 }
	 
//	 cout<<" after read : "<<(double)clock()/CLOCKS_PER_SEC<<endl;

	pair<ULL,int> tmp,*at;
	sort(h2list,h2list+N,cmp);
	for (int i=1;i<N;i++)
	 if (!cmp(h2list[i],h2list[i-1]) && !cmp(h2list[i-1],h2list[i])) dupe[h2list[i].y]=1;
	//cout<<"                  ahses 2 :\n";
	//Repi(N) cout<<"           "<<h2list[i].x<<" - "<<h2list[i].y<<" \n";
//	 cout<<" after duped : "<<(double)clock()/CLOCKS_PER_SEC<<endl;
	
	memset(next,-1,sizeof(next));
	memset(dp,-1,sizeof(dp));
	int ans=0,yey=-1;
	Repi(N)
	 if (cnt[i]==3 && !dupe[i])
	  if (solve(i)>ans)
	   ans=solve(i),yey=i;

//	 cout<<"  after all : "<<(double)clock()/CLOCKS_PER_SEC<<endl;
	  
	while (yey>-1)  
		printf("%s\n",duma[yey]),yey=next[yey];
	  
    return 0;
}
