/*
TASK: nobel
LANG: C++
*/
// momtchil
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

int Q; LL MOD;
LL b,n;

LL power(LL x,LL p)
{
	LL ans=1;
	while (p)
	 {
			if (p&1) ans=ans*x%MOD;
			p>>=1;
			x=x*x%MOD;
	 }
	return ans;
}

LL solve(LL p)
{
	if (p==1) return b;
	LL tmp=solve(p/2),ret=(tmp+tmp*power(b,p/2))%MOD;
	if (p%2) return (ret+power(b,p))%MOD;
	return ret;
}

LL brute()
{
	LL res=0,pw=1;
	Repi(n+1)
	 {
			res=(res+pw)%MOD; pw=pw*b%MOD;
	 }
	return res;
}

int main()
{
	cin>>Q;
    Repi(Q)
     {
			cin>>b>>n>>MOD;
			cout<<(solve(n)+1)%MOD<<"\n";
//			cout<<(solve(n)+1)%MOD<<" "<<brute()<<"\n";
		//	LL a=(solve(n)+1)%MOD,b=brute();
		//	if (a!=b) cout<<" asdffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffff "<<a<<" "<<b<<" at row "<<i<<"\n";
	 }
    return 0;
}
