/*
TASK: platforms
LANG: C++
*/
#include <cstdio>
#include <queue>

using namespace std;
int n,m;
int r[52][2], c[52][2];
int sx,sy,st,ex,ey;
char used[52][52];
priority_queue < pair<int,pair<char,char> > , vector < pair<int,pair<char,char> > >, greater < pair<int,pair<char,char> > > > q;

int find(char mode, char i, char p, int t, char dir)
{
    int u,v;
    char d='+';
    if (mode == 'r') {
       u = r[i][0]; v = 1;
       if (t > u) {u += ((t-u)/((2*m-2)*r[i][1]))*(2*m-2)*r[i][1];}
       while (1) {
             if (v == p && dir == d && u >= t) return u+r[i][1];
             if (d == '+' && v == m) {d='-'; continue;}
             if (d == '-' && v == 1) {d='+'; continue;}
             if (d == '+') {u+=r[i][1]; ++v;}
             if (d == '-') {u+=r[i][1]; --v;}
             }
       }
    if (mode == 'c') {
       u = c[i][0]; v = 1;
       if (t > u) {u += ((t-u)/((2*n-2)*c[i][1]))*(2*n-2)*c[i][1];}
       while (1) {
             if (v == p && dir == d && u >= t) return u+c[i][1];
             if (d == '+' && v == n) {d='-'; continue;}
             if (d == '-' && v == 1) {d='+'; continue;}
             if (d == '+') {u+=c[i][1]; ++v;}
             if (d == '-') {u+=c[i][1]; --v;}
             }
       }
}

void input()
{
     int i; char z;
     scanf("%d %d\n",&n,&m);
     for (i=1;i<=n;++i) {
         scanf("%c %d\n",&z,&r[i][0]);
         if (z == 'F') r[i][1] = 1;
         if (z == 'O') r[i][1] = 2;
         if (z == 'S') r[i][1] = 3;
         }
     for (i=1;i<=m;++i) {
         scanf("%c %d\n",&z,&c[i][0]);
         if (z == 'F') c[i][1] = 1;
         if (z == 'O') c[i][1] = 2;
         if (z == 'S') c[i][1] = 3;
         }
     scanf("%d %d %d %d %d",&sx,&sy,&st,&ex,&ey);
}

void solve()
{
     int i;
     char x,y;
     pair< int,pair<char,char> > p;
     q.push(make_pair(st,make_pair(sx,sy)));
     while (1) {
           p = q.top(); q.pop();
           x = p.second.first; y = p.second.second;
           //printf("pop %d (%d,%d)\n",p.first,x,y);
           if (x == ex && y == ey) {printf("%d\n",p.first); return ;}
           if (used[x][y]) continue;
           used[x][y] = 1;
           
           if (x < n && !used[x+1][y]) {
              i = find('c',y,x,p.first,'+');
              q.push(make_pair(i,make_pair(x+1,y)));
              }
           if (x > 1 && !used[x-1][y]) {
              i = find('c',y,x,p.first,'-');
              q.push(make_pair(i,make_pair(x-1,y)));
              }
           if (y < m && !used[x][y+1]) {
              i = find('r',x,y,p.first,'+');
              q.push(make_pair(i,make_pair(x,y+1)));
              }
           if (y > 1 && !used[x][y-1]) {
              i = find('r',x,y,p.first,'-');
              q.push(make_pair(i,make_pair(x,y-1)));
              }
           }
}

int main()
{
    input();
    solve();
    return 0;
}
