/*
TASK:nobel
LANG:C++
*/
#include <stdio.h>
#include <utility>
using namespace std;

long long test(long long base, long long power, long long modulo);
pair<long long, long long> EUC(long long a, long long b);

int main()
{
	int N;
	long long a, b, c;
	scanf("%d", &N);
	for(int i=0; i<N; i++)
	{
		scanf("%lld %lld %lld", &a, &b, &c);
		printf("%lld\n", test(a, b, c));
	}
	return 0;
}

long long test(long long base, long long power, long long modulo)
{
	long long i;
	long long result;
	long long currPower;
	long long diviser;

	result = 0;
	currPower = 1;

	for(i=power+1; i; i=i>>1)
	{
		result = ((i&1) * currPower + result)%modulo;
		currPower = ((currPower%modulo) * (base%modulo))%modulo;
	}

	result -= 1;
	if(result < 0)
		result += modulo;

	diviser = (base - 1)%modulo;

	pair<long long, long long> get = EUC(diviser, modulo);


	return (get.first * base)%modulo + (get.first<0?modulo:0);
}

pair<long long, long long> EUC(long long a, long long b)
{
	pair <long long, long long> get;
    if (a % b == 0)
        return make_pair(0, 1);
    else
	{
        get = EUC(b, a % b);
        return make_pair(get.second, get.first-get.second*(a / b));
	}
}