{                     Hrsito Atanasov Ivanov XI klas
                                 Dobrich}
program Short;
type
  Ogr    = 0..19;
  TPoint = record
             X, Y : Real;
             Used : Boolean;
           end;
  TTriangle = record
                A, B, C : TPoint;
              end;
  TTriangleArray = array [ 1..19 ] of TTriangle;

var

  Triangles     : TTriangleArray;
  A, B          : TPoint;
  TriangleCount : Ogr;
  Biggest       : Real;
  Eps           : Real;

procedure Init;
var
  InpF : Text;
  i    : Integer;
begin

  Assign( InpF, 'short.inp');
  ReSet( InpF );

  ReadLn( InpF, TriangleCount );
  for i := 1 to TriangleCount do
    ReadLn( InpF, Triangles[ i ].A.X, Triangles[ i ].A.Y,
                  Triangles[ i ].B.X, Triangles[ i ].B.Y,
                  Triangles[ i ].C.X, Triangles[ i ].C.Y );
  Read( InpF, A.X, A.Y, B.X, B.Y );

  Close( InpF );
end;

procedure Print;
var
  OutF : Text;

begin

  Assign( OutF, 'short.out' );
  ReWrite( OutF );
  Write( OutF, Biggest : 10 : 8 );
  Close( OutF );

end;

function FindR( A, B : TPoint ) : Real;
begin

  FindR := Sqrt(Sqr( B.X - A.X ) + Sqr( B.Y - A.Y ));

end;

function Cross( A, B, C, D : TPoint ) : Boolean;
var
  Znak1,
  Znak2 : real;
begin

  Znak1 := ( A.Y - B.Y ) * C.X + ( B.X - A.X ) * C.Y +
           ( A.X * B.Y - A.Y * B.X );
  Znak2 := ( A.Y - B.Y ) * D.X + ( B.X - A.X ) * D.Y +
           ( A.X * B.Y - A.Y * B.X );

  Cross := not ((( ( Znak1 > Eps ) and ( Znak2 > Eps ) ) or
                   ( Znak1 < Eps ) and ( Znak2 < Eps ) ) );
end;
procedure CalcEps;
begin

  Eps := 0.1;
  while ( 1 - Eps ) <> 1 do
    Eps := Eps * 0.1;

end;

function Ravni( A, B : TPoint ) : Boolean;
begin
  Ravni := ( Abs ( A.X - B.X ) < Eps ) and
           ( Abs ( A.Y - B.Y ) < Eps );
end;

procedure Solve;
type
  TAnswer = array [ Ogr ] of Ogr;
var
  Current : Real;
  Answer  : TAnswer;
  AnswerL : Ogr;
  Left ,
  Right   : TPoint;
  N       : Ogr;
  Usable  : Boolean;
  procedure FindCrossed;
  var
    I : Ogr;

  begin
    for i := 1 to TriangleCount do
      if Cross( A, B, Triangles[ I ].A, Triangles[ I ].B ) or
         Cross( A, B, Triangles[ I ].A, Triangles[ I ].C ) or
         Cross( A, B, Triangles[ I ].B, Triangles[ I ].C ) then
      begin

        Inc( AnswerL );
        Answer[ AnswerL ] := I;

      end;
  end;
  function NePresicha( Left, Right : TPoint ) : Boolean;
  var
    J : Ogr;
    Usable : Boolean;
  begin

    Usable := True;

    for J := 1 to AnswerL do
      if  Cross( Left, Right,
                 Triangles[ Answer[ J ] ].A, Triangles[ Answer[ J ] ].B ) or
          Cross( Left, Right,
                 Triangles[ Answer[ J ] ].A, Triangles[ Answer[ J ] ].C ) or
          Cross( Left, Right,
                 Triangles[ Answer[ J ] ].B, Triangles[ Answer[ J ] ].C ) then
      begin

        Usable := false;
        Break;

      end;

    NePresicha := Usable;
  end;
procedure FindRight;
var
  I : Integer;
begin
  if NePresicha(Left, B) then Right := b else
  for i := 1 to AnswerL do
  begin
    Right  := Triangles[ Answer[ I ] ].A;

    if not Right.Used then
      if NePresicha( Left, Right ) then
      begin
        Triangles[ Answer[ I ] ].A. Used := True;
        exit;
      end;

    Right := Triangles[ Answer[ I ] ].B;

    if not Right.Used then
      if NePresicha( Left, Right ) then
      begin
        Triangles[ Answer[ I ] ].B.Used := True;
        Exit
      end;

    Right := Triangles[ Answer[ I ] ].C;

    if not Right.Used then
      if NePresicha( Left, Right ) then
      begin
        Triangles[ Answer[ I ] ].B.Used := True;
        Exit
      end;

  end;
end;
function AllDone : boolean;
begin

  Inc ( N );
  AllDone := N = 20;
end;
begin

  AnswerL := 0;
  FindCrossed;
  if AnswerL = 0 then
  begin

    Biggest := FindR( A, B );
    Print;
    Halt;

  end;


  Left := A;
  n:= 15;
  Biggest := MaxInt;
  while not AllDone do
  while (Right.X <> B.X) and (Right.Y <> B.Y) do
  begin
    FindRight;
    Current := FindR( Left, Right );

    if NePresicha( Right, B ) then
    begin
      Current := Current + FindR( Right, B );
      if Current < Biggest then
        Biggest := Current;
    end;

    Left := Right;
    FindRight;
  end;
end;
begin
  CalcEps;
  Init;
  Solve;
  Print;
end.
