// Gabrovo4 - 1
#include <fstream>
#include <iomanip>
#include <cstring>


int n,k;
int a[320];
int b[320][320];
bool u[320];
int m[320];
int r[320];


int bitcount(int x)
{
  int c=0;
  while (x)
  {
    x&=x-1;
    c++;
  }
  return c;
}


void goout(int oc,int r[])
{
  ofstream fout("comp.out");
  fout << oc << endl;
  for (int i=1;i<k;i++) fout << r[i] << " ";
  fout << r[k] << endl;
  fout.close();
  exit(0);
}


void tryone(int oc,bool u[])
{
  int i=1,nk=1;
  do{
    int s=0;
    int si=i;
    while ((!u[i])&&(i<=n)&&(s<=oc)) s+=b[1][i++];
    if (s>oc) s-=b[1][--i];
    if (i-si>0) r[nk++]=i-si;
    if (u[i])
    {
      si=i;
      while (u[i]&&(i<=n)) i++;
      r[nk++]=i-si;
    }
  }while (i<=n);
  if (nk==k+1) goout(oc,r);
  if (nk<k)
  {
    int i=1,ni=1;
    int nr[320];
    while (nk<k)
    {
      if (nr[i]>1)
        for (int j=1;(j<=r[i])&&(nk<k);j++,nk++)
          nr[ni++]=1;
      else
        nr[ni++]=r[i];
      i++;
    }
    for (;i<=k;i++,ni++)
      nr[ni]=r[i];
    goout(oc,nr);
  }
}


int main()
{
  ifstream fin("comp.inp");
  fin >> n >> k;
  for (int i=1;i<=n;i++)
    fin >> a[i];

  for (int i=1;i<=n;i++)
    b[1][i]=bitcount(a[i]);

  for (int i=2;i<=n;i++)
    for (int j=1;j<=n-i+1;j++)
      b[i][j]=b[i-1][j]+b[1][j+i-1];

  /*
  for (int i=1;i<=n;i++)
  {
    for (int j=1;j<=n-i+1;j++)
      cout << setw(4) << b[i][j];
    cout << endl;
  }
  */

  bool first=true;
  int gmx=-1;
  for (int i=1;i<=n;i++)
  {
    int mx=1;
    for (int j=2;j<=n-i+1;j++)
      if (first)
        if (b[i][j]>b[i][mx]) mx=j;else;
      else
        if ((b[i][j]<b[i][mx])&&(b[i][j]>gmx)) mx=j;
    first=false;

    memset(u,0,sizeof(u));
    for (int k=mx;k<=mx+i-1;k++)
    {
      u[k]=true;
      m[k]=1;
    }
    int k;
    k=mx+i;while ((b[1][k]==0)&&(k<=n)) {u[k]=true;m[k]=1;k++;}
    k=mx-i;while ((b[1][k]==0)&&(k>=0)) {u[k]=true;m[k]=1;k--;}
    tryone(b[i][mx],u);

    gmx=b[i][mx];
  }
  
  return 0;
}
