// Source written by Dimitar Issussov - SMG
// - SQRT Domain error cause's problems

#include <stdio.h>
#include <math.h>
#include <stdlib.h>

int n;

float fig_data[20][3][2];
float graph[62][62];
float sh[2][2];

float path(float *a, float *b) {
 return sqrt((a[0]-b[0])*(a[0]-b[0])+(a[1]-b[1])*(a[1]-b[1]));;
}

void ml(float *a, float *b, int c)  {
  if (a[1] == b[1]) sh[c][0] = 0;
  else sh[c][0] = (a[1]-b[1])/(a[0]-b[0]);
  sh[c][1] = a[1]-sh[c][0]*a[0];
}

int crossing(float * v1, float * v2)  {
  int i, k;
  float crs[2];
  float pathx[3];

  ml(v1, v2, 0);

  for(i=0; i<n; i++)  {
    for(k=0;k<3;k++)  {
      ml(fig_data[i][k], fig_data[i][(k+1)%3], 1);
      if(sh[1][0] == sh[0][0]) continue;
      crs[0] = (sh[1][1]-sh[0][1])/(sh[0][0]-sh[1][0]);
      crs[1] = sh[0][0]*crs[0]+sh[0][1];
      if(((crs[0] == v1[0]) && ((crs[1] == v1[1]))) || ((crs[0] == v2[0]) && ((crs[1] == v2[1]))) || ((crs[0] == fig_data[i][k][0]) & (crs[1] == fig_data[i][k][1]))|| ((crs[0] == fig_data[i][(k+1)%3][0]) && (crs[1] == fig_data[i][(k+1)%3][1]))) continue;
      pathx[0] = path(v1, crs);
      pathx[1] = path(v2, crs);
      pathx[2] = path(v1, v2);
      if(abs(pathx[0]+pathx[1]-pathx[2])<0.00000001) {
	if(abs(path(fig_data[i][k], crs)+path(fig_data[i][(k+1)%3], crs)-path(fig_data[i][k], fig_data[i][(k+1)%3])) < 0.00000001) return 1;
      }
      pathx[2] -= pathx[1]+pathx[0];
    }
  }
  return 0;
}

int main(void)  {

  FILE *fin = fopen("short.inp", "rt");
  FILE *fout = fopen("short.out", "w+");

  int i = 0, j, k, l;
  float a[2], b[2];

  fscanf(fin, "%d", &n);
  while(i<n){
    fscanf(fin,"%f %f", &fig_data[i][0][0], &fig_data[i][0][1]);
    fscanf(fin,"%f %f", &fig_data[i][1][0], &fig_data[i][1][1]);
    fscanf(fin,"%f %f", &fig_data[i][2][0], &fig_data[i][2][1]);
    i++;
  }
  fscanf(fin, "%f %f %f %f", &a[0], &a[1], &b[0], &b[1]);
  if((n == 0) || !crossing(a, b))  fprintf(fout, "%f", path(a, b));
  else {
   for(i=0;i<n;i++) {
     if(!(crossing(fig_data[i][0], a)))  {
       graph[n*3][i*3] = path(fig_data[i][0], a);
       graph[i*3][n*3] = graph[n*3][i*3];
     }
     if(!crossing(fig_data[i][1], a))  {
       graph[n*3][i*3+1] = path(fig_data[i][1], a);
       graph[i*3+1][n*3] = graph[n*3][i*3+1];
     }
     if(!crossing(fig_data[i][2], a))  {
       graph[n*3][i*3+2] = path(fig_data[i][2], a);
       graph[i*3+2][n*3] = graph[n*3][i*3+2];
     }
   }
   for(i=0;i<n;i++) {
     if(!crossing(fig_data[i][0], b))  {
       graph[n*3+1][i*3] = path(fig_data[i][0], b);
       graph[i*3][n*3+1] = graph[n*3+1][i*3];
     }
     if(!crossing(fig_data[i][1], b))  {
       graph[n*3+1][i*3+1] = path(fig_data[i][1], b);
       graph[i*3+1][n*3+1] = graph[n*3+1][i*3+1];
     }
     if(!crossing(fig_data[i][2], b))  {
       graph[n*3+1][i*3+2] = path(fig_data[i][2], b);
       graph[i*3+2][n*3+1] = graph[n*3+1][i*3+2];
     }
   }
   for(i=0;i<n;i++)  {
     for(j=0;j<n;j++)  {
       for(k=0;k<3;k++) {
	 for(l=0;l<3;l++) {
	   if((i==j) && (k==l)) continue;
	   if(!crossing(fig_data[i][k], fig_data[j][l]))  {
	     graph[j*3+l][i*3+k] = floor(path(fig_data[i][k], fig_data[j][l])*100000000)/100000000;
	     graph[i*3+k][j*3+l] = graph[j*3+l][i*3+k];
	   }
	 }
       }
     }
   }
   for(i=0;i<n*3+2;i++) {
     for(j=0;j<n*3+2;j++) {
       if(i==j) continue;
       if(graph[n*3+1][i] > graph[n*3+1][j]+graph[j][i]) {
	 graph[n*3+1][i] = graph[n*3+1][j]+graph[j][i];
	 graph[i][n*3+1] = graph[n*3+1][i];
       }
     }
   }
   fprintf(fout, "%f", graph[n*3+1][n*3+2]);
  }
  fclose(fin);
  fclose(fout);

  return 0;
}
