// Velin Krassimirov Tzanov, SMG, 11 star klas
#include <stdio.h>
#include <math.h>

FILE *fn;

int n;
double point[64][2];
double path[64][64];
double tri[32][8];
double infpath=500000000;

int orient(double x1, double y1, double x2, double y2, double x3, double y3) {
  double s=x1*y2+x2*y3+x3*y1-x1*y3-x2*y1-x3*y2;
  if (s>0.000001) return 1;
  else if (s<-0.000001) return -1;
  else return 0;
}

int main(void) {
int i, j, k, t;

fn=fopen("SHORT.INP", "r");
fscanf(fn, "%d", &n);
for (i=0; i<n; i++) {
  fscanf(fn, "%lf %lf %lf %lf %lf %lf", &tri[i][0], &tri[i][1], &tri[i][2], &tri[i][3], &tri[i][4], &tri[i][5]);
  point[3*i][0]=tri[i][0];
  point[3*i][1]=tri[i][1];
  point[3*i+1][0]=tri[i][2];
  point[3*i+1][1]=tri[i][3];
  point[3*i+2][0]=tri[i][4];
  point[3*i+2][1]=tri[i][5];
}
fscanf(fn, "%lf %lf %lf %lf", &point[n*3][0], &point[n*3][1], &point[n*3+1][0], &point[n*3+1][1]);
fclose(fn);

t=3*n+2;
for (i=0; i<=n*3; i++) {
  for (j=i+1; j<t; j++) {
    for (k=0; k<n; k++) {
      if (orient(point[i][0], point[i][1], point[j][0], point[j][1], tri[k][0], tri[k][1])*orient(point[i][0], point[i][1], point[j][0], point[j][1], tri[k][2], tri[k][3])==-1 && orient(tri[k][0], tri[k][1], tri[k][2], tri[k][3], point[i][0], point[i][1])*orient(tri[k][0], tri[k][1], tri[k][2], tri[k][3], point[j][0], point[j][1])==-1) break;
      else if (orient(point[i][0], point[i][1], point[j][0], point[j][1], tri[k][4], tri[k][5])*orient(point[i][0], point[i][1], point[j][0], point[j][1], tri[k][2], tri[k][3])==-1 && orient(tri[k][4], tri[k][5], tri[k][2], tri[k][3], point[i][0], point[i][1])*orient(tri[k][4], tri[k][5], tri[k][2], tri[k][3], point[j][0], point[j][1])==-1) break;
      else if (orient(point[i][0], point[i][1], point[j][0], point[j][1], tri[k][0], tri[k][1])*orient(point[i][0], point[i][1], point[j][0], point[j][1], tri[k][4], tri[k][5])==-1 && orient(tri[k][0], tri[k][1], tri[k][4], tri[k][5], point[i][0], point[i][1])*orient(tri[k][0], tri[k][1], tri[k][4], tri[k][5], point[j][0], point[j][1])==-1) break;
    }
    if (k==n) {
      path[i][j]=path[j][i]=sqrt((point[i][0]-point[j][0])*(point[i][0]-point[j][0])+(point[i][1]-point[j][1])*(point[i][1]-point[j][1]));
    } else {
      path[i][j]=path[j][i]=infpath;
    }
  }
}

for (k=0; k<t; k++) {
  for (i=0; i<t; i++) {
    for (j=0; j<t; j++) {
      if (path[i][k]+path[k][j]<path[i][j]) path[i][j]=path[i][k]+path[k][j];
    }
  }
}

fn=fopen("SHORT.OUT", "w");
fprintf(fn, "%.8lf\n", path[t-2][t-1]);
fclose(fn);

return 0;
}
