 /* Nikolay Bachiyski 11 klas */
 /* PMG "Vasil Drimev " Veliko Tyrnovo */

 program Short;


 const
  eps =0.0000000001 ;



 var
  inp, out :text;

 type
  rtype = double;
  point=record
    x,y : rtype;
   end;

  tri=array[1..3] of point;


  tris = array [1..20] of tri;

  tgraph = array[1..60,1..60] of rtype;

  tallp =array[1..59] of point;



 var
  N:integer;
  i,j : longint;
  T : tris;
  St,Dst : point;
  allp :tallp;
  g : tgraph;
  sp : tgraph;

 function gmax(p,q:rtype) : rtype;
  begin
   if (p-q>eps) then
    gmax:=p
   else
    gmax:=q;
  end;

 function gmin(p,q:rtype) : rtype;
  begin
   if (p-q>eps) then
    gmin:=q
   else
    gmin:=p;
  end;



 function ots_ots(o1A,o1B,o2A,o2B : point) : boolean;
 var
  tmp : point;
  A1,A2,B1,B2,C1,C2,min,max : rtype;
  sign:boolean;
  begin
   A1 := o1A.y - o1B.y; A2 := o2A.y - o2B.y;
   B1 := o1B.x - o1A.x; B2 := o2B.x - o2A.x;
   C1 := o1A.x*o1B.y - o1B.x*o1A.y; C2 := o2A.x*o2B.y - o2A.y*o2B.x;
   if (A2*B1-B2*A1)=0 then
    begin
     ots_ots := false;
     exit;
    end;
   tmp.x := (B2*C1-C2*B1)/(A2*B1-B2*A1);
   if (B1=0) then
    tmp.y := (-C2-A2*tmp.x)/B2
   else
    tmp.y := (-C1-A1*tmp.x)/B1;

   sign := true;

   if (o1A.x<>o1B.x) then
     sign := sign and
      (tmp.x < gmax(o1A.x,o1B.x)) and
      (tmp.x > gmin(o1A.x,o1B.x));

   if (o1A.y<>o1B.y) then
    sign := sign and
      (tmp.y < gmax(o1A.y,o1B.y)) and
      (tmp.y > gmin(o1A.y,o1B.y));

   if (o2A.x<>o2B.x) then
    sign := sign and
      (tmp.x < gmax(o2A.x,o2B.x)) and
      (tmp.x > gmin(o2A.x,o2B.x));

   if (o2A.y<>o2B.y) then
    sign:=sign and
      (tmp.y < gmax(o2A.y,o2B.y)) and
      (tmp.y > gmin(o2A.y,o2B.y));
   ots_ots:=sign;
  end; {ots_ots}

 function rast (p1,p2 : point) : rtype;
  begin
   rast := sqrt(sqr(p1.x-p2.x)+sqr(p1.y-p2.y));
  end;

 procedure ReadData;
 var
  cnt : integer;
  begin
   cnt :=2;
   assign(inp,'short.inp');
   reset(inp);
   assign(out,'short.out');
   rewrite(out);
   readln(inp,N);
   for i:=1 to N do
    begin
      readln(inp,T[i,1].x,T[i,1].y,T[i,2].x,T[i,2].y,T[i,3].x,T[i,3].y);
      inc(cnt); allp[cnt]:=T[i,1];
      inc(cnt); allp[cnt]:=T[i,2];
      inc(cnt); allp[cnt]:=T[i,3];
    end;
   readln(inp,St.x,St.y,Dst.x,Dst.y);
   allp[1]:=St;
   allp[2]:=Dst;
  end;


 procedure mark_rebro(pt1,pt2 : point;n1,n2 : integer);
 begin
  G[n1][n2] := rast(pt1,pt2);
  G[n2][n1] := rast(pt1,pt2);
 end;


 procedure Floyd;
 var
  i,j,k : integer;
  ff:rtype;
 begin
  sp:=g;
  for k:=1 to N*3+2 do
   for i:=1 to N*3+1 do
    for j:=i+1 to N*3+2 do
     begin
      if (sp[i,j]<>0)and(sp[i,k]<>0)and(sp[k,j]<>0) then
       ff := gmin(sp[i,j],sp[i,k]+sp[k,j])
      else
       ff:=sp[i,j];
      if (sp[i,j]=0) then
       if (sp[i,k]-0>eps) and (sp[k,j]-0>eps) then
        ff:=sp[i,k]+sp[k,j];
      sp[i,j]:=ff;
     end;

 end;


 procedure DoIt;
 var
  i,j,k,w,l,m,n1,n2 : integer;
  sign,gs : boolean;
  begin
   for i:=1 to N*3+1 do
    for j:=i+1 to N*3 +2 do
     begin
      sign:=true; gs:=true;
      for k:=1 to N do
       for w:=1 to 2 do
        for l:=w+1 to 3 do
        begin
         n1:=2+(k-1)*3+w;
         n2:=2+(k-1)*3+l;
         sign := not(ots_ots(allp[i],allp[j],allp[n1],allp[n2]));
         if not sign then gs:=false;
        end;
      if (gs) then
       mark_rebro(allp[i],allp[j],i,j);
     end;
   if (N=0)or(G[1,2]>0) then
    begin
     writeln(out,G[1,2]:0:8);
     close(out);
     halt;
    end;
   Floyd;
   writeln(out,sp[1,2]:0:8);
  end;


 begin
  ReadData;
{  writeln(ots_ots(allp[2],allp[3],allp[4],allp[5]));}
  DoIt;
  close(out);
 end.