#include <stdio.h>

FILE *fin,*fout;
int partl[1000];
char parts[1000][255];
long int left[1000][2],nl=0;
long int right[1000][2],nr=0;
int n,maxn;

void readinput() {
    fin=fopen("genom.inp","r");
    fscanf(fin,"%d",&n);
    int i,j;
    char x=0;
    x=fgetc(fin);
    for (i=0;i<n;i++) {
       j=0;
       x=fgetc(fin);
       while ((!feof(fin))&&(x!=10)) {
           parts[i][j]=x;
           x=fgetc(fin);
           j++;
       }
       parts[i][j]=0;
       partl[i]=j-1;
    }
    maxn=n*2;
    fclose(fin);
}

int checked[1000];
unsigned char recurse[1000];
int forblock[1000];

int ingen(int a,int b,int d) {
    d=abs(d);
    int mova=(1-(a%2)*2),movb=(1-(b%2)*2);
    int sa=d,sb=0;
    a/=2;
    b/=2;
    int ea=partl[a],eb=partl[b];
    if (mova==-1) {
        sa=partl[a]-d;
        ea=0;
    }
    if (movb==-1) {
        sb=partl[b];
        eb=0;
        //sa=partl[a]-d+1;
    }
    int ok=0;

    while ((sa!=ea)&&(eb!=sb)) {
        if (parts[a][sa]!=parts[b][sb]) {
            ok=1;
            break;
        }
        sa+=mova;
        sb+=movb;
    }
    return ok;
}

void writeoutput() {
    int i;
    fout=fopen("genom.out","w");
    for (i=0;i<nl;i++)
        fprintf(fout,"%d\n",(left[i][0]/2+1)*(1-left[i][0]%2*2));
    for (i=nr-1;i>=0;i--)
        fprintf(fout,"%d\n",(right[i][0]/2+1)*(right[i][0]%2*2-1));
    fclose(fout);
}

void checkfirstlast() {
    int i,j,d,x;
    int level=0;
    forblock[level]=0;
    char mustreturn=0;
    for (j=0;j<1000;j++) checked[j]=0;
    left[0][1]=0;
    right[0][1]=0;
    int maxlevel=0;
    int okk=0;
    while (okk==0) {
        if (level==n) {
            d=left[nl][1]-right[nr][1];
            okk=1;
            if (d>0) {
                i=left[nl-1][0]/2;
                maxlevel=partl[i]+1;
                x=1;
                for (j=maxlevel-d;j<maxlevel-d/2;j++) {
                   if (parts[i][j]!=parts[i][maxlevel-x])
                      okk=0;
                   x++;
                }
            }
            if (d<0) {
                i=right[nr-1][0]/2;
                maxlevel=partl[i]+1;
                x=1;d=-d;
                for (j=maxlevel-d;j<maxlevel-d/2;j++) {
                   if (parts[i][j]!=parts[i][maxlevel-x])
                      okk=0;
                   x++;
                }
            }
        }
        if (okk==1) break;
        //if (level>maxlevel) { printf("%d",level);maxlevel=level;}
        /*for (d=0;d<n;d++) if (checked[d]==1) mustreturn++;
        if (mustreturn>2)
          for (d=0;d<n;d++)
             if (checked[d]==0)
                 printf(",%s\n",parts[d]);
        //writeoutput();*/
        mustreturn=0;
        d=left[nl][1]-right[nr][1];
        mustreturn=1;
        if (d==0) {
            for (j=forblock[level];j<maxn;j++) {
                if (checked[j/2]==0) {
                    recurse[level]=0;
                    forblock[level++]=j+1;
                    forblock[level]=0;
                    left[nl][0]=j;
                    left[++nl][1]=left[nl-1][1]+partl[j/2]+1;
                    checked[j/2]=1;
                    mustreturn=0;
                    break;
                }
            }
            if (mustreturn==0)
                continue;
        }
        if (d>0) {
            for (j=forblock[level];j<maxn;j++) {
                if (checked[j/2]==0) {
                    if (ingen(left[nl-1][0],j,partl[left[nl-1][0]/2]-d+1)==0) {
                        //printf("%d,%d,%s,%s,%d\n",j,left[nl-1][0],parts[j/2],parts[left[nl-1][0]/2],partl[left[nl-1][0]/2]-d+1);
                        recurse[level]=1;
                        forblock[level++]=j+1;
                        forblock[level]=0;
                        right[nr][0]=j;
                        right[++nr][1]=right[nr-1][1]+partl[j/2]+1;
                        checked[j/2]=1;
                        mustreturn=0;
                        break;
                    }
                }
            }
            if (mustreturn==0)
                continue;
        }
        else {
            for (j=forblock[level];j<maxn;j++) {
                if (checked[j/2]==0) {
                    if (ingen(j,right[nr-1][0],d+partl[right[nr-1][0]/2]+1)==0) {
                        recurse[level]=0;
                        forblock[level++]=j+1;
                        forblock[level]=0;
                        left[nl][0]=j;
                        left[++nl][1]=left[nl-1][1]+partl[j/2]+1;
                        checked[j/2]=1;
                        mustreturn=0;
                        break;
                    }
                }
            }
            if (mustreturn==0)
                continue;
        }
        level--;
        if (level<0) return;
        if (recurse[level]==0)
            checked[left[--nl][0]/2]=0;
        else
            checked[right[--nr][0]/2]=0;
    }
}

int main() {
    readinput();
    checkfirstlast();
    writeoutput();
    return 0;
}
