const inp = 'genom.inp';
      out = 'genom.out';

type TRez = record
              ind: integer;
              pos: boolean;
            end;

      BoolArray = array[1..1000] of boolean;
      StrArray = array[1..1000] of string;
      CharArray = array[1..255000] of char;

var F1,F2 : text;
    n, ind, sl: integer;
    L: longint;

    peace: StrArray;
    taken: BoolArray;
    str: CharArray;
    rez: Array[1..1000] of TRez;

{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}
Procedure SortPeaces;
var i,j: integer;
    tmp: string;

begin
for i:= 1 to n-1 do  for j:=i+1 to n do
  if length(peace[i]) < length(peace[j]) then
    begin
    tmp:= peace[i]; peace[i]:= peace[j]; peace[j]:= tmp;
    end;
end;

{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}
Procedure Init;
var i: integer;

begin
assign(F1, inp); reset(f1);
assign(f2, out); rewrite(f2);
L:= 0;
readln(f1, n);
for i:=1 to n do
  begin readln(f1, peace[i]); L:= L+length(peace[i]); end;

fillchar(rez, sizeof(rez), 0);
fillchar(taken, sizeof(taken), false);
fillchar(str, sizeof(str), '0');
sl:= 0;
end;

{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}
Procedure Done;
var i: integer;
begin
for i:=1 to n do
  begin
  if not rez[i].pos then write(f2, '-');
  writeln(f2, rez[i].ind);
  end;
close(f1); close(f2);
halt;
end;


{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}
Function Check: boolean;
var i, k: integer;
    b: boolean;

begin
if sl <= (L+1) div 2 then
  begin Check:= true; exit; end;

if odd(L) then
  begin
  k:= sl - (L+1) div 2;
  b:= true;
  for i:= 1 to k do
    if str[(L+1) div 2 + i] <> str[(L+1) div 2 - i] then
      begin b:= false; break; end;
  if b then check:= true else check:= false;
  exit;
  end;

if not odd(L) then
  begin
  k:= sl - L div 2;
  b:= true;
  for i:= 1 to k do
    if str[L div 2 + i] <> str[L div 2 - i+1] then
      begin b:= false; break; end;
  if b then check:= true else check:= false;
  exit;
  end;

end;

{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}
Procedure Try;
var i, j, saveL: integer;

begin
for i:= 1 to n do  if not taken[i] then
  begin
  saveL:= sl;

  for j:=1 to length(peace[i]) do str[sl+j]:= peace[i][j]; sl:= sl+j;
  if check then
    begin
    rez[ind].ind:= i; rez[ind].pos:= true;
    taken[i]:= true;
    if ind = n then Done else inc(ind);
    Try;
    dec(ind); taken[i]:= false;
    end;

  if length(peace[i])=1 then continue;
  sl:= savel;
  for j:=1 to length(peace[i]) do str[sl+j]:= peace[i][length(peace[i])-j+1]; sl:= sl+j;
  if check then
    begin
    rez[ind].ind:= i; rez[ind].pos:= false;
    taken[i]:= true;
    if ind = n then Done else inc(ind);
    Try;
    dec(ind); taken[i]:= false;
    end;
  sl:= savel;
  end;
end;

{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}
{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}
{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}
BEGIN
Init;
ind:= 1;
Try;
Done;
END.
