/****************************************************************************
   name : Mihail Volen Mukov
   city : Pleven
   group: 4
 ****************************************************************************/
/* INCLUDES *****************************************************************/
   #include <fstream>
   #include <string>
   #include <cmath>
   #include <cstdlib>
 
   using namespace std;

/* CONSTANTS ****************************************************************/
   const int MAX = 303;
   const int MAX_VAL = 2010010;

/* CLASSES ******************************************************************/
/* GLOBALS ******************************************************************/
   ifstream fin("comp.inp");
   ofstream fout("comp.out");

   int n;
   int k;
   int m[MAX];
   int c[MAX];
   int d[MAX][MAX];
   int p[MAX][MAX];

/* FUNCTIONS ****************************************************************/
/****************************************************************************/
   void init()
   {  fin >> n >> k;
      int i;
      for (i = 1; i <= n; i++)
      {  fin >> m[i];
      }
   }
/****************************************************************************/
   void done()
   {
      /*
      int i;
      for (i = 1; i <= k; i++)
      {  int j;
         for (j = 1; j <= n; j++)
         {  fout << d[j][i] << " ";
         }
         fout << endl;
      }

      fout << endl;
      for (i = 1; i <= k; i++)
      {  int j;
         for (j = 1; j <= n; j++)
         {  fout << p[j][i] << " ";
         }
         fout << endl;
      }
      /**/
   
      fin.close();
      fout.close();
      exit(0);
   }
/****************************************************************************/
   int count_one(int a)
   {  int res = 0;

      while (a > 0)
      {  res += a % 2;
         a /= 2;
      }

      return res;
      
   }
/****************************************************************************/
   inline int min(int a, int b)
   {  return (a < b) ? a : b;
   }
/****************************************************************************/
   inline int max(int a, int b)
   {  return (a > b) ? a : b;
   }
/****************************************************************************/
   void findpath(int i, int g)
   {  if (g == 0) return;

      findpath(p[i][g] - 1, g - 1);

      if (g == k)
      {  fout << i - p[i][g] + 1 << endl;
      } else
         {  fout << i - p[i][g] + 1 << ' ';
         }
   }
/****************************************************************************/
   void run()
   {  int i;
   
      for (i = 1; i <= n; i++)
         c[i] = count_one(m[i]);

      for (i = 1; i <= n; i++)
      {  d[i][1] = d[i - 1][1] + c[i];
         p[i][1] = 1;
      }

      int g;
      for (g = 2; g <= k; g++)
      {  int i;
         for (i = 1; i <= n; i++)
         {  int res = 0;

            d[i][g] = MAX_VAL;
            int j;
            for (j = i; j > 0; j--)
            {  res += c[j]; //d[j][g - 1];

               int nres = max(res, d[j - 1][g - 1]);
               if (nres < d[i][g])
               {  d[i][g] = nres;
                  p[i][g] = j;
               }
            }
         }
      }

      fout << d[n][k] << endl;
      
      findpath(n, k);


   }
/****************************************************************************/
   int main()
   {  init();
   
      run();
      /*
      int i;
      for (i = 1; i <= 32; i++)
      {  fout << i << " - " << count_one(i) << endl;
      }
      */
      
      done();

      return 0;
   }
/****************************************************************************/

