{
        gr. Ruse
        grupa 4
        uchenik nomer 1

        Stoyan Tsonev Hristov

}
Const
     InFile = 'short.inp';
     OutFile = 'short.out';

     EPS = 0.000000001;

     MAX = 1000000.0;

Type

    TPoint = record
           x,y : real;
    end;

    TTr = array [1..4] of TPoint;

Var
    FIn,FOut  : Text;
    PS        : array [1..100] of TPoint;
    tr        : array [1..30] of TTr;
    count     : integer;
    d         : array [1..100,1..100] of real;
    n,i,j     : integer;

function ss(p1,p2,p3 : TPoint) : integer;
var
   s : real;
begin
     s := (p1.x - p2.x) * (p1.y + p2.y) +
          (p2.x - p3.x) * (p2.y + p3.y) +
          (p3.x - p1.x) * (p3.y + p1.y);
     if s > eps then
        ss := 1
     else
         if s < - eps then
             ss := -1
         else
             ss := 0;
end;

function eq(p1,p2 : TPoint) : boolean;
begin
     eq := (p1.x = p2.x) and (p1.y = p2.y);
end;

function dist(p1,p2 : TPoint) : real;
begin
     dist := sqrt( sqr(p1.x - p2.x) + sqr(p1.y - p2.y));
end;


function pres(p1,p2,p3,p4 : TPoint) : boolean;
var
   s1,s2 : integer;

begin
   s1 := ss(p1,p2,p3) * ss(p1,p2,p4);
   s2 := ss(p3,p4,p1) * ss(p3,p4,p2);

   if eq(p1,p3) or eq(p1,p4) or eq(p2,p3) or eq(p2,p4) then begin
      pres := false;
      exit;
   end;

   if s1 = 0 then begin
      if ss(p1,p2,p3) = 0 then begin
         if abs( dist(p1,p2) - ( dist(p1,p3) + dist(p2,p3 ))) < EPS then begin
            pres := true;
            exit;
         end;
      end
      else begin
         if abs( dist(p1,p2) - ( dist(p1,p4) + dist(p2,p4))) < EPS then begin
            pres := true;
            exit;
         end;
      end;
   end;

   if s2 = 0 then begin
      if ss(p3,p4,p1) = 0 then begin
         if abs( dist(p3,p4) - ( dist(p3,p1) + dist(p4,p1))) < EPS then begin
            pres := true;
            exit;
         end;
      end
      else begin
         if abs( dist(p3,p4) - ( dist(p3,p2) + dist(p4,p2))) < EPS then begin
            pres := true;
            exit;
         end;
      end;
   end;


   pres := (s1 < 0) and (s2 < 0);

end;

function can(p1,p2 : TPoint) : boolean;
var
   i,j : integer;

begin
     for i := 1 to n do
         for j := 1 to 3 do
             if pres(p1,p2,tr[i][j],tr[i][j+1]) then begin
                can := false;
                exit;
             end;

     can := true;
end;

function dekstra : real;
var
   used    : array [1..100] of boolean;
   best    : array [1..100] of real;
   i,j ,id : integer;
   min     : real;

begin
     for i := 1 to count do
         best[i] := MAX;

     best[1] := 0;
     fillchar(used,sizeof(used),false);

     for i := 1 to count do begin
         min := MAX;
         id := 0;
         for j := 1 to count do
             if (not used[j]) and ( best[j] < min ) then begin
                min := best[j];
                id := j;
             end;

         used[id] := true;

         for j := 1 to count do
             if (not used[j]) then begin
                if best[id] + d[id,j] < best[j] then
                   best[j] := best[id] +d[id,j];
             end;

     end;

     dekstra := best[2];
end;

procedure solve;
var
   i,j : integer;

begin
   for i := 1 to count do
       d[i,i] := MAX;

   for i := 1 to count do
       for j := i+1 to count do
           if can(ps[i],ps[j]) then begin
               d[i,j] := dist(ps[i],ps[j]);
               d[j,i] := d[i,j];
           end
           else begin
               d[i,j] := MAX;
               d[j,i] := MAX;
           end;

   writeln(FOut,dekstra:0:8);
end;

Begin
     assign(FIn,InFile);        reset(FIn);
     assign(FOut,OutFile);      rewrite(FOut);
     readln(FIn,N);
     count := 2;
     for i := 1 to n do begin
         readln(FIn,tr[i][1].x,tr[i][1].y,tr[i][2].x,tr[i][2].y,tr[i][3].x,tr[i][3].y);
         tr[i][4] := tr[i][1];
         for j := 1 to 3 do
             ps[count+j] := tr[i][j];
         inc(count,3);
     end;
     readln(FIn,ps[1].x,ps[1].y,ps[2].x,ps[2].y);
     close(FIn);
     solve;
     close(FOut);
End.