/*
  George Tsankov, 11 star, SMG
*/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>


#define MAXN 310
#define MAXK 310

int N, K;
int c[MAXN];
int sum[MAXN];
int minnk[MAXN][MAXN];
int nink[MAXN][MAXN];
int P;
int p[MAXK];


void read_all(void);
void do_all(void);
int getminnk(int n, int k);
void write_all(void);



int main(void)
{
  read_all();
  do_all();
  write_all();
  return 0;
}



void read_all(void)
{
  int i;
  
  FILE *f = fopen("comp.inp", "rt");
  fscanf(f, "%d %d", &N, &K);
  for (i = 0; i < N; i++) {
    fscanf(f, "%d", &c[i]);
  }
  fclose(f);
}


void do_all(void)
{
  int i, j, a;

  for (i = 0; i < N; i++) {
    a = 0;
    for (j = 28; j >= 0; j--)  a += !!(c[i]&(1<<j));
    c[i] = a;
    for (j = i; j >= 0; j--) {
      sum[j] += a;
    }
  }
  memset(minnk, -1, sizeof(minnk));
  P = getminnk(N, K);
  for (i = K; i >= 1; i--) {
    p[i-1] = nink[N][i];
    N -= p[i-1];
  }
}


int getminnk(int n, int k)
{
  int i, a, res, res1;

  res1 = sum[0];
  if (minnk[n][k] >= 0)  return minnk[n][k];
  if (k == 1) {
    nink[n][k] = n;
    return minnk[n][k] = sum[0]-sum[n];
  }
  for (i = 1; n-i >= k-1; i++) {
    a = sum[n-i]-sum[n];
    res = getminnk(n-i, k-1);
    if (a > res)  res = a;
    if (res < res1) {
      res1 = res;
      nink[n][k] = i;
    }
  }
  return minnk[n][k] = res1;
}


void write_all(void)
{
  int i;
  
  FILE *f = fopen("comp.out", "wt");
  fprintf(f, "%d\n", P);
  for (i = 0; i < K; i++) {
    fprintf(f, "%s%d", (i==0)?"":" ", p[i]);
  }
  fprintf(f, "\n");
  fclose(f);
}


