/*
Nikola Momchev Momchev
SMG
11 klas
*/

#include <stdio.h>
#include <limits.h>

#define N 300

#define min(a,b) ((a<b)?a:b)
#define max(a,b) ((a>b)?a:b)

int n,k;
int mass[N];
int group[N];

int ret[N][N];
int isused[N][N];

int conv(int x)
{
  int ret=0;
  for(;x!=0; x>>=1)
    ret += (x%2);

  return ret;
}

int foo(int n, int k)
{
  if(isused[n][k])
    return ret[n][k];
  else
    isused[n][k] = 1;
    
  if(n<k || (k==0 && n!=0))
  {
    ret[n][k] = INT_MAX;
    return ret[n][k];
  }
  if(k==0 && n==0)
  {
    ret[n][k] = 0;
    return ret[n][k];
  }

  int cur = INT_MAX;
  int paca;
  
  for(int i=1; i<=n; i++)
  {
    paca = mass[n-1]-mass[n-i-1];
    int huj = foo(n-i, k-1);
    int kur = max(huj,paca);
    
    cur = min(kur,cur);
    
    if(cur==kur)
      group[k-1] = i;
    
    if(paca == kur)
      break;
  }
  
  ret[n][k] = cur;
  return cur;
}

int main(void)
{
  freopen("comp.inp","r", stdin);
  freopen("comp.out", "w", stdout);

  scanf("%d %d\n", &n, &k);

  int x;
  scanf("%d", &x);
  mass[0] = conv(x);
  
  for(int i=1; i<n; i++)
  {
    scanf("%d", &x);
    mass[i] = conv(x)+mass[i-1];
  }

  printf("%d\n", foo(n,k));
  for(int i=0; i<k-1; i++)
    printf("%d ", group[i]);
  printf("%d\n", group[k-1]);

  fclose(stdin);
  fclose(stdout);
  return 0;
}
