//Vladimir Nedev MG Varna 11-12 class(IV grupa)
#define IN                "SHORT.INP"
#define OUT               "SHORT.OUT"
#define REAL              double
#define MAX               25
#define MAXRIB            80
#define GETIND(nom,tri)   (tri==-1)?(nom):(nom*3+1+tri);
#define sqr(a)            (a)*(a)
///////////////////////////////////////
#include <math.h>
#include <stdio.h>
///////////////////////////////////////
struct TRIANGLE
{
 REAL x[3],y[3];
}mas[MAX];
REAL       xp1,yp1,xp2,yp2,matrix[MAXRIB][MAXRIB];
int        n;
///////////////////////////////////////
void input()
{int i;
 FILE *inp=fopen(IN,"r");
 fscanf(inp,"%d",&n);
 for(i=0;i<n;i++)
 {
  fscanf(inp,"%lf%lf%lf%lf%lf%lf"
                              ,&(mas[i].x[0]),&(mas[i].y[0])
                              ,&(mas[i].x[1]),&(mas[i].y[1])
                              ,&(mas[i].x[2]),&(mas[i].y[2]));
 }
 fscanf(inp,"%lf%lf%lf%lf",&xp1,&yp1,&xp2,&yp2);
 fclose(inp);
}
/////////////
REAL DIST(REAL x1,REAL y1,REAL x2,REAL y2)
{return sqrt(sqr(x1-x2)+sqr(y1-y2));}
/////////////
void GetCoor(REAL& x,REAL& y,int nom,int tri)
{
 if(tri==-1&&!nom) {x=xp1;y=yp1;return;}
 if(nom==n*3+1)    {x=xp2;y=yp2;return;}
 x=mas[nom].x[tri];
 y=mas[nom].y[tri];
}
///////////////
int LICE(REAL x1,REAL y1,REAL x2,REAL y2,REAL x3,REAL y3)
{REAL lice;
 lice=x1*y2+y1*x3+x2*y3-(y2*x3+y1*x2+x1*y3);
 if(lice<0.0) return 1;
 if(lice>0.0) return 0;
 return -1;
}
int Presich(REAL x1,REAL y1,REAL x2,REAL y2)
{int  i,j,nach,end,s1,s2,s3,s4;
 REAL PRESx1,PRESx2,PRESy1,PRESy2;
///////////////////
 for(i=0;i<n;i++)
    for(j=0;j<3;j++)
    {
     nach=j;
     end=j+1;if(j==2) end=0;
     PRESx1=mas[i].x[nach];
     PRESy1=mas[i].y[nach];
     PRESx2=mas[i].x[end];
     PRESy2=mas[i].y[end];
     s1=LICE(x1,y1,PRESx1,PRESy1,PRESx2,PRESy2);
     s2=LICE(x2,y2,PRESx1,PRESy1,PRESx2,PRESy2);
     s3=LICE(PRESx1,PRESy1,x1,y1,x2,y2);
     s4=LICE(PRESx2,PRESy2,x1,y1,x2,y2);
     if(((!s1&&s2)||(s1&&!s2))&&
        ((!s3&&s4)||(s3&&!s4))&&
        s1!=-1&&s2!=-1&&s3!=-1&&s4!=-1)
        return 1;
    }
 return 0;
}
/////////////
void add_ribs(int nom,int tri)
{
int  i,j,ind1,ind2;
REAL x1,y1,x2,y2;
///////////////
ind1=GETIND(nom,tri);
GetCoor(x1,y1,nom,tri);
///////////////
 for(i=0;i<n;i++)
    for(j=0;j<3;j++)
    if(i==nom&&j==tri) {matrix[ind1][ind1]=0.0;}
    else
    {
     ind2=GETIND(i,j);
     GetCoor(x2,y2,i,j);
     /////////presicha li se s niakoia ot stranite na niakoi ot triigilnicite?
     if(Presich(x1,y1,x2,y2))
       matrix[ind1][ind2]=-1.0;
     else
       matrix[ind1][ind2]=DIST(x1,y1,x2,y2);
    }
///////////////
 ind2=n*3+1;
 if(ind1!=ind2)
 {
 GetCoor(x2,y2,n*3+1,-1);
 if(Presich(x1,y1,x2,y2))
   {matrix[ind1][ind2]=-1.0;matrix[ind2][ind1]=-1.0;}
 else
   {matrix[ind1][ind2]=DIST(x1,y1,x2,y2);matrix[ind2][ind1]=matrix[ind1][ind2];}
 }
///////////////
 ind2=0;
 if(ind1!=ind2)
 {
 GetCoor(x2,y2,0,-1);
 if(Presich(x1,y1,x2,y2))
   {matrix[ind1][ind2]=-1.0;matrix[ind2][ind1]=-1.0;}
 else
   {matrix[ind1][ind2]=DIST(x1,y1,x2,y2);matrix[ind2][ind1]=matrix[ind1][ind2];}
 }
}
/////////////
void make_ribs()
{int i,j;
 add_ribs(0,-1); //nachalnata tochka
 for(i=0;i<n;i++)//virhovete na triigilnicite
  for(j=0;j<3;j++)
    add_ribs(i,j);
 add_ribs(1+n*3,-1);//krainata tochka
}
/////////////
void Floyd()
{int i,j,k;
 for(k=0;k<=n*3+1;k++)
  for(i=0;i<=n*3+1;i++)
   if(matrix[i][k]>=0.0)
     for(j=0;j<=n*3+1;j++)
      if(matrix[j][k]>=0.0)
       if(matrix[i][j]<0.0||( matrix[i][j]-(matrix[i][k]+matrix[k][j])>0.0 ))
         matrix[i][j]=matrix[i][k]+matrix[k][j];
}
/////////////
void solve()
{make_ribs();
 Floyd(); //Deikstra();
}
/////////////
void output()
{FILE *outp=fopen(OUT,"w");
 fprintf(outp,"%.8lf",matrix[0][n*3+1]);
 fclose(outp);
}
///////////////////////////////////////
void main()
{input();solve();output();}
