/*
Ime:Valentin Stoianov Mihov
Grad:Varna
Vyzrastova grupa:4
Nomer v otbora:3
*/


#include <fstream>
#define INPF "comp.inp"
#define OUTF "comp.out"
#define MAXN 400
#define MAX(a,b) ((a)>(b)?(a):(b))
#define MIN(a,b) ((a)<(b)?(a):(b))

int n,k;
int nums[MAXN];
int ones[MAXN];
int s[MAXN],T[MAXN][MAXN];
int back[MAXN][MAXN];
int sps[MAXN];

void Init()
  {
    ifstream f(INPF);
    f>>n>>k;
    for(int i=0;i<n;i++)
      f>>nums[i];
    f.close();
  }

void FindOnes()
  {
    int num,ost,o;
    for(int i=0;i<n;i++)
      {
        num=nums[i];
        o=0;
        while(num)
          {
             ost=num%2;
             if(ost) o++;
             num/=2;
          }
        ones[i]=o;
      }
  }

void CalculateSums()
  {
    int sum=0;
    for(int i=n-1;i;i--)
      {
        sum+=ones[i];
        s[i]=sum;
      }
  }
  
int Sum(int i1,int i2)
  {
    int sum=0;
    for(int i=i1;i<=i2;i++)
      sum+=ones[i];
    return sum;
  }

void Initialize()
  {
    for(int i=0;i<=k;i++)
      T[0][i]=ones[0];
    for(int i=0;i<n;i++)
      T[i][1]=s[i];
    for(int i=0;i<n;i++)
      T[i][1]=Sum(0,i);
  }

void Solve()
   {
     int min,max;
      for(int j=2;j<=k;j++)
        for(int i=j-1;i<n;i++)
         {
           min=10000000;
           for(int l=0;l<i;l++)
             {
               max=MAX(T[l][j-1],Sum(l+1,i));
               if(min>=max) { min=max;back[i][j]=l;}
             }
           T[i][j]=min;
         }
   }

void Output()
  {
    int gr;
    ofstream f(OUTF);
    f<<T[n-1][k]<<endl;
    gr=1;
    for(int i=1;i<n;i++)
      if(sps[i]) {f<<++gr<<" ";gr=0;}
            else gr++;
    f<<gr<<endl;
    f.close();
  }

void GoBack(int ind,int sp)
  {
     if(!sp) return;
     sps[back[ind][sp]]=1;
     GoBack(back[ind][sp],sp-1);
  }

void main()
  {
    Init();
    FindOnes();
    CalculateSums();
    Initialize();
    Solve();
    GoBack(n-1,k);
    Output();
  }
