/*
Ime:Valentin Stoianov Mihov
Grad:Varna
Vyzrastova grupa:4
Nomer v otbora:3
*/

#include <math.h>
#include <stdio.h>
#define INPF "short.inp"
#define OUTF "short.out"
#define MAXN 30

struct _Point {
                float x,y;
              } toch1,toch2;

struct Triang { _Point p1,p2,p3; };

Triang tr[MAXN];
int n;


void Init()
  {
    _Point p1,p2,p3;
    Triang tri;
    FILE *f=fopen(INPF,"rt");
    fscanf(f,"%d",&n);
    for(int i=0;i<n;i++)
      {
        fscanf(f,"%f%f%f%f%f%f",&p1.x,&p1.y,&p2.x,&p2.y,&p3.x,&p3.y);
        tri.p1=p1;tri.p2=p2,tri.p3=p3;
        tr[i]=tri;
      }
    fscanf(f,"%f%f%f%f",&toch1.x,&toch1.y,&toch2.x,&toch2.y);
    fclose(f);
  }

////////////////////Short functions///////////////////////////////////////////

int Razl(_Point p1,_Point p2)
  {
    int a=p1.x!=p2.x,b=p1.y!=p2.y;
    return (a || b);
  }

double Lice(_Point p1,_Point p2,_Point p3)
  {return (p1.x*p2.y+p1.y*p3.x+p2.x*p3.y-p1.x*p3.y-p1.y*p2.x-p2.y*p3.x);}

double Dist(_Point p1,_Point p2)
  {return sqrt(pow(p1.x-p2.x,2)+pow(p1.y-p2.y,2));}

int PresichaVec(_Point p1,_Point p2,_Point p3,_Point p4)
  {return ((Lice(p3,p4,p1)*Lice(p3,p4,p2)<0)&&(Lice(p1,p2,p3)*Lice(p1,p2,p4))<0);}

/////////////////////Main functions///////////////////////////////////////////

int PresichaTr(_Point p1,_Point p2)
  {
    Triang curr;
    for(int i=0;i<n;i++)
      {
        if(PresichaVec(p1,p2,tr[i].p1,tr[i].p2)) return i;
        if(PresichaVec(p1,p2,tr[i].p2,tr[i].p3)) return i;
        if(PresichaVec(p1,p2,tr[i].p3,tr[i].p1)) return i;
      }
    return -1;
  }

double FindRast(_Point p1,_Point p2)
  {
    double min=1000000000,d;
    Triang curr;
    int index=PresichaTr(p1,p2);
    if(index!=-1)
          {
            curr=tr[index];
            if(Razl(p1,curr.p1) && Razl(curr.p1,p2))
              {
                d=FindRast(p1,curr.p1)+FindRast(curr.p1,p2);
                if(min>d) min=d;
              }
            if(Razl(p1,curr.p2) && Razl(curr.p2,p2))
              {
                d=FindRast(p1,curr.p2)+FindRast(curr.p2,p2);
                if(min>d) min=d;
              }
            if(Razl(p1,curr.p3)&&Razl(curr.p3,p2))
              {
                d=FindRast(p1,curr.p3)+FindRast(curr.p3,p2);
                if(min>d) min=d;
              }
          }
     else min=Dist(p1,p2);
    return min;
  }

void Output()
  {
    FILE *f=fopen(OUTF,"wt");
    fprintf(f,"%0.8f\n",FindRast(toch1,toch2));
    fclose(f);
  }

void main()
  {
    Init();
    Output();
  }

