{$N+,R-,S-,I-,C-}
{Martin Georgiev Chillev
 Veliko Turnovo
 12 klas
}
Const Exp=0.00001;
      MaxTriangle=20;
      MaxVruhs=62;
      Endless=2000000000;
Type TCoord = Record
                 X,Y:Extended;
              End;
Var T:Array[1..MaxTriangle]of Array[1..3] of TCoord;
    G:Array[1..MaxVruhs,1..MaxVruhs]of Extended;
    N,MaxVr:Word;
    Nach,Kraj:TCoord;
    fin,fout:text;
Procedure Init(St:String);
Var i,j:Word;
 Begin
   Assign(fin,St);
   Reset(fin);
   Readln(fin,N);
   MaxVr:=(N*3)+2;
   For i:=1 to N Do
    Begin
      For j:=1 to 3 Do Read(fin,T[i][j].X,T[i][j].Y);
      Readln(fin);
    End;
   Readln(fin,Nach.X,Nach.Y,Kraj.X,Kraj.Y);
   Close(fin);
 End;
Procedure Floyd;
 Var i,j,tmp:Word;
  Begin
    For tmp:=1 to MaxVr Do
     For i:=1 to MaxVr Do
      For j:=1 to MaxVr Do
       If((tmp<>i)And(tmp<>j)And(i<>j))then
        Begin
          If((G[i][tmp]+G[tmp][j])<G[i][j])then G[i][j]:=(G[i][tmp]+G[tmp][j]);
        End;
  End;
Function Razst(Dot1,Dot2:TCoord):Extended;
 Begin Razst:=Sqrt(Sqr(Dot1.X-Dot2.X)+Sqr(Dot1.Y-Dot2.Y));End;
Function Pres(Dot11,Dot12,Dot21,Dot22:TCoord):Boolean;
Var A1,A2,B1,B2,C1,C2,Chis1,Chis2,Znam:Extended;
    PresDot:TCoord;
    flag:Boolean;
 Begin
   flag:=true;
   A1:=Dot11.Y-Dot12.Y;
   B1:=Dot12.X-Dot11.X;
   C1:=(Dot11.X*Dot12.Y)-(Dot11.Y*Dot12.X);
   A2:=Dot21.Y-Dot22.Y;
   B2:=Dot22.X-Dot21.X;
   C2:=(Dot21.X*Dot22.Y)-(Dot21.Y*Dot22.X);
   If((A1*B2)=(A2*B1))then Pres:=false Else
    Begin
      Chis1:=((B1*C2)-(B2*C1));
      Chis2:=((A2*C1)-(A1*C2));
      Znam:=((A1*B2)-(A2*B1));
      PresDot.X:=Chis1/Znam;
      PresDot.Y:=Chis2/Znam;
      If (Abs(Razst(Dot11,PresDot)+Razst(Dot12,PresDot)-Razst(Dot11,Dot12))>Exp)
       then flag:=false;
      If (Abs(Razst(Dot21,PresDot)+Razst(Dot22,PresDot)-Razst(Dot21,Dot22))>Exp)
       then flag:=false;
      Pres:=flag;
    End;
 End;
Function CheckPravi1(tr,vr:Byte;Coord1:TCoord):Boolean;
Var i,j:Word;
    flag:Boolean;
 Begin
   flag:=true;
   For i:=1 to N Do
    If(i<>tr)then
     Begin
       If(Pres(Coord1,T[tr][vr],T[i][1],T[i][2]))then flag:=false;
       If(Pres(Coord1,T[tr][vr],T[i][1],T[i][3]))then flag:=false;
       If(Pres(Coord1,T[tr][vr],T[i][2],T[i][3]))then flag:=false;
     End;
   If((vr=1)And(Pres(Coord1,T[tr][vr],T[tr][2],T[tr][3])))then flag:=false;
   If((vr=2)And(Pres(Coord1,T[tr][vr],T[tr][1],T[tr][3])))then flag:=false;
   If((vr=3)And(Pres(Coord1,T[tr][vr],T[tr][1],T[tr][2])))then flag:=false;
   CheckPravi1:=flag;
 End;
Function CheckPravi2(tr,vr1,tr2,vr2:Byte):Boolean;
Var i:Word;
    flag:Boolean;
 Begin
   flag:=true;
   For i:=1 to N Do
    If((i<>tr)And(i<>tr2))then
     Begin
       If(Pres(T[tr][vr1],T[tr2][vr2],T[i][1],T[i][2]))then flag:=false;
       If(Pres(T[tr][vr1],T[tr2][vr2],T[i][1],T[i][3]))then flag:=false;
       If(Pres(T[tr][vr1],T[tr2][vr2],T[i][2],T[i][3]))then flag:=false;
     End;
   If((vr1=1)And(Pres(T[tr][vr1],T[tr2][vr2],T[tr][2],T[tr][3])))then flag:=false;
   If((vr1=2)And(Pres(T[tr][vr1],T[tr2][vr2],T[tr][1],T[tr][3])))then flag:=false;
   If((vr1=3)And(Pres(T[tr][vr1],T[tr2][vr2],T[tr][1],T[tr][2])))then flag:=false;
   If((vr2=1)And(Pres(T[tr][vr1],T[tr2][vr2],T[tr2][2],T[tr2][3])))then flag:=false;
   If((vr2=2)And(Pres(T[tr][vr1],T[tr2][vr2],T[tr2][1],T[tr2][3])))then flag:=false;
   If((vr2=3)And(Pres(T[tr][vr1],T[tr2][vr2],T[tr2][1],T[tr2][2])))then flag:=false;
   CheckPravi2:=flag;
 End;
Procedure Solve;
Var i,j,k,l:Word;
    flag:Boolean;
 Begin
   flag:=true;
   Assign(fout,'Short.Out');
   Rewrite(fout);
   For i:=1 to MaxVr Do
    For j:=1 to MaxVr Do G[i][j]:=Endless;
   For i:=1 to N Do
    For j:=1 to 3 Do
     Begin
       If Checkpravi1(i,j,Nach)then G[1][((i-1)*3)+j+1]:=Razst(Nach,T[i][j]);
        G[((i-1)*3)+j+1][1]:=G[1][((i-1)*3)+j+1];
       If Checkpravi1(i,j,Kraj)then G[MaxVr][((i-1)*3)+j+1]:=Razst(Kraj,T[i][j]);
       G[((i-1)*3)+j+1][MaxVr]:=G[MaxVr][((i-1)*3)+j+1];
     End;
   For i:=1 to N Do
    Begin
      If(Pres(Nach,Kraj,T[i][1],T[i][2]))then flag:=false;
      If(Pres(Nach,Kraj,T[i][2],T[i][3]))then flag:=false;
      If(Pres(Nach,Kraj,T[i][1],T[i][3]))then flag:=false;
    End;
   If(flag)then Writeln(fout,Razst(Nach,Kraj):0:8)Else
    Begin
      For i:=1 to N Do
       Begin
         G[((i-1)*3)+1+1][((i-1)*3)+1+2]:=Razst(T[i][1],T[i][2]);
         G[((i-1)*3)+1+2][((i-1)*3)+1+1]:=G[((i-1)*3)+1+1][((i-1)*3)+1+2];
         G[((i-1)*3)+1+1][((i-1)*3)+1+3]:=Razst(T[i][1],T[i][3]);
         G[((i-1)*3)+1+3][((i-1)*3)+1+1]:=G[((i-1)*3)+1+1][((i-1)*3)+1+3];
         G[((i-1)*3)+1+2][((i-1)*3)+1+3]:=Razst(T[i][2],T[i][3]);
         G[((i-1)*3)+1+3][((i-1)*3)+1+2]:=G[((i-1)*3)+1+2][((i-1)*3)+1+3];
         For j:=1 to N Do
          If(j<>i)then
           For k:=1 to 3 Do
            For l:=1 to 3 Do
              If(CheckPravi2(i,k,j,l))then
                Begin
                  G[((i-1)*3)+1+k][((j-1)*3)+1+l]:=Razst(T[i][k],T[j][l]);
                  G[((j-1)*3)+1+l][((i-1)*3)+1+k]:=G[((i-1)*3)+1+k][((j-1)*3)+1+l];
                End;
       End;
      Floyd;
      Writeln(fout,G[1][MaxVr]:0:8);
    End;
   Close(fout);
 End;
Begin
  Init('Short.Inp');
  Solve;
End.