{ Stefan Tashev - gr.Yambol 11 klas }

type tpoint = record
       x,y: real;
       vis: boolean;
     end;
     tline = record
       a,b,c: real;
     end;
     triangle = record
       p1,p2,p3: tpoint;
     end;
     tots = record
       p1,p2: tpoint;
     end;

var m: array[1..19] of triangle;
    n: byte;
    s,d: tpoint;
    f: text;

procedure rti;
var i: byte;
begin
  assign(f,'short.inp');
  reset(f);
  readln(f,n);
  if n > 0 then
  for i:= 1 to n do
  begin
    readln(f,m[i].p1.x,m[i].p1.y,m[i].p2.x,m[i].p2.y,m[i].p3.x,m[i].p3.y);
    m[i].p1.vis:= false; m[i].p2.vis:= false; m[i].p3.vis:= false;
  end;
  readln(f,s.x,s.y,d.x,d.y);
  close(f);
end;

function define_line(p1,p2: tpoint): tline;
begin
  with define_line do
  begin
    a:= p2.y - p1.y;
    b:= p1.x - p2.x;
    c:= p2.x*p1.y - p1.x*p2.y;
  end;
end;

function dis(p1,p2: tpoint): real;
begin
  dis:= sqrt(sqr(p1.x-p2.x) + sqr(p1.y-p2.y));
end;

function point_on_line(p: tpoint; l: tline): boolean;
begin
  point_on_line:= l.a*p.x + l.b*p.y + l.c = 0;
end;

function same_side(p1,p2: tpoint; l: tline): boolean;
begin
  if point_on_line(p1,l) or point_on_line(p2,l) then same_side:= true else
  same_side:= (l.a*p1.x + l.b*p1.y + l.c)*(l.a*p2.x + l.b*p2.y + l.c) > 0;
end;

function ots_crossing(o1,o2: tots): boolean;
var l1,l2: tline;
begin
  l1:= define_line(o1.p1,o1.p2);
  l2:= define_line(o2.p1,o2.p2);
  ots_crossing:= (not same_side(o1.p1,o1.p2,l2)) and
                 (not same_side(o2.p1,o2.p2,l1));
end;

function sech(o: tots): boolean;
var i: byte;
    se: boolean;
    oo: tots;
begin
  se:= false;
  i:= 0;
  repeat
    i:= i + 1;
    oo.p1:= m[i].p1; oo.p2:= m[i].p2;
    if ots_crossing(o,oo) then se:= true;
    oo.p1:= m[i].p1; oo.p2:= m[i].p3;
    if ots_crossing(o,oo) then se:= true;
    oo.p1:= m[i].p2; oo.p2:= m[i].p3;
    if ots_crossing(o,oo) then se:= true;
  until se or (i = n);
  sech:= se;
end;

function scan(s,d: tpoint): real;
var i: byte;
    o: tots;
    min,t: real;
begin
  min:= 10000000;
  o.p1:= s; o.p2:= d;
  if not sech(o) then begin scan:= dis(s,d); exit; end else
  for i:= 1 to n do
  begin
    o.p1:= s; o.p2:= m[i].p1;
    if (not sech(o)) and (not m[i].p1.vis) then
    begin
      m[i].p1.vis:= true;
      t:= scan(m[i].p1,d) + dis(s,m[i].p1);
      if t < min then min:= t;
      m[i].p1.vis:= false;
    end;
    o.p1:= s; o.p2:= m[i].p2;
    if (not sech(o)) and (not m[i].p2.vis) then
    begin
      m[i].p2.vis:= true;
      t:= scan(m[i].p2,d) + dis(s,m[i].p2);
      if t < min then min:= t;
      m[i].p2.vis:= false;
    end;
    o.p1:= s; o.p2:= m[i].p3;
    if (not sech(o)) and (not m[i].p3.vis) then
    begin
      m[i].p3.vis:= false;
      t:= scan(m[i].p3,d) + dis(s,m[i].p3);
      if t < min then min:= t;
      m[i].p3.vis:= false;
    end;
  end;
  scan:= min;
end;

begin
  rti;
  assign(f,'short.out');
  rewrite(f);
  if n = 0 then writeln(f,dis(s,d):3:8)
  else writeln(f,scan(s,d):3:8);
  close(f);
end.