(* Asen Krustev Krustev, NPMG, grupa 2, nomer 3 *)
(* PARA.pas *)

type
  paral = record
    a, b, c: integer;
  end;

procedure input (var a, b: paral; var f: text);
begin
  read (f, a.a); read (f, a.b); read (f, a.c);
  read (f, b.a); read (f, b.b); read (f, b.c);
end;

function is_equal (a, b: paral): boolean;
begin
  is_equal :=
           ( (a.a = b.a) and (a.b = b.b) and (a.c = b.c) ) or
           ( (a.a = b.a) and (a.c = b.b) and (a.b = b.c) ) or
           ( (a.b = b.a) and (a.a = b.b) and (a.c = b.c) ) or
           ( (a.b = b.a) and (a.c = b.b) and (a.a = b.c) ) or
           ( (a.c = b.a) and (a.a = b.b) and (a.b = b.c) ) or
           ( (a.c = b.a) and (a.b = b.b) and (a.a = b.c) )
end;

function can_be_in (a, b: paral): boolean;
begin
  can_be_in :=
           ( (a.a <= b.a) and (a.b <= b.b) and (a.c <= b.c) ) or
           ( (a.a <= b.a) and (a.c <= b.b) and (a.b <= b.c) ) or
           ( (a.b <= b.a) and (a.a <= b.b) and (a.c <= b.c) ) or
           ( (a.b <= b.a) and (a.c <= b.b) and (a.a <= b.c) ) or
           ( (a.c <= b.a) and (a.a <= b.b) and (a.b <= b.c) ) or
           ( (a.c <= b.a) and (a.b <= b.b) and (a.a <= b.c) )
end;

var
  inp, out: text;
  m, n: paral;

begin
  assign (inp, 'PARA.inp'); assign (out, 'PARA.out');
  reset (inp); rewrite (out);  input (m, n, inp);
  if is_equal (m, n) then writeln (out, 3)
  else if can_be_in (m, n) then writeln (out, 1)
       else if can_be_in (n, m) then writeln (out, 2)
            else writeln (out, 0);
  close (inp); close (out);
end.