                       (* Nikolay Georgiev Semov *)
                       (* Zala 1 - PC 5          *)
                       (* PMG - Haskovo          *)

Program Join;

Const   NMax = 1999;

Type    TAP  = Array[1..NMax] Of Word;

Var     N : Integer;   P : TAP;
        R : Integer;  RP : TAP;
        T : Integer;  TP : TAP;

Procedure InputData;
Var F : Text;
    i : Integer;
Begin
   Assign(F, 'JOIN.INP');
   Reset(F);
   ReadLn(F, N);
   For i := 1 To N Do
      If i < N Then
         Read(F, P[i])
      Else
         ReadLn(F, P[i]);
   Close(F);
End;

Function IsOK(What, CMax : Word) : Boolean;
Begin
   If P[What] > CMax Then
      IsOK := True
   Else
      IsOK := False;
End;

Procedure ReplaceResult;
Var i : Integer;
Begin
   If T > R Then Begin
      R := T;
      RP := TP;
   End Else If T = R Then Begin
      For i := 1 To R Do
         If TP[i] < RP[i] Then Begin
            R := T;
            RP := TP;
            Break;
         End;
   End;
End;

Procedure CheckPoint(FP : Word);
Var i : Integer;
    B : Boolean;
Begin
   T := T + 1;
   TP[T] := FP;
   B := False;
   If FP = N Then Begin
      ReplaceResult;
      T := T - 1;
      Exit;
   End;
   For i := FP + 1 To N Do
      If IsOK(i, P[FP]) Then Begin
         B := True;
         CheckPoint(i);
      End;
   If Not B Then ReplaceResult;
   T := T - 1;
End;

Procedure ProceedData;
Var i : Integer;
Begin
   T := 0;
   R := 0;
   For i := 1 To N Do RP[i] := 20001;
   For i := 1 To N Do CheckPoint(i);
End;

Procedure OutputData;
Var F : Text;
    i : Integer;
Begin
   Assign(F, 'JOIN.OUT');
   ReWrite(F);
   WriteLn(F, R);
   For i := 1 To R Do Write(F, RP[i], ' ');
   Close(F);
End;

BEGIN
   InputData;
   ProceedData;
   OutputData;
END.