                   (* Nikolay Georgiev Semov *)
                   (* Zala 1 - PC 5          *)
                   (* PMG - Haskovo          *)

Program Paral;

Const   MaxN = 100;

Type    TRect = Record
           Width  : Word;
           Height : Word;
        End;

        TARect = Array [1..MaxN] Of TRect;

Var     P : TARect;
        N : Integer;
        R : Integer;
        TR : Integer;

Procedure InputData;
Var F : Text;
    i : Integer;
Begin
   Assign(F, 'PARAL.INP');
   Reset(F);
   ReadLn(F, N);
   For i := 1 To N Do Begin
      Read(F, P[i].Width);
      ReadLn(F, P[i].Height);
   End;
   Close(F);
End;

Function Max(Value1, Value2 : Word) : Word;
Begin
   If Value1 > Value2 Then
      Max := Value1
   Else
      Max := Value2;
End;

Procedure SortData;
Var i, j : Integer;
    T : TRect;
Begin
   For i := 1 To N - 1 Do
      For j := i + 1 To N Do
         If Max(P[i].Width, P[i].Height) > Max(P[j].Width, P[j].Height) Then Begin
            T := P[i];
            P[i] := P[j];
            P[j] := T;
         End;
End;

Procedure Rotate(Var What : TRect);
Var T : Word;
Begin
   T := What.Width;
   What.Width := What.Height;
   What.Height := T;
End;

Function IsInsertable(What, InWhat : TRect) : Boolean;
Var T : TRect;
Begin
   T := InWhat;
   If (T.Width > What.Width) And (T.Height < What.Height) Then Rotate(T);
   If (T.Width = What.Width) And (T.Height = What.Height) Then Begin
      IsInsertable := False;
      Exit;
   End;
   If (T.Width >= What.Width) And (T.Height >= What.Height) Then
      IsInsertable := True
   Else
      IsInsertable := False;
End;

Procedure CheckInsert(FR : Integer);
Var i : Integer;
    B : Boolean;
Begin
   TR := TR + 1;
   B := False;
   If FR = N Then Begin
      If TR > R Then R := TR;
      TR := TR - 1;
      Exit;
   End;
   For i := FR + 1 To N Do
      If IsInsertable(P[FR], P[i]) Then Begin
         B := True;
         CheckInsert(i);
      End;
   If Not B Then
      If TR > R Then R := TR;
   TR := TR - 1;
End;

Procedure ProceedData;
Begin
   R := 0;
   TR := 0;
   CheckInsert(1);
End;

Procedure OutputData;
Var F : Text;
Begin
   Assign(F, 'PARAL.OUT');
   ReWrite(F);
   WriteLn(F, R);
   Close(F);
End;

BEGIN
   InputData;
   SortData;
   ProceedData;
   OutputData;
END.
