/*
Rangel Petkov Dokov - OMG "Akademik Kiril Popov", gr. Plovdiv
zala 1, PC 7
*/
#include <fstream.h>
#include <stdlib.h>
#include <alloc.h>
#include <process.h>

#define DONE 0
#define MAX 1
#define BAD 2

ifstream input("join.inp");
ofstream output("join.out");

int *lines, count;
int best=0, *bestway;
int current=0, *currentway;

void getinput();
void solve();
int test( int last, int next );
void makebest();

void getinput()
{
	char tmp[6];
	int i;

	for( i=1; i<count; i++ ) {
		input.getline( tmp, 5, ' ' );
		lines[i] = strtol( tmp, NULL, 10 );
	}
	input.getline( tmp, 5 );
	lines[count] = strtol( tmp, NULL, 10 );
}

void solve()
{
	unsigned char tmp[6];
	int i;

	input.getline( tmp, 5 );
	count = strtol( tmp, NULL, 10 );
	lines = (int *) calloc( count+2, sizeof(int) );
	if( lines == NULL ) {
		cout<<"Not enough memmory"<<endl<<endl;
		exit(1);
	}
	bestway = (int *) calloc( count+2, sizeof(int) );
	if( bestway == NULL ) {
		cout<<"Not enough memmory"<<endl<<endl;
		exit(1);
	}
	currentway = (int *) calloc( count+2, sizeof(int) );
	if( currentway == NULL ) {
		cout<<"Not enough memmory"<<endl<<endl;
		exit(1);
	}
	getinput();

	for( i=1; i<count; i++ ) {
		test( i, i);
		current = 0;
	}
}

void makebest()
{
	int i;
	best = current;
	for( i=0; i<current; i++ ) {
		bestway[i] = currentway[i];
	}
}

int test( int last, int next )
{
	int i;
	if( next >= count ) {
		if( current > best )
			makebest();
		return MAX;
	}
	if( lines[last] > lines[next] ) {
		if( test( last, next+1 ) == DONE )
			current--;
		return BAD;
	}
	currentway[current] = next;
	current++;
	for( i=next+1; i<=count; i++ ) {
		if( test( next, i) == DONE )
			current--;
	}
	return DONE;
}

void main()
{
	int i;
	solve();

	output<<best<<endl;
	for( i=0; i<best-1; i++ )
		output<<bestway[i]<<" ";
	output<<bestway[best-1];

	input.close();
	output.close();
}