/*
Rangel Petkov Dokov - OMG "Akademik Kiril Popov", gr. Plovdiv
zala 1, PC 7
*/
#include <fstream.h>
#include <stdlib.h>
#include <search.h>
#include <alloc.h>
#include <process.h>

struct rect {
	int x;
	int y;
};

#define max(a, b) (a>b ? a : b)

ifstream input("paral.inp");
ofstream output("paral.out");

int solve();
int sortcmpx( const void *a, const void *b );
int sortcmpy( const void *a, const void *b );
void getinput( rect **array, int count );
int getcount();

int getcount()
{
	char tmp[6];
	int n;
	input.getline( tmp, 6 );
	n = strtol( tmp, NULL, 10 );
	return n;
}

void getinput( rect **array, int count )
{
	unsigned char tmp[6];
	int i;

	for( i=0; i<count; i++ ) {
		input.getline( tmp, 6, ' ' );
		(*array)[i].x = strtol( tmp, NULL, 10 );
		input.getline( tmp, 6 );
		(*array)[i].y = strtol( tmp, NULL, 10 );
	}
}

int sortcmpx( const void *a, const void *b )
{
	if( ((rect*)a)->x > ((rect*)b)->x )
		return -1;
	else if( ((rect*)a)->x < ((rect*)b)->x )
		return 1;
	else if( ((rect*)a)->y > ((rect*)b)->y)
		return -1;
	else if( ((rect*)a)->y < ((rect*)b)->y)
		return 1;
	else
		return 0;
}

int sortcmpy( const void *a, const void *b )
{
	if( ((rect*)a)->y > ((rect*)b)->y )
		return -1;
	else if( ((rect*)a)->y < ((rect*)b)->y )
		return 1;
	else if( ((rect*)a)->x > ((rect*)b)->x)
		return -1;
	else if( ((rect*)a)->x < ((rect*)b)->x)
		return 1;
	else
		return 0;
}


int solve()
{
	unsigned int count, i, ansx=1, ansy=1, last=0;
	rect *array;
	count = getcount();
	array = (rect *) calloc( count, sizeof(rect) );
	if( array == NULL ) {
		cout<<"Not enough memmory"<<endl<<endl;
		exit(1);
	}
	getinput( &array, count );

	qsort( (void *)array, count, sizeof(rect), sortcmpx );
	for( i=1; i<count; i++ ) {
		if( array[i].y < array[last].y ) {
			last = i;
			ansx++;
		}
	}

	qsort( (void *)array, count, sizeof(rect), sortcmpy );
	for( i=1; i<count; i++ ) {
		if( array[i].x < array[last].x ) {
			last = i;
			ansy++;
		}
	}

	return max(ansx, ansy);
}

void main()
{
	int ans;
	ans = solve();
	output<<ans;
	input.close();
	output.close();
}