//Haralambi Haralambiev / A6 / Lights
#include <stdio.h>
#include <string.h>

const int maxn = 201;
const int maxk = 11;
const int infinity = 1023456789;

char nei[maxn][maxk][maxn];
int path[maxn][maxn];
int a[maxn];
int d[maxn][maxn];
char made[maxn];
char unvis[maxn];
int br[maxn];

int n,m,kk;

/*************/
void input()
{
  int i,j,l;

  for(i=1; i<=maxn; i++)
    for(j=1; j<=maxn; j++)
      path[i][j]=infinity;


  scanf("%d%d%d",&n,&m,&kk);


  for(i=1; i<=n; i++) {
    scanf("%d",&a[i]);

    for(j=0; j<kk; j++) {
      do {
        scanf("%d",&l);
        if(l==-1) break;
        else nei[i][j][l]=1;
      } while (1);
    }
  }

  int leng;
  for(l=0; l<m; l++) {
    scanf("%d%d%d",&i,&j,&leng);
    path[i][j]=leng;
    path[j][i]=leng;
  }

  for(i=1; i<=maxn; i++)
    for(j=1; j<=maxn; j++)
      d[i][j]=infinity;

  memset(made, 0, sizeof(made));

}
/*************/
void go(int x)
{
  int i,j,k;

  memset(unvis, 0x01, sizeof(unvis));
  memset(br, 0xFF, sizeof(br));

  made[x]=1;

  k=x;
  d[k][k]=0;
  unvis[k]=0;
  br[k]=1;

  do {
    /* updating nei's */
    for(i=1; i<=n; i++) {
      int temp=a[i];
      if (nei[k][br[k]%kk][i]) temp=0;

      if (d[x][k]+path[k][i]+temp < d[x][i]) {
        d[x][i]=d[x][k]+path[k][i]+temp;
        br[i]=br[k]+1;
      }
    }

    /* choosing nearest */
    k=-1;
    int l=infinity;
    for(i=1; i<=n; i++)
      if (unvis[i] && l>d[x][i]) {
        l=d[x][i];
        k=i;
      }

    if (k==-1) break;
    else unvis[k]=0;
  } while (1);
}
/*************/
void output()
{
  int i,j;

  do {
    i=-1; j=-1;
    scanf("%d%d",&i,&j);

    if(i==-1 || j==-1) break;

    if (!made[i]) go(i);
    if (d[i][j]==infinity) printf("No route\n");
    else printf("%d\n",d[i][j]);

  } while (1);

}
/*************/
int main()
{
  input();
  output();

  return 0;
}
