//Haralambi Haralambiev / A6 / Worch
#include <stdio.h>

const int maxn = 250002;
const int maxw = 23;
const int let_a = 97;
const int let_z = 122;

char a[maxn][maxw];
char unvis[maxn];
int max[maxn];


int n=0;
int ans, cur_ans;
int words[maxn], cur_words[maxn];

/*************/
void input()
{
  int i;
  char ch;

  do {
    ch='A';
    scanf("%c",&ch);
    if (ch<let_a || ch>let_z) break;
    else {
      n++;
      a[n][1]=ch;
    }
    i=1;
    while (ch!='\n') {
      i++;
      scanf("%c",&ch);
      if (ch!='\n') a[n][i]=ch;
    }
    a[n][0]=i-1;

  } while (1);
}
/*************/
char compat(int x, int y)
{
  int letter[let_z - let_a + 2];
  memset(letter, 0, sizeof(letter));

  int i;
  for(i=1; i<=a[x][0]; i++)
    letter[a[x][i]-let_a]++;

  for(i=1; i<=a[y][0]; i++)
    if (letter[a[y][i]-let_a]>0)
      letter[a[y][i]-let_a]--;

  int j=0;
  for(i=0; i<=let_z-let_a; i++)
    j+=letter[i];

  if (j==0) return 1;
  else return 0;
}
/*************/
void greedy(int x)
{
  unvis[x]=0;

  int i;


  for(i=1; i<=n; i++)
    if (a[x][0]+1==a[i][0]) {
      if (compat(x,i)) {
        if (unvis[i]) {
          cur_ans++;
          cur_words[cur_ans]=i;
          greedy(i);
          break;
        }
        else {
          if (a[words[1]][0]<a[words[ans]][0] ) {
            if (words[1]==i) {
              ans++;
              words[ans]=x;
            }
          }
          else if (words[ans]==i) {
            ans++;
            words[ans]=x;
          }
        }
      }
    }
}
/*************/
void sort(int l, int r)
{
  int i=l, j=r, mid=a[words[(i+j)/2]][0];

  do {
    while (a[words[i]][0]<mid) i++;
    while (a[words[j]][0]>mid) j--;
    if (i<=j) {
      int temp=words[i]; words[i]=words[j]; words[j]=temp;
      i++; j--;
    }
  } while (i<=j);

  if (i<r) sort(i,r);
  if (l<j) sort(l,j);
}
/*************/
void go()
{
  int i,j;

  ans=0;

  for(i=1; i<=n; i++) unvis[i]=1;
  for(i=1; i<=n; i++) if (unvis[i]) {
    cur_ans=1;
    cur_words[cur_ans]=i;
    greedy(i);
    if(ans<cur_ans) {
      ans=cur_ans;
      for(j=1; j<=ans; j++)
        words[j]=cur_words[j];
    }
  }

  sort(1,ans);

}
/*************/
void output()
{
  int i,j;
  for(i=1; i<=ans; i++) {
    for(j=1; j<=a[words[i]][0]; j++)
      printf("%c",a[words[i]][j]);
    printf("\n");
  }
}
/*************/
int main()
{
  input();
  go();
  output();

  return 0;
}
