#include <stdio.h>
#include <string.h>
#include <math.h>

#define MAX_P 2
#define MAX_SZ 512
#define MAX_Q 23

#define PL1 0
#define PL2 1

int ii1,ii2,ij1,ij2,sol=0;
int m[MAX_P][MAX_SZ][MAX_SZ],sq[MAX_SZ];

int max(int a,int b) { return a>b?a:b; }

void init () {
  scanf("%d%d%d%d",&ii1,&ij1,&ii2,&ij2);
}

void solve () {
int i,j,k,l;
int maxq;
  for (i=1;i<MAX_SZ;i++) sq[i] = sqrt(i);

  for (i=0;i<MAX_P;i++)
    for (j=0;j<MAX_SZ;j++)
      for (k=0;k<MAX_SZ;k++) {
        m[i][j][k] = 0;
      }

  m[PL1][1][1] = 0;
  m[PL2][1][1] = 1;

  for (i=1;i<MAX_SZ;i++)
    for (j=1;j<MAX_SZ;j++)
      if (!(i==1 && j==1)) {
      m[PL1][i][j] = 0;
      m[PL2][i][j] = 1;
      for (k=PL1;k<=PL2;k++) {
        maxq = max(sq[i],sq[j]);
        for (l=1;l<=maxq;l++) {
        int pos1 = i-l*l;
        int pos2 = j-l*l;
          if (k==PL2) {
            if (pos1==1 && j==1) { m[PL2][i][j]=1; continue; }
            if (pos2==1 && i==1) { m[PL2][i][j]=1; continue; }
            if (pos1>0)
              if (m[PL1][pos1][j]==1) m[PL2][i][j] = 0;
            if (pos2>0)
              if (m[PL1][i][pos2]==1) m[PL2][i][j] = 0;
          } else {
            if (pos1==1 && j==1) { m[PL1][i][j]=1; continue; }
            if (pos2==1 && i==1) { m[PL1][i][j]=1; continue; }

            if (pos1>0)
              if (m[PL2][pos1][j]==0) m[PL1][i][j] = 1;
            if (pos2>0)
              if (m[PL2][i][pos2]==0) m[PL1][i][j] = 1;
          }
        }
      }
    }
  for (i=ii1+1;i<ii2;i++)
    for (j=ij1+1;j<ij2;j++)
      if (m[PL1][i][j]==1) sol++;
}
int main () {
  init();
  solve();
  printf("%d\n",sol);
  return 0;
}
