#include <stdio.h>

#define IN "lights.in"
#define MAX_N 201
#define MAX_K 11
#define MAX_VAL 100000000

//FILE *fp;

int  dd[MAX_N][MAX_N][MAX_K];
char cross[MAX_N][MAX_K][MAX_N];
int  slow[MAX_N];

int n,k,m;

void input();
void solve();
void output();
int  min(int a, int bb);

int main(void){

 input();
 solve();
 output();

 return 0;
}

void input(){
 int i,j,l;
 int a,b,c;

 //fp=fopen(IN,"r");
  fscanf(stdin,"%d %d %d\n", &n, &m, &k);
  memset(cross,0,sizeof(cross));
  for(i=0; i<n; i++){
   fscanf(stdin,"%d\n", &slow[i]);
   for(j=0; j<k; j++){
    a=0;
    while(a!=-1){
     fscanf(stdin,"%d ", &a);
     if(a!=-1) cross[i][j][a-1]=1;
    }
   }
  }

  for(i=0; i<n; i++)
   for(j=0; j<n; j++)
    for(l=0; l<k; l++)
     if(i==j) dd[i][j][l]=0;
     else
      dd[i][j][l]=MAX_VAL;

 for(i=0; i<m; i++){
  fscanf(stdin,"%d %d %d\n", &a, &b, &c);
  for(j=0; j<k; j++){
   if(cross[b-1][j][a-1]==1) dd[a-1][b-1][j]=c;
   else
    dd[a-1][b-1][j]=c+slow[b-1];

   if(cross[a-1][j][b-1]==1) dd[b-1][a-1][j]=c;
   else
    dd[b-1][a-1][j]=c+slow[a-1];

  }
 }
}

void solve(){
 int i,j,l,h,g;


 for(i=0; i<n; i++)
  for(j=0; j<n; j++)
   for(l=0; l<n; l++)
    for(h=0; h<k; h++)
     for(g=0; g<k; g++){
     if(dd[j][i][h]!=MAX_VAL&&dd[i][l][g]!=MAX_VAL&&
        dd[j][i][h]+dd[i][l][g]<dd[j][l][g])
      dd[j][l][g]=dd[j][i][h]+dd[i][l][g];

    }
}

void output(){
 int a,b,i;
 int mini;

 while(!feof(stdin)){
  fscanf(stdin,"%d %d\n", &a, &b);
  mini=MAX_VAL;
  for(i=0; i<k; i++)
   mini=min(mini,dd[a-1][b-1][i]);

  if(mini!=MAX_VAL) printf("%d\n", mini);
  else
   printf("No route\n");
 }

// fclose(fp);
}

int min(int aa, int bb){
 return (aa<bb) ? aa:bb;
}

