#include <climits>
#include <cstdlib>
#include <iostream>

using namespace std;

int N;//2..200
int M;
int K;//1..10
bool A[200 + 1][10][200 + 1];
int T[200 + 1];
int w[200 + 1][200 + 1];
bool tr[200 + 1][200 + 1];
int final;
int best;
/*
bool visited[200 + 1];
int n[2000 + 1][200];
int nw[2000 + 1][200];
int np[2000 + 1];
*/
int W[2000][2000];

/*
void obh(int ot, int kym, int broj, int time) {
     cout << "obh(ot=" << ot << ", kym=" << kym <<  ", broj=" << broj << ", time=" << time << ")\n";
     if (!visited[kym]) {
        cerr << "ERROR2\n";
        exit(EXIT_FAILURE);
     }

//    if (time > best) return;
    //visited[i] = false;//JG
    time += w[ot][kym];
    if (!A[kym][broj % K][ot]) time += T[kym];
    if (kym == final) {
       if (time < best) best = time;
    } else {
        for (int i = 0; i <= N; i++)
            if (w[kym][i] && !visited[i]) {
               visited[i] = true;
               obh(kym, i, broj + 1, time);
               visited[i] = false;
            }
    }
 }
 */

void transitive() {
     for (int m = 1; m <= N; m++)
         for (int i = 1; i <= N; i++)
             for (int j = 1; j <= N; j++)
                 if (tr[i][m] && tr[m][j]) tr[i][j] = true;//JG
}
/*
void fw() {
     for (int m = 0; m < N * K; m++) {
         for (int i = 0; i < N * K; i++) {
             for (int j = 0; j < N * K; j++) {
                 int tmp = D[i][m] + D[m][j];
                 if (tmp < D[i][j]) D[i][j] = tmp;
             }
         }
     }
}
*/

int dijkstra(int start, int final) {
     int D[2000];
     bool t[2000];
     for (int i = 0; i < N * K; i++) {
         D[i] = INT_MAX / 2;
     }
     /*
     for (int R = 0; R < K; R++) {
         cout << "D[" << final << "_" << R << "]=" << D[(final - 1) * K + R] << '\n';
     }
     */
     for (int i = 0; i < N * K; i++) {
         t[i] = true;
     }
     D[(start - 1) * K + 0] = 0;
     int broj = N * K;
     while (broj > 0) {
           int b;
           int db = INT_MAX;
           for (int i = 0; i < N * K; i++) {
               if (t[i] && D[i] < db) {
                  b = i;
                  db = D[i];
               }
           }
           t[b] = false;
           /*
           cout << "b=" << b << '\n';
           cout << "db=" << db << '\n';
           */
           broj--;
           for (int i = 0; i < N * K; i++) {
               if (D[b] + W[b][i] < D[i]) D[i] = D[b] + W[b][i];
           }
     }
     int best = INT_MAX;
     for (int R = 0; R < K; R++) {
         if (D[(final - 1) * K + R] < best) best = D[(final - 1) * K + R];
         /*
         cout << "D[" << final << "_" << R << "]=" << D[(final - 1) * K + R] << '\n';
         */
     }
     return best;
}

void construct() {
     /*
     for (int i = 0; i <= N * K; i++) np[i] = 0;
     for (int i = 1; i <= N; i++) {
         for (int j = 1; j <= N; j++) {
             if (w[i][j] != -1) {
                int tmp = w[i][j];
                for (int R = 0; R < K; R++) {
                    int tmp = w[i][j];
                    if (!A[j][R][i]) {
                       tmp += T[j];
                       n[i * K + R
                    }
                }
             }
         }
     }
     for (int i = 1; i <= 2000; i++)
         for (int j = 0; j <= 200; j++)
             n[i][j] =
             */
     for (int i = 0; i < 2000; i++)
         for (int j = 0; j < 2000; j++)
             W[i][j] = INT_MAX / 2;
     for (int R = 0; R < K; R++) {
          for (int i = 1; i <= N; i++) {
                   for (int j = 1; j <= N; j++) {
                       if (w[i][j] != -1) {
                          int tmp = w[i][j];
                          if (!A[j][(R + 1) % K][i]) {
                             tmp += T[j];
                          }
                          W[(i - 1) * K + R][(j - 1) * K + (R + 1) % K] = tmp;
                       }
                   }
          }
     }
     for (int R = 0; R < K; R++) {
          for (int i = 1; i <= N; i++) {
                   for (int j = 1; j <= N; j++) {
                       int tmp = W[(i - 1) * K + R][(j - 1) * K + (R + 1) % K];
                       if (tmp != INT_MAX) {
                       }
                   }
          }
     }
}

int main() {
    for (int i = 0; i < 201; i++) {
        for (int j = 0; j < 10; j++) {
            for (int k = 0; k < 201; k++) {
                if (A[i][j][k]) {
                    cout << "ERROR\n";
                    exit(EXIT_FAILURE);
                 }
            }
        }
    }
    cin >> N >> M >> K;
    for (int i = 1; i <= N; i++) {
        cin >> T[i];
        for (int j = 0; j < K; j++) {
            for ( ; ; ) {
                int tmp;
                cin >> tmp;
                if (tmp == -1) break;
                A[i][j][tmp] = true;
            }
        }
    }
    for (int i = 1; i <= N; i++)
        for (int j = 1; j <= N; j++)
            w[i][j] = -1;
    for (int i = 0; i < M; i++) {
        int a, b;
        int tmp;
        //cin >> a >> b >> w[a][b];//JG
        cin >> a >> b >> tmp;
        w[a][b] = tmp;
        w[b][a] = tmp;
        tr[a][b] = true;
        tr[b][a] = true;
    }

    transitive();

    /*
    for (int i = 1; i <= N; i++) {
        visited[i] = false;
    }

    int start;
    while (cin >> start >> final) {
          if (tr[start][final]) {
             best = INT_MAX;
             //int tmp = f(start, final);
             for (int i = 1; i <= N; i++) {
                 if (i != start) {
                     visited[i] = true;
                     obh(start, i, 1, 0);
                     visited[i] = false;
                 }
             }
             if (best == INT_MAX) {
                cout << "0\n";
             } else {
               cout << best << '\n';
             }
             //cout << tmp << '\n';
          } else cout << "No route\n";
    }
    */
    construct();
    /*
    for (int i = 0; i < N * K; i++) {
        for (int j = 0; j < N * K; j++) {
            if (W[i][j] != INT_MAX) {
               cout << "W[" << (i / K + 1) << "_" << (i % K) << "][" << (j / K + 1) << "_" << (j % K) << "]=" << W[i][j] << '\n';
            }
        }
    }
    */
    int start, final;
    while (cin >> start >> final) {
          if (start == final) {
             cout << "0\n";
             continue;
          }
          if (tr[start][final]) {
             int tmp = dijkstra(start, final);
             cout << tmp << '\n';
          } else {
            cout << "No route\n";
          }
    }
}
