/* INCLUDES *****************************************************************/
   #include <iostream>
   #include <cstdlib>
   #include <cassert>

   using namespace std;

/* CONSTANTS ****************************************************************/
   const int MAX = 510;

/* CLASSES ******************************************************************/
/* GLOBALS ******************************************************************/
   enum type {w, l} m[MAX][MAX];

   int y1; // i1
   int x1; // j1

   int y2; // i2
   int x2; // j2

   int res;

/* FUNCTIONS ****************************************************************/
/****************************************************************************/
   void done()
   {
      cout << res << endl << flush;

      exit(0);
   }
/****************************************************************************/
   void init()
   {
      cin >> y1 >> x1 >> y2 >> x2;
   }
/****************************************************************************/
/****************************************************************************/
   void run()
   {
      res = 0;
      for (int y = 1; y < y2; ++y)
         for (int x = 1; x < x2; ++x)
         {
            m[x][y] = l;
            for (int s = 1;; ++s)
            {
               int dec = s * s;

               if ( (x - dec < 1) && (y - dec < 1) ) break;

               if (x - dec > 0 && m[x - dec][y] == l)
               {
                  m[x][y] = w;
                  if (x > x1 && x < x2 && y > y1 && y < y2) ++res;
                  break;
               }

               if (y - dec > 0 && m[x][y - dec] == l)
               {
                  m[x][y] = w;
                  if (x > x1 && x < x2 && y > y1 && y < y2) ++res;
                  break;
               }
            }
         }
   }
/****************************************************************************/
   int main()
   {
      init();
      run();
      done();

      return 0;
   }
/****************************************************************************/

