#include <stdio.h>

#define MAXN			510
#define MAX(a, b)		( (a)>(b)?(a):(b) )

int squares[] = {1, 4, 9, 16, 25, 36, 49, 64, 81, 100,
				 121, 144, 169, 196, 225, 256, 289, 324,
				 361, 400, 441, 484, 10000};

int xmin, ymin, xmax, ymax;

char board[MAXN][MAXN];

int main() {
	int i, j, k;
	int ans;

	scanf("%d %d %d %d\n", &xmin, &ymin, &xmax, &ymax);

	ans = 0;
	board[1][1] = 0;
	for (i = 1; i < xmax; i++)
		for (j = 1; j < ymax; j++)
			for (k = 0; squares[k] < MAX(i, j); k++) {
				if (((j > squares[k]) && (board[i][j - squares[k]] == 0)) ||
					((i > squares[k]) && (board[i - squares[k]][j] == 0))) {

					board[i][j] = 1;
					if ((i > xmin) && (j > ymin))
						ans++;
					break;
				}
			}

	printf("%d\n", ans);

	return 0;
}

