{Georgi Kadrev, Ruse}

Const
 MaxN = 250000;

Type
 WRec = Record
         St  : String[20];
         Ln  : LongInt;
         Cnt : Array['a'..'z'] Of Byte;
        End;

Var
 StAfterThree,
 N,I,J : LongInt;
 W     : Array[1..MaxN] Of WRec;
 D,P   : Array[1..MaxN] Of LongInt;
 Ind   : Array[1..20] Of Integer; {Start of words width length of i}
 C     : Char;

 Procedure SwapW(var W1,W2 : WRec);
 Var
  Tmp : WRec;
 Begin
  Tmp := W1;
  W1 := W2;
  W2 := Tmp;
 End;

procedure quicksort(Lo,Hi: integer);

procedure sort(l,r: integer);
var
  i,j,x: integer;
begin
  i:=l; j:=r; x:=W[(l+r) DIV 2].Ln;
  repeat
    while w[i].ln<x do i:=i+1;
    while x<w[j].Ln do j:=j-1;
    if i<=j then
    begin
      swapw(W[I],W[J]);
      {y:=a[i]; a[i]:=a[j]; a[j]:=y;}
      i:=i+1; j:=j-1;
    end;
  until i>j;
  if l<j then sort(l,j);
  if i<r then sort(i,r);
end;

begin {quicksort};
  sort(Lo,Hi);
end;

 Function Similar(II,JJ : LongInt) : Boolean; {Word JJ is after word II}
 Var
  Diff : Integer;
  Ch   : Char;
 Begin
  Diff := 0;
  Similar := True;

  For Ch := 'a' To 'z' Do
   Begin
    Diff := Diff + Abs(W[JJ].Cnt[Ch] - W[II].Cnt[Ch]);
    If Diff > 1 Then
     Begin
      Similar := False;
      Exit;
     End;
   End;

  If Diff <> 1 Then
   Similar := False;
 End;

 Procedure Show(II : Integer);
 Begin
  If P[II] = 0 Then
   Writeln(W[II].St)
  Else
   Begin
    Show(P[II]);
    Writeln(W[II].St);
   End;
 End;

 Procedure WriteOut;
 Var
  MaxI : LongInt;
 Begin
  MaxI := 1;
  For I:=2 To N Do
   If D[I] > D[MaxI] Then
    MaxI := I;

  Show(MaxI);
 End;

Begin
 N := 0;
 Repeat
  Inc(N);
  For C:='a' To 'z' Do W[N].Cnt[C] := 0;
  Readln(W[N].St);
  If W[N].St='' Then
   Begin
    Dec(N);
    Break;
   End;
  W[N].Ln := Length(W[N].St);
  For I:=1 To W[N].Ln Do
   W[N].Cnt[W[N].St[I]] := W[N].Cnt[W[N].St[I]] + 1;
 Until W[N].St='';

 For I:=1 To N Do P[I] := 0;

{Sort by length}
{Funny selection sort by now
 For I:=1 To N Do
  For J:=I+1 To N Do
   If W[I].Ln > W[J].Ln Then
    SwapW(W[I],W[J]);
}
 QuickSort(1,N);

{End of sorting by length}

{Get inds}
 For I:=1 To N do Ind[I] := -1;

 Ind[W[1].Ln]  := 1;
 For I:=2 To N Do
  Begin
   If W[I].Ln <> W[I-1].Ln Then
    Ind[W[I].Ln] := I;
  End;
{End of getting inds}

{Finding maximum}
 StAfterThree := 0;

 If Ind[3] > 0 Then
 For I:=Ind[3] To N Do
  Begin
   If W[I].Ln <= 3 Then
    D[I] := 1
   Else
    Begin
     StAfterThree := I;
     Break;
    End;
  End;

 If StAfterThree < 1 Then
  Begin
   Writeln;
   Exit;
  End;

 For I:=StAfterThree To N Do
  Begin
   D[I] := 0;
   If Ind[W[I].Ln-1] <> -1 {Exists} Then
   For J:=Ind[W[I].Ln-1] To Ind[W[I].Ln]-1 Do {For each 1 shorter word}
    If Similar(J,I) Then
     If D[J]+1 > D[I] Then
      Begin
       D[I] := D[J]+1;
       P[I] := J;
      End;
  End;

  WriteOut;
End.
