{Dimitar Kunchev, Ruse, A 40}
  Const MaxWords = 250000;
        FN       = '';

  Type TWord = Record
                 W    : String[20];
                 WCHL : Longint; {Which N in formation}
                 WDF  : Longint; {Prev word in formation}
               End;

  Var Word  : Array [1..MaxWords] of TWord;
      N     : Longint;
      f     : Text;

  Procedure SortByL;
      Var J  : Longint;
          Sw : TWord;
    Begin
      Repeat
        J:=0;
        Repeat
          Inc(J);
        Until (J=N) Or (Length(Word[J].W)>Length(Word[J+1].W));
        If J<N Then
          Begin
            Sw:=Word[J];
            Word[J]:=Word[J+1];
            Word[J+1]:=SW;
          End;
      until J=N;
    End;

  Function Form(A,B : Longint) : Boolean; {Check if Word[A] is derived from Word[B]}
      Var SA,SB : String[20];
          J,K   : Integer;
          BF    : Array [0..20] Of Boolean; {BF[0] is for the added letter}

    Begin
      SA:=Word[A].W;
      SB:=Word[B].W;
      If Length(SB)+1<>Length(SA) Then Form:=False Else
        Begin
          For J:=0 To Length(SA) Do
            BF[J]:=False;
          For J:=1 To Length(SA) Do
            Begin
              K:=Pos(Sa[J],SB);
              If Not BF[K] Then BF[K]:=True Else
                Begin
                  Form:=false;
                  Exit;
                End;
              Form:=true;
            End;
        End;

    End;

  Procedure DoWordForm;
      Var I,Z : Longint;
    Begin
      For I :=1 To N Do
        Begin
          For Z:=1 To I-1 Do
            Begin
              If Form(I,Z) And (Word[Z].WCHL+1>Word[I].WCHl) Then
                Begin
                  Word[I].WCHL:=Word[Z].WCHl+1;
                  Word[I].WDF:=Z;
                End;
            End;
        End;
    End;

  Procedure Output;
      Var I,J,P : Longint;
          OA    : Array [1..MaxWords] Of Longint;
    Begin
      J:=0;
      For I:=1 To N Do
        Begin
          if J<Word[I].WCHL Then
            Begin
              P:=I;
              J:=Word[I].WCHl;
            End;
        End;
      OA[J]:=P;
      For I:=J-1 downto 1 Do
        Begin
          OA[I]:=Word[OA[I+1]].WDF;
        End;
      For I:=1 To J Do
        Writeln (Word[OA[I]].W);
    End;

BEGIN
  N:=0;
  Assign (F,FN);
  reset(F);
  Repeat
    Inc (N);
    Readln (F,Word[N].W);
    Word[N].WCHL:=1;
    Word[N].WDF:=0;
  Until Eof(F); {?!!!}

  SortByL;

  DoWordForm;

  Output;

END.
