/*
ID: A52
NAME: Martin Gogov
SCHOOL: SMG
*/
#include <stdio.h>
#include <string.h>
FILE *input, *output;
typedef struct  {
  int len, next;
} word;
char M[250001][21]; int snum, beg;
word N[250001];
void Init (void)  {
//input=fopen ("worch.in", "r");
//output=fopen ("worch.out", "w");
  input=stdin;
  output=stdout;
  while (fscanf (input, "%s", &M[++snum])==1);
  snum--;
}
int max (int a, int b)  {
  return a>=b?a:b;
}
void exc (int i, int j)  {
  int len=max (strlen(M[i]),strlen(M[j])), k;
  char temp;
  for (k=0; k<=len; k++)  {
    temp=M[i][k]; M[i][k]=M[j][k]; M[j][k]=temp;
  }
}
int cmp (char *M, char *N)  {
  return strlen(M)-strlen(N);
}
int link (int p, int q)  {
  int i, flag=0, A[26], B[26];
  if (strlen (M[p])==strlen (M[q]) ) return 0;
  for (i=0; i<=25; i++) A[i]=B[i]=0;
  for (i=0; i<strlen (M[p]); i++) A[(M[p][i]-'a')]++;
  for (i=0; i<strlen (M[q]); i++) B[(M[q][i]-'a')]++;
  for (i=0; i<=25; i++)
      if (A[i]!=B[i])  {
        if (flag) return 0;
        flag=1;
      }
  return 1;
}
void qsort (int l, int r)  {
  int i, j;
  char X[21];
  for (i=0; i<=strlen(M[l]); i++) X[i]=M[l][i];
  i=l; j=r;
  for (;;)  {
    while ( cmp (M[i],X)<0 ) i++;
    while ( cmp (M[j],X)>0 ) j--;
      if (i<j)  {
        exc (i,j);
        i++; j--;
      }
      else break;
    }
  if (l<j  ) qsort (l,j);
  if (j+1<r) qsort (j+1,r);
}
void Think (void)  {
  int i, j;
  beg=snum;
  qsort (1, snum);
  for (i=snum; 1<=i; i--)  {
    for (j=i+1; j<=snum; j++)
      if (link(i,j) && N[i].len<N[j].len+1)  {
        N[i].len=N[j].len+1;
        N[i].next=j;
      }
    if (N[beg].len<N[i].len) beg=i;
  }
}
void Print (void) {
  int i;
  for (i=beg; ;)  {
    fprintf (output, "%s", M[i]);
    if (N[i].next==0) break;
    fprintf (output, "\n");
    i=N[i].next;
  }
}
int main ()  {
  Init ();
  Think ();
  Print ();
  return 0;
}

