#include <stdio.h>
#include <string.h>
#define inf 20000000

 // FILE *f;

  struct groups
    {
      int zab;
      int B[12][210];
    };

  int n, m, k;
  unsigned int A[300][300];
  groups Z[210];
  unsigned int D[300][300];

  int Find (int x, int y, int r)
    {
      for (int i = 1; i <= Z[x].B[r][0]; i++)
        if (Z[x].B[r][i] == y)
          return true;
      return false;
    }

  void Solve ()
    {
      for (int l = 1; l <= n; l++)
        for (int i = 1; i <= n; i++)
          if (l != i)
            for (int j = 1; j <= n; j++)
              if (l != j && i != j)
                {
                  unsigned int d = A[i][l] + A[l][j] + (Find (j, i, ((l + 1)%k) + 1) ? 0 : Z[j].zab);
                  if (d < A[i][j])
                    A[i][j] = d;
                }
      for (int i = 0; i <= n; i++)
        A[i][i] = 0;
    }

 unsigned int FordBelman (int x, int y)
    {
      for (int i = 0; i <= n; i++)
        for (int j = 0; j <= n; j++)
          D[i][j] = inf;
      for (int i = 1; i <= n; i++)
        D[0][i] = A[x][i] + (Find (i, x, 2) ? 0 : Z[i].zab);
      for (int i = 1; i <= n - 2; i++)
        for (int j = 1; j <= n; j++)
          for (int k = 1; k <= n; k++)
            if (D[i - 1][j] + A[j][k] + (Find (k, j, ((i + 1)%k) + 1) ? 0 : Z[k].zab) < D[i][k])
                D[i][k] = D[i - 1][j] + A[j][k] + (Find (k, j, ((i + 1)%k) + 1) ? 0 : Z[k].zab);
      return D[n - 2][y];
    }

  void ReadData ()
    {
      //f = fopen ("lights.inp", "r");
      scanf ("%ld %ld %ld", &n, &m, &k);
      for (int i = 1; i <= n; i++)
        for (int j = 1; j <= n; j++)
          A[i][j] = inf;
      for (int i = 1; i <= n; i++)
        {
          scanf ("%ld", &Z[i].zab);
          for (int j = 1; j <= k; j++)
            {
              int x;
              while (1)
                {
                  scanf ("%ld", &x);
                  if (x == -1)
                    break;
                  Z[i].B[j][0]++;
                  Z[i].B[j][Z[i].B[j][0]] = x;
                }
            }
        }
      int x, y, p;
      for (int i = 1; i <= m; i++)
        {
          scanf ("%ld %ld %ld", &x, &y, &p);
          if (A[x][y] > p)
            {
              A[x][y] = p;
              A[y][x] = p;
            }
        }
      Solve ();
      while (scanf ("%ld %ld", &x, &y) != EOF)
        {
          int qqq = FordBelman (x, y);
          if (qqq == inf)
            printf ("No route\n");
              else
                printf ("%ld\n", qqq);
        }
//      fclose (f);
    }

  int main ()
    {
      ReadData ();
      return 0;
    }
