#include <stdio.h>

#define min(a,b) (a<b?a:b)

typedef struct bank {
       int s;
       int id;
} bank;

typedef struct tran {
       int bfrom;
       int bto;
       int bsum;
} tran;

bank  banks[30000];
tran  trans[60000];

int c;

void transact(int i, int j)
{
    int x = -(banks[j].s);
    int y = banks[i].s;
    int s =min (x,y);

    banks[i].s-=s;
    banks[j].s+=s;

    trans[c].bfrom = banks[i].id;
    trans[c].bto   = banks[j].id;
    trans[c].bsum  = s;
    c++;
}

int cmp(void *e1, void *e2)
{
    return ((bank *)e2)->s - ((bank *)e1)->s;
}

int main()
{
    int n, i, j, s;
    int top, bottom;

    scanf("%d", &n);

    for (i=1;i<=n;i++)
    {
        banks[i].s=0;
        banks[i].id=i;
    }

    while (1)
    {
        scanf("%d %d %d", &i, &j, &s);
        if (i==0 && j==0 && s==0) break;
        banks[i].s+=s;
        banks[j].s-=s;
    }

    qsort(&banks[1],n,sizeof(bank),cmp);

    top = 1;
    bottom = n;
    c = 0;

    while (1)
    {
        while (banks[top].s == 0) top++;
        while (banks[bottom].s == 0) bottom--;

        if (top>=bottom) break;

        transact(top, bottom);
    }

    printf("%d\n", c);
    for (i=0;i<c;i++)
    {
        printf("%d %d %d\n", trans[i].bfrom, trans[i].bto, trans[i].bsum);
    }

    return 0;
}
