/*
  Nikolay Valtchanov, SMG, B50
  zadacha BANK
*/
#include <iostream.h>
#include <stdlib.h>

#define MAXN 30000

int banks[MAXN], N;

int ball[MAXN], L;


void init () {
     cin >> N;
     for (int a,b,c ; a != -1; ) {
         cin >> a >> b >> c;
         a--; b--;
         if (a > -1) {
            banks[a] -= c;
            banks[b] += c;
         }
     }
}

void print () {
     cout << 1 << endl << 2 << " " << 5 << " " << 1;
}

void process () {
     for (int i = 0; i < N; i++)
         if (banks[i])
            ball[L++] = i;

     // sort
     int step = L, swapped;
     do {
        if ((step = (int)(step/1.3)) < 1)
           step = 1;
        swapped = 0;
        for (int i = 0; i < L-step; i++)
            if (abs(banks[ball[i]]) < abs(ball[banks[i+step]])) {
               int t = ball[i];
               ball[i] = ball[i+step];
               ball[i+step] = t;
               swapped++;
            }
     } while (step > 1 || swapped > 0);

}

void main () {
     init ();
     process ();
     print ();
}
