/*********************
Program name: sort.exe (D2)
Made by: Stoyan Denkov (D20)
**********************/
#include <iostream.h>
#include <stdlib.h>
#include <string.h>

typedef unsigned short int usint;


usint A[20],N;
struct sbor
{
 usint sb, ind;
} E[20];

void init();
int sort_function( const void *a, const void *b);
void mysort();
void swap(sbor &a, sbor &b);
void bsort();

int main()
{
 init();
 bsort();
 mysort();
 cout<<A[E[0].ind];
 for(int i=1;i<N;i++)
 {
  cout<<' '<<A[E[i].ind];
 }
 cout<<'\n';

 return 0;
}

void init()
{
 usint tmp[3], t;
 cin>>N;
 for(int i=0;i<N;i++)
 {
  cin>>A[i];
  t=A[i];
  tmp[0]=t%10;
  t-=tmp[0];
  tmp[1]=(t%100)/10;
  t-=tmp[1];
  tmp[2]=(t%1000)/100;
  t-=tmp[2];
  E[i].sb=tmp[0]+tmp[1]+tmp[2];
  E[i].ind=i;
 }
}

int sort_function( const void *a, const void *b)
{
   return( strcmp((char *)a,(char *)b) );
}

void mysort()
{
 for(int i=0;i<N;i++)
 {
  if(E[i].sb==E[i+1].sb)
   if(A[E[i].ind]>A[E[i+1].ind])
	swap(E[i],E[i+1]);
 }
}

void swap(sbor &a, sbor &b)
{
 sbor t;
 t=a; a=b; b=t;
}

void bsort()
{
 int flag;
 for(int i=0;i<N;i++)
  for(int j=0;j<N;j++)
  {
   if(E[i].sb<E[j].sb) swap(E[i],E[j]);
  }
}