#include <iostream>
#include <vector>
#include <cstdlib>

using namespace std;

struct myPair
{
	int Ai;
	int Bi;

	myPair () : Ai (0), Bi (0) {}
	myPair (int ai, int bi) : Ai (ai), Bi (bi) {}
};

vector <myPair*> Barabans;

int N, S;

void Input ()
{
	cin >> N >> S;

	for (int i=0; i<N; i++)
	{
		int _ai, _bi;

		cin >> _ai >> _bi;

		myPair* t_myPair = new myPair (_ai, _bi);

		Barabans.push_back (t_myPair);
	}
}

int Solve ()
{
	int nResult = 0;

	for (vector <myPair*>::iterator iter = Barabans.begin (); iter != Barabans.end (); iter++)
	{
		for (vector <myPair*>::iterator iter2 = iter; iter2 != Barabans.end (); iter2++)
		{
			if (iter == iter2) continue;

			myPair& First = (**iter);
			myPair& Second = (**iter2);

			int F_Ai, S_Ai, F_Bi, S_Bi;

			F_Ai = First.Ai;
			S_Ai = Second.Ai;
			F_Bi = First.Bi;
			S_Bi = Second.Bi;

			if (First.Ai + Second.Ai > S || First.Bi + Second.Bi < S) continue;

			if (F_Ai < S_Bi && F_Ai+S_Bi < S)
				while (F_Ai+S_Bi < S) F_Ai++;

			else if (F_Ai < S_Bi && F_Ai+S_Bi > S)
				while (F_Ai+S_Bi > S) S_Bi--;

			if (S_Ai < F_Bi && S_Ai+F_Bi < S)
				while (S_Ai+F_Bi < S) S_Ai++;

			else if (S_Ai < F_Bi && S_Ai+F_Bi > S)
				while (S_Ai+F_Bi > S) F_Bi--;

			for (int i=F_Ai; i<=F_Bi; i++)
			{
				for (int j=S_Ai; j<=S_Bi; j++)
				{
					if (i+j == S) nResult++;
				}
			}
		}
	}

	return nResult;
}

void Output (int nResult)
{
	cout << nResult;
}

int main ()
{
	Input ();

	int nResult = Solve ();

	Output (nResult);
	return 0;
}
