#include <iostream>

using namespace std;

int my_x0, my_y0, my_x1, my_y1, my_N;

void Init ()
{
	cin >> my_x0 >> my_y0 >> my_x1 >> my_y1 >> my_N;
}

void Output (int nRetVal)
{
	cout << nRetVal << '\n';
}

int Solve (int _x0, int _y0, int nMovesLeft)
{
	if (_x0 < -10000 || _x0 > 10000 || _y0 < -10000 || _y0 > 10000)
		return 0;

	int nRetVal = 0;

	if ( abs (_x0) - abs (my_x0) + abs (_y0) - abs (my_x0)  < 0 )
		return 0;

	if (nMovesLeft == 0 && _x0 == my_x1 && _y0 == my_y1)
	{
		return 1;
	}
	else if (nMovesLeft == 0)
	{
		return 0;
	}

	nRetVal += Solve (_x0-1, _y0, nMovesLeft-1);
	nRetVal += Solve (_x0+1, _y0, nMovesLeft-1);
	nRetVal += Solve (_x0, _y0-1, nMovesLeft-1);
	nRetVal += Solve (_x0, _y0+1, nMovesLeft-1);

	return nRetVal;
}

int main ()
{
	Init ();

	if (my_x0 < -10000 || my_x0 > 10000 || my_x1 < -10000 || my_x1 > 10000 ||
		my_y0 < -10000 || my_y0 > 10000 || my_y1 < -10000 || my_y1 > 10000)
		return 0;

	int nResult = Solve (my_x0, my_y0, my_N);

	Output (nResult);
	return 0;
}
