#include <stdio.h>
#include <stdlib.h>

#define MAXN            25
#define MAXK            100
#define VADD            10001

int px1,py1;
int nx1,ny1;
int px2,py2;
int nx2,ny2;
int n;
long long dp[MAXN][MAXK][MAXK];
int maxk;

void init()
{
  int i,i2,i3;

  for(i=0;i<MAXN;i++)
    for(i2=0;i2<MAXK;i2++)
      for(i3=0;i3<MAXK;i3++)
        dp[i][i2][i3] = 0;

}

void input()
{
  scanf("%d %d %d %d %d",&px1,&py1,&px2,&py2,&n);

  px1 += VADD;
  py1 += VADD;
  px2 += VADD;
  py2 += VADD;

//  nx1 = px1;
//  if(nx1>n+1)
    nx1 = n+1;

//  ny1 = py1;
//  if(ny1>n+1)
    ny1 = n+1;

  nx2 = px2 - (px1-nx1);
  ny2 = py2 - (py1-ny1);

  if(nx2>2*n+1 || ny2>2*n+1)
  {
    printf("0\n");
    exit(0);
  }

  if(nx2<1 || ny2<1)
  {
    printf("0\n");
    exit(0);
  }

}

void solve()
{
  int i,i2,i3;

  dp[0][nx1][ny1] = 1;

  maxk = 2*n+3;  

  for(i=0;i<n;i++)
  {
    for(i2=1;i2<maxk;i2++)
      for(i3=1;i3<maxk;i3++)
      {
        if(dp[i][i2][i3]!=0)
        {
          dp[i+1][i2-1][i3]+=dp[i][i2][i3];
          dp[i+1][i2+1][i3]+=dp[i][i2][i3];
          dp[i+1][i2][i3-1]+=dp[i][i2][i3];
          dp[i+1][i2][i3+1]+=dp[i][i2][i3];
        }
      }
  }

}

void output()
{
  printf("%lld\n",dp[n][nx2][ny2]);

}

int main()
{
  init();
  input();
  solve();
  output();

  return 0;
}

