/*
NAME : Valentin Stoynov Mihov
PROB : mono
CITY : Varna
DIVISION : A
*/

#include <stdio.h>
#include <string.h>

#define MAXN 30

int n;
int T[MAXN][30];
int S[MAXN];
char res[MAXN];

void Init()
  {
//    freopen("mono.in","rt",stdin);
    scanf("%d",&n);
  }

void CalcT()
  {
    int i,j,k;
    memset(T,0,sizeof(T));
    
    for (i = 0;i < 26;i++)
      T[1][i] = 1;
    S[1] = 26;
    for (i = 2;i <= 26;i++)
      {
        for (j = 0;j < 26;j++)
            for (k = j + 1;k < 26;k++)
              T[i][j] += T[i - 1][k];
        // Sums
        S[i] = 0;
        for (j = 0;j < 26;j++)
          S[i] += T[i][j];
      }
  }

void Find(int pos,int len,int num,int from)
  {
    int sum = 0,i;
    for (i = from;i < 26;i++)
      if (sum + T[len][i] >= num) break;
      else sum += T[len][i];

    res[pos] = 'a' + i;
    num -= sum;
    if (len - 1) Find(pos + 1,len - 1,num,i + 1);
  }

void Solve()
  {
    int sum = 0,i;
    // First find the length

    for (i = 0;i <= 26;i++)
      if (sum + S[i] >= n) break;
      else sum += S[i];

    Find(0,i,n - sum,0);
    res[i] = '\0';
  }

void Output()
  {
    printf("%s\n",res);
  }

int main()
  {
    Init();
    CalcT();
    Solve();
    Output();
    return 0;
  }
