#include <stdio.h>
#include <string.h>

#define MAXN 210
#define MAXS 20010

typedef struct {
        int l;
        char m[400];
} bignum;

bignum m1[MAXS],m2[MAXS],sum1[MAXS],sum2[MAXS];
int a[MAXN],b[MAXN];

int min(int a,int b) { return (a<b)?a:b; }
int max(int a,int b) { return (a>b)?a:b; }

void add(bignum *res,bignum x,bignum y) { // res = x+y;
int len = max(x.l,y.l);
int i,ost=0;
    for (i=0;i<len;i++) {
        res->m[i] = ost+x.m[i]+y.m[i];
        ost = res->m[i]/10;
        res->m[i]%=10;
    }
    res->m[i] = ost;
    res->l = len;
    if (res->m[i]==1)
       res->l++;
}

void substr(bignum *res,bignum x,bignum y) { // res=x-y;
int i,j,ll;
int tmp;
     for (i=0;i<x.l;i++) {
         tmp =x.m[i]-y.m[i];

         if (tmp<0) {
            res->m[i]=tmp+10;
            for (j=i+1;j<x.l;j++)
                if (x.m[j]!=0) {
                   x.m[j]--;
                   break;
                } else
                  x.m[j]=9;
         } else
           res->m[i]=tmp;
     }
     ll=x.l-1;
     res->l=x.l;
     while (res->m[ll]==0 && ll>=0) {
           res->l--;
           ll--;
     }
}


void test_bignum() {
bignum x,y,z;
bignum w;
       w.l=2;
       w.m[0]=9;
       w.m[1]=2;
       x.l=2;
       x.m[0]=9;
       x.m[1]=1;
       y.l=2;
       y.m[0]=1;
       y.m[1]=9;
       add(&z,x,y);
       substr(&x,z,w);
       x.l=0;
}

int main () {
int i,j,k,n,s,mx;
int nach,krai;
//    test_bignum();
//    FILE *f = fopen ( "game.in" , "r");
    scanf("%d%d",&n,&s);
    for (i=1;i<=n;i++)
        scanf("%d%d",&a[i],&b[i]);
//    fclose(f);
    memset(m1,0,sizeof(m1));
    memset(sum1,0,sizeof(sum1));
    for (i=a[1];i<=b[1];i++) {
        m1[i].l = 1;
        m1[i].m[0] = 1;
        memset(sum1[i].m,0,sizeof(sum1[i].m));
        sum1[i].l=0;
        add(&sum1[i],sum1[i-1],m1[i]);
    }
    for (i=b[1]+1;i<=s;i++) {
        sum1[i].l = sum1[b[1]].l;
        memcpy(sum1[i].m,sum1[b[1]].m,sizeof(sum1[i].m));
    }
    for (i=2;i<=n;i++) {
        for (j=1;j<=s;j++) {
            // m2[j] = 0;
            memset(m2[j].m,0,sizeof(m2[j].m));
            m2[j].l = 0;
            /////////////
            nach = j-b[i]-1;
            krai = j-a[i];
            if (nach<0) nach = 0;
            if (krai<0) krai = 0;
            if (nach<krai)
               substr(&m2[j],sum1[krai],sum1[nach]);
            add(&sum2[j],sum2[j-1],m2[j]);
        }
        memcpy(m1,m2,sizeof(m2));
        memcpy(sum1,sum2,sizeof(sum1));
        memset(sum2,0,sizeof(sum2));
    }
    if (m1[s].l<=0)
       printf("0");
    else
    for (j=m1[s].l-1;j>=0;j--)
        printf("%d",m1[s].m[j]);
    printf("\n");
    return 0;
}
