#include <stdio.h>
#include <values.h>

#define MAXN 1000

typedef struct{
	float x;
	float y;
	int id;
	int flag;
	} s1;

int counter=0;
int used[MAXN]={0};

s1 P[MAXN];
s1 A[MAXN];
int N;
int minxid;




double Determinanta(int i,int j,int k)
{
	return (P[i].x*P[j].y+P[i].y*P[k].x+P[j].x*P[k].y)-(P[k].x*P[j].y+P[k].y*P[i].x+P[j].x*P[i].y);
}


int GetNaslednik(int i)
{

	int flag=0;
	int j,k;

	for(j=0;j<counter;j++)
	{

		if(i==j) continue;
		for(k=j+1;k<counter;k++)
		{
			if(Determinanta(A[i].id,A[j].id,A[k].id)>0)
			{
				flag=1;
				break;
			}
		}
		if(flag==0)
		{
			if(minxid!=j) printf("%d ",A[j].id);
			used[j]=1;
			break;
		}
		else flag=0;
	}


	return j;
}





int check(int a,int b)
{

	float flag,temp;

	int i=1;

	while(i==a||i==b){
		i++;}

	flag=Determinanta(a,b,i);


	if(flag>0)
	{
	for(;i<=N;i++)
	{
		if(i==a||i==b) continue;
		else
		{
			temp=Determinanta(a,b,i);
			if(temp<0) return 0;
		}
	}
	}
	else{
	for(;i<=N;i++)
	{
		if(i==a||i==b) continue;
		else
		{
			temp=Determinanta(a,b,i);
			if(temp>0) return 0;
		}
	}
	}

	return 1;
}


int main()
{

	int i,j;
	float minx=MAXFLOAT;

	int naslednik;

	scanf("%d",&N);
/*
	P[1].x=0.5;
	P[1].y=2.0;
	P[1].id=1;
	P[1].flag=0;
	P[2].x=3.0;
	P[2].y=1.0;
	P[2].id=2;
	P[2].flag=0;
	P[3].x=3.0;
	P[3].y=3.0;
	P[3].id=3;
	P[3].flag=0;
	P[4].x=2.5;
	P[4].y=2.0;
	P[4].id=4;
	P[4].flag=0;
*/
	for(i=1;i<=N;i++)
	{
		scanf("%f",&P[i].x);
		scanf("%f",&P[i].y);
		P[i].id=i;
		P[i].flag=0;
	}


	for(i=1;i<=N-1;i++)
		for(j=i+1;j<=N;j++)
		{
			if(check(i,j)==1)
			{
				P[i].flag++;
				P[j].flag++;


			}
		}



   counter=0;
   for(i=1;i<=N;i++)
   {

	if(P[i].flag>1)
	{
		A[counter].x=P[i].x;
		A[counter].y=P[i].y;
		A[counter].id=P[i].id;
		counter++;
	}
   }


   printf("%d\n",counter);


   for(i=0;i<counter;i++)
   {

	if(A[i].x==minx)
	{
		if(A[minxid].y>A[i].y)
		minxid=i;
	}

	if(A[i].x<minx)
	{
		minx=A[i].x;
		minxid=i;
	}

   }
   printf("%d ",A[minxid].id);

   naslednik=minxid;

   do{
   naslednik=GetNaslednik(naslednik);
   }while (naslednik!=minxid);

  return 0;
}












