#include <stdio.h>

#define MAX 101

int M, N, a[MAX][MAX];

int fh(void);
int fv(void);
int fd(void);
int d_check(int k, int t, int r);

int main(void)
{
  int i, j, sumh, sumv, sumd, mas[3];

  scanf("%d%d", &M, &N);

  for(i=0; i<M; i++)
    for(j=0; j<N; j++)
     scanf("%d", &a[i][j]);

  sumh = fh();
  sumv = fv();
  sumd = fd();

  if(!sumh && !sumv && !sumd) printf("%d\n", 0);
  if(sumh > sumd && sumh > sumv) printf("%d\n", sumh);
  if(sumv > sumd && sumv > sumh) printf("%d\n", sumv);
  if(sumd > sumh && sumd > sumv) printf("%d\n", sumd);

  return 0;
}

int fh(void)
{
  int i, j, sum = 0, smax = -1;

  for(i=0; i<M; i++)
  {
    sum = 0;
    for(j=0; j<N; j++)
      if(a[i][j] > 0) break;

    for(; j<M; j++)
    {
      if(a[i][j] <= 0) break;

      else sum += a[i][j];
    }
    if(sum > smax) smax = sum;
  }

  return smax;
}

int fv(void)
{
  int i, j, sum = 0, smax = -1;

  for(i=0; i<N; i++)
  {
    sum = 0;
    for(j=0; j<M; j++)
      if(a[j][i] > 0) break;

    for(; j<M; j++)
    {
      if(a[j][i] <= 0) break;
      else sum += a[j][i];
    }
    if(sum > smax) smax = sum;
  }

  return smax;
}

int fd(void)
{
  int i, j, sum, smax = -10;

  for(i=0; i<M; i++)
  {
    for(j=0; j<N; j++)
    {
      sum = d_check(i, j, i - j);
      if(sum > smax) smax = sum;
    }
  }

  return smax;
}

int d_check(int k, int t, int r)
{
  int i, j, sum = 0;

  for(i=k; i<M; i++)
    for(j=t; j<N; j++)
    {
      if( (i - j) == r && a[i][j] > 0) sum += a[i][j];
    }

  return sum;
}