program game;

const
	MAX_AB				= 3001;

var
	win				: Array [1 .. MAX_AB] of Boolean;
	move				: Array [1 .. MAX_AB] of Integer;
	A, B, N				: Integer;
	i, j				: Integer;
	f				: Text;

procedure swap(var a, b: Integer);
var
	temp				: Integer;
begin
	temp := a;
	a := b;
	b := temp;
end;

procedure readInput;
begin
	readln(A, B);
	if (A > B) then begin
		N := A;
		swap(A, B);
	end
	else 
		N := B;
end;

procedure Solve;
var
	idiv2				: Integer;
        found				: Boolean;
begin
	win[1] := False;
	for i := 2 to N do begin
		idiv2 := i div 2;
                found := False;
		for j := 1 to idiv2 do
			if (not win[j]) and (not win[i - j]) then begin
				win[i] := True;
				move[i] := j;
                                found := True;
				break;
			end;
                if (not found) then
                	win[i] := False;
	end;
end;

procedure writeOutput;
begin
	if (win[A]) then
		writeln(move[A], ' ', A - move[A])
	else if (win[B]) then
		writeln(move[B], ' ', B - move[B])
	else
		writeln('0');
end;

begin
	readInput;
	Solve;
	writeOutput;
end.