program table;

const
	MAXM				= 1000;
	MAXN				= 1000;
	inpf				= '';
	outf				= '';

var
	T				: Array [1 .. MAXM, 0 .. MAXN + 1] of Integer;
	F				: Array [1 .. MAXM, 1 .. MAXN, 1 .. 4] of LongInt;
	M, N				: Integer;
	ff				: Text;
	i, j, k				: Integer;

procedure writeOutput;
var
	max				: LongInt;
begin
	max := 0;
	for i := 1 to M do
		for j := 1 to N do
			for k := 1 to 4 do
				if (F[i, j, k] > max) then
					max := F[i, j, k];
	assign(ff, outf);
	rewrite(ff);
	writeln(ff, max);
	close(ff);
			
end;

procedure readInput;
var
	i, j				: Integer;
begin
	assign(ff, inpf);
	reset(ff);
	readln(ff, M, N);
	for i := 1 to M do begin
		for j := 1 to N do
			read(ff, T[i, j]);
		readln(ff);
	end;
	close(ff);
end;

procedure Solve;
var
	temp				: LongInt;
begin
	for i := 1 to M do begin
		T[i, 0] := -1;
		T[i, N + 1] := -1;
	end;
	for i := 1 to N do begin
		for k := 1 to 4 do
			F[1, i, k] := T[1, i];
	end;
	for i := 1 to M do
		for j := 1 to N do
			if (T[i, j] > 0) then begin
				for k := 1 to 4 do
					F[i, j, k] := T[i, j];
				if (T[i - 1, j - 1] > 0) then
				 	F[i, j, 1] := F[i - 1, j - 1, 1] + T[i, j];
				if (T[i - 1, j] > 0) then
					F[i, j, 2] := F[i - 1, j, 2] + T[i, j];
				if (T[i - 1, j + 1] > 0) then
					F[i, j, 3] := F[i - 1, j + 1, 3] + T[i, j];
				if (T[i, j - 1] > 0) then
					F[i, j, 4] := F[i, j - 1, 4] + T[i, j];
			end;
end;

begin
	readInput;
	Solve;
	writeOutput;
end.