#include <iostream.h>
#include <math.h>

int n;

struct point
{
	long int x;
	long int y;
	int id;
}a[ 1001 ];


void init( )
{
	int i;
	double d;
//	ifstream cin( "hull.inp" );

	cin>>n;
	for ( i=1; i<=n; i++ )
	{
		a[ i ].id = i;
		cin>>d;
		d *= 10000;

		a[ i ].x = d;

		cin>>d;
		d *= 10000;

		a[ i ].y = d;
	}
//	cin.close( );
}


double theta( point p1, point p2 )
{
	double t;
	long int dx = p2.x - p1.x;
	long int dy = p2.y - p1.y;
	long int ax = abs( dx );
	long int ay = abs( dy );

	t =  ax + ay == 0 ? 0.0 : dy / (ax+ay);

	if ( dx < 0 )
		t = 2-t;
	else
		if ( dy < 0 )
			t = 4+t;

	return t;
}


int wrap( )
{
	int m;
	double th, v;
	int i, min;
	point w;

	for ( i=1, min=1; i<=n; i++ )
	{
		if ( a[ i ].y < a[ min ].y )
		{
			min = i;
		}
	}
	th = 0.0;
	a[ n+1 ] = a[ min ];

	for ( m=1; m<=n; m++ )
	{
		w = a[ min ];
		a[ min ] = a[ m ];
		a[ m ] = w;

		v = th; th = 360.0;

		for ( i=m+1; i<=n+1; i++ )
		{
			if ( theta( a[ m ], a[ i ] ) > v )
				if ( theta( a[ m ], a[ i ] ) < th )
				{
					th = theta( a[ m ], a[ i ] );
					min = i;
				}
		}

		if ( min == n+1 )
			break;
	}
	return m;
}


void solve( )
{
	int m = wrap( );
	int i;

	cout<<m<<endl;

	for ( i=m; i>=2; i-- )
		cout<<a[ i ].id<<" ";

	cout<<a[ 1 ].id<<endl;
}


void main()
{
  init( );
  solve( );
}
