#include <iostream.h>


typedef struct _COORD
{
 int x;
 int y;
} COORD;



void init();
int inside(COORD pt, int i);
int between(int x,int a,int b);
void rect();
int FindMaxX();
int FindMaxY();
void out(int a,int b);

int N;
COORD *min,*max;
int np=0; //numbres printed

int main()
{
 init();
 rect();

 cout<<endl;

 delete[]min;
 delete[]max;

 return 0;
}

void init()
{
 cin>>N;

 min=new COORD[N];
 max=new COORD[N];

 for(int i=0;i<N;i++)
  cin>>min[i].x>>min[i].y>>max[i].x>>max[i].y;
}

int inside(COORD pt,int i)
{
 if(!between(pt.x,min[i].x,max[i].x)) return 0;
 if(!between(pt.y,min[i].y,max[i].y)) return 0;
 return 1;
}

int between(int x,int a,int b)
{
 if(x>a&&x<b) return 1;
 return 0;
}

void rect()
{
 int mfn=0; //za kolko nai-mnogo pravougulnici
 int mx=FindMaxX()+1;
 int my=FindMaxY()+1;
 int count;

 for(int x=0;x<mx;x++)
  for(int y=0;y<my;y++)
  {
   COORD pt;
   pt.x=x;
   pt.y=y;
   int rects=0;
   for(int i=0;i<N;i++)
    if(inside(pt,i)) rects++;
   if(rects>mfn) {mfn=rects; count=0;}
   if(rects==mfn) count++;
  }

 cout<<count<<endl;

 for(x=0;x<mx;x++)
  for(int y=0;y<my;y++)
  {
   COORD pt;
   pt.x=x;
   pt.y=y;
   int rects=0;
   for(int i=0;i<N;i++)
    if(inside(pt,i)) rects++;
   if(mfn==rects) out(x,y);
  }
}

int FindMaxX()
{
 int g=0;
 for(int i=0;i<N;i++)
  if(max[i].x>g) g=max[i].x;

 return g;
}

int FindMaxY()
{
 int g=0;
 for(int i=0;i<N;i++)
  if(max[i].y>g) g=max[i].y;

 return g;
}

void out(int a,int b)
{
 if(np==20) {np=0;cout<<endl;}
 if(np!=0) cout<<' ';
 np+=2;
 cout<<a<<' '<<b;
}