#include <stdio.h>

#define N 100100

#define inf 1e16

int n;
int kk;
int lk[N];
int is[N];
struct es {
	int a;
	int b;
	int c;
	int n;
} e[2*N];
int g[N];
int nc[N];
int ec;

int q[N];
int qb, qe;

int bs1[N];
long long bd1[N];
int bs2[N];
long long bd2[N];

int p[N];

void read_input() {
	int i;
	int t1, t2, t3, j;

	scanf("%d%d", &n, &kk);
	for (i = 0; i < n-1; i++) {
		scanf("%d%d%d", &t1, &t2, &t3);
		j = ++ec;
		if (g[t1] != 0)
			e[j].n = g[t1];
		g[t1] = j;
		nc[t1]++;
		e[j].a = t1;
		e[j].b = t2;
		e[j].c = t3;

		j = ++ec;
		if (g[t2] != 0)
			e[j].n = g[t2];
		g[t2] = j;
		nc[t2]++;
		e[j].a = t2;
		e[j].b = t1;
		e[j].c = t3;
	}
	for (i = 1; i <= kk; i++) {
		scanf("%d", &lk[i]);
		is[lk[i]] = i;
	}
}

void solve() {
	int i, j;
	int cn, nn;

	qe = qb = 0;
	for (i = 1; i <= n; i++) {
		if (is[i]) {
			bs1[i] = is[i];
			bd1[i] = 0;
		} else {
			bs1[i] = 0;
			bd1[i] = inf;
		}
		bs2[i] = 0;
		bd2[i] = inf;
		if (nc[i] == 1)
			q[qe++] = i;
	}

	while (qb < qe) {
		cn = q[qb++];
		nc[cn] = 0;
		for (j = g[cn]; j != 0; j = e[j].n) {
			nn = e[j].b;
			if (nc[nn] == 0) continue;
			nc[nn]--;

			if ((bd1[cn] + e[j].c < bd1[nn]) ||
					((bd1[cn] + e[j].c == bd1[nn]) && (bs1[cn] < bs1[nn]))) {
				bd2[nn] = bd1[nn];
				bs2[nn] = bs1[nn];

				bd1[nn] = bd1[cn] + e[j].c;
				bs1[nn] = bs1[cn];
			} else if ((bs1[cn] != bs1[nn]) && ((bd1[cn] + e[j].c < bd2[nn])
					|| ((bd1[cn] + e[j].c == bd2[nn])&&(bs1[cn]<bs2[nn])))) {
				bd2[nn] = bd1[cn] + e[j].c;
				bs2[nn] = bs1[cn];
			}
			if ((bd2[cn] + e[j].c < bd2[nn])
					|| ((bd2[cn] + e[j].c == bd2[nn])&&(bs2[cn] < bs2[nn]))){
				bd2[nn] = bd2[cn] + e[j].c;
				bs2[nn] = bs2[cn];
			}

			if (nc[nn] == 1)
				q[qe++] = nn;
		}
	}

	qb = qe = 0;
	q[qe++] =cn;
	p[cn] = 0;

	while (qb < qe) {
		cn = q[qb++];
		for (j = g[cn]; j != 0; j = e[j].n) {
			nn = e[j].b;
			if (p[cn] == nn) continue;

			if ((bd1[cn] + e[j].c < bd1[nn]) ||
					((bd1[cn] + e[j].c == bd1[nn]) && (bs1[cn] < bs1[nn]))) {
				bd2[nn] = bd1[nn];
				bs2[nn] = bs1[nn];

				bd1[nn] = bd1[cn] + e[j].c;
				bs1[nn] = bs1[cn];
			} else if ((bs1[cn] != bs1[nn]) && ((bd1[cn] + e[j].c < bd2[nn])
					|| ((bd1[cn] + e[j].c == bd2[nn])&&(bs1[cn]<bs2[nn])))){
				bd2[nn] = bd1[cn] + e[j].c;
				bs2[nn] = bs1[cn];
			}
			if ((bd2[cn] + e[j].c < bd2[nn])
					|| ((bd2[cn] + e[j].c == bd2[nn])&&(bs2[cn] < bs2[nn]))){
				bd2[nn] = bd2[cn] + e[j].c;
				bs2[nn] = bs2[cn];
			}

			p[nn] = cn;
			q[qe++] = nn;
		}
	}

	for (i = 1; i <= n; i++)
		if (bs1[i] == is[i])
			printf("%d %lld\n", bs2[i], bd2[i]);
		else
			printf("%d %lld\n", bs1[i], bd1[i]);
}

int main() {
	read_input();
	solve();

	return 0;
}
