#include<stdio.h>
#include<math.h>

#define MAXN 1024

char used[MAXN],adj[MAXN][MAXN];
int next[MAXN][MAXN],n,x;
double dist[MAXN][MAXN];

void add(int a)
{
        int i,j,b,c;
        double kos,angle=0,AB,AC,BC,XA,XB,XC;
        for(i=1;i<=next[a][0];i++)
        {
                c=next[a][i];
                if(used[c]) continue;
                for(j=1;j<=next[c][0];j++)
                {
                        b=next[c][j];
                        if(b==x||!used[b]||!adj[a][b]) continue;
                        AB=dist[a][b];
                        AC=dist[a][c];
                        BC=dist[b][c];
                        XA=dist[x][a];
                        XB=dist[x][b];
                        angle+=acos((XA*XA+AB*AB-XB*XB)/(2*XA*AB));
                        angle+=acos((AC*AC+AB*AB-BC*BC)/(2*AC*AB));
                        kos=cos(angle);
                        XC=sqrt(XA*XA+AC*AC-2*kos*XA*AC);
                        dist[x][c]=dist[c][x]=XC;
                        adj[x][c]=adj[c][x]=1;
                        next[c][++next[c][0]]=x;
                        next[x][++next[x][0]]=c;
                        used[c]=1;
                        add(c);
                }
        }
}

int main()
{
        int y,i,l,r;
        double c;
        scanf("%d%d%d",&n,&x,&y);
        used[x]=1;
        while(scanf("%d%d%lf",&l,&r,&c)==3)
        {
                adj[l][r]=adj[r][l]=1;
                dist[l][r]=dist[r][l]=c;
                next[l][++next[l][0]]=r;
                next[r][++next[r][0]]=l;
                if(l==x) used[r]=1;
                if(r==x) used[l]=1;
        }
        for(i=1;i<=n;i++) if(used[i]&&i!=x) add(i);
        for(i=1;i<=n;i++) printf("%.2lf\n",dist[x][i]);
        return 0;
}
