#include<stdio.h>

#define MAXN    1024

int N,g,f1;
double adj[MAXN][MAXN];
int msus[MAXN][MAXN];

void find(int ind1,int ind2,int idx)
{
        int x1,x2,i,j;
        double a,b,c,d,e;
        double cosa,cosb,sina,sinb,cosab,distx=0;
        a=adj[g][ind1];
        b=adj[g][ind2];
        c=adj[ind2][idx];
        d=adj[ind1][idx];
        e=adj[ind1][ind2];
        cosa=(a*a + e*e - b*b)/(2.*a*e);
        cosb=(d*d + e*e - c*c)/(2.*d*e);
        sina=sqrt(1-cosa*cosa);
        sinb=sqrt(1-cosb*cosb);
        cosab=cosa*cosb-sina*sinb;
        distx=sqrt( a*a + d*d - 2*a*d*cosab );
//        printf("(%d,%d,%d)  distx = %f\n",ind1,ind2,idx,distx);
        adj[g][idx]=distx;
//        adj[i][g]=distx;
}

void DFS(int ind2)
{
        int i,j,vert=0,idx=0;
        for(i=1;i<=msus[ind2][0];i++)
        {
                vert=msus[ind2][i];
                if(vert==g)continue;
                if(adj[g][vert]>0.)
                {
                        for(j=1;j<=msus[vert][0];j++)
                        {
                                idx=msus[vert][j];
                                if(idx==g)continue;
                                if(adj[ind2][idx]>0. && adj[g][idx]<0.000001)
                                {
                                        find(ind2,vert,idx);
                                }
                        }
                }
        }
}

void findall()
{
        int i,j;
//        fix[f1]=1;fix[g]=1;
        for(i=0;i<N;i++)
                if(i!=g)
                        DFS(f1);
}

int main()
{
        int i,j,x,y;
        double dist;
        scanf("%d %d %d",&N,&g,&f1);
        g--;f1--;
        while(scanf("%d %d %lf",&x,&y,&dist)==3)
        {
                x--;y--;
                adj[x][y]=dist;
                adj[y][x]=dist;
                msus[x][msus[x][0]++]=y;
                msus[y][msus[y][0]++]=x;
        }
        findall();
        for(i=0;i<N;i++)
        {
//                adj[g][i]+=0.005;
                printf("%.2f\n",adj[g][i]);
        }
        return 0;
}
