#include <stdio.h>
#include <string.h>

#define int long

const int MAX = 2010;
const int MOD = 1020847;

int iL,iSegC;
int iR[MAX][MAX];

void init() {
        memset(iR,0,sizeof(iR));
}

void load() {
	scanf("%ld%ld",&iL,&iSegC);
}

void add(int iCurL,int iCurSegC,int iAdd) {
        iR[iCurL][iCurSegC] = (iR[iCurL][iCurSegC] + iAdd) % MOD;
}

int solve() {
	iR[1][1] = 1;

        for (int iCurSegC=1;iCurSegC <= iSegC;iCurSegC++)
		for (int iCurL=iCurSegC;iCurL <= iL;iCurL++) {
                	//The next element is placed at the begining of each segment
                	add(iCurL+1,iCurSegC,iR[iCurL][iCurSegC]*iCurSegC);
                        
                        //The next elemetn is placed inside each segment
                        add(iCurL+1,iCurSegC+1,(iCurL+1-iCurSegC)*iR[iCurL][iCurSegC]);
                }
        
        return iR[iL][iSegC];
}

void save(int iR) {
	printf("%ld\n",iR);
}

#undef int

int main() {
	init();
        load();
        save(solve());
        
	return 0;
}
