#include <iostream>
#define MAXN 100000
#define MAX_VALUE 1999000000

using namespace std;

struct graph
       {unsigned long long data;
        unsigned long nasl;
        graph *next;
       };

unsigned long n, k;
graph *a[MAXN]; //!!!
unsigned long long d[MAXN];
bool used[MAXN];
unsigned long isZala[MAXN];

void AddRib(unsigned long x, unsigned long y, unsigned long c)
     {graph *tec=new(graph);
      tec->data=c;
      tec->nasl=y;
      tec->next=a[x];
      a[x]=tec;
     }

void Input()
     {cin>>n>>k;

      /*
      for (unsigned long i=0; i<n-1; i++)
          for (unsigned long j=0; j<n-1; j++)
              a[i][j]=0;
      */

      for (unsigned long i=0; i<n; i++)
          a[i]=NULL;
      
      unsigned long x, y, c;        
      for (unsigned long i=0; i<n-1; i++)
          {cin>>x>>y>>c;
           AddRib(x-1, y-1, c);
           AddRib(y-1, x-1, c);
           /*
           a[x-1][y-1]=c;
           a[y-1][x-1]=c;
           */
          }
      /* !!!!!!!!!!!!!!!!!!!!!!!!
      for (unsigned long i=1; i<=k; i++)
          {cin>>x;
           a[x-1][x-1]=i;
          }
      */
      for (unsigned long i=0; i<n; i++)
          isZala[i]=0;
          
      for (unsigned long i=1; i<=k; i++)
          {cin>>x;
           isZala[x-1]=i;
          }
     }

void Dijkstra(unsigned long s)
     {/*
      for (unsigned long i=0; i<n; i++)
          //if (s!=i)
             if (a[s][i])
                d[i]=a[s][i];
             else
                 d[i]=MAX_VALUE;
      d[s]=MAX_VALUE;
      */
      for (unsigned long i=0; i<n; i++)
          d[i]=MAX_VALUE;
          
      graph *help=a[s];
      while (help)
            {d[help->nasl]=help->data;
             help=help->next;
            }

      for (unsigned long i=0; i<n; i++)
          used[i]=false;


      used[s]=true;
      unsigned long long j, dj;
      while (1)
            {j=n+1;
             dj=MAX_VALUE;
             for (unsigned long i=0; i<n; i++)
                 if (!used[i] && d[i]<dj)
                    {j=i;
                     dj=d[i];
                    }

             if (j==n+1) break;
             used[j]=true;
             /*
             for (unsigned long i=0; i<n; i++)
                 if (i!=j && a[i][j])
                    if (!used[i] && d[i]>a[i][j]+dj)
                       d[i]=a[i][j]+dj;
             */
             help=a[j];
             while (help)
                   {if (!used[help->nasl] && d[help->nasl]>help->data+dj)
                       d[help->nasl]=help->data+dj;
                    help=help->next;
                   }
            }
     }

void Solve()
     {unsigned long long tecMin;
      for (unsigned long i=0; i<n; i++)
          {Dijkstra(i);

           d[n]=MAX_VALUE;
           tecMin=n;
           for (unsigned long j=0; j<n; j++)
               if (i!=j && isZala[j])
                  if (d[j]<d[tecMin])
                     tecMin=j;
                     
           cout<<isZala[tecMin]<<" "<<d[tecMin]<<"\n";
          }
     }

int main()
    {Input();
     Solve();
     return 0;
    }
