#include <stdio.h>

#define MAX		100

int n, m, x, y, idx = 1;
int buf[MAX+1][MAX+1] = {0};
int v[MAX] = {0}, res[MAX] = {0};
int used[MAX+1] = {0};

void way(int x, int y)
{
	int i, j;

	if (x == y)
		res[idx++] = y;

	if (buf[x][y] == 1)
	{
		res[idx++] = y;
		idx = 100;
	}

	for (i = 1; i <= n; i++)
	{
		if (buf[x][i] == 1 && used[i] == 0)
		{
			res[idx++] = i;
			used[i] = 1;

			way(i, y);
			idx--;
		}
	}
}

int main()
{
	int i, j, p, q;

	scanf("%d %d %d %d", &n, &m, &x, &y);

	res[0] = x;
	used[x] = 1;

	for (i = 0; i < n; i++)
		scanf("%d", &v[i]);

	for (i = 0; i < m; i++)
	{
		scanf("%d %d", &p, &q);

		buf[p][q] = 1;
		buf[q][p] = 1;
	}

	way(x, y);

	for (i = 0; ; i++)
	{
		printf("%d ", res[i]);

		if (res[i] == y)
			break;
	}

	printf("\n");

	return 0;
}

