#include<cstdio>

const int M_max=15, N_max=15, K_max=15;
int M, N, K;
const int max_bands=1000;
char band[max_bands][N_max+1];
int bande[max_bands];
bool conflict[max_bands][max_bands];

long long int d[M_max+1][max_bands][K_max+1];

int c=0;
void gen_band(int p=0)
{
  if(p>N) 
   {
     c++;
     for(int j=1;j<=N;j++) band[c][j]=band[c-1][j];
     return;
   }
       
  band[c][p]=0; gen_band(p+1);
  if(p>0)if(band[c][p-1]==0) 
   {band[c][p]=1; gen_band(p+1);} 
}

void count_bands()
{
 for(int i=0;i<c;i++)
 { 
   bande[i]=0;
   for(int j=1;j<=N;j++) bande[i] += band[i][j];
 }     
}

void compute_conflicts()
{ 
  for(int i=1;i<c;i++) conflict[i][i]=true;
  
  for(int i1=0;i1<c;i1++)
  for(int i2=0;i2<i1;i2++)
  for(int j=1;j<=N;j++)
   {
     if((band[i1][j]==1)&&(band[i2][j]==1))
      {conflict[i1][i2]=conflict[i2][i1]=true; break;}
     if(j>1)
     if((band[i1][j]==1)&&(band[i2][j-1]==1))
      {conflict[i1][i2]=conflict[i2][i1]=true; break;}
     if(j<N)
     if((band[i1][j]==1)&&(band[i2][j+1]==1))
      {conflict[i1][i2]=conflict[i2][i1]=true; break;}
   }            
}

int main()
{
  scanf("%d%d%d",&N, &M, &K);    
  gen_band(0);
  count_bands();
  compute_conflicts();
  
  for(int t=0;t<c;t++)
  for(int k=0;k<=K;k++)
   d[1][t][k]=(bande[t]==k)?1:0;     
  
  for(int j=2;j<=M;j++)
  for(int t1=0;t1<c;t1++)
  for(int k=bande[t1];k<=K;k++)
  {
    long long int s=0;
    for(int t2=0;t2<c;t2++)
      if(!conflict[t1][t2]) s += d[j-1][t2][k-bande[t1]]; 
     d[j][t1][k]=s;    
  }
  long long int s=0;
  for(int t=0;t<c;t++) s += d[M][t][K];
  printf("%I64d\n",s);
}
