/*
TASK:aminosoup
LANG:C++
*/

#include <iostream>
#include <cstdio>

using namespace std;

bool A[1<<17][8];
long long n, m, answer;

void solve(int num)
{
    int x=num/m;
    int y=num%m;
    
    if (num == n*m)
    {
        ++answer;
        return;
    }
    
    if (A[x][y])
    {
        solve(num+1);
        return;
    }
    if ((A[x][y+1] || y+1==m) && (A[x+1][y] || x+1==n))
        return;
    if (!A[x][y+1] && y+1<m)
    {
        A[x][y]=1;
        A[x][y+1]=1;
        solve(num+1);
        A[x][y]=0;
        A[x][y+1]=0;
    }
    if (!A[x+1][y] && x+1<n)
    {
        A[x][y]=1;
        A[x+1][y]=1;
        solve(num+1);
        A[x][y]=0;
        A[x+1][y]=0;
    }
}

int fib(int k)
{
    int a=1;
    int b=1;
    int next;
    for (int i=2; i<=k; ++i)
    {
        next=a+b;
        a=b%602214179;
        b=next%602214179;
    }
    
    return b;
}

inline void input()
{ cin >> n >> m; }

int main()
{
    input();
    if (m == 1)
    {
        if (n & 1)
        {
            cout << 1 << endl;
        }
        else
            cout << 0 << endl;
    }
    else if (m == 2)
    {
        cout << fib(n) << endl;
    }
    else if (m&1 && n&1)
        cout << 0 << endl;
    else
    {
        solve(0);
        cout << answer << endl;
    }
return 0;
}
