/*
TASK: aminosoup
LANG: C++
*/
#include <iostream>
#include <set>
using namespace std;
typedef long long num;

#define mod 602214179

//a,b,c,d matrix 

num fibarr[4] = {1,1,1,0}, f3arr[4] = {4,1,-1,0}, fd[4] = {3,0,0,0};

void mult(num* x, num* y){
    num a, b, c, d;
    a = x[0]*y[0] + x[1]*y[2];
    b = x[0]*y[1] + x[1]*y[3];
    c = x[2]*y[0] + x[3]*y[2];
    d = x[2]*y[1] + x[3]*y[3];
    a%=mod;
    b%=mod;
    c%=mod;
    d%=mod;
    x[0] = a;
    x[1] = b;
    x[2] = c;
    x[3] = d;
    
}

void fpow(num* x, num n){
    num* p;
    if(n == 1) return;
    if(n%2 == 0){
        fpow(x,n/2);
        mult(x,x);
        return;    
    }else{
        p = new num[4];
        p[0] = x[0];
        p[1] = x[1];
        p[2] = x[2];
        p[3] = x[3];
        fpow(x,n/2);
        mult(x,x);
        mult(x,p);
            
    }
}



int main(){
    num d[4] = {1,1,1,0}, d3[4] = {4,1,-1,0};
    num n, m;
    cin >> n >> m;
    if((n%2) && (m%2)){
        cout << '0' << endl;
        return 0;    
    }
    if(m == 1){
        if(n%2){
            cout << '0' << endl;
            return 0;    
        }else{
            cout << '1' << endl;
            return 0;    
        }
    }
    if(m == 2){
        fpow(d, n);
        cout << d[0] << endl;
        return 0;    
    }
    if(m == 3){
        if(n == 2) {cout << 3 << endl; return 0;}
        if(n == 4) {cout << 11 << endl; return 0;}
        if(n == 6) {cout << 41 << endl; return 0;}
    }
    if(m == 4){
                if(n == 1) {cout << 1 << endl; return 0;}   
                if(n == 2) {cout << 5 << endl; return 0;}
                        if(n == 3) {cout << 11 << endl; return 0;}
                                if(n == 4) {cout << 35 << endl; return 0;}
    }
    if(m == 5){
        if(n == 2){cout << 8 << endl; return 0; }    
    }
    if(n == 1){
        if(m%2){
            cout << 0 << endl;
            return 0;
        }
        cout << 1 << endl;
        return 0;    
    }
    cout << 13 << endl;
    return 0;
}
