/*
TASK: guard
LANG: C++
*/
#include <iostream>
#include <algorithm>
#include <cmath>
using namespace std;
#define PI 3.141592653589

double ang[6];

struct cmpls{
    bool operator()(const int& a, const int& b){
        return ang[a] < ang[b];
    }    
};

cmpls Tcmp;

int main(){
    int i, j, xo, yo, dx[6], dy[6], st[6], res;
    double area = 0.0;
    bool it[10];
    cin >> xo >> yo;
    for(i = 0; i < 6; i++){
        st[i] = i;
        cin >> dx[i] >> dy[i];
        dx[i] -= xo;
        dy[i] -= yo;
        ang[i] = atan2((double)dy[i], (double)dx[i]);
        if(ang[i] < 0.0) ang[i] = 2.0*PI + ang[i];
    }
    
    //sort by angle
    sort(st, st+6, Tcmp);
    
    for(i = 0; i < 7; i++)
    it[i] = false;
    for(i = 0; i < 6; i++){
        switch(st[i]){
            case 0:
            for(j = i; j < 6; j++){
                if(st[j] == 1) goto NewYork;
                it[j+1] = true;
            }
            break;
            case 2:
            for(j = i; j < 6; j++){
                if(st[j] == 3) goto NewYork;
                it[j+1] = true;
            }
            break;
            case 4:
            for(j = i; j < 6; j++){
                if(st[j] == 5) goto NewYork;
                it[j+1] = true;
            }
            break;
            case 1:
            for(j = i; j >= 0; j--){
                if(st[j] == 0) goto NewYork;
                it[j] = true;    
            }
            break;
            case 3:
            for(j = i; j >= 0; j--){
                if(st[j] == 2) goto NewYork;
                it[j] = true;    
            }
            break;
            case 5:
            for(j = i; j >= 0; j--){
                if(st[j] == 4) goto NewYork;
                it[j] = true;    
            }
            break;
        }    
        NewYork:;
    }
    
    it[0] = it[0] || it[6];
    
    for(i = 1; i < 6; i++)
    if(it[i]){
        area += ang[st[i]] - ang[st[i-1]];
    }
    if(it[0]){
        area += ang[st[0]] + 2.0*PI - ang[st[5]];    
    }
    
    //cout << area << endl;
    if(area == 0.0){
        cout << '0' << endl;
        return 0;    
    }
    area /= 2.0*PI;
    area*=100.0;
    //cout << area << endl;
    area += 0.5;
    res = (int)floor(area);
    cout << res << endl;
    return 0;
}
