/*
TASK: guard
LANG: C++
*/
#include <iostream>
#include <cmath>

using namespace std;

#define PI_ 3.1415926535897932384626433832795
#define eps 0.00000001

struct pts
{
	int x,y;
}c,t[3][2];

struct interval
{
	double pa,an;
}in[3];

pts mp(int x,int y) {pts ret;ret.x=x;ret.y=y;return ret;}

int os(pts a,pts b,pts c)
{
	return a.x*(b.y-c.y)+b.x*(c.y-a.y)+c.x*(a.y-b.y);\
}

double op(double x)
{
	if(x<0) x+=2*PI_;
	if(x>2*PI_) x-=2*PI_;
	return x;
}

interval mi(pts a,pts b)
{
	interval ret;
	if(a.x==0)
	{
		ret.pa=PI_/2;
	}
	else
	{
		ret.pa=atan((double)a.y/(double)a.x);
		if(a.x<0) ret.pa+=PI_;
		if(ret.pa<0) ret.pa+=(2*PI_);
	}	
	if(b.x==0)
	{
		ret.an=PI_/2.0;
	}
	else
	{
		ret.an=atan((double)b.y/(double)b.x);
		if(b.x<0) ret.an+=PI_;
		if(ret.an<0) ret.an+=(2*PI_);
	}
	double pp=ret.an;
	ret.an-=ret.pa;
	if(ret.an<0) ret.an+=(2*PI_);
	if(ret.an>2*PI_) ret.an-=2*PI_;
	if(ret.pa<0) ret.pa+=(2*PI_);
	if(ret.pa>2*PI_) ret.pa-=2*PI_;
	return ret;
}

bool tr(interval a,double b)
{
	if(fabs(op(b-a.pa)+op(a.pa+a.an-b)-a.an)<eps) return 1;
	return 0;
}

interval och(interval a,interval b)
{
	interval ret;
	if(tr(a,b.pa))
	{
			if(tr(a,op(b.pa+b.an)))
			{
				return b;
			}
			ret.pa=b.pa;
			ret.an=op(a.an+a.pa-b.pa);
			return ret;
	}
	if(tr(b,a.pa))
	{
		if(tr(b,op(a.pa+a.an)))
		{
			return a;
		}
		ret.pa=a.pa;
		ret.an=op(b.pa+b.an-a.pa);
		return ret;
	}
	ret.pa=0;
	ret.an=0;
	return ret;
}

void read()
{
	int cx,cy,x,y;
	scanf("%d %d",&cx,&cy);
	for(int i=0;i<3;i++) for(int j=0;j<2;j++)
	{
		scanf("%d %d",&x,&y);
		t[i][j]=mp(x-cx,y-cy);
	}
	c=mp(0,0);
	
	for(int i=0;i<3;i++) in[i]=mi(t[i][0],t[i][1]);
	
	double ans=0;
	ans=in[0].an+in[1].an+in[2].an;
	interval pr;
	pr=och(in[0],in[1]);
	ans-=pr.an;
//	cout<<pr.an<<endl;
	pr=och(in[0],in[2]);
	ans-=pr.an;
//	cout<<pr.an<<endl;
	pr=och(in[1],in[2]);
	ans-=pr.an;
//	cout<<pr.an<<endl;
	pr=och(och(in[0],in[1]),in[2]);
	ans+=pr.an;
//	cout<<pr.an<<endl;
	ans/=(2*PI_);
//	cout<<ans<<endl;
	ans*=100;
//	cout<<ans<<endl;
	ans+=0.5;
//	cout<<ans<<endl;
	int ra=(int)ans;
	printf("%d\n",ra);
}

int main()
{
	read();
	return 0;
}
