/*
TASK: aminosoup
LANG: C++
*/
#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>
#define DEBUG true
#define SHOW(v) if (DEBUG) cout << #v << " = " << v << " (size: " << sizeof(v) << ") (pointer: " << &v << ")" << endl;
#define SHOWA(a, n) if (DEBUG) for(int asd = 0; asd < n; asd++) cout << #a << "[" << asd << "] = " << a[asd] << endl;
#define SHOWV(v) if (DEBUG) for(int asd = 0; asd <= v.size(); asd++) cout << #v << "[" << asd << "] = " << v[asd] << endl;
#define PAUSE if(DEBUG) system("pause");
#define FOR(i, a, b) for(int i = a; i <= b; i++)
#define FORB(i, a, b) for(int i = a; i >= b; i--)
#define SZ(v) v.size()
#define ST(v) v.begin()
#define EN(v) v.end()
#define ADD(v, var) v.push_back(var);
#define MIN(a, b) a < b ? a : b
#define MAX(a, b) a > b ? a : b
#define DEL 602214179
using namespace std;
int n, m;
int toplace;
bool data[128][128];
long long sol;
void solve(int x, int y, int plcd)
{
    //cout << "solve(" << x << ", " << y << ", " << plcd << ");" << endl;
    if (plcd == toplace)
    {
        sol++; //check
        if (sol >= DEL) sol = sol % DEL;
        /*cout << endl;
        FOR(i, 1, n)
        {
            FOR(j, 1, m) cout << data[i][j];
            cout << endl;
        }
        */
        return;
    }
    if (y > m) return;
    if (x > n) return;
    //if (data[x][y]) solve(x, y + 1);
    if (data[x][y])
    {
        if (y + 1 > m) solve(x + 1, 1, plcd);
        else solve(x, y + 1, plcd);
    }
    // --
    if (!data[x][y] && !data[x][y+1] && y + 1 <= m)
    {
        data[x][y] = true;
        data[x][y+1] = true;
        //cout << "- ";
        if (y + 1 == m) solve(x + 1, 1, plcd+1);
        else solve(x, y + 2, plcd+1);
        data[x][y] = false;
        data[x][y+1] = false;
    }
    // |
    if (!data[x][y] && !data[x+1][y] && x + 1 <= n)
    {
        data[x][y] = true;
        data[x+1][y] = true;
        //cout << "| ";
        if (y == m) solve(x + 1, 1, plcd+1);
        else solve(x, y + 1, plcd+1);
        data[x][y] = false;
        data[x+1][y] = false;
    }
}
int main()
{
    cin >> n >> m;
    if ((n * m) % 2 == 1) { return 0; }
    sol = 0;
    toplace = n * m / 2;
    solve(1, 1, 0);
    cout << sol << endl;
    //PAUSE;
    return 0;
}

/*
2 3
32 48 4
512 768 8
8192 12288 12
131072 196608 16
2097152 3145728 20
33554432 50331648 24
536870912 805306368 28
0 0 32
Press any key to continue . . .





        1        2        3        4        5        6
1       0        1        0        1        0        1
2       1        2        3        5        8        13
3       0        3        0        11       0        41
4       1        5        11       36       95       281
5       0        8        0        95       0        1183
6       1        13       41       281      1183     6728
7       0        21       0        781      0        31529
8       1        34       153      2245     14824    167089
9       0        55       0        6336     0        817991
10      1        89       571      18061    185921   4213133
11      0        144      0        51205    0        21001799
12      1        233      2131     145601   2332097  106912793
13      0        377      0        413351   0        536948224
14      1        610      7953     1174500  29253160
15      0        987      0        3335651  0
16      1        1597     29681    9475901
17      0        2584     0        26915305 0
18      1        4181     110771   76455961
*/
