/*
LANG: C++
TASK: gen
*/
#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>
#define DEBUG true
#define SHOW(v) if (DEBUG) cout << #v << " = " << v << " (size: " << sizeof(v) << ") (pointer: " << &v << ")" << endl;
#define SHOWA(a, n) if (DEBUG) for(int asd = 0; asd < n; asd++) cout << #a << "[" << asd << "] = " << a[asd] << endl;
#define SHOWV(v) if (DEBUG) for(int asd = 0; asd <= v.size(); asd++) cout << #v << "[" << asd << "] = " << v[asd] << endl;
#define PAUSE if(DEBUG) system("pause");
#define FOR(i, a, b) for(int i = a; i <= b; i++)
#define FORB(i, a, b) for(int i = a; i >= b; i--)
#define SZ(v) v.size()
#define ST(v) v.begin()
#define EN(v) v.end()
#define ADD(v, var) v.push_back(var);
#define MIN(a, b) a < b ? a : b
#define MAX(a, b) a > b ? a : b
#define DT pair<long long, long long>
#define DT2 pair<DT,int>
using namespace std;
int p, q;
int np, nq;
double pp, qq;
int main()
{
    cin >> p >> q;
    if (p == q) { cout << "0" << endl; return 0; }
    pp = (double)p;
    qq = (double)q;
    queue< DT2 > data;
    DT c;
    int c2 = 0;
    data.push(DT2(DT(p, q), c2));
    int lastc2 = -1;
    while(!data.empty())
    {
        c = data.front().first;
        c2 = data.front().second;
        if (c2 > 20) { cout << "0" << endl; break; }
        //if (c.first / pp == c.second / qq && c2 > 0) { cout << c2 << endl; break; }
        if (c.first / pp == c.second / qq && c2 > 0) { cout << c2 << endl; break; }
        //if (c2 != lastc2) {SHOW(c2); lastc2 =c2;}
        np = 2*c.first+c.second;
        nq = c.second;
        data.push(DT2(DT(np, nq), c2 + 1));
        np = c.first;
        nq = 2*c.second+c.first;
        data.push(DT2(DT(np, nq), c2 + 1));
        data.pop();
    }
    //PAUSE;
    return 0;
}

/*
2 3
32 48 4
512 768 8
8192 12288 12
131072 196608 16
2097152 3145728 20
33554432 50331648 24
536870912 805306368 28
0 0 32
Press any key to continue . . .
*/
