/*
TASK: guard
LANG: C++
*/
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
using namespace std;

const double pi=3.141592653589;
const double eps=1e-7;

struct pa
{
  double ang;
  int in;
  pa(){}
  pa(double angg, int inn) {ang=angg; in=inn; }
};

inline int isless(pa a, pa b) { return a.ang<b.ang; }

int main()
{
  int x, y;
  cin>>x>>y;
  int px1, py1, px2, py2;
  double a1, a2;
  pa s[100]; int slen=0;
  for(int i=0; i<3; i++)
  {
    cin>>px1>>py1>>px2>>py2;
    px1-=x; py1-=y; px2-=x; py2-=y;
    a1=atan2(py1, px1); a2=atan2(py2, px2);
    if( fabs(a1-pi)<=eps) a1=-pi;
    //cout<<a1<<' '<<a2<<endl;
    s[slen++]=(pa(a1, 1)); s[slen++]=(pa(a2, -1));
    if(a1>a2) { s[slen++]=(pa(-pi, 1)); s[slen++]=(pa(pi, -1)); }
  }
  
  for(int i=0; i<slen; i++)
    for(int j=i+1; j<slen; j++)
      if(isless(s[j], s[i])) swap(s[j], s[i]);
  
  double length=0;
  int are=0;
  for(int i=0; i<slen-1; i++)
  {
    //cout<<i<<' '<<s[i].ang<<' '<<s[i].in<<endl;
    are+=s[i].in;
    if(are) length+=s[i+1].ang-s[i].ang;
  }
  
  cout<<(int)(50.0*length/pi+0.5)<<endl;
  return 0;
}
