/*
TASK: guard
LANG: C++
*/
#include <cstdio>
#include <cmath>

struct point {
	int x, y;
	
	point(){}
	point(int _x, int _y) : x(_x), y(_y) {}	
};

bool circle[1024];
point o, a, b;
int res;

int main() {
	scanf("%d%d", &o.x, &o.y);
	while(scanf("%d%d", &a.x, &a.y, &b.x, &b.y) == 2) {
		int m = (int)(atan2(a.x - o.x, a.y - o.y)*500/M_PI + 500);
		int n = (int)(atan2(b.x - o.x, b.y - o.y)*500/M_PI + 500);
		if(m > n) {
			for(int i = n; i < m; ++i) {
				circle[i] = 1;
			}
		} else {
			for(int i = 0; i < m; ++i) {
				circle[i] = 1;
			}
			for(int i = n; i < 1000; ++i) {
				circle[i] = 1;
			}
		}
	}
	
	for(int i = 0; i < 1000; ++i) {
		res += circle[i];
	}
	
	printf("%d\n", res/10);
	
	return 0;
}
