/*
TASK:guard
LANG:C++
*/
#include <iostream>
#include <cmath>
using namespace std;
#define eps 1e-14
#define mp make_pair
struct point 
{
       double x, y;
       void read()
       {
            scanf("%lf%lf", &x, &y);
        }
};

point o;
point a[4][2];
pair <double, double> ang[4];

bool cmp(pair <double, double> p1, pair <double, double> p2)
{
    if(fabs(p1.first - p2.first) < eps)
        return p1.second < p2.second;
        
        return p1.first < p2.first;
}

int main ()
{
    
    o.read();
    int i;
    for(i = 0;i<3;i++)
    {
          a[i][1].read();
          a[i][1].x -= o.x; 
          a[i][1].y -= o.y; 
          
          a[i][0].read(); 
          a[i][0].x -= o.x; 
          a[i][0].y -= o.y; 
    
    }
    
    for(i = 0;i<3;i++)
    {
          ang[i] = mp(atan2(a[i][0].y, a[i][0].x), atan2(a[i][1].y, a[i][1].x) );
          if(ang[i].first <  -eps) ang[i].first += 2.0*M_PI;
          if(ang[i].second <  -eps) ang[i].second += 2.0*M_PI;
          
               if(ang[i].second < ang[i].first) ang[i].second += 2.0*M_PI;
    }
    
    if(ang[0].first + eps > ang[0].second) ang[0].second += 2.0*M_PI;
    
    for(i = 1;i<3;i++)
    {

     if(ang[0].first + eps > ang[i].first) 
     { 
            ang[i].first += 2.0*M_PI; 
            ang[i].second += 2.0*M_PI; 
     }
     if(ang[i].second > ang[0].first + 2.0*M_PI + eps) ang[i].second = ang[0].first + 2.0*M_PI; 
    }
   
     //for(i = 0;i<3;i++) printf("%.2lf %.2lf\n", ang[i].first*180.0/M_PI,ang[i].second*180.0/M_PI);
   
    sort(ang+1, ang+3, cmp);
    
    double f = -1.0;
    double l = -1.0;
    double bla = 0.0;
    
    for (i=0;i<3;i++)
    {
        if(ang[i].first < l + eps) l = max(l, ang[i].second);
        else
        {
        bla += l - f;
        f = ang[i]. first;
        l = ang[i].second;
        } 
    }
    bla += l - f;
    //printf("%.4lf\n", bla*180.0/M_PI);
    
    bla = bla / (2.0*M_PI);
    bla = bla * 100.0;
    bla += 0.5 + eps;
    
    printf("%d\n", (int)bla);  
    
    //system("pause");
    return 0;
}
