/*
TASK:aminosoup
LANG:C++
*/
#include <iostream>
#include <cmath>

typedef unsigned long long uint64;

#define UP 602214179

using namespace std;

int Group2(uint64 n)
{
    if(n%2)
    {
           uint64 r = (int)pow(2.0f, (int)(n-1)/2);
           if(n < 5) return r;
           for(int k=n-3;k>0;k-=2)
                   r -= (uint64)pow(2.0f, (int)k/2);
           return r;
    }
    else
    {
        return (int)pow(2.0f, (int)n);
    }
}

/*
int Column(uint64 n)
{
    int m=1;
    for(int i = (n%2)?(n-2):(n-3); i>0; i-=2)
            for(int j=2; j<i; j+=2)
                    m *= (n - j);
}
*/

int main()
{
    uint64 N;
    int M;
    cin >> N >> M;
    
    if( N%2 && M%2)
    {
        cout << 0 << endl;
        return 0;
    }
    
    
    switch(M)
    {
             case 1:
                  cout << 1 << endl;
                  break;
             case 2:
                  cout << Group2(N)%UP;
                  break;
             case 3:
                  cout <<  (2 * Group2(N)) %  UP;
                  break;
//             case 4:
    }
}
