/*
TASK:gen
LANG:c++
*/

#include <iostream>
#include <cmath>

using namespace std;

unsigned long long a, b;
unsigned long long q[10000];
unsigned long long r[10000];
int last = 0;
int steps = 1;

int lcd(int a, int b)
{
    if (a==0) return b;
    if (b==0) return a;
    if(a>b) return lcd(a%b, b);
    return lcd(a , b%a);
}

inline void simplify(unsigned long long &a, unsigned long long &b)
{
     int n = lcd(a, b);
     if(n > 1)
     {
          a /= n;
          b /=n;
     }
}

inline void proc(int c, int d)
{
     if( (c == a) && (d == b))
     {
         cout << steps << endl;
         //system("pause");
         exit(0);
     }
}
       

void search()
{
//     cout << c << " " << d << endl;
     
    // cout << "Level " << steps << " iteration." << endl;
  //   cout << "levels so far:" << endl;
//     for(int i =0; i < last; ++ i)
 //            cout << q[i] << "/" << r[i] << endl;
//     cin.get();
     
     if(steps > 10)
             return;
             
     steps++;

     int p = last;
     unsigned long long k, l;
     for(int i = last - pow(2.0f, steps); i < last; ++i)
     {
            //out << "Reforming " << q[i] << "/" << r[i] << endl;
             k = 2*q[i] + r[i];
             l = r[i];
            //out << "r - " << r[i] << " ... " << l;
             simplify(k, l);
             proc(k, l);

             q[p] = k;
             r[p] = l;
             p++;
            //out << " ........ " << r[p] << endl;
             
             k = q[i];
             l = q[i] + 2*r[i];
             simplify(k, l);    
             proc(k, l);

             q[p] = k;
             r[p] = l;
             p++;
     }
     last = p;

     search();
}



int main()
{
    cin >> a >> b;
    
    q[0] = 2 * a + b;
    q[1] = a;
    r[0] = b;
    r[1] = a + 2 * b;
    simplify(q[0],r[0]);
    simplify(q[1], r[1]);
    last = 2;
   
    search();
    cout << 0 << endl;
                  
    //system("pause");
}
