/*
TASK:king
LANG:C++
*/

#include <iostream>
#include <queue>
using namespace std;

struct dve
{
       int x, y;
};

int N, M, K;
long long br = 0;

void nuli( int p[][16] )
{
     int i, j;
     for ( i = 0; i <= 15; i++ )
         for ( j = 0; j <= 15; j++ )
             p[i][j] = 0;
}


void boq( int i, int j, int p[][16], queue<dve> &que )
{
     int k, l;
     dve a;
     for ( k = i-1; k <= i+1; k++ )
     {
         for ( l = j-1; l <= j+1; l++ )
         {
             if ( p[k][l] != 1 )
             {
                p[k][l] = 1;
                a.x = k;
                a.y = l;
                que.push( a );
             }
         }
     }
}

void cikal( int MR, int p[][16] )
{
     queue<dve> que;
     int q[16][16];
     dve a;
     int i, j, k, p1, q1;
     for ( p1 = 0; p1 <= 15; p1++ )
     {
         for ( q1 = 0; q1 <= 15; q1++ )
             q[p1][q1] = p[p1][q1];
     }
     for ( i = 1; i <= N; i++ )
     {
         for ( j = 1; j <= M; j++ )
         {
             if ( p[i][j] == 0 )
             {
                  boq( i, j, q, que );
                  if ( MR > 1 )
                  {
                      cikal( MR-1, q );
                  }
                  else
                  {
                      br++;
                  }
                  while ( !que.empty() )
                  {
                        a = que.front();
                        que.pop();
                        p1 = a.x;
                        q1 = a.y;
                        q[p1][q1] = 0;
                  }
             }
         }
     }
}

int main()
{
    int i, j;
    int a, b;
    int p[16][16];
    
    cin >> N >> M >> K;
    br = 0;
    nuli( p );
    cikal( K, p );
    cout << br/K << endl;
    return 0;
}
