/*
TASK:king
LANG:C++
*/
#include <iostream>
using namespace std;

int N, M, K;
bool flag[13][13];
int cnt(0);

void place (int x, int y, int kings) {
    if (x<0 || y<0 || x>=N || y>=M) return;
    if (flag[x][y] == true) return;
    if (flag[x-1][y-1] == true ||
        flag[x-1][y+1] == true ||
        flag[x+1][y-1] == true ||
        flag[x+1][y+1] == true ||
        flag[x+1][y] == true ||
        flag[x-1][y] == true ||
        flag[x][y+1] == true ||
        flag[x][y-1] == true
    ) return;
    
    if (kings == 0) {cnt++; return;}
    
    flag[x][y] = true;
    place (x+2, y, kings-1);
    place (x-2, y, kings-1);
    place (x, y+2, kings-1);
    place (x, y-2, kings-1);
    place (x-2, y-2, kings-1);
    place (x-2, y+2, kings-1);
    place (x+2, y-2, kings-1);
    place (x+2, y+2, kings-1);
    flag[x][y] = false;
}

int main() {
    scanf("%i%i%i", &N, &M, &K);
    memset (flag, false, sizeof(flag));
    for (int i=0; i<N; i++)
        for (int j=0; j<M; j++)
            place(i, j, K-1);
    printf("%i\n", cnt);
}
