/* Mugurel Ionut Andreica - Bucuresti, ROMANIA */

#include <stdio.h>
#define filein "fibo.in"
#define fileout "fibo.out"
#define P 1000000000
#define maxn 201

long long fibo[maxn];
long index[maxn],n,nel;

void readdata(void);
void compute(void);
void printdata(void);

int main()
{
readdata();
compute();
printdata();
return 0;
}

void readdata(void)
{
freopen(filein,"r",stdin);
scanf("%ld",&n);
}

long exists(long ind)
{
long i;

for (i=1;i<=nel;i++)
  if (index[i]==ind)
    return 1;
return 0;
}

void add(long ind)
{
nel++;
index[nel]=ind;
}

long long fib(long ind)
{
long i;

if (ind==0)
  return 0;
else
if ((ind==1) || (ind==2))
  return 1;
else
if (ind==3)
  return 2;
else
  {
  for (i=1;i<=nel;i++)
    if (index[i]==ind && fibo[i]>-1)
      return fibo[i];

  i=ind/2;
  if (ind%2==0)
    return (fib(i)*fib(i+1)+fib(i-1)*fib(i))%P;
  else
    return (fib(i+1)*fib(i+1)+fib(i)*fib(i))%P;
  }
}

void compute(void)
{
long i,j,k;

nel=1;
index[1]=n;

for (i=1;i<=nel;i++)
  {
  k=index[i];

  if (k<=3) continue;
  
  if (k%2==0)
    {
    k/=2;
    if (!exists(k-1))
      add(k-1);
    if (!exists(k))
      add(k);
    if (!exists(k+1))
      add(k+1);
    }
  else
    {
    k/=2;
    if (!exists(k))
      add(k);
    if (!exists(k+1))
      add(k+1);
    }
  }

/* sort the array */
for (i=1;i<nel;i++)
  for (j=i+1;j<=nel;j++)
    if (index[i]<index[j])
      {
      k=index[i]; index[i]=index[j]; index[j]=k;
      }

for (i=1;i<=nel;i++)
  fibo[i]=-1;

/* compute the Fibonacci numbers */
for (i=nel;i>=1;i--)
  fibo[i]=fib(index[i]);
}

void printdata(void)
{
freopen(fileout,"w",stdout);
printf("%Ld\n",fibo[1]);
}
