// Mircea Digulescu - Bucuresti, ROMANIA

// Time Complexity: O(N^2)

#include <fstream.h>
#include <string.h>

ifstream in("pali.in");
ofstream out("pali.out");

#define INF 10000

int i,j;
int n;
int JJ;
char s[5003];

char pal[2][5003];
int cs[5003];

inline int IsPali()
 {
  if(i==j) return 1;
  if(j+1==i) return (s[i]==s[j]);
  return ((s[i]==s[j]) && (pal[JJ][j+1]));
 }

void main()
 {
  in>>s+1;
  s[0]='';
  n = strlen(s);
  for(i=0;i<n;i++) cs[i]=INF;
  JJ=0;
  cs[0]=0;
  cs[1]=1;
  pal[JJ][1]=1;
  for(i=2;i<n;i++)
   {
    for(j=i;j>0;j--)
     if(IsPali())
      {
       pal[!JJ][j]=1;
       if(cs[j-1]+1<cs[i]) cs[i]=cs[j-1]+1;
      }
     else pal[!JJ][j]=0;
    JJ=!JJ;
   }
  out<<cs[n-1];
 }